/**
 * @source: 
 * 
 * @licstart The following is the entire license notice for the 
 *  JavaScript code in this page.
 *
 * Copyright (C) 2015 Adriano Marchetti
 *
 * The JavaScript code in this page is free software: you can
 * redistribute it and/or modify it under the terms of the GNU
 * General Public License (GNU GPL) as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option)
 * any later version. The code is distributed WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU GPL for more details.
 *
 * As additional permission under GNU GPL version 3 section 7, you
 * may distribute non-source (e.g., minimized or compacted) forms of
 * that code without the copy of the GNU GPL normally required by
 * section 4, provided you include this license notice and a URL
 * through which recipients can access the Corresponding Source.
 *
 * @licend The above is the entire license notice
 * for the JavaScript code in this page.
 */
(function () {
    "use strict";
    //Global-ish variables
    var nome = 'player';
    var sectID = ['intro', 'nome', 'classe', 'morte', 'vittoria', 'gioco', 'aiuto',
        'dialog', 'data', 'stats', 'items', 'takeoff', 'levelup', 'menu'];
    var dialog = null, infoplay = null, infodun = null;
    var context = null, wsize = 0, hsize = 0;
    var swidth = 0, sheight = 0, sfont = 0, midx = 0, midy = 0;
    var messages = [];
    var player = null;
    var necro = '';
    var savedGame = Object.create(null);
    var isUp = false, isWilderness = false, isTarget = false, isMap = false;

    /*
     * Some general-purpose objects, collecting strings and so on. Might add some more, later
     */
    //The first two are objects to help with item & target screens. Which is to say, a shameless hack
    var itemscreen = {
        multiselect: false,
        mustchoose: false,
        items: [],
        item: null,
        selected: {},
        ok: null
    };
    var targetscreen = {
        targetx: 0,
        targety: 0,
        ok: null,
        item: null,
        hasTarget: false
    };
    var strings = {
        death: "<span class='red'>You have died... Click, tap or press [Enter] to continue.</span>",
        nodeath: "<span class='green'>Death smiles and reverses your hourglass: you have another chance... but this won't happen again.</span>",
        dundeath: "%s the %s died on level %s of the dungeon %s",
        acideath: ", melted by acid.",
        burndeath: ", burned to a crisp.",
        electrodeath: " in a very shocking way.",
        frozedeath: " in an extremely cool way.",
        poisdeath: ", killed by poison.",
        bleeddeath: " killed by the loss of blood.",
        magifail: " by a burst of uncontrolled magic.",
        hungerdeath: " killed by malnoutrition.",
        isdead: ", killed by %s.",
        kill: "<span class='green'>You kill %s.</span>",
        poison: "<span class='yellow'>You feel poisoned!</span>",
        ispois: "<span class='yellow'>%s is poisoned!</span>",
        paral: "<span class='red'>You are paralyzed!</span>",
        stoneyou: "<span class='gray'>You are turned into a stone statue!</span>",
        youstoneit: "<span class='gray'>%s turns into a stone statue.</span>",
        repre: "<span style='color: %s; background-color: %s'>%s</span>",
        lvlup: "<span class='cyan'>You advance to level %s.</span>",
        vamp: "<span class='cold'>You feel cold...</span>",
        conftext: "%s - %s (click here or press [enter] to confirm the target)",
        whichw: "Which %s do you want to %s?",
        remostr: "You remove your %s.",
        noremo: "You have no %s to remove.",
        notto: "You have nothing to %s.",
        onlydun: "You can only do this in a dungeon.",
        pick: "You pick up %s.",
        youhit: "You are hit: -%s!",
        youshot: "A %s is shot from %s!",
        youmiss: "You miss %s.",
        youmissed: "%s misses you.",
        ishit: "%s is hit: -%s!",
        unseenhit: "Something is hit.",
        vultest: "%s is %s by the %s damage.",
        youvultest: "You are %s by the %s damage.",
        ammobr: "The ammo breaks.",
        ammolo: "You load %s. You have %s now.",
        notele: "The air vibrates around %s, but nothing happens.",
        floorburn: "The floor burns under %s feet: -%s!",
        floorsand: "The floor under %s feet turns into quicksand.",
        lightbolt: "Lightning crackles from %s finger!",
        charchange: "You feel %s.",
        moschange: "%s looks %s.",
        cure: "A holy light surronds %s.",
        smite: "A holy bolt comes crushing from the sky.",
        giveimm: " It grants <span class='cyan'>immunity</span> to %s.",
        giveres: " It grants <span class='orange'>resistance</span> to %s.",
        exdam: " It does <span class='yellow'>extra damage</span> by %s.",
        vamdam: " It <span class='red'>drains life</span> from enemies.",
        poidam: " It <span class='green'>poisons</span> its enemies.",
        spelldesc: "<br><span class='white'>%s</span>",
        whiteln: "<span class='white'>%s</span>",
        bonusln: "<span class='white'>%s (%s)</span>",
        redmex: "<span class='red'>%s</span>",
        greenmex: "<span class='green'>%s</span>",
        oranmex: "<span class='orange'>%s</span>",
        dot: "<span class='dot'> § </span>"
    };
    var damages = {
        fire: 'fire',
        cold: 'cold',
        acid: 'acid',
        electro: 'electricity',
        vamp: 'vampiric',
        confu: 'confusion',
        petro: 'petrification',
        paral: 'paralysis',
        magic: 'magic',
        holy: 'holy',
        unholy: 'unholy',
        sleep: 'sleep',
        pois: 'poison',
        tele: 'teleport',
        light: 'light',
        dark: 'dark',
        cut: 'cut',
        blunt: 'blunt',
        pierce: 'pierce',
        bleed: 'bleed',
        rust: 'rust',
        sound: 'sound'
    };
    var parts = {
        hand1: "Main weapon",
        hand2: "Secondary weapon",
        body: "Armour",
        head: "Head",
        neck: "Neck",
        back: "Back",
        feet: "Feet"
    };
    var terrains = [
            // Sea (0-20).
            '#195A9C', '#195AA0', '#195AA4', '#195AA8', '#195BAC',
            '#1A5DAF', '#1A5EB2', '#1B60B5', '#1C63BB', '#1D67C2',
            '#1E6BC9', '#2070D1', '#2272D4', '#2577D9', '#297CDF',
            '#2D81E6', '#338DF3', '#3A9BFF', '#46AAFF', '#53BAFF',
            '#79DBFF',
            // Plains (21-29)
            '#5EA953', '#4EA546', '#3FA139', '#2F9D2C', '#209920',
            '#209920', '#33932C', '#468E38', '#5F9737',
            // Hills (30-33)
            '#819D3A', '#A1B252', '#C0C85C',
            // Mountains (34-36)
            '#AD9743', '#A27D24', '#996415', '#8B530F',
            // High mountains (37-39)
            '#836F4C', '#9B8C75', '#BDB8AA'
    ];
    var dir = {
        NW: [-1, -1],
        N: [0, -1],
        NE: [1, -1],
        W: [-1, 0],
        E: [1, 0],
        SW: [-1, 1],
        S: [0, 1],
        SE: [1, 1],
        all: [[-1, -1], [0, -1], [1, -1], [-1, 0], [1, 0], [-1, 1], [0, 1], [1, 1], [0, 0]]
    };
    var keys = {
        VK_CANCEL: 3,
        VK_HELP: 6,
        VK_BACK_SPACE: 8,
        VK_TAB: 9,
        VK_CLEAR: 12,
        VK_RETURN: 13,
        VK_ENTER: 14,
        VK_SHIFT: 16,
        VK_CONTROL: 17,
        VK_ALT: 18,
        VK_PAUSE: 19,
        VK_CAPS_LOCK: 20,
        VK_ESCAPE: 27,
        VK_SPACE: 32,
        VK_PAGE_UP: 33,
        VK_PAGE_DOWN: 34,
        VK_END: 35,
        VK_HOME: 36,
        VK_LEFT: 37,
        VK_UP: 38,
        VK_RIGHT: 39,
        VK_DOWN: 40,
        VK_PRINTSCREEN: 44,
        VK_INSERT: 45,
        VK_DELETE: 46,
        VK_0: 48,
        VK_1: 49,
        VK_2: 50,
        VK_3: 51,
        VK_4: 52,
        VK_5: 53,
        VK_6: 54,
        VK_7: 55,
        VK_8: 56,
        VK_9: 57,
        VK_COLON: 58,
        VK_SEMICOLON: 59,
        VK_LESS_THAN: 60,
        VK_EQUALS: 61,
        VK_GREATER_THAN: 62,
        VK_QUESTION_MARK: 63,
        VK_AT: 64,
        VK_A: 65,
        VK_B: 66,
        VK_C: 67,
        VK_D: 68,
        VK_E: 69,
        VK_F: 70,
        VK_G: 71,
        VK_H: 72,
        VK_I: 73,
        VK_J: 74,
        VK_K: 75,
        VK_L: 76,
        VK_M: 77,
        VK_N: 78,
        VK_O: 79,
        VK_P: 80,
        VK_Q: 81,
        VK_R: 82,
        VK_S: 83,
        VK_T: 84,
        VK_U: 85,
        VK_V: 86,
        VK_W: 87,
        VK_X: 88,
        VK_Y: 89,
        VK_Z: 90,
        VK_CONTEXT_MENU: 93,
        VK_NUMPAD0: 96,
        VK_NUMPAD1: 97,
        VK_NUMPAD2: 98,
        VK_NUMPAD3: 99,
        VK_NUMPAD4: 100,
        VK_NUMPAD5: 101,
        VK_NUMPAD6: 102,
        VK_NUMPAD7: 103,
        VK_NUMPAD8: 104,
        VK_NUMPAD9: 105,
        VK_MULTIPLY: 106,
        VK_ADD: 107,
        VK_SEPARATOR: 108,
        VK_SUBTRACT: 109,
        VK_DECIMAL: 110,
        VK_DIVIDE: 111,
        VK_F1: 112,
        VK_F2: 113,
        VK_F3: 114,
        VK_F4: 115,
        VK_F5: 116,
        VK_F6: 117,
        VK_F7: 118,
        VK_F8: 119,
        VK_F9: 120,
        VK_F10: 121,
        VK_F11: 122,
        VK_F12: 123,
        VK_F13: 124,
        VK_F14: 125,
        VK_F15: 126,
        VK_F16: 127,
        VK_F17: 128,
        VK_F18: 129,
        VK_F19: 130,
        VK_F20: 131,
        VK_F21: 132,
        VK_F22: 133,
        VK_F23: 134,
        VK_F24: 135,
        VK_NUM_LOCK: 144,
        VK_SCROLL_LOCK: 145,
        VK_CIRCUMFLEX: 160,
        VK_EXCLAMATION: 161,
        VK_DOUBLE_QUOTE: 162,
        VK_HASH: 163,
        VK_DOLLAR: 164,
        VK_PERCENT: 165,
        VK_AMPERSAND: 166,
        VK_UNDERSCORE: 167,
        VK_OPEN_PAREN: 168,
        VK_CLOSE_PAREN: 169,
        VK_ASTERISK: 170,
        VK_PLUS: 171,
        VK_PIPE: 172,
        VK_HYPHEN_MINUS: 173,
        VK_OPEN_CURLY_BRACKET: 174,
        VK_CLOSE_CURLY_BRACKET: 175,
        VK_TILDE: 176,
        VK_COMMA: 188,
        VK_PERIOD: 190,
        VK_SLASH: 191,
        VK_BACK_QUOTE: 192,
        VK_OPEN_BRACKET: 219,
        VK_BACK_SLASH: 220,
        VK_CLOSE_BRACKET: 221,
        VK_QUOTE: 222,
        VK_META: 224,
        VK_ALTGR: 225,
        VK_WIN: 91,
        VK_KANA: 21,
        VK_HANGUL: 21,
        VK_EISU: 22,
        VK_JUNJA: 23,
        VK_FINAL: 24,
        VK_HANJA: 25,
        VK_KANJI: 25,
        VK_CONVERT: 28,
        VK_NONCONVERT: 29,
        VK_ACCEPT: 30,
        VK_MODECHANGE: 31,
        VK_SELECT: 41,
        VK_PRINT: 42,
        VK_EXECUTE: 43,
        VK_SLEEP: 95
    };

    /*
     * Queue, Scheduler and Engine, used to drive the game. Or something like that
     */
    var Queue = {
        init: function () {
            this.time = 0;
            this.events = [];
            this.eventTimes = [];
            return this;
        },
        clear: function () {
            this.events.length = 0;
            this.eventTimes.length = 0;
            return this;
        },
        addEvent: function (event, time) {
            var index = this.events.length, max = this.eventTimes.length;
            for (var i = 0; i < max; i++) {
                if (this.eventTimes[i] > time) {
                    index = i;
                    break;
                }
            }
            this.events.splice(index, 0, event);
            this.eventTimes.splice(index, 0, time);
            return this;
        },
        getNext: function () {
            if (this.events.length < 1) {
                return null;
            }
            var time = this.eventTimes.splice(0, 1)[0];
            if (time > 0) {
                this.time += time;
                var max = this.eventTimes.length;
                for (var i = 0; i < max; i++) {
                    this.eventTimes[i] -= time;
                }
            }
            return this.events.splice(0, 1)[0];
        },
        removeEvent: function (event) {
            var index = this.events.indexOf(event);
            if (index < 0) {
                return false;
            }
            this.events.splice(index, 1);
            this.eventTimes.splice(index, 1);
            return true;
        }
    };
    /**
     * @param {String} type "speed" or "action", according to the kind of scheduler you want
     */
    var Scheduler = {
        init: function (type) {
            this.type = type || false;
            this.queue = Object.create(Queue).init();
            this.actors = [];
            this.acting = null;
            this.defaultDuration = 1;
            this.duration = this.defaultDuration;
            return this;
        },
        getTime: function () {
            return this.queue.time;
        },
        addActor: function (item, repeat, time) {
            switch (this.type) {
                case "speed":
                    this.queue.addEvent(item, 1 / item.getSpeed());
                    break;
                case "action":
                    this.queue.addEvent(item, time || this.defaultDuration);
                    break;
            }
            if (repeat) {
                this.actors.push(item);
            }
            return this;
        },
        clear: function () {
            this.queue.clear();
            this.actors.length = 0;
            this.acting = null;
            this.duration = this.defaultDuration;
            return this;
        },
        removeActor: function (item) {
            if (this.type === "action" && item === this.acting) {
                this.duration = this.defaultDuration;
            }
            var result = this.queue.removeEvent(item);
            var index = this.actors.indexOf(item);
            if (index >= 0) {
                this.actors.splice(index, 1);
            }
            if (this.acting === item) {
                this.acting = null;
            }
            return result;
        },
        nextActor: function () {
            switch (this.type) {
                case "speed":
                    if (this.acting && this.actors.indexOf(this.acting) >= 0) {
                        this.queue.addEvent(this.acting, 1 / this.acting.getSpeed());
                    }
                    break;
                case "action":
                    if (this.acting && this.actors.indexOf(this.acting) >= 0) {
                        this.queue.addEvent(this.acting, this.duration || this.defaultDuration);
                        this.duration = this.defaultDuration;
                    }
                    break;
            }
            this.acting = this.queue.getNext();
            return this.acting;
        },
        setDuration: function (time) {
            if (this.type !== "action") {
                return this;
            }
            if (this.current) {
                this.duration = time;
            }
            return this;
        }
    };
    var Engine = {
        init: function (scheduler) {
            this.scheduler = scheduler || null;
            this.paused = true;
            return this;
        },
        start: function () {
            this.paused = false;
            this.run();
        },
        stop: function () {
            this.paused = true;
            this.run();
        },
        run: function () {
            if (this.paused) {
                return this;
            }
            while (!this.paused) {
                var actor = this.scheduler.nextActor();
                if (!actor) {
                    this.stop();
                    return this;
                }
                var result = actor.act();
            }
            return this;
        }
    };

    /*
     * Basic components: Face, Tile, Thing, Brain (for pseudo-AI purposes)
     */
    var Face = {
        init: function (properties) {
            properties = properties || {};
            this.ch = properties.ch || ' ';
            this.fg = properties.fg || 'white';
            this.bg = properties.bg || 'black';
            this.description = properties.description || '';
            return this;
        },
        getChar: function () {
            return this.ch;
        },
        getForeground: function () {
            return this.fg;
        },
        getBackground: function () {
            return this.bg;
        },
        getRepresentation: function (isCanvas) {
            if (isCanvas) {
                return "%c{%s}%b{%s}%s%c{white}%b{black}".format(this.getForeground(),
                this.getBackground(), this.getChar());
            }
            return strings.repre.format(this.getForeground(),
                this.getBackground(), this.getChar());
        },
        getDescription: function () {
            return this.description;
        }
    };
    var Tile = Object.create(Face);
    Tile.setup = function (properties) {
        properties = properties || {};
        this.init(properties);
        this.walkable = properties.walk || false;
        this.opaque = properties.opaque || false;
        this.damage = properties.damage || 0;
        this.dtype = properties.dtype || '';
        return this;
    };
    Tile.isWalkable = function (who) {
        if (who && who.type !== 'player') {
            return this.walkable && this.getDamage(who) < 1;
        }
        return this.walkable;
    };
    Tile.isOpaque = function () {
        return this.opaque;
    };
    Tile.getDamage = function (target) {
        if (this.damage === 0) {
            return 0;
        } else {
            return testVulnerability(target, this.damage, this.dtype)[0];
        }
    };
    var makeTile = function (options) {
        return Object.create(Tile).setup(options);
    };
    var Thing = Object.create(Face);
    Thing.setup = function (properties) {
        properties = properties || {};
        this.init(properties);
        this.name = properties.name || '';
        this.type = properties.type || '';
        this.impassable = properties.impass || false;
        this.invisible = properties.invisible || false;
        this.x = properties.x || 0;
        this.y = properties.y || 0;
        this.resistances = properties.resist || [];
        this.invulnerabilities = properties.invuln || [];
        this.vulnerable = properties.vuln || [];
        this.specialpowers = properties.specpow || [];
        this.addedMixins = [];
        this.addedMixinGroup = [];
        this.listeners = {};
        this.addedEffects = properties.effects || {};
        var mixins = properties.mixins || [];
        mixins.forEach(function (mix) {
            this.addMixin(mix, properties);
        }, this);
        return this;
    };
    Thing.getName = function (capitalize) {
        if (capitalize) {
            return this.name.capitalize();
        }
        return this.name;
    };
    Thing.rename = function (newname) {
        this.name = newname;
    };
    Thing.isAlive = function () {
        return this.hasMixin(Mixins.Living) && this.alive;
    };
    Thing.isInvisible = function (toWhom) {
        if (toWhom && toWhom.hasMixin(Mixins.Sight)) {
            return (this.invisible || this.hasEffect("invisible")) && !toWhom.canSeeInvisible();
        }
        return this.invisible || this.hasEffect("invisible");
    };
    Thing.getX = function () {
        return this.x;
    };
    Thing.getY = function () {
        return this.y;
    };
    Thing.getPosition = function () {
        return {
            x: this.getX(),
            y: this.getY()
        };
    };
    Thing.put = function (x, y) {
        this.x = x;
        this.y = y;
    };
    Thing.getResistances = function () {
        var res = this.resistances.slice(0);
        if (this.hasMixin(Mixins.Equipper)) {
            for (var i = 0; i < this.equipment.length; i++) {
                var temp = this.equipment[i];
                if (temp.hasMixin(Mixins.VulnerabilityChanger)) {
                    temp.newRes.forEach(function (a) {
                        if (res.indexOf(a) < 0) {
                            res.push(a);
                        }
                    });
                }
            }
        }
        return res;
    };
    Thing.isResistantTo = function (resist) {
        if (this.resistances.indexOf(resist) >= 0) {
            return true;
        }
        if (this.hasMixin(Mixins.Equipper)) {
            for (var i = 0; i < this.equipment.length; i++) {
                var temp = this.equipment[i];
                if (temp.hasMixin(Mixins.VulnerabilityChanger) && temp.newRes.indexOf(resist) >= 0) {
                    return true;
                }
            }
        }
        return false;
    };
    Thing.addResistance = function (resist) {
        if (!this.isResistantTo(resist)) {
            this.resistances.push(resist);
        }
    };
    Thing.removeResistance = function (resist) {
        this.resistances = this.resistances.filter(function (a) {
            return a !== resist;
        });
    };
    Thing.getInvulnerabilities = function () {
        var inv = this.invulnerabilities.slice(0);
        if (this.hasMixin(Mixins.Equipper)) {
            for (var i = 0; i < this.equipment.length; i++) {
                var temp = this.equipment[i];
                if (temp.hasMixin(Mixins.VulnerabilityChanger)) {
                    temp.newInvuln.forEach(function (a) {
                        if (inv.indexOf(a) < 0) {
                            inv.push(a);
                        }
                    });
                }
            }
        }
        return inv;
    };
    Thing.isInvulnerableTo = function (type) {
        if (this.invulnerabilities.indexOf(type) >= 0) {
            return true;
        }
        if (this.hasMixin(Mixins.Equipper)) {
            for (var i = 0; i < this.equipment.length; i++) {
                var temp = this.equipment[i];
                if (temp.hasMixin(Mixins.VulnerabilityChanger) && temp.newInvuln.indexOf(type) >= 0) {
                    return true;
                }
            }
        }
        return false;
    };
    Thing.addInvulnerability = function (type) {
        if (!this.isInvulnerableTo(type)) {
            this.invulnerabilities.push(type);
        }
    };
    Thing.removeInvulnerability = function (type) {
        this.invulnerabilities = this.invulnerabilities.filter(function (a) {
            return a !== type;
        });
    };
    Thing.getVulnerables = function () {
        var vuln = this.vulnerable.slice(0);
        if (this.hasMixin(Mixins.Equipper)) {
            for (var i = 0; i < this.equipment.length; i++) {
                var temp = this.equipment[i];
                if (temp.hasMixin(Mixins.VulnerabilityChanger)) {
                    temp.newVuln.forEach(function (a) {
                        if (vuln.indexOf(a) < 0) {
                            vuln.push(a);
                        }
                    });
                }
            }
        }
        return vuln;
    };
    Thing.isVulnerableTo = function (type) {
        if (this.vulnerable.indexOf(type) >= 0) {
            return true;
        }
        if (this.hasMixin(Mixins.Equipper)) {
            for (var i = 0; i < this.equipment.length; i++) {
                var temp = this.equipment[i];
                if (temp.hasMixin(Mixins.VulnerabilityChanger) && temp.newVuln.indexOf(type) >= 0) {
                    return true;
                }
            }
        }
        return false;
    };
    Thing.makeVulnerableTo = function (type) {
        if (!this.isVulnerableTo(type)) {
            this.vulnerable.push(type);
        }
    };
    Thing.removeVulnerableTo = function (type) {
        this.vulnerable = this.vulnerable.filter(function (a) {
            return a !== type;
        });
    };
    Thing.getSpecialPowers = function () {
        return this.specialpowers;
    };
    Thing.hasSpecialPower = function (which) {
        return this.specialpowers.indexOf(which) >= 0;
    };
    Thing.addSpecialPower = function (which) {
        if (!this.hasSpecialPower(which)) {
            this.specialpowers.push(which);
        }
    };
    Thing.removeSpecialPower = function (which) {
        this.specialpowers = this.specialpowers.filter(function (a) {
            return a !== which;
        });
    };
    Thing.hasMixin = function (obj) {
        var temp;
        if (typeof obj === 'object') {
            temp = obj.name;
        } else {
            temp = obj;
        }
        for (var i = 0, j = this.addedMixins.length; i < j; i++) {
            if (temp === this.addedMixins[i]) {
                return true;
            }
        }
        for (var i = 0, j = this.addedMixinGroup.length; i < j; i++) {
            if (temp === this.addedMixinGroup[i]) {
                return true;
            }
        }
        return false;
    };
    Thing.addMixin = function (what, properties) {
        properties = properties || {};
        if (typeof what === 'object') {
            what = what.name;
        }
        if (this.hasMixin(what)) {
            return;
        }
        this.addedMixins.push(what);
        if (Mixins[what].groupName) {
            this.addedMixinGroup.push(Mixins[what].groupName);
        }
        for (var key in Mixins[what]) {
            if (key !== 'init' && key !== 'name' && key !== 'groupName' &&
                    key !== 'listeners' && !this.hasOwnProperty(key)) {
                this[key] = Mixins[what][key];
            }
        }
        if (Mixins[what].listeners) {
            for (var key in Mixins[what].listeners) {
                if (!this.listeners[key]) {
                    this.listeners[key] = [];
                }
                this.listeners[key].push(Mixins[what].listeners[key]);
            }
        }
        if (Mixins[what].init) {
            Mixins[what].init.call(this, properties);
        }
    };
    Thing.raiseEvent = function (event) {
        if (!this.listeners[event]) {
            return;
        }
        var args = Array.prototype.slice.call(arguments, 1);
        var results = [];
        for (var i = 0, j = this.listeners[event].length; i < j; i++) {
            results.push(this.listeners[event][i].apply(this, args));
        }
        return results;
    };
    Thing.getEffect = function (which) {
        return this.addedEffects[which];
    };
    Thing.getEffects = function () {
        return this.addedEffects;
    };
    Thing.hasEffect = function (obj) {
        if (typeof obj === 'object') {
            return this.addedEffects[obj.name];
        } else {
            return this.addedEffects[obj];
        }
    };
    Thing.addEffect = function (effect) {
        if (!this.hasEffect(effect)) {
            this.addedEffects[effect.name] = effect;
            return true;
        } else {
            this.addedEffects[effect.name].duration += effect.duration;
        }
        return false;
    };
    Thing.removeEffect = function (effect) {
        if (this.hasEffect(effect)) {
            delete this.addedEffects[effect];
            return true;
        }
        return false;
    };
    Thing.applyEffects = function () {
        for (var key in this.addedEffects) {
            var temp = this.addedEffects[key];
            if (Effects[temp.name] && temp.active) {
                Effects[temp.name](temp, this);
            }
            if (temp.duration === 0 && !temp.active) {
                this.removeEffect(temp);
            }
        }
        if (this.hasMixin(Mixins.InventoryHolder)) {
            var items = getEverything(this);
            for (var i = 0; i < items.length; i++) {
                items[i].applyEffects();
            }
        }
    };
    Thing.describeA = function (capitalize) {
        var prefixes = capitalize ? ['A', 'An'] : ['a', 'an'];
        var string = this.getName();
        var firstLetter = string.charAt(0).toLowerCase();
        var prefix = 'aeiou'.indexOf(firstLetter) >= 0 ? 1 : 0;
        return prefixes[prefix] + ' ' + string;
    };
    Thing.describeThe = function (capitalize) {
        var prefix = capitalize ? 'The' : 'the';
        return prefix + ' ' + this.getName();
    };
    Thing.save = function () {
        var that = this;
        var temp = {
            name: that.name,
            type: that.type,
            ch: that.ch,
            fg: that.fg,
            bg: that.bg,
            x: that.x,
            y: that.y,
            description: that.description,
            impass: that.impassable,
            invisible: that.invisible,
            mixins: that.addedMixins,
            effects: that.addedEffects,
            resist: that.resistances,
            invuln: that.invulnerabilities,
            vuln: that.vulnerable,
            specpow: that.specialpowers
        };
        this.raiseEvent('onSave', temp);
        return temp;
    };
    Thing.restore = function (world, noSchedule) {
        world.addThing(this, this.getPosition(), noSchedule);
    };
    var makeThing = function (options) {
        return Object.create(Thing).setup(options);
    };
    var Brain = {
        init: function (properties) {
            properties = properties || {};
            this.angry = properties.angry || false;
            this.scared = properties.scared || false;
            this.enemy = properties.enemy || null;
            return this;
        },
        canAct: function (who) {
            return !who.hasEffect('sleep') && !who.hasEffect('paralysis') && player.isAlive();
        },
        canMove: function (who) {
            return who.hasMixin(Mixins.Mobile);
        },
        isNear: function (who, target) {
            return Math.abs(who.x - target.x) === 1 && Math.abs(who.y - target.y) === 1;
        },
        goToward: function (who, target) {
            var dx = target.x - who.x;
            var dy = target.y - who.y;
            if (dx < 0) {
                if (dy < 0) {
                    return dir.NW;
                }
                else if (dy > 0) {
                    return dir.SW;
                }
                else {
                    return dir.W;
                }
            }
            else if (dx > 0) {
                if (dy < 0) {
                    return dir.NE;
                }
                else if (dy > 0) {
                    return dir.SE;
                }
                else {
                    return dir.E;
                }
            }
            else {
                if (dy < 0) {
                    return dir.N
                }
                else if (dy > 0) {
                    return dir.S;
                }
                else {
                    return [0, 0];
                }
            }
        },
        walkRandom: function (who, world) {
            if (!this.canMove(who)) {
                return;
            }
            var direc = dir.all.random();
            return tryMove(who, direc, world);
        },
        tryEquip: function (who) {
            if (who.hasMixin(Mixins.Equipper) && who.hasMixin(Mixins.InventoryHolder)) {
                var items = who.getItems();
                for (var i = 0, j = items.length; i < j; i++) {
                    var item = items[i];
                    if (item) {
                        if (item.hasMixin(Mixins.Shootable) && who.hasMixin(Mixins.Shooter)) {
                            return who.reload(item);
                        } else if (item.hasMixin(Mixins.Equippable)) {
                            if (!item.isShooting()) {
                                return who.equip(item);
                            } else if (who.hasMixin(Mixins.Shooter)) {
                                return who.wieldRanged(item);
                            }
                        }
                    }
                }
            } else {
                return false;
            }
        },
        pickupItem: function (who, world) {
            var mapItems = world.getItemsAt(who.getX(), who.getY());
            if (who.addItem(mapItems[0])) {
                mapItems.shift();
                world.setItemsAt(mapItems, who.getX(), who.getY());
                return true;
            }
            return false;
        },
        tryPickup: function (who, world) {
            if (who.hasMixin(Mixins.InventoryHolder) && who.canPickup(world)) {
                return this.pickupItem(who, world);
            } else {
                return false;
            }
        },
        chase: function (hunter, world, prey) {
            if (!this.canMove(hunter)) {
                return;
            }
            prey = prey || this.enemy;
            var target = world.getEntityAt(prey.x, prey.y);
            var offsets = Math.abs(prey.x - hunter.getX()) + Math.abs(prey.y - hunter.getY());
            if (offsets === 1) {
                if (target && target.type === "player") {
                    attack(hunter, target);
                    return;
                }
            }
            var path = new ROT.Path.AStar(prey.x, prey.y, function (x, y) {
                var entity = world.getEntityAt(x, y);
                if (entity && entity !== target && entity !== hunter) {
                    return false;
                }
                return world.getTile(x, y).isWalkable();
            }, { topology: 8 });
            var way = [];
            path.compute(hunter.x, hunter.y, function (x, y) {
                way.push([x - hunter.x, y - hunter.y])
            });
            if (way.length > 1) {
                tryMove(hunter, way[1], world);
            } else if (target) {
                tryMove(hunter, this.goToward(hunter, target), world);
            } else {
                this.walkRandom(hunter, world);
            }
            if (hunter.getX() === this.enemy.x && this.enemy.y === hunter.getY()) {
                this.enemy = false;
            }
        },
        beCalm: function (who, world) {
            if (!this.tryEquip(who) && !this.tryPickup(who, world)) {
                this.walkRandom(who, world);
            }
        },
        beConfused: function (who, world) {
            this.walkRandom(who, world);
        },
        beAngry: function (who, target, world) {
            who.look(world);
            if (who.canSee(target)) {
                this.enemy = target.getPosition();
                if (this.isNear(who, target)) {
                    attack(who, target);
                } else {
                    this.chase(who, world, target);
                }
            } else if (this.enemy) {
                this.chase(who, world);
            } else {
                this.beCalm(who, world);
            }
        },
        beMage: function (who, target, world) {
            who.look(world);
            if (who.canSee(target)) {
                this.enemy = target.getPosition();
                if (ROT.RNG.getPercentage() % 3) {
                    if (ROT.RNG.getPercentage() % 2 === 0) {
                        castSpell(who, who.offspell.random(), target);
                    } else {
                        castSpell(who, who.defspell.random(), who);
                    }
                } else if (this.isNear(who, target)) {
                    attack(who, target);
                } else if (ROT.RNG.getPercentage() < 20) {
                    this.walkRandom(who, world);
                } else {
                    this.chase(who, world, target);
                }
            } else {
                this.beCalm(who, world);
            }
        },
        beShaman: function (who, target, world) {
            who.look(world);
            if (who.canSee(target)) {
                this.enemy = target.getPosition();
                if (who.hp < who.maxhp / 2) {
                    castPrayer(who, who.defspell.random(), who);
                } else if (ROT.RNG.getPercentage() % 3) {
                    if (ROT.RNG.getPercentage() < 40) {
                        castPrayer(who, who.defspell.random(), who);
                    } else {
                        castPrayer(who, who.offspell.random(), target);
                    }
                } else if (this.isNear(who, target)) {
                    attack(who, target);
                } else if (ROT.RNG.getPercentage() < 20) {
                    this.walkRandom(who, world);
                } else {
                    this.chase(who, world, target);
                }
            } else {
                this.beCalm(who, world);
            }
        },
        beShooter: function (who, target, world) {
            who.look(world);
            if (who.canSee(target)) {
                this.enemy = target.getPosition();
                if (this.isNear(who, target)) {
                    attack(who, target);
                } else if (who.canShoot() && ROT.RNG.getPercentage() % 3) {
                    shoot(who, target);
                } else if (!who.ammo || who.getAmmos() < 1) {
                    if (!this.tryEquip(who)) {
                        if (ROT.RNG.getPercentage() < 20) {
                            this.walkRandom(who, world);
                        } else {
                            this.chase(who, world, target);
                        }
                    }
                } else {
                    this.chase(who, world, target);
                }
            } else {
                this.beCalm(who, world);
            }
        },
        beSummoner: function (who, target, world) {
            who.look(world);
            if (who.canSee(target)) {
                this.enemy = target.getPosition();
                if (ROT.RNG.getPercentage() % 4 && who.canSummon(world)) {
                    summon(who, world);
                } else if (this.isNear(who, target)) {
                    attack(who, target);
                } else if (ROT.RNG.getPercentage() < 20) {
                    this.walkRandom(who, world);
                } else {
                    this.chase(who, world, target);
                }
            } else if (this.enemy) {
                this.chase(who, world, target);
            } else {
                this.beCalm(who, world);
            }
        },
        save: function (where) {
            var that = this;
            var temp = {
                angry: that.angry,
                scared: that.scared,
                enemy: that.enemy
            };
            return temp;
        }
    };
    var makeBrain = function (properties) {
        return Object.create(Brain).init(properties);
    };

    /*
     * Mixins
     */
    var Mixins = Object.create(null);
    Mixins.PlayerActor = {
        name: 'PlayerActor',
        groupName: 'Actor',
        acting: false,
        init: function (template) {
            this.plclass = template.plclass || 'none';
        },
        act: function () {
            if (this.acting) {
                return;
            }
            if (this.isAlive() && (this.hasEffect("sleep") || this.hasEffect("paralysis"))) {
                drawScreen();
                clearMessages();
                return;
            }
            this.acting = true;
            if (!this.isAlive()) {
                sendMessage(strings.death);
            }
            Engine.stop();
            drawScreen();
            this.acting = false;
        },
        listeners: {
            onSave: function (where) {
                where.plclass = this.plclass;
            },
            onLevelUp: function () {
                var amount = ROT.RNG.getUniformInt(2, 8);
                this.basehp += amount;
                this.maxhp += amount;
                this.hp += amount;
                if (this.level % 3 === 0 || this.level === 50) {
                    doLevelup();
                }
                this.recalculateHP(true);
            }
        }
    };
    Mixins.BaseActor = {
        name: 'BaseActor',
        groupName: 'Actor',
        init: function (template) {
            this.brain = makeBrain(template.brain || {});
            this.challenge = template.challenge || 1;
        },
        act: function () {
            if (this.brain.canAct(this)) {
                if (this.hasEffect("confusion")) {
                    this.brain.beConfused(this, World);
                } else if (this.brain.angry) {
                    this.brain.beAngry(this, player, World);
                } else {
                    this.brain.beCalm(this, World);
                }
            }
            this.applyEffects();
            this.raiseEvent('onEnd');
        },
        listeners: {
            onSave: function (where) {
                where.brain = this.brain.save();
                where.challenge = this.challenge;
            }
        }
    };
    Mixins.AggressiveActor = {
        name: 'AggressiveActor',
        groupName: 'Actor',
        init: function (template) {
            this.brain = makeBrain(template.brain || { angry: true });
            this.challenge = template.challenge || 1;
        },
        act: function () {
            if (this.brain.canAct(this)) {
                if (this.hasEffect("confusion")) {
                    this.brain.beConfused(this, World);
                } else if (this.brain.angry) {
                    this.brain.beAngry(this, player, World);
                } else {
                    this.brain.beCalm(this, World);
                }
            }
            this.applyEffects();
            this.raiseEvent('onEnd');
        },
        listeners: {
            onSave: function (where) {
                where.brain = this.brain.save();
                where.challenge = this.challenge;
            }
        }
    };
    Mixins.ShamanActor = {
        name: 'ShamanActor',
        groupName: 'Actor',
        init: function (template) {
            this.brain = makeBrain(template.brain || { angry: true });
            this.challenge = template.challenge || 1;
            this.offspell = template.offsp || [];
            this.defspell = template.defsp || [];
        },
        act: function () {
            if (this.brain.canAct(this)) {
                if (this.hasEffect("confusion")) {
                    this.brain.beConfused(this, World);
                } else if (this.brain.angry) {
                    this.brain.beShaman(this, player, World);
                } else {
                    this.brain.beCalm(this, World);
                }
            }
            this.applyEffects();
            this.raiseEvent('onEnd');
        },
        listeners: {
            onSave: function (where) {
                where.brain = this.brain.save();
                where.challenge = this.challenge;
                where.offsp = this.offspell;
                where.defsp = this.defspell;
            }
        }
    };
    Mixins.ShooterActor = {
        name: 'ShooterActor',
        groupName: 'Actor',
        init: function (template) {
            this.brain = makeBrain(template.brain || { angry: true });
            this.challenge = template.challenge || 1;
        },
        act: function () {
            if (this.brain.canAct(this)) {
                if (this.hasEffect("confusion")) {
                    this.brain.beConfused(this, World);
                } else if (this.brain.angry) {
                    this.brain.beShooter(this, player, World);
                } else {
                    this.brain.beCalm(this, World);
                }
            }
            this.applyEffects();
            this.raiseEvent('onEnd');
        },
        listeners: {
            onSave: function (where) {
                where.brain = this.brain.save();
                where.challenge = this.challenge;
            }
        }
    };
    Mixins.SpellcasterActor = {
        name: 'SpellcasterActor',
        groupName: 'Actor',
        init: function (template) {
            this.brain = makeBrain(template.brain || { angry: true });
            this.challenge = template.challenge || 1;
            this.offspell = template.offsp || [];
            this.defspell = template.defsp || [];
        },
        act: function () {
            if (this.brain.canAct(this)) {
                if (this.hasEffect("confusion")) {
                    this.brain.beConfused(this, World);
                } else if (this.brain.angry) {
                    this.brain.beMage(this, player, World);
                } else {
                    this.brain.beCalm(this, World);
                }
            }
            this.applyEffects();
            this.raiseEvent('onEnd');
        },
        listeners: {
            onSave: function (where) {
                where.brain = this.brain.save();
                where.challenge = this.challenge;
                where.offsp = this.offspell;
                where.defsp = this.defspell;
            }
        }
    };
    Mixins.SummonerActor = {
        name: 'SummonerActor',
        groupName: 'Actor',
        init: function (template) {
            this.brain = makeBrain(template.brain || { angry: true });
            this.challenge = template.challenge || 1;
        },
        act: function () {
            if (this.brain.canAct(this)) {
                if (this.hasEffect("confusion")) {
                    this.brain.beConfused(this, World);
                } else if (this.brain.angry) {
                    this.brain.beSummoner(this, player, World);
                } else {
                    this.brain.beCalm(this, World);
                }
            }
            this.applyEffects();
            this.raiseEvent('onEnd');
        },
        listeners: {
            onSave: function (where) {
                where.brain = this.brain.save();
                where.challenge = this.challenge;
                where.offsp = this.offspell;
                where.defsp = this.defspell;
            }
        }
    };
    Mixins.Aimable = {
        name: 'Aimable',
        init: function (template) {
            this.charges = template.charges || 0;
            this.radius = template.radius || 0;
            this.powerStrength = template.powstr || 0;
        },
        getName: function (capitalize) {
            if (capitalize) {
                return this.name.capitalize() + " (%s)".format(this.charges);
            }
            return this.name + " (%s)".format(this.charges);
        },
        recharge: function (howmuch) {
            this.charges += howmuch;
        },
        listeners: {
            onSave: function (where) {
                where.charges = this.charges;
                where.radius = this.radius;
                where.powstr = this.powerStrength;
            }
        }
    };
    Mixins.BaseAttacker = {
        name: 'BaseAttacker',
        groupName: 'Attacker',
        init: function (template) {
            this.diceNumber = template.dam1 || 1;
            this.diceFaces = template.dam2 || 2;
            this.damageType = template.damtype || false;
            if (template.extradamt) {
                this.extraDamageType = template.extradamt;
            }
            this.damageBonus = template.dambon || 0;
            this.attackPerRound = template.apr || 1;
            this.attackBonus = template.attbon || 0;
        },
        getAttackValue: function () {
            var bonus = this.getBonus(this.strength) + this.attackBonus;
            if (this.hasMixin(Mixins.Equipper)) {
                bonus += this.getEquipmentBonus('att');
            }
            return bonus;
        },
        getDamageType: function () {
            if (this.hasMixin(Mixins.Equipper) && this.getHand1()) {
                return this.getHand1().damageType;
            }
            return this.damageType;
        },
        getDamage: function () {
            if (this.hasMixin(Mixins.Equipper) && this.getHand1()) {
                return this.getEquipmentBonus('dam') + this.damageBonus + getBonus(this.strength);
            } else {
                return ROT.RNG.getUniformInt(this.diceNumber, (this.diceNumber * this.diceFaces)) + this.damageBonus;
            }
        },
        listeners: {
            onHit: function (target, damage, isPlayer) {
                if (this.extraDamageType) {
                    for (var i = 0, j = this.extraDamageType.length; i < j; i++) {
                        if (!target.isAlive()) {
                            return;
                        }
                        var result = testVulnerability(target, damage, this.extraDamageType[i], true);
                        if (isPlayer && result[1]) {
                            sendMessage(result[1]);
                        }
                        target.changeHealth(-result[0]);
                    }
                }
            },
            onKill: function (victim) {
                var mex = '';
                if (victim.type === 'player') {
                    if (this.type === 'player') {
                        mex = "You killed yourself...";
                        necro = strings.dundeath.format(player.getName(), player.plclass, World.lvl,
                            World.name) + strings.isdead.format("a deplorable mistake");
                    } else {
                        mex = "%s kills you.".format(this.describeThe(true));
                        necro = strings.dundeath.format(player.getName(), player.plclass, World.lvl,
                            World.name) + strings.isdead.format(this.describeA());
                    }
                } else if (this.type === 'player') {
                    mex = strings.kill.format(this.canSee(victim) ? victim.describeThe() : 'something');
                }
                sendMessage(mex);
            },
            onSave: function (where) {
                where.dam1 = this.diceNumber;
                where.dam2 = this.diceFaces;
                where.damtype = this.damageType;
                if (this.extraDamageType) {
                    where.extradamt = this.extraDamageType;
                }
                where.dambon = this.damageBonus;
                where.apr = this.attackPerRound;
                where.attbon = this.attackBonus;
            }
        }
    };
    Mixins.Boss = {
        name: "Boss",
        listeners: {
            onDeath: function (World) {
                savedGame[World.name] = true;
                if (World.name === "Avernus") {
                    sendMessage("<span class='green'>The final boss is defeated: you have won!</span> Now you can quit the game at any time as a winner by pressing CTRL + Q or via the menu.");
                }
            }
        }
    }
    Mixins.Butcherable = {
        name: 'Butcherable',
        init: function (template) {
            this.butchered = template.butch || false;
        },
        listeners: {
            onSave: function (where) {
                where.butch = this.butchered;
            }
        }
    };
    Mixins.Cookable = {
        name: 'Cookable',
        init: function (template) {
            this.cooked = template.cooked || false;
        },
        listeners: {
            onSave: function (where) {
                where.cooked = this.cooked;
            }
        }
    };
    Mixins.CorpseDropper = {
        name: 'CorpseDropper',
        init: function (template) {
            this.dropChances = template.dropch || 33;
            this.weight = template.weight || 1;
            this.energy = template.energy || 100;
            this.corpseEffect = template.corpseff || false;
            this.corpseEffectStrength = template.corpefst || 0;
        },
        makeCorpse: function () {
            var that = this;
            var temp = {
                name: that.name + ' corpse',
                plural: that.name + ' corpses',
                ch: '%',
                fg: that.fg,
                energy: that.energy,
                portions: that.weight,
                power: that.corpseEffect,
                powstr: that.corpseEffectStrength,
                description: "The rotting corpse of a " + that.name + ". How yummy...",
                resist: [damages.fire, damages.electro, damages.cold],
                mixins: [Mixins.Item, Mixins.Eatable, Mixins.Cookable, Mixins.Butcherable],
                type: that.name + ' cr'
            };
            return makeThing(temp);
        },
        listeners: {
            onDeath: function (world) {
                if (ROT.RNG.getPercentage() <= this.dropChances) {
                    world.addItem(this.makeCorpse(), this.getPosition());
                }
            },
            onSave: function (where) {
                where.dropch = this.dropChances;
                where.weight = this.weight;
                where.energy = this.energy;
                where.corpseff = this.corpseEffect;
                where.corpefst = this.corpseEffectStrength;
            }
        }
    };
    Mixins.DataChanger = {
        name: 'DataChanger',
        init: function (template) {
            this.changes = template.changes || {};
        },
        listeners: {
            onPut: function (whence) {
                for (var key in this.changes) {
                    if (this.changes.hasOwnProperty(key) && whence[key]) {
                        whence[key] += this.changes[key];
                        if (key === 'constitution') {
                            whence.recalculateHP(true);
                        }
                    }
                }
            },
            onRemove: function (whence) {
                for (var key in this.changes) {
                    if (this.changes.hasOwnProperty(key) && whence[key]) {
                        whence[key] -= this.changes[key];
                        if (key === 'constitution') {
                            whence.recalculateHP(true);
                        }
                    }
                }
            },
            onSave: function (where) {
                where.changes = this.changes;
            }
        }
    };
    Mixins.Drinkable = {
        name: 'Drinkable',
        init: function (template) {
            this.powerStrength = template.powstr || 1;
            this.doses = template.doses || 1;
            this.makeVulnerableTo(damages.sound);
        },
        listeners: {
            onSave: function (where) {
                where.powstr = this.powerStrength;
                where.doses = this.doses;
            }
        }
    };
    Mixins.Eatable = {
        name: 'Eatable',
        init: function (template) {
            this.powerStrength = template.powstr || 0;
            this.portions = template.portions || 1;
            this.energy = template.energy || 200;
            this.addInvulnerability(damages.sound);
            this.addInvulnerability(damages.rust);
        },
        getName: function (capitalize) {
            if (this.portions > 1) {
                if (capitalize) {
                    return this.name.capitalize() + " (%s)".format(this.portions);
                }
                return this.name + " (%s)".format(this.portions);
            }
            if (capitalize) {
                return this.name.capitalize();
            }
            return this.name;
        },
        listeners: {
            onSave: function (where) {
                where.powstr = this.powerStrength;
                where.portions = this.portions;
                where.energy = this.energy;
            }
        }
    };
    Mixins.Eater = {
        name: 'Eater',
        init: function (template) {
            this.energy = template.energy || 1000;
        },
        setEnergy: function (change) {
            this.energy += change;
            if (this.energy < 100 && !this.hasEffect("starving")) {
                this.addEffect({
                    name: "starving",
                    active: true
                });
            } else if (this.energy >= 100 && this.hasEffect("starving")) {
                this.removeEffect("starving");
            } else if (this.energy < 500 && !this.hasEffect("hungry")) {
                this.addEffect({
                    name: "hungry",
                    active: true
                });
            } else if (this.energy >= 500 && this.hasEffect("hungry")) {
                this.removeEffect("hungry");
            } else if (this.energy >= 3000 && !this.hasEffect("full")) {
                this.addEffect({
                    name: "full",
                    active: true
                });
            } else if (this.energy < 3000 && this.hasEffect("full")) {
                this.removeEffect("full");
            } else if (this.energy > 4000 && !this.hasEffect("bursting")) {
                this.addEffect({
                    name: "bursting",
                    active: true
                });
            } else if (this.energy < 4000 && this.hasEffect("bursting")) {
                this.removeEffect("bursting");
            }
        },
        listeners: {
            onSave: function (where) {
                where.energy = this.energy;
            }
        }
    };
    Mixins.Enchanted = {
        name: 'Enchanted',
        init: function (template) {
            if (this.extraDamageType) {
                this.extraDamageType.push(template.extradamt);
            } else {
                this.extraDamageType = template.extradamt || [];
            }
        },
        listeners: {
            onHit: function (target, damage, isPlayer) {
                for (var i = 0, j = this.extraDamageType.length; i < j; i++) {
                    if (!target.isAlive()) {
                        return;
                    }
                    var result = testVulnerability(target, damage, this.extraDamageType[i]);
                    if (isPlayer && result[1]) {
                        sendMessage(result[1]);
                    }
                    target.changeHealth(-result[0]);
                }
            },
            onSave: function (where) {
                if (!where.extradamt) {
                    where.extradamt = this.extraDamageType;
                }
            }
        }
    };
    Mixins.Equippable = {
        name: 'Equippable',
        init: function (template) {
            this.attackValue = template.attVal || 0;
            this.defenceValue = template.defVal || 0;
            this.dam1 = template.dam1 || 0;
            if (template.dam2) {
                this.dam2 = template.dam2;
            }
            if (template.bonus) {
                this.bonus = template.bonus;
            }
            this.critical = template.crit || 2;
            this.hindrance = template.hind || 0;
            this.part = template.part || '';
            this.shooting = template.shot || false;
            this.twohands = template.twohands || false;
            if (template.part === parts.hand1) {
                this.damageType = template.damtype || false;
                this.extraDamageType = template.extradamt || [];
            }
            this.wearable = template.wearable || false;
        },
        getAttackValue: function () {
            return this.attackValue;
        },
        getDefenceValue: function () {
            return this.defenceValue;
        },
        getDamage: function () {
            if (this.dam2) {
                var temp = ROT.RNG.getUniformInt(this.dam1, (this.dam1 * this.dam2));
                if (this.bonus) {
                    temp += this.bonus;
                }
                return temp;
            }
            return this.dam1;
        },
        getPart: function () {
            return this.part;
        },
        isShooting: function () {
            return this.shooting;
        },
        isTwohands: function () {
            return this.twohands;
        },
        listeners: {
            onHit: function (target, damage, wielder) {
                if (this.part === parts.hand1) {
                    for (var i = 0, j = this.extraDamageType.length; i < j; i++) {
                        if (!target.isAlive()) {
                            return;
                        }
                        var result = testVulnerability(target, damage, this.extraDamageType[i], true);
                        if (wielder.type === 'player' && result[1]) {
                            sendMessage(result[1]);
                        }
                        target.changeHealth(-result[0]);
                    }
                }
            },
            onSave: function (where) {
                where.attVal = this.attackValue;
                where.defVal = this.defenceValue;
                where.dam1 = this.dam1;
                if (this.dam2) {
                    where.dam2 = this.dam2;
                }
                if (this.bonus) {
                    where.bonus = this.bonus;
                }
                where.crit = this.critical;
                where.hind = this.hindrance;
                where.part = this.part;
                where.shot = this.shooting;
                where.twohands = this.twohands;
                if (this.damageType) {
                    where.damtype = this.damageType;
                    where.extradamt = this.extraDamageType;
                }
                where.wearable = this.wearable;
            },
            onTouch: function (user, damage) {
                if (this.isInvulnerableTo(damage) ||
                    (this.isResistantTo(damage) && ROT.RNG.getPercentage() <= 80) ||
                    (!this.isVulnerableTo(damage) && ROT.RNG.getPercentage() <= 25)) {
                    if (user.type === 'player') {
                        sendMessage("Your %s resists.".format(this.getName()));
                    }
                } else {
                    if (user.type === 'player') {
                        sendMessage("Your %s disintegrates.".format(this.getName()));
                    } else if (player.canSee(user)) {
                        sendMessage("%s disintegrates.".format(this.describeThe(true)));
                    }
                    user.removeFromEquipment(this);
                }
            }
        }
    };
    Mixins.Equipper = {
        name: 'Equipper',
        init: function (template) {
            this.equipment = [];
            if (template.equipment) {
                template.equipment.forEach(function (a) {
                    this.equipment.push(makeThing(a));
                }, this);
            }
        },
        getHand1: function () {
            return this.getPart(parts.hand1);
        },
        getHand2: function () {
            return this.getPart(parts.hand2);
        },
        getBody: function () {
            return this.getPart(parts.body);
        },
        getPart: function (what) {
            for (var i = 0, j = this.equipment.length; i < j; i++) {
                var t = this.equipment[i];
                if (t.part === what) {
                    return t;
                }
            }
            return false;
        },
        addToEquipment: function (item) {
            this.equipment.push(item);
        },
        removeFromEquipment: function (item) {
            this.equipment = this.equipment.filter(function (a) {
                return a !== item;
            });
        },
        getEquipmentBonus: function (type) {
            var bonus = 0;
            if (type === 'att') {
                this.equipment.forEach(function (a) {
                    bonus += a.getAttackValue();
                });
            } else if (type === 'def') {
                this.equipment.forEach(function (a) {
                    bonus += a.getDefenceValue();
                });
            } else if (type === 'dam') {
                this.equipment.forEach(function (a) {
                    bonus += a.getDamage();
                });
            } else if (type === 'hind') {
                this.equipment.forEach(function (a) {
                    bonus += a.hindrance;
                });
            }
            return bonus;
        },
        unequip: function (item) {
            this.removeFromEquipment(item);
            item.raiseEvent('onRemove', this);
            if (this.hasMixin(Mixins.InventoryHolder)) {
                if (this.canAddItem()) {
                    this.addItem(item);
                } else {
                    this.dropSingleItem(item, World);
                }
            } else {
                World.addItem(item, this.getPosition());
            }
        },
        equip: function (item) {
            var where = item.getPart();
            if (where === parts.hand2 && this.getHand1() && this.getHand1().isTwohands()) {
                if (this.type === 'player') {
                    sendMessage("You can't hold %s: both your hands are already full with %s.".format(item.describeA(),
                        this.getHand1().describeA()));
                }
                return false;
            }
            if (where === parts.hand1 && item.isTwohands() && this.getHand2()) {
                if (this.type === 'player') {
                    sendMessage("You must remove your %s first: %s is a two-handed weapon.".format(this.getHand2().getName(),
                        item.describeThe()));
                }
                return false;
            }
            var t = this.getPart(where);
            if (t) {
                this.unequip(t);
            }
            if (this.hasMixin(Mixins.InventoryHolder)) {
                this.removeSingleItem(item);
                item = makeThing(item.save());
                item.number = 1;
            }
            this.addToEquipment(item);
            item.raiseEvent('onPut', this);
            return true;
        },
        listeners: {
            onContact: function (touched, damage, damagetype, isAttacking) {
                if (isAttacking) {
                    if (this.getHand1()) {
                        this.getHand1().raiseEvent('onTouch', this, damagetype);
                    } else {
                        damage = testVulnerability(this, damage, damagetype, true);
                        if (damage[0]) {
                            this.changeHealth(-damage[0]);
                            if (!this.isAlive()) {
                                touched.raiseEvent('onKill', this);
                            }
                        }
                    }
                } else {
                    if (this.getBody()) {
                        this.getBody().raiseEvent('onTouch', this, damagetype);
                    } else {
                        damage = testVulnerability(this, damage, damagetype, true);
                        if (damage[0]) {
                            this.changeHealth(-damage[0]);
                            if (!this.isAlive()) {
                                touched.raiseEvent('onKill', this);
                            }
                        }
                    }
                }
            },
            onDeath: function () {
                var where = this.getPosition();
                this.equipment.forEach(function (a) {
                    World.addItem(a, where);
                });
            },
            onSave: function (where) {
                where.equipment = [];
                if (this.equipment.length > 0) {
                    this.equipment.forEach(function (a) {
                        where.equipment.push(a.save());
                    });
                }
            }
        }
    };
    Mixins.HurtingSkin = {
        name: 'HurtingSkin',
        init: function (template) {
            this.touchdamage = template.touchdam || false;
            this.addInvulnerability(template.touchdam);
        },
        listeners: {
            onHit: function (target, damage) {
                if (this.hasMixin(Mixins.Equipper) && this.getHand1()) {
                    return false;
                }
                if (target.hasMixin(Mixins.Equipper)) {
                    target.raiseEvent('onContact', this, damage, this.touchdamage, false);
                    return;
                }
                damage = testVulnerability(target, damage, this.touchdamage, true);
                target.changeHealth(-damage[0]);
                if (damage[1] && (this.type === 'player' || target.type === 'player')) {
                    sendMessage(damage[1]);
                }
            },
            onSave: function (where) {
                where.touchdam = this.touchdamage;
            },
            onTouched: function (toucher, damage) {
                if (toucher.hasMixin(Mixins.Equipper) && toucher.getHand1()) {
                    toucher.getHand1().raiseEvent('onTouch', toucher, this.touchdamage);
                } else {
                    var damage = testVulnerability(toucher, damage, this.touchdamage, true);
                    toucher.changeHealth(-damage[0]);
                    if (damage[1] && (this.type === 'player' || toucher.type === 'player')) {
                        sendMessage(damage[1]);
                    }
                    if (!toucher.isAlive()) {
                        this.raiseEvent('onKill', toucher);
                    }
                }
            }
        }
    };
    Mixins.InventoryHolder = {
        name: 'InventoryHolder',
        init: function (template) {
            this.inventorySlots = template.inventory || 15;
            this.items = [];
            if (template.items) {
                for (var i = 0, j = template.items.length; i < j; i++) {
                    this.items[i] = makeThing(template.items[i]);
                }
            }
        },
        hasItems: function () {
            return this.items.length > 0;
        },
        getItems: function () {
            return this.items;
        },
        getItem: function (item) {
            for (var i = 0, j = this.items.length; i < j; i++) {
                if (this.items[i] === item) {
                    return this.items[i];
                }
            }
            return false;
        },
        addItem: function (item) {
            var temp;
            for (var i = 0, j = this.items.length; i < j; i++) {
                temp = this.items[i];
                if (!temp.hasMixin(Mixins.Aimable) && temp.isEqual(item)) {
                    this.items[i].stack(item);
                    return true;
                }
            }
            if (this.canAddItem()) {
                this.items.push(item);
                return true;
            } else {
                return false;
            }
        },
        removeSingleItem: function (item) {
            if (item.number > 1) {
                item.number--;
            } else {
                this.removeItem(item);
            }
        },
        removeItem: function (item) {
            this.items = this.items.filter(function (a) {
                return a !== item;
            });
        },
        canAddItem: function () {
            return this.items.length < this.inventorySlots;
        },
        canPickup: function (world) {
            var items = world.getItemsAt(this.getX(), this.getY());
            return items && items.length;
        },
        dropItem: function (item, world) {
            world.addItem(item, this.getPosition());
            this.removeItem(item);
        },
        dropEverything: function (world) {
            for (var i = 0, j = this.items.length; i < j; i++) {
                world.addItem(this.items[i], this.getPosition());
            }
            this.items = [];
        },
        listeners: {
            onDeath: function (world) {
                this.dropEverything(world);
            },
            onSave: function (where) {
                where.inventory = this.inventorySlots;
                where.items = [];
                for (var i = 0, j = this.items.length; i < j; i++) {
                    where.items[i] = this.items[i].save();
                }
            }
        }
    };
    Mixins.Item = {
        name: 'Item',
        init: function (template) {
            this.number = template.number || 1;
            this.plural = template.plural || '';
            this.power = template.power || null;
            this.addInvulnerability(damages.pois);
        },
        getDescription: function () {
            var extra = '';
            if (this.hasMixin(Mixins.Equippable)) {
                if (this.extraDamageType.length > 0) {
                    extra += strings.exdam.format(this.extraDamageType.join(", "));
                }
            }
            if (this.hasMixin(Mixins.Poisonous)) {
                extra += strings.poidam;
            }
            if (this.hasMixin(Mixins.Vampiric)) {
                extra += strings.vamdam;
            }
            if (this.hasMixin(Mixins.VulnerabilityChanger)) {
                if (this.newInvuln.length > 0) {
                    extra += strings.giveimm.format(this.newInvuln.join(", "));
                }
                if (this.newRes.length > 0) {
                    extra += strings.giveres.format(this.newRes.join(", "));
                }
            }
            return this.description + extra;
        },
        getNumber: function () {
            return this.number;
        },
        getPlural: function () {
            return "%s %s".format(this.number, this.plural);
        },
        isEqual: function (item) {
            return this.type === item.type && this.name === item.name;
        },
        stack: function (item) {
            if ((item.hasMixin(Mixins.Butcherable && item.butchered)) ||
                (item.hasMixin(Mixins.Cookable) && item.cooked)) {
                this.portions += item.portions;
            } else {
                this.number += item.number;
            }
        },
        separateItems: function (num) {
            num = num || 1;
            if (num >= this.getNumber()) {
                return this;
            }
            var temp = makeThing(this.save());
            temp.number = num;
            this.number -= num;
            return temp;
        },
        listeners: {
            onSave: function (where) {
                where.number = this.number;
                where.plural = this.plural;
                where.power = this.power;
            }
        }
    };
    Mixins.Living = {
        name: 'Living',
        init: function (template) {
            this.alive = true;
            this.strength = template.str || 0;
            this.dexterity = template.dex || 0;
            this.constitution = template.con || 0;
            this.intelligence = template.inte || 0;
            this.wisdom = template.wis || 0;
            this.charisma = template.cha || 0;
            if (template.hp1 && template.hp2) {
                this.maxhp = ROT.RNG.getUniformInt(template.hp1, template.hp2);
            } else {
                this.maxhp = template.maxhp || 1;
            }
            this.hp = template.hp || this.maxhp;
            this.basehp = template.basehp || this.maxhp;
            this.defence = template.defence || 0;
            this.speed = template.speed || 100;
            this.addInvulnerability(damages.rust);
        },
        getSpeed: function () {
            return this.speed;
        },
        getDefence: function () {
            var modifier = this.getBonus(this.dexterity);
            if (this.hasMixin('Equipper')) {
                modifier += this.getEquipmentBonus('def');
            }
            return this.defence + modifier;
        },
        getBonus: function (which) {
            if (which <= 1) {
                return -5;
            } else if (which === 10 || which === 11) {
                return 0;
            } else {
                if (which < 10) {
                    return Math.floor((which - 11) / 2);
                } else {
                    return Math.floor((which - 10) / 2);
                }
            }
        },
        getHealth: function () {
            return "%s/%s".format(this.hp, this.maxhp);
        },
        changeHealth: function (howMuch) {
            var result = (howMuch < 0 && Math.abs(howMuch) > this.hp) ? this.hp : Math.abs(howMuch);
            this.hp += howMuch;
            if (this.hp > this.maxhp) {
                this.hp = this.maxhp;
            } else if (this.hp <= 0) {
                if (this.hasSpecialPower("Second Life")) {
                    this.hp = this.maxhp;
                    this.removeSpecialPower("Second Life");
                    if (this.type === 'player') {
                        sendMessage(strings.nodeath);
                    }
                } else {
                    this.die();
                }
            }
            return result;
        },
        recalculateHP: function (isleveup) {
            var temp = 0;
            if (isleveup && this.hasMixin('XPGainer')) {
                temp = this.basehp + this.getBonus(this.constitution) * this.level;
            } else {
                temp = this.basehp + this.getBonus(this.constitution);
            }
            this.hp += (temp - this.maxhp);
            this.maxhp = temp;
            return temp;
        },
        die: function (noAct) {
            this.alive = false;
            this.raiseEvent('onDeath', World);
            if (this.type === 'player') {
                if (!noAct) {
                    this.act();
                }
            } else {
                World.removeEntity(this);
            }
        },
        listeners: {
            onSave: function (where) {
                where.str = this.strength;
                where.dex = this.dexterity;
                where.con = this.constitution;
                where.inte = this.intelligence;
                where.wis = this.wisdom;
                where.cha = this.charisma;
                where.maxhp = this.maxhp;
                where.hp = this.hp;
                where.basehp = this.basehp;
                where.defence = this.defence;
                where.speed = this.speed;
            }
        }
    };
    Mixins.Mobile = {
        name: 'Mobile',
        init: function (template) {
            this.speed = template.speed || 100;
        },
        getSpeed: function () {
            return this.speed;
        },
        setSpeed: function (newspeed) {
            this.speed = newspeed;
        },
        move: function (x, y, world) {
            var ox = this.x, oy = this.y;
            this.put(x, y);
            world.setThing(this, ox, oy);
        },
        listeners: {
            onSave: function (where) {
                where.speed = this.speed;
            }
        }
    };
    Mixins.Paralyzer = {
        name: 'Paralyzer',
        init: function (template) {
            this.paralysisDuration = template.paradur || 1;
            this.paralysisChances = template.paracha || 1;
        },
        listeners: {
            onHit: function (target) {
                var chance = ROT.RNG.getUniformInt(1, 20);
                if (target.isInvulnerableTo(damages.paral) ||
                    chance + target.getBonus(target.charisma) >= this.paralysisChances) {
                    return;
                }
                if (target.type === 'player') {
                    sendMessage(strings.paral);
                }
                target.addEffect({
                    name: 'paralysis',
                    duration: this.paralysisDuration,
                    active: true
                });
            },
            onSave: function (where) {
                where.paradur = this.paralysisDuration;
                where.paracha = this.paralysisChances;
            }
        }
    };
    Mixins.Poisonous = {
        name: 'Poisonous',
        init: function (template) {
            this.poisonDamage = template.poisdam || 1;
            this.poisonDuration = template.poisdur || 1;
            this.poisonStrength = template.poisstr || 1;
            this.poisonChanches = template.poischa || 1;
        },
        listeners: {
            onHit: function (target) {
                var chance = ROT.RNG.getUniformInt(1, 20);
                if (target.isInvulnerableTo(damages.pois) ||
                    chance + target.getBonus(target.constitution) >= this.poisonChances) {
                    return;
                }
                if (target.type === 'player') {
                    sendMessage(strings.poison);
                }
                target.addEffect({
                    name: 'poison',
                    damage: this.poisonDamage,
                    duration: this.poisonDuration,
                    strength: this.poisonStrength,
                    active: true
                });
            },
            onSave: function (where) {
                where.poisdam = this.poisonDamage;
                where.poisdur = this.poisonDuration;
                where.poisstr = this.poisonStrength;
                where.poischa = this.poisonChances;
            }
        }
    };
    Mixins.Readable = {
        name: 'Readable',
        init: function (template) {
            this.oneshot = template.oneshot || false;
            if (template.extra) {
                this.extra = template.extra;
            }
        },
        isOneshot: function () {
            return this.oneshot;
        },
        listeners: {
            onSave: function (where) {
                where.oneshot = this.oneshot;
                if (this.extra) {
                    where.extra = this.extra;
                }
            }
        }
    };
    Mixins.Regenerator = {
        name: 'Regenerator',
        init: function (template) {
            this.regeneration = template.regen || 1;
        },
        listeners: {
            onEnd: function () {
                this.changeHealth(this.regeneration);
            },
            onSave: function (where) {
                where.regen = this.regeneration;
            }
        }
    };
    Mixins.Sharp = {
        name: 'Sharp',
        init: function (template) {
            //if (this.extraDamageType) {
            //    this.extraDamageType.push(damages.bleed);
            //} else {
            //    this.extraDamageType = [damages.bleed];
            //}
            this.deepness = template.deepness || 1;
            this.bleedchances = template.blchan || 25;
            this.bleedduration = template.bldur || 20;
        },
        listeners: {
            onHit: function (target) {
                if (target.isInvulnerableTo(damages.bleed) ||
                    (target.isResistantTo(damages.bleed) && ROT.RNG.getPercentage() < 80)) {
                    return;
                }
                if (target.type === 'player') {
                    sendMessage("%s cuts deep into your flesh.".format(this.describeThe(true)));
                }
                if (target.hasEffect("bleeding")) {
                    var temp = target.getEffect("bleeding");
                    if (this.bleedduration > temp.duration) {
                        temp.duration = this.bleedduration;
                    }
                    if (this.bleedchances > temp.chances) {
                        temp.chances = this.bleedchances;
                    }
                    if (this.deepness > temp.damage) {
                        temp.damage = this.deepness;
                    }
                } else {
                    target.addEffect({
                        name: 'bleeding',
                        damage: this.deepness,
                        chances: this.bleedchances,
                        duration: this.bleedduration,
                        active: true
                    });
                }
            },
            onSave: function (where) {
                //if (!where.extradamt) {
                //    where.extradamt = this.extraDamageType;
                //}
                where.deepness = this.deepness;
                where.blchan = this.bleedchances;
                where.bldur = this.bleedduration;
            }
        }
    };
    Mixins.Shootable = {
        name: 'Shootable',
        init: function (template) {
            this.bonus = template.bonus || 0;
            this.breakingChances = template.breakch || 0;
            this.damageType = template.damtype || false;
            this.extraDamageType = template.extradamt || [];
        },
        isBroken: function (chance) {
            return this.breakingChances >= chance;
        },
        isEqual: function (other) {
            return this.type === other.type && this.bonus === other.bonus &&
                    this.breakingChances === other.breakingChances;
        },
        listeners: {
            onHit: function (target, damage, user) {
                for (var i = 0, j = this.extraDamageType.length; i < j; i++) {
                    if (!target.isAlive()) {
                        return;
                    }
                    var result = testVulnerability(target, damage, this.extraDamageType[i]);
                    if (user.type === 'player' && result[1]) {
                        sendMessage(result[1]);
                    }
                    target.changeHealth(-result[0]);
                }
            },
            onSave: function (where) {
                where.bonus = this.bonus;
                where.breakch = this.breakingChances;
                where.damtype = this.damageType;
                where.extradamt = this.extraDamageType;
            }
        }
    };
    Mixins.Shooter = {
        name: 'Shooter',
        init: function (template) {
            this.ranged = template.ranged ? makeThing(template.ranged) : null;
            this.ammo = template.ammo ? makeThing(template.ammo) : null;
        },
        getRanged: function () {
            return this.ranged;
        },
        getRangedValue: function () {
            var bonus = this.getBonus(this.dexterity) + this.attackBonus;
            //if (this.hasMixin(Mixins.Equipper)) {
            //    bonus += this.getEquipmentBonus('att');
            //}
            return bonus;
        },
        getRangedDamage: function () {
            if (this.ranged) {
                return ROT.RNG.getUniformInt(this.ranged.dam1, (this.ranged.dam1 * this.ranged.dam2));
            }
            return 0;
        },
        getAmmo: function () {
            return this.ammo;
        },
        getAmmos: function () {
            if (this.ammo) {
                return this.ammo.getNumber();
            } else {
                return 0;
            }
        },
        decreaseAmmos: function () {
            this.ammo.number--;
            if (this.ammo.number === 0 && this.type === "player") {
                sendMessage('You are out of ammos.');
                this.ammo = null;
            }
        },
        removeAmmo: function () {
            if (this.hasMixin(Mixins.InventoryHolder)) {
                if (this.canAddItem()) {
                    this.addItem(this.ammo);
                } else {
                    this.dropItem(this.ammo);
                }
            } else {
                World.addItem(this.ammo, this.getPosition());
            }
            this.ammo = null;
        },
        loadAmmo: function (item) {
            if (this.ammo !== null) {
                this.removeAmmo();
            }
            if (this.hasMixin(Mixins.InventoryHolder)) {
                this.removeItem(item);
            }
            this.ammo = item;
        },
        putAmmoToGround: function (world, where) {
            var temp = makeThing(this.ammo.save());
            temp.number = 1;
            world.addItem(temp, where);
        },
        canReload: function (item) {
            return this.ammo && this.ammo.isEqual(item);
        },
        reload: function (item) {
            if (this.canReload(item)) {
                this.ammo.number += item.number;
                return true;
            }
            return false;
        },
        wieldRanged: function (item) {
            if (this.ranged !== null) {
                this.unwieldRanged();
            }
            if (this.hasMixin(Mixins.InventoryHolder)) {
                this.removeSingleItem(item);
            }
            this.ranged = item;
        },
        unwieldRanged: function () {
            if (this.hasMixin(Mixins.InventoryHolder)) {
                if (this.canAddItem()) {
                    this.addItem(this.ranged);
                } else {
                    this.dropItem(this.ranged);
                }
            } else {
                World.addItem(this.ranged, this.getPosition());
            }
            this.ranged = null;
        },
        canShoot: function () {
            return this.ranged && this.getAmmos() > 0;
        },
        listeners: {
            onDeath: function (world) {
                if (this.ranged) {
                    world.addItem(this.ranged, this.getPosition());
                }
                if (this.ammo) {
                    world.addItem(this.ammo, this.getPosition());
                }
            },
            onSave: function (where) {
                where.ranged = this.ranged ? this.ranged.save() : null;
                where.ammo = this.ammo ? this.ammo.save() : null;
            }
        }
    };
    Mixins.Sight = {
        name: 'Sight',
        groupName: 'Sight',
        init: function (template) {
            this.sightRadius = template.sightRad || 5;
            this.vision = {};
        },
        canSee: function (entity) {
            if (!entity || entity.isInvisible(this)) {
                return false;
            }
            if (this.vision[entity.x + "," + entity.y]) {
                return true;
            } else {
                return false;
            }
        },
        canSeeInvisible: function () {
            return this.hasSpecialPower("Second Sight") || this.hasEffect("second-sight");
        },
        look: function () {
            var temp = {};
            var fov = World.fov;
            fov.compute(this.x, this.y, this.sightRadius,
                    function (x, y, radius, visibility) {
                        temp[x + "," + y] = true;
                    });
            this.vision = temp;
            return this.vision;
        },
        listeners: {
            onSave: function (where) {
                where.sightRad = this.sightRadius;
            }
        }
    };
    Mixins.Spellcaster = {
        name: 'Spellcaster',
        init: function (template) {
            this.spells = template.spells || [];
        },
        learnSpell: function (spell) {
            this.spells.push(spell);
        },
        listeners: {
            onSave: function (where) {
                where.spells = this.spells;
            }
        }
    };
    Mixins.Summoner = {
        name: 'Summoner',
        init: function (template) {
            this.summonable = template.summonable || [];
        },
        canSummon: function (world) {
            return this.summonable.length > 0 && world.getFreeTilesWithinRadius(this.x, this.y).length > 0;
        },
        listeners: {
            onSave: function (where) {
                where.summonable = this.summonable;
            }
        }
    };
    Mixins.Throwable = {
        name: 'Throwable',
        init: function (template) {
            this.fragile = template.fragile || false;
            this.returning = template.returning || false;
        },
        listeners: {
            onBroken: function (user, place) {
                if (this.power) {
                    Powers[this.power](this, place);
                }
            },
            onSave: function (where) {
                where.fragile = this.fragile;
                where.returning = this.returning;
            }
        }
    };
    Mixins.Vampiric = {
        name: 'Vampiric',
        init: function (template) {
            this.vampower = template.vamp || 1;
        },
        listeners: {
            onHit: function (target, damage, attacker) {
                var bonus = damage > this.vampower ? this.vampower : damage;
                if (target.isResistantTo(damages.vamp)) {
                    bonus = Math.floor(bonus / 2);
                }
                if (bonus > 0 && !target.isInvulnerableTo(damages.vamp)) {
                    if (attacker) {
                        attacker.changeHealth(bonus);
                        if (attacker.type === 'player') {
                            sendMessage("Your weapon drains %s's life. You feel better.".format(target.describeThe()));
                        }
                    } else {
                        this.changeHealth(bonus);
                    }
                    if (target.type === 'player' && target.isAlive()) {
                        sendMessage(strings.vamp);
                        if (!attacker) {
                            sendMessage("%s looks stronger.".format(this.describeThe(true)));
                        }
                    }
                }
            },
            onSave: function (where) {
                where.vamp = this.vampower;
            }
        }
    };
    Mixins.VulnerabilityChanger = {
        name: 'VulnerabilityChanger',
        init: function (template) {
            this.newVuln = template.newvuln || [];
            this.newRes = template.newres || [];
            this.newInvuln = template.newinvuln || [];
        },
        listeners: {
            onSave: function (where) {
                where.newvuln = this.newVuln;
                where.newres = this.newRes;
                where.newinvuln = this.newInvuln;
            }
        }
    };
    Mixins.XPGainer = {
        name: 'XPGainer',
        init: function (template) {
            this.level = template.level || 1;
            this.experience = template.exp || 0;
            this.nextLevelXP = template.nextxp || 20;
            this.difference = template.difference || 20;
        },
        getLevel: function () {
            return this.level;
        },
        getExperience: function () {
            return Math.floor(this.experience);
        },
        getNextLevelXP: function () {
            return this.nextLevelXP;
        },
        gainExperience: function (amount) {
            this.experience += amount;
            if (this.canLevelUp()) {
                this.doLevelUp();
            }
        },
        canLevelUp: function () {
            return this.experience >= this.nextLevelXP && this.level < 50;
        },
        doLevelUp: function () {
            this.difference = this.difference * 2 + Math.floor(this.difference / 10);
            this.nextLevelXP += this.difference;
            this.level++;
            sendMessage(strings.lvlup.format(this.level));
            this.raiseEvent('onLevelUp', this);
            if (this.canLevelUp()) {
                this.doLevelUp();
            }
        },
        listeners: {
            onKill: function (victim) {
                var amount = victim.maxhp * (victim.challenge / this.level);
                if (amount > 0) {
                    this.gainExperience(amount);
                }
            },
            onSave: function (where) {
                where.level = this.level;
                where.exp = this.experience;
                where.nextxp = this.nextLevelXP;
                where.difference = this.difference;
            }
        }
    };

    /*
     * Effects, Powers, Spells
     */
    var Abilities = Object.create(null);
    Abilities.warrior = ["Increase", "Great Dodger", "Charge", "Extra Attack", "Heavy Hitter", "Extra Attack II", "Berserker"];
    Abilities.ranger = ["Increase", "Great Dodger", "Aimed Shot", "Burning Shot", "Superb Dodger", "Poison Ammos"];
    Abilities.wizard = ["Increase", "Great Dodger", "Fighting Mage", "Explosive Rune", "Destructive Rune", "Superb Dodger"];
    Abilities["Increase"] = function () {
    };
    Abilities["Increase"].desc = "Permanently increase one of your characteristics.";
    Abilities["Charge"] = function (actor) {
        if (actor.hasEffect('charge')) {
            actor.getEffect('charge').duration += 10;
        } else {
            var addedsp = 200, addedatt = 5;
            actor.addEffect({
                name: 'charge',
                duration: 10,
                addedsp: addedsp,
                addedatt: addedatt,
                active: true
            });
            actor.speed += addedsp;
            actor.attackBonus += addedatt;
            if (actor.type === 'player') {
                sendMessage('Chaaaarge!');
            }
        }
        return true;
    };
    Abilities["Charge"].desc = "It gives a temporary boost to your speed and attack, in order to charge an enemy.";
    Abilities["Charge"].usable = true;
    Abilities["Heavy Hitter"] = function (actor) {
        if (actor.hasEffect('hitter')) {
            actor.getEffect('hitter').duration += 10;
        } else {
            var addeddam = 4;
            actor.addEffect({
                name: 'hitter',
                duration: 10,
                addeddam: addeddam,
                active: true
            });
            actor.damageBonus += addeddam;
            if (actor.type === 'player') {
                sendMessage('You are ready to kick some serious arses.');
            }
        }
        return true;
    };
    Abilities["Heavy Hitter"].desc = "Temporarily increase your melee damage by 4.";
    Abilities["Heavy Hitter"].usable = true;
    Abilities["Aimed Shot"] = function (actor) {
        if (!actor.ammo || actor.ammo.number === 0) {
            sendMessage("You have no ammo in your quiver");
            return false;
        }
        if (actor.ammo.hasEffect('aimed')) {
            actor.ammo.getEffect('aimed').duration += 10;
        } else {
            var addedbonus = 4;
            actor.addEffect({
                name: 'aimed',
                duration: 10,
                addedbonus: addedbonus,
                active: true
            });
            actor.ammo.bonus += addedbonus;
            if (actor.type === 'player') {
                sendMessage('Your hand is firm, your aim accuate.');
            }
        }
        return true;
    };
    Abilities["Aimed Shot"].desc = "Temporarily increase by 4 the damage done by your loaded ammos.";
    Abilities["Aimed Shot"].usable = true;
    Abilities["Burning Shot"] = function (actor) {
        if (!actor.ammo || actor.ammo.number === 0) {
            sendMessage("You have no ammo in your quiver");
            return false;
        }
        if (actor.ammo.hasEffect('alight')) {
            sendMessage("Your ammo is already alight, now you should shoot it beforse it's consumed.");
        } else {
            var hasFire = actor.ammo.extraDamageType.indexOf(damages.fire) >= 0;
            actor.ammo.addEffect({
                name: 'alight',
                duration: 10,
                basechanches: actor.ammo.breakingChances,
                isAdded: hasFire ? false : true,
                isPlayer: actor.type === 'player',
                active: true
            });
            if (!hasFire) {
                actor.ammo.extraDamageType.push(damages.fire);
            }
            if (actor.type === 'player') {
                sendMessage('The tip of your ammo is on fire, now [s]hoot it!');
            }
        }
        return true;
    };
    Abilities["Burning Shot"].desc = "Light up your next ammo for a fiery shot.";
    Abilities["Burning Shot"].usable = true;
    Abilities["Poison Ammos"] = function (actor) {
        if (actor.type === 'player') {
            doPoison();
        }
    };
    Abilities["Poison Ammos"].desc = "If you have a bottle of poison, you can use it to poison up to 20 of your ammos.";
    Abilities["Poison Ammos"].usable = true;
    Abilities["Poison Ammos"].minimum = 20;
    Abilities["Explosive Rune"] = function (actor) {
        if (actor.hp < 2) {
            sendMessage("You are too weak: the loss of HP would kill you.");
            return false;
        }
        if (World.getTile(actor.x, actor.y) === Templates.runedTile) {
            sendMessage("There is already a rune here.");
            return;
        }
        World.setTile(actor.x, actor.y, Templates.runedTile);
        actor.changeHealth(-1);
        sendMessage("You spill your blood on the floor and draw a rune with it.");
        return true;
    };
    Abilities["Explosive Rune"].desc = "At the cost of 1 HP you can draw with your blood an explosive rune on the floor; it will cause 1d6 damage to the first monster stepping on it.";
    Abilities["Explosive Rune"].usable = true;
    Abilities["Destructive Rune"] = function (actor) {
        if (actor.hp < 3) {
            sendMessage("You are too weak: the loss of HP would kill you.");
            return false;
        }
        if (World.getTile(actor.x, actor.y) === Templates.runedTile) {
            sendMessage("There is already a rune here.");
            return;
        }
        World.setTile(actor.x, actor.y, Templates.runedTile);
        actor.changeHealth(-2);
        sendMessage("You spill your blood on the floor and draw a rune with it.");
        return true;
    };
    Abilities["Destructive Rune"].desc = "At the cost of 2 HP you can draw with your blood a destructive rune on the floor; it will cause 2d10 damage to the first monster stepping on it.";
    Abilities["Destructive Rune"].usable = true;
    Abilities["Destructive Rune"].minimum = 20;
    Abilities["Destructive Rune"].prereq = "Explosive Rune";
    Abilities["Extra Attack"] = function (actor) {
        actor.attackPerRound++;
        sendMessage("You have %s attacks per round now.".format(actor.attackPerRound));
    };
    Abilities["Extra Attack"].desc = "It permanently increases by 1 the number of attacks per round you can perform.";
    Abilities["Extra Attack"].minimum = 5;
    Abilities["Extra Attack II"] = function (actor) {
        actor.attackPerRound++;
        sendMessage("You have %s attacks per round now.".format(actor.attackPerRound));
    };
    Abilities["Extra Attack II"].desc = "It permanently increases by 1 the number of attacks per round you can perform.";
    Abilities["Extra Attack II"].minimum = 26;
    Abilities["Extra Attack II"].prereq = "Extra Attack"
    Abilities["Fighting Mage"] = function (actor) {
        actor.attackBonus += 3;
        sendMessage("You feel more confident with a weapon.");
    };
    Abilities["Fighting Mage"].desc = "It permanently increases by 3 your attack bonus in melee fights.";
    Abilities["Great Dodger"] = function (actor) {
        actor.defence += 3;
        sendMessage("You are better at judging and evading attacks aimed at you.");
    };
    Abilities["Great Dodger"].desc = "It permanently increases by 3 your defence bonus.";
    Abilities["Superb Dodger"] = function (actor) {
        actor.defence += 6;
        sendMessage("You become even better at judging and evading attacks aimed at you.");
    };
    Abilities["Superb Dodger"].desc = "It permanently increases by 6 your defence bonus.";
    Abilities["Superb Dodger"].prereq = "Great Dodger";
    Abilities["Superb Dodger"].minimum = 26;
    Abilities["Berserker"] = function (actor) {
        if (actor.hasEffect('berserker')) {
            actor.getEffect('berserker').duration += 30;
        } else {
            var addeddam = 10, addedatt = 10;
            actor.addEffect({
                name: 'berserker',
                duration: 30,
                addeddam: addeddam,
                addedatt: addedatt,
                active: true
            });
            actor.damageBonus += addeddam;
            actor.attackBonus += addedatt;
            if (actor.type === 'player') {
                sendMessage(strings.redmex.format('Graaaargh! Bloooood!!'));
            }
        }
        return true;
    };
    Abilities["Berserker"].desc = "It temporarily drives you into a killing frenzy, boosting your attack and damage. And hunger.";
    Abilities["Berserker"].usable = true;
    Abilities["Berserker"].minimum = 20;
    var Effects = Object.create(null);
    Effects.alight = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.breakingChances = source.basechanches;
            if (source.isAdded) {
                target.extraDamageType = target.extraDamageType.filter(function (a) {
                    return a !== damages.fire;
                });
            }
            target.removeEffect(source.name);
            if (source.isPlayer) {
                sendMessage('Your ammo burns up completely.');
                player.decreaseAmmos();
            }
        } else if (source.active) {
            source.duration--;
        }
    };
    Effects.aimed = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.bonus -= source.addedbonus;
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage('Your shoot is back to normal.');
            }
        } else if (source.active) {
            source.duration--;
        }
    };
    Effects.armour = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.defence -= source.addeddef;
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage(strings.oranmex.format("The magical light around you vanishes."));
            }
        } else if (source.active) {
            source.duration--;
        }
    };
    Effects.berserker = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.damageBonus -= source.addeddam;
            target.attackBonus -= source.addedatt;
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage(strings.oranmex.format("You calm down, but you feel really exausted now."));
            }
        } else if (source.active) {
            source.duration--;
        }
    };
    Effects.bleeding = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage(strings.greenmex.format("The bleeding stops."));
            } else if (player.canSee(target)) {
                sendMessage("%s stops bleeding.".format(target.describeThe(true)));
            }
        } else if (source.active) {
            source.duration--;
            if (ROT.RNG.getPercentage() < source.bleedchances) {
                if (target.type === 'player') {
                    sendMessage(strings.redmex.format("You are losing blood."));
                } else if (player.canSee(target)) {
                    sendMessage("%s is bleeding.".format(target.describeThe(true)));
                }
                target.changeHealth(-source.damage);
                if (target.type === 'player' && !player.isAlive()) {
                    necro = strings.dundeath.format(player.getName(), player.plclass, World.lvl, World.name) +
                        strings.bleeddeath;
                }
            }
        }
    };
    Effects.blessed = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            if (source.isAdded) {
                target.extraDamageType = target.extraDamageType.filter(function (a) {
                    return a !== damages.holy;
                });
                target.name = source.oldname;
            }
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage(strings.oranmex.format("The magical light vanishes."));
            }
        } else if (source.active) {
            source.duration--;
        }
    };
    Effects.blessing = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.defence -= source.incr;
            target.attackBonus -= source.incr;
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage(strings.oranmex.format('The divine light vanishes.'));
            }
        } else if (source.active) {
            source.duration--;
        }
    };
    Effects.bursting = function (source, target) {
        if (target.type === 'player' && ROT.RNG.getPercentage() < 11) {
            sendMessage(strings.oranmex.format("You really ate too much... Burp!"));
        }
    };
    Effects.charge = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.speed -= source.addedsp;
            target.attackBonus -= source.addedatt;
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage(strings.oranmex.format('You calm down.'));
            }
        } else if (source.active) {
            source.duration--;
        }
    };
    Effects.confusion = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage(strings.greenmex.format('You are no longer confused.'));
            } else {
                target.brain.angry = true;
                target.type = 'aggressive';
                if (player.canSee(target)) {
                    sendMessage("%s looks very, very angry.".format(target.describeThe(true)));
                }
            }
        } else if (source.active) {
            source.duration--;
            if (target.type === 'player') {
                sendMessage('You feel confused.');
            }
        }
    };
    Effects.full = function (source, target) {
    };
    Effects.haste = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.speed -= source.addedsp;
            target.removeEffect('haste');
            if (target.type === 'player') {
                sendMessage(strings.oranmex.format('Your feet slow down.'));
            }
        } else if (source.active) {
            source.duration--;
        }
    };
    Effects.hitter = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.damageBonus -= source.addeddam;
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage(strings.oranmex.format('Your hits revert back to their normal damage.'));
            }
        } else if (source.active) {
            source.duration--;
        }
    };
    Effects.hungry = function (source, target) {
        if (target.type === 'player' && ROT.RNG.getPercentage() < 11) {
            sendMessage(strings.redmex.format("You are hungry."));
        }
    };
    Effects.invisible = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage(strings.oranmex.format('You are no longer invisible.'));
            } else {
                if (player.canSee(target)) {
                    sendMessage("%s suddenly appears.".format(target.describeThe(true)));
                }
            }
        } else if (source.active) {
            source.duration--;
        }
    };
    Effects.paralysis = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage(strings.greenmex.format('You can move again.'));
            } else {
                target.brain.angry = true;
                if (player.canSee(target)) {
                    sendMessage("%s can move again.".format(target.describeThe(true)));
                }
            }
        } else if (source.active) {
            source.duration--;
        }
    };
    Effects.poison = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage(strings.greenmex.format('The poison wears out.'));
            }
        } else if (source.active) {
            source.duration--;
            if (ROT.RNG.getPercentage() < source.strength) {
                var dam = testVulnerability(target, source.damage, damages.pois)[0];
                if (target.type === 'player') {
                    sendMessage("<span class='yellow'>The poison burns in your body.</span>");
                }
                target.changeHealth(-dam);
                if (target.type === 'player' && !player.isAlive()) {
                    necro = strings.dundeath.format(player.getName(), player.plclass, World.lvl, World.name) +
                        strings.poisdeath;
                }
            }
        }
    };
    Effects["second-sight"] = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage(strings.oranmex.format('You are no longer able to see invisible things.'));
            }
        } else if (source.active) {
            source.duration--;
        }
    };
    Effects.sleep = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage(strings.greenmex.format('You wake up.'));
            } else {
                target.brain.angry = true;
                if (player.canSee(target)) {
                    sendMessage("%s wakes up.".format(target.describeThe(true)));
                }
            }
        } else if (source.active) {
            source.duration--;
        }
    };
    Effects.slow = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.speed += source.minussp;
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage(strings.greenmex.format('You speed up.'));
            } else if (player.canSee(target)) {
                sendMessage(strings.greenmex.format("%s speeds up.".format(target.describeThe(true))));
            }
        } else if (source.active) {
            source.duration--;
        }
    };
    Effects.speed = function (source, target) {
        if (source.duration === 0) {
            source.active = false;
            target.speed -= source.addedsp;
            target.removeEffect(source.name);
            if (target.type === 'player') {
                sendMessage(strings.oranmex.format('You slow down.'));
            }
        } else if (source.active) {
            source.duration--;
        }
    };
    Effects.starving = function (source, target) {
        if (target.type === 'player' && ROT.RNG.getPercentage() < 21) {
            sendMessage(strings.redmex.format("You are starving!"));
            target.changeHealth(-1);
            if (!target.isAlive()) {
                necro = strings.dundeath.format(player.getName(), player.plclass, World.lvl, World.name) +
                        strings.hungerdeath;
            }
        }
    };
    for (var i in damages) {
        if (damages.hasOwnProperty(i)) {
            Effects["resistance to " + i] = function (source, target) {
                if (source.duration === 0) {
                    source.active = false;
                    if (source.isAdded) {
                        target.removeResistance(source.strength);
                    }
                    target.removeEffect(source.name);
                    if (target.type === 'player') {
                        sendMessage('You no longer feel resistant to %s.'.format(source.strength));
                    }
                } else if (source.active) {
                    source.duration--;
                }
            }
        }
    }
    var Magics = Object.create(null);
    Magics.ball = function (user, target, radius, damage, bonus, type, text) {
        var victims = World.getEntitiesWithinRadius(target[0], target[1], radius);
        victims.forEach(function (a) {
            var result = testVulnerability(a, ROT.RNG.getUniformInt(damage[0], damage[1]) + bonus, damages.fire);
            var dam = result[0];
            if (a.type === 'player') {
                sendMessage(strings.youhit.format(dam));
            } else if (user && user.type === 'player') {
                if (user.canSee(a)) {
                    sendMessage(strings.ishit.format(a.describeThe(true), dam));
                }
                a.brain.angry = true;
                if (result[1]) {
                    sendMessage(result[1]);
                }
            }
            a.changeHealth(-dam);
            if (a.type === 'player' && !player.isAlive()) {
                necro = strings.dundeath.format(player.getName(), player.plclass, World.lvl, World.name) +
                    strings.burndeath;
            } else if (user.type === 'player' && !a.isAlive()) {
                player.raiseEvent('onKill', a);
            }
        });
        setItems(target[0], target[1], radius, type, text, user);
    };
    Magics.heal = function (target, amount) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (target.isAlive()) {
            target.changeHealth(amount);
        }
        if (target.type === 'player') {
            sendMessage(strings.greenmex.format('You feel better.'));
        } else if (player.canSee(target)) {
            sendMessage("%s looks healtier.".format(target.describeThe(true)));
        }
    };
    Magics.missile = function (user, target, damage, bonus, type) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        var result, dam;
        if (type) {
            result = testVulnerability(target, ROT.RNG.getUniformInt(damage[0], damage[1]) + bonus, type);
            dam = result[0];
        } else {
            dam = ROT.RNG.getUniformInt(damage[0], damage[1]) + bonus;
        }
        if (dam < 0) {
            dam = 0;
        }
        if (user.type === 'player') {
            if (user.canSee(target)) {
                sendMessage(strings.ishit.format(target.describeThe(true), dam));
            } else {
                sendMessage(strings.unseenhit);
            }
            if (target.brain) {
                target.brain.angry = true;
            }
            if (result && result[1]) {
                sendMessage(result[1]);
            }
        } else if (target.type === 'player') {
            sendMessage(strings.youhit.format(dam));
        }
        target.changeHealth(-dam);
        if (!target.isAlive()) {
            user.raiseEvent('onKill', target);
        }
    };
    Magics.slow = function (user, target, duration, power) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (target.hasEffect('slow')) {
            target.getEffect('slow').duration += duration;
        } else {
            var minussp = target.speed - power > 10 ? power : target.speed - 10;
            target.addEffect({
                name: 'slow',
                duration: duration,
                minussp: minussp,
                active: true
            });
            target.speed -= minussp;
            if (target.type === 'player') {
                sendMessage('You suddenly slow down.');
            } else if (player.canSee(target)) {
                sendMessage('%s suddenly slows down.'.format(target.describeThe(true)));
            }
        }
    };
    Magics.speed = function (user, target, duration, power, effectName) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (target.hasEffect(effectName)) {
            target.getEffect(effectName).duration += duration;
        } else {
            target.addEffect({
                name: effectName,
                duration: duration,
                addedsp: power,
                active: true
            });
            target.speed += power;
            if (target.type === 'player') {
                sendMessage(strings.greenmex.format('You start moving faster.'));
            } else if (player.canSee(target)) {
                sendMessage('%s starts moving faster.'.format(target.describeThe(true)));
            }
        }
    };
    var Powers = Object.create(null);
    Powers.antidote = function (source, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (target.hasEffect(damages.pois)) {
            target.removeEffect(damages.pois);
            if (target.type === 'player') {
                sendMessage(strings.greenmex.format('You are no longer poisoned.'));
            }
        }
    };
    Powers.confusion = function (source, target) {
        var victim = null;
        if (target.type && target.hasMixin(Mixins.Living)) {
            victim = target;
        } else {
            victim = World.getEntityAt(target[0], target[1]);
        }
        if (victim) {
            if (victim.isResistantTo(damages.confu) || victim.isInvulnerableTo(damages.confu)) {
                if (victim.type === 'player') {
                    sendMessage("You feel confused for a moment, but soon it passes.");
                } else if (player.canSee(victim)) {
                    sendMessage("%s is not affected.".format(victim.describeThe(true)));
                }
                return;
            }
            victim.addEffect({
                name: damages.confu,
                duration: source.powerStrength,
                active: true
            });
            if (victim.type === 'player') {
                sendMessage(strings.redmex.format('You feel confused.'));
            } else {
                victim.type = 'confused';
                if (player.canSee(victim)) {
                    sendMessage("%s looks confused.".format(victim.describeThe(true)));
                }
            }
        }
    };
    Powers.decrease = function (source, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        target[source.powerStrength]--;
        var what = null;
        switch (source.powerStrength) {
            case "strength":
                what = "weak";
                break;
            case "dexterity":
                what = "clumsy";
                break;
            case "constitution":
                what = "sick";
                break;
            case "intelligence":
                what = "stupid";
                break;
            case "wisdom":
                what = "dumb";
                break;
            case "charisma":
                what = "less confident";
                break;
            default:
                what = "";
                break;
        }
        if (target.type === "player") {
            sendMessage(strings.charchange.format(what));
        } else if (player.canSee(target)) {
            sendMessage(strings.moschange.format(target.describeThe(true), what));
        }
    };
    Powers.enchant = function (source, target) {
        return doEnchant(source.extra);
    };
    Powers.fireball = function (source, target, user) {
        sendMessage(strings.youshot.format("huge fireball", source.describeThe()));
        Magics.ball(user, target, source.radius, [1, source.powerStrength], 0, damages.fire, "is consumed by the fire");
    };
    Powers.heal = function (source, target) {
        Magics.heal(target, source.powerStrength);
    };
    Powers.increase = function (source, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        target[source.powerStrength]++;
        var what = null;
        switch (source.powerStrength) {
            case "strength":
                what = "stronger";
                break;
            case "dexterity":
                what = "nimbler";
                break;
            case "constitution":
                what = "tougher";
                break;
            case "intelligence":
                what = "more clever";
                break;
            case "wisdom":
                what = "wiser";
                break;
            case "charisma":
                what = "more confident";
                break;
            default:
                what = "";
                break;
        }
        if (target.type === "player") {
            sendMessage(strings.charchange.format(what));
        } else if (player.canSee(target)) {
            sendMessage(strings.moschange.format(target.describeThe(true), what));
        }
    };
    Powers.icearrow = function (source, target, user) {
        sendMessage(strings.youshot.format("arrow of pure frost", source.describeThe()));
        Magics.missile(user, target, [1, 6], source.powerStrength, damages.cold);
    };
    Powers.invisibility = function (source, target) {
        var victim = null;
        if (target.type && target.hasMixin(Mixins.Living)) {
            victim = target;
        } else {
            victim = World.getEntityAt(target[0], target[1]);
        }
        if (victim) {
            //if (victim.isResistantTo(damages.confu) || victim.isInvulnerableTo(damages.confu)) {
            //    if (victim.type === 'player') {
            //        sendMessage("You feel confused for a moment, but soon it passes.");
            //    } else {
            //        sendMessage("%s is not affected.".format(victim.describeThe(true)));
            //    }
            //    return;
            //}
            victim.addEffect({
                name: "invisible",
                duration: source.powerStrength,
                active: true
            });
            if (victim.type === 'player') {
                sendMessage(strings.greenmex.format("You can no longer see yourself."));
            } else {
                sendMessage("%s disappears.".format(victim.describeThe(true)));
            }
        }
    };
    Powers.learnranged = function (source, target) {
        if (target.hasMixin(Mixins.Shooter)) {
            if (target.type = 'player') {
                sendMessage("You are already trained in ranged fight.");
            }
            return false;
        } else {
            target.addMixin(Mixins.Shooter);
            if (target.type === 'player') {
                sendMessage("You now know the basic of ranged fight.");
            }
            return true;
        }
    };
    Powers.learnmagic = function (source, target) {
        if (target.hasMixin(Mixins.Spellcaster)) {
            if (target.type = 'player') {
                sendMessage("You already know how to use magic.");
            }
            return false;
        } else {
            target.addMixin(Mixins.Spellcaster);
            if (target.type === 'player') {
                sendMessage("You now know how the basic of magic.");
            }
            return true;
        }
    };
    Powers.learnspell = function (source, target) {
        if (!target.hasMixin(Mixins.Spellcaster)) {
            if (target.type = 'player') {
                sendMessage("You don't know how to use magic...");
            }
            return false;
        } else if (target.spells.indexOf(source.extra) >= 0) {
            if (target.type = 'player') {
                sendMessage("You already know this spell.");
            }
            return false;
        } else {
            target.learnSpell(source.extra);
            if (target.type === 'player') {
                sendMessage("You now know the spell %s.".format(source.extra));
            }
            return true;
        }
    };
    Powers.magicmissile = function (source, target, user) {
        sendMessage(strings.youshot.format("magic missile", source.describeThe()));
        Magics.missile(user, target, [1, 4], source.powerStrength, damages.magic);
    };
    Powers.poison = function (source, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (target.isInvulnerableTo(damages.pois)) {
            return;
        }
        if (target.type === 'player') {
            sendMessage(strings.poison);
        } else if (player.canSee(target)) {
            sendMessage(strings.ispois.format(target.describeThe(true)));
        }
        target.addEffect({
            name: 'poison',
            damage: source.powerStrength,
            duration: 50,
            strength: 15,
            active: true
        });
    };
    Powers.recall = function (source, target) {
        if (!isWilderness) {
            Spells["Word of Recall"](source, target);
            return true;
        } else {
            sendMessage("This only works in a dungeon.");
        }
    };
    Powers.recharge = function (source, target) {
        return doRecharge();
    };
    Powers.resistance = function (source, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        var rname = 'resistance to ' + source.powerStrength;
        if (target.hasEffect(rname)) {
            target.getEffect(rname).duration += 20;
        } else {
            target.addEffect({
                name: rname,
                duration: 20,
                isAdded: !target.isResistantTo(source.powerStrength),
                strength: source.powerStrength,
                active: true
            });
            if (!target.isResistantTo(source.powerStrength)) {
                target.addResistance(source.powerStrength);
            }
            if (target.type === 'player') {
                sendMessage('You feel resistant to %s damage.'.format(source.powerStrength));
            } else if (player.canSee(target)) {
                sendMessage("%s is now resistant to %s damage.".format(target.describeThe(true), source.powerStrength));
            }
        }
    };
    Powers.secondlife = function (source, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (!target.hasSpecialPower("Second Life")) {
            target.addSpecialPower("Second Life");
            if (target.type === 'player') {
                sendMessage(strings.greenmex.format("Now Death will look the other way if you hit 0 HP. But remember, this will happen only once."));
            }
        }
    };
    Powers.secondsight = function (source, target) {
        if (!target.type || !target.hasMixin(Mixins.Living)) {
            target = World.getEntityAt(target[0], target[1]);
        }
        if (target && !target.hasSpecialPower("Second Sight")) {
            target.addEffect({
                name: "second-sight",
                duration: source.powerStrength,
                active: true
            });
            if (target.type === 'player') {
                sendMessage(strings.greenmex.format("You can see things hidden from mortal eyes, now."));
            }
        }
    };
    Powers.permanentsecondsight = function (source, target) {
        if (!target.type || !target.hasMixin(Mixins.Living)) {
            target = World.getEntityAt(target[0], target[1]);
        }
        if (!target.hasSpecialPower("Second Sight")) {
            target.addSpecialPower("Second Sight");
            if (target.type === 'player') {
                sendMessage(strings.greenmex.format("Your eyes now can see things hidden from common mortals."));
            }
        }
    };
    Powers.slow = function (source, target) {
        Magics.slow(source, target, 10, source.powerStrength);
    };
    Powers.speed = function (source, target) {
        Magics.speed(source, target, 10, source.powerStrength, 'speed');
    };
    Powers.teleport = function (source, target) {
        Spells["Teleport"](source, target);
        return true;
    };
    Powers.water = function (source, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (target.type === 'player') {
            target.setEnergy(10);
            sendMessage(strings.greenmex.format('You feel less thirsty now.'));
        } else if (/ fire/.test(target.name)) {
            target.changeHealth(-ROT.RNG.getUniformInt(1, 6));
            if (player.canSee(target)) {
                sendMessage("%s is hurt by the water.".format(target.describeThe(true)));
            }
        }
    };
    var Spells = Object.create(null);
    //for wizards
    Spells.first = ['Magic Missile', 'Acid Splash', 'Ray of Frost', "Arrow of Fire", 'Mage Armour', 'Fast Foot', 'Slow Down'];
    Spells.second = ['Acid Arrow', 'Touch of Idiocy', 'Sleep', 'Sap Muscles', "Minor Bolt", "See Invisible"];
    Spells.third = ["Ray of Light", "Ray of Darkness", 'Fireball', 'Teleport', 'Invisibility', "Paralysis"];
    Spells.fourth = ['Melt Floor', "Quicksand", 'Lightning Bolt', "Word of Recall", 'Dispel Magic', "Petrify"];
    Spells.fifth = ["Thunderstorm", 'Ice Storm', 'Insanity', "Great Shout"];
    Spells.sixth = ["Swansong"];
    Spells["Magic Missile"] = function (caster, target) {
        var bonus = Math.floor(caster.getBonus(caster.intelligence) / 2);
        if (caster.type === 'player') {
            sendMessage(strings.youshot.format("magic missile", "your finger"));
            bonus -= caster.getEquipmentBonus('hind');
        } else {
            sendMessage(strings.youshot.format("magic missile", caster.describeThe() + "'s finger"));
        }
        Magics.missile(caster, target, [1, 4], bonus, damages.magic);
    };
    Spells["Magic Missile"].desc = "A missile of pure magic will cause a damage of 1d4 plus half your intelligence bonus to a single target.";
    Spells["Magic Missile"].inline = true;
    Spells["Acid Splash"] = function (caster, target) {
        var bonus = Math.floor(getBonus(caster.intelligence) / 2);
        if (caster.type === 'player') {
            sendMessage(strings.youshot.format("small ball of acid", "your hand"));
        } else {
            sendMessage(strings.youshot.format("small ball of acid", caster.describeThe() + "'s hand"));
        }
        Magics.ball(caster, target, Spells["Acid Splash"].area, [1, 3], bonus, damages.acid, "melts");
    };
    Spells["Acid Splash"].desc = "A little ball of acid will cause acid damage of 1d3 plus half your intelligence bonus to everyone in a radius of 1 tile around the target.";
    Spells["Acid Splash"].area = 1;
    Spells["Ray of Frost"] = function (caster, target) {
        var bonus = Math.floor(caster.getBonus(caster.intelligence) / 2);
        if (caster.type === 'player') {
            sendMessage(strings.youshot.format("ray of pure frost", "your finger"));
            bonus -= caster.getEquipmentBonus('hind');
        } else {
            sendMessage(strings.youshot.format("ray of pure frost", caster.describeThe() + "'s finger"));
        }
        Magics.missile(caster, target, [1, 3], bonus, damages.cold);
    };
    Spells["Ray of Frost"].desc = "A ray of pure cold will cause cold damage of 1d3 plus half your intelligence bonus to a single target.";
    Spells["Ray of Frost"].inline = true;
    Spells["Arrow of Fire"] = function (caster, target) {
        var bonus = Math.floor(caster.getBonus(caster.intelligence) / 2);
        if (caster.type === 'player') {
            sendMessage(strings.youshot.format("flaming arrow", "your finger"));
            bonus -= caster.getEquipmentBonus('hind');
        } else {
            sendMessage(strings.youshot.format("flaming arrow", caster.describeThe() + "'s finger"));
        }
        Magics.missile(caster, target, [1, 3], bonus, damages.fire);
    };
    Spells["Arrow of Fire"].desc = "An arrow of fire will cause fire damage of 1d3 plus half your intelligence bonus to a single target.";
    Spells["Arrow of Fire"].inline = true;
    Spells["Mage Armour"] = function (caster, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (target.hasEffect('armour')) {
            target.getEffect('armour').duration += 20;
        } else {
            var addeddef = 4;
            target.addEffect({
                name: 'armour',
                duration: 20,
                addeddef: addeddef,
                active: true
            });
            target.defence += addeddef;
            sendMessage("A magical light surrounds %s.".format(target.type === 'player' ? "you" : target.describeThe()));
        }
    };
    Spells["Mage Armour"].desc = "A magical light will surround the target, increasing the defence bonus by 4 for 50 turns.";
    Spells["Fast Foot"] = function (caster, target) {
        Magics.speed(source, target, 10, 300, 'haste');
    };
    Spells["Fast Foot"].desc = "The speed of the target will be greatly increased for the next 10 turns.";
    Spells["Slow Down"] = function (caster, target) {
        Magics.slow(caster, target, 10, 60);
    };
    Spells["Slow Down"].desc = "The speed of the target will be greatly decreased for the next 20 turns.";
    Spells["Acid Arrow"] = function (caster, target) {
        var bonus = Math.floor(caster.getBonus(caster.intelligence) / 2);
        if (caster.type === 'player') {
            sendMessage(strings.youshot.format("arrow of acid", "your finger"));
            bonus -= caster.getEquipmentBonus('hind');
        } else {
            sendMessage(strings.youshot.format("arrow of acid", caster.describeThe() + "'s finger"));
        }
        Magics.missile(caster, target, [2, 8], bonus, damages.acid);
    };
    Spells["Acid Arrow"].desc = "An arrow of acid will cause acid damage of 2d4 plus half your intelligence bonus to a single target.";
    Spells["Acid Arrow"].inline = true;
    Spells["Touch of Idiocy"] = function (caster, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        var bonus = Math.floor(caster.getBonus(caster.intelligence) / 4);
        if (caster.type === 'player') {
            sendMessage("A ray hits %s's head: %s starts screaming!".format(target.describeThe(), target.describeThe()));
            bonus -= caster.getEquipmentBonus('hind');
            if (target.brain) {
                target.brain.angry = true;
            }
        } else {
            sendMessage("%s shoots a ray at you: you feel like you're losing your mind!".format(caster.describeThe(true)));
        }
        var dam = ROT.RNG.getUniformInt(1, 6) + bonus;
        if (dam < 1) {
            dam = 1;
        }
        target.intelligence -= dam;
        if (target.intelligence < 1) {
            if (target.type !== 'player') {
                sendMessage("%s collapses, foaming from the mouth.".format(target.describeThe(true)));
            }
            target.die();
            caster.raiseEvent('onKill', target);
        }
    };
    Spells["Touch of Idiocy"].desc = "The target's intelligence will decrease by 1d6 plus a fourth of your intelligence bonus.";
    Spells["Sleep"] = function (caster, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (target.isInvulnerableTo(damages.sleep) || target.isResistantTo(damages.sleep) ||
            ROT.RNG.getUniformInt(1, 20) + getBonus(caster.intelligence) < 10 + getBonus(target.intelligence)) {
            if (target.type === 'player') {
                sendMessage('You resist the spell!');
                return;
            } else {
                sendMessage("%s resists the spell!".format(target.describeThe(true)));
                return;
            }
        }
        if (target.hasEffect(damages.sleep)) {
            target.getEffect(damages.sleep).duration += 20;
        } else {
            target.addEffect({
                name: damages.sleep,
                duration: 20,
                active: true
            });
            if (target.type !== 'player') {
                target.type = 'sleep';
                sendMessage("%s falls asleep.".format(target.describeThe(true)));
            } else {
                sendMessage('You suddenly fall asleep!');
            }
        }
    };
    Spells["Sleep"].desc = "The target will fall asleep for up to 20 turns or until hit.";
    Spells["Sap Muscles"] = function (caster, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        var bonus = Math.floor(caster.getBonus(caster.intelligence) / 4);
        if (caster.type === 'player') {
            sendMessage("A ray hits %s: %s starts withering!".format(target.describeThe(), target.describeThe()));
            bonus -= caster.getEquipmentBonus('hind');
            if (target.brain) {
                target.brain.angry = true;
            }
        } else {
            sendMessage("%s shoots a ray at you: you feel weak and tired...".format(caster.describeThe(true)));
        }
        var dam = ROT.RNG.getUniformInt(1, 6) + bonus;
        if (dam < 1) {
            dam = 1;
        }
        target.strength -= dam;
    };
    Spells["Sap Muscles"].desc = "The target's strength will decrease by 1d6 plus a fourth of your intelligence bonus.";
    Spells["Minor Bolt"] = function (caster, target) {
        var bonus = Math.floor(caster.getBonus(caster.intelligence) / 2);
        if (caster.type === 'player') {
            sendMessage(strings.lightbolt.format("your"));
            bonus -= caster.getEquipmentBonus('hind');
        } else {
            sendMessage(strings.lightbolt.format(caster.describeThe() + "'s"));
        }
        Magics.missile(caster, target, [2, 12], bonus, damages.electro);
    };
    Spells["Minor Bolt"].desc = "A lightning bolt will cause electric damage of 2d6 plus half your intelligence bonus to a single target.";
    Spells["See Invisible"] = function (caster, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (target.hasEffect("second sight")) {
            target.getEffect("second sight").duration += 20;
        } else {
            target.addEffect({
                name: "second sight",
                duration: 20,
                active: true
            });
            if (target.type === 'player') {
                sendMessage("You can see things hidden from mortal eyes, now.");
            }
        }
    };
    Spells["See Invisible"].desc = "Allows the target to see invisible things for the next 20 rounds.";
    Spells["Ray of Light"] = function (caster, target) {
        var bonus = caster.getBonus(caster.intelligence);
        if (caster.type === 'player') {
            sendMessage(strings.youshot.format("ray of pure light", "your finger"));
            bonus -= caster.getEquipmentBonus('hind');
        } else {
            sendMessage(strings.youshot.format("ray of pure light", caster.describeThe() + "'s finger"));
        }
        Magics.missile(caster, target, [3, 18], bonus, damages.light);
    };
    Spells["Ray of Light"].desc = "A ray of pure light will cause light damage of 3d6 plus your intelligence bonus to a single target.";
    Spells["Ray of Light"].inline = true;
    Spells["Ray of Darkness"] = function (caster, target) {
        var bonus = caster.getBonus(caster.intelligence);
        if (caster.type === 'player') {
            sendMessage(strings.youshot.format("ray of pure darkness", "your finger"));
            bonus -= caster.getEquipmentBonus('hind');
        } else {
            sendMessage(strings.youshot.format("ray of pure darkness", caster.describeThe() + "'s finger"));
        }
        Magics.missile(caster, target, [3, 18], bonus, damages.dark);
    };
    Spells["Ray of Darkness"].desc = "A ray of pure darkness will cause dark damage of 3d6 plus your intelligence bonus to a single target.";
    Spells["Ray of Darkness"].inline = true;
    Spells["Fireball"] = function (caster, target) {
        var bonus = Math.floor(getBonus(caster.intelligence) / 2);
        if (caster.type === 'player') {
            sendMessage("You shoot a ball of fire from your hand!");
            bonus -= caster.getEquipmentBonus('hind');
        } else {
            sendMessage("%s shoots a ball of fire from the hand!".format(caster.describeThe(true)));
        }
        Magics.ball(caster, target, Spells["Fireball"].area, [2, 16], bonus, damages.fire, "is consumed by the fire");
    };
    Spells["Fireball"].desc = "A ball of fire will cause fire damage of 2d8 plus half your intelligence bonus to everyone in a radius of 2 tiles around the target.";
    Spells["Fireball"].area = 2;
    Spells["Teleport"] = function (caster, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (target.isInvulnerableTo(damages.tele) || target.isResistantTo(damages.tele)) {
            if (target.type === 'player') {
                sendMessage(strings.notele.format("you"));
            } else {
                sendMessage(strings.notele.format(target.describeThe()));
            }
        } else {
            if (target.type === 'player') {
                sendMessage('You suddenly find yourself in another place.');
            } else if (player.canSee(target)) {
                sendMessage("%s disappears from your sight.".format(target.describeThe(true)));
            }
            World.moveEntity(target);
        }
    };
    Spells["Teleport"].desc = "The target will be moved to another part of the dungeon at random.";
    Spells["Invisibility"] = function (caster, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        target.addEffect({
            name: "invisible",
            duration: 20,
            active: true
        });
        if (target.type === 'player') {
            sendMessage("You can no longer see yourself.");
        } else {
            sendMessage("%s disappears.".format(target.describeThe(true)));
        }
    };
    Spells["Invisibility"].desc = "The target will become invisible to normal eyes for the next 20 rounds.";
    Spells["Paralysis"] = function (caster, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (target.isInvulnerableTo(damages.paral) ||
            ROT.RNG.getUniformInt(1, 20) + target.getBonus(target.intelligence) > 10 + caster.getBonus(caster.intelligence)) {
            if (target.type === 'player') {
                sendMessage('You resist the spell!');
                return;
            } else {
                sendMessage("%s resists the spell!".format(target.describeThe(true)));
                return;
            }
        }
        if (target.hasEffect(damages.paral)) {
            target.getEffect(damages.paral).duration += ROT.RNG.getUniformInt(2, 12);
        } else {
            target.addEffect({
                name: damages.paral,
                duration: ROT.RNG.getUniformInt(2, 12),
                active: true
            });
            if (target.type !== 'player') {
                sendMessage("%s is paralyzed.".format(target.describeThe(true)));
            } else {
                sendMessage("You suddenly can't move!");
            }
        }
    };
    Spells["Paralysis"].desc = "The target will be paralyzed for the next 2d6 turns."
    Spells["Melt Floor"] = function (caster, target) {
        World.setTile(target[0], target[1], Templates.magmaTile);
        var place = World.getTile(target[0], target[1]);
        target = World.getEntityAt(target[0], target[1]);
        if (!target) {
            return;
        }
        var dam = place.getDamage(target);
        if (caster.type === 'player') {
            sendMessage(strings.floorburn.format(target.describeThe() + "'s", dam));
            if (target.brain) {
                target.brain.angry = true;
            }
        } else if (target.type === 'player') {
            sendMessage(strings.floorburn.format("your", dam));
        }
        target.changeHealth(-dam);
        if (target.type === 'player' && !player.isAlive()) {
            necro = strings.dundeath.format(player.getName(), player.plclass, World.lvl, World.name) +
                strings.burndeath;
        } else if (caster.type === 'player' && !target.isAlive()) {
            player.raiseEvent('onKill', target);
        }
    };
    Spells["Melt Floor"].desc = "The targeted tile will be turned into a pool of magma.";
    Spells["Quicksand"] = function (caster, target) {
        World.map[target[0]][target[1]] = Templates.quicksandTile;
        var place = World.getTile(target[0], target[1]);
        target = World.getEntityAt(target[0], target[1]);
        if (!target) {
            return;
        }
        if (caster.type === 'player') {
            sendMessage(strings.floorsand.format(target.describeThe() + "'s"));
            if (target.brain) {
                target.brain.angry = true;
            }
        } else if (target.type === 'player') {
            sendMessage(strings.floorsand.format("your"));
        }
    };
    Spells["Quicksand"].desc = "The targeted tile will be turned into quicksand.";
    Spells["Lightning Bolt"] = function (caster, target) {
        var bonus = caster.getBonus(caster.intelligence);
        if (caster.type === 'player') {
            sendMessage(strings.lightbolt.format("your"));
        } else {
            sendMessage(strings.lightbolt.format(caster.describeThe() + "'s"));
        }
        Magics.missile(caster, target, [bonus, bonus * 8], 0, damages.electro);
    };
    Spells["Lightning Bolt"].desc = "A big lightning bolt will cause electric damage up to 8 times your intelligence bonus to a single target.";
    Spells["Word of Recall"] = function (caster, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (isWilderness) {
            sendMessage("This spell only works inside of a dungeon.");
            return;
        }
        if (target.isInvulnerableTo(damages.tele) || target.isResistantTo(damages.tele)) {
            if (target.type === 'player') {
                sendMessage(strings.notele.format("you"));
            } else {
                sendMessage(strings.notele.format(target.describeThe()));
            }
        } else {
            if (target.type === 'player') {
                backToWilderness();
                sendMessage('You are back to the surface, the horrors of the dungeon now somewhere behind you.');
            } else if (caster.type === 'player') {
                sendMessage("%s disappears from your sight.".format(target.describeThe(true)));
            }
        }
    };
    Spells["Word of Recall"].desc = "The target will be safely teleported right outside of the whole dungeon.";
    Spells["Dispel Magic"] = function (caster, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        var eff = target.getEffects();
        eff.forEach(function (a) {
            if (a !== damages.pois) {
                target.removeEffect(a);
            }
        });
        if (caster.type === 'player') {
            sendMessage("All the magic affecting %s disappears!".format(target.type === 'player' ?
                'you' : target.describeThe()));
        }
    };
    Spells["Dispel Magic"].desc = "All of the magic (good or bad) affecting the target will be removed.";
    Spells["Petrify"] = function (caster, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (target.isInvulnerableTo(damages.petro) ||
            ROT.RNG.getUniformInt(1, 20) + getBonus(caster.intelligence) < 10 +
            getBonus(target.intelligence) + target.isResistantTo(damages.petro) ? 5 : 0) {
            if (target.type === 'player') {
                sendMessage('You resist the spell!');
            } else if (caster.type === 'player') {
                sendMessage("%s resists the spell!".format(target.describeThe(true)));
            }
            return;
        }
        var temp = {
            name: target.name + ' statue',
            plural: target.name + ' statues',
            ch: target.ch,
            fg: 'gray',
            description: "The stone statue of a " + target.name,
            mixins: [Mixins.Item],
            type: target.name + ' stat'
        };
        World.addItem(makeThing(temp), target.getPosition());
        if (target.type !== 'player') {
            sendMessage(strings.youstoneit.format(target.describeThe(true)));
            if (caster.type === 'player') {
                player.raiseEvent('onKill', target);
            }
            World.removeEntity(target);
        } else {
            sendMessage(strings.stoneyou);
            player.act();
        }
    };
    Spells["Petrify"].desc = "Turn the target into a statue, killing it in the process.";
    Spells["Thunderstorm"] = function (caster, target) {
        var bonus = caster.getBonus(caster.intelligence);
        if (caster.type === 'player') {
            sendMessage("A violent storm rages in front of you!");
            bonus -= caster.getEquipmentBonus('hind');
        } else {
            sendMessage("A violent storm rages all around you!");
        }
        Magics.ball(caster, target, Spells["Thunderstorm"].area, [5, 40], bonus, damages.electro, "is destroyed");
    };
    Spells["Thunderstorm"].desc = "A violent storm filled with lightning bolts will cause electric damage of 5d8 plus your intelligence bonus to everyone in a radius of 4 tiles around the target.";
    Spells["Thunderstorm"].area = 4;
    Spells["Ice Storm"] = function (caster, target) {
        var bonus = caster.getBonus(caster.intelligence);
        if (caster.type === 'player') {
            sendMessage("Deadly shards of ice fill the air in front of you!");
            bonus -= caster.getEquipmentBonus('hind');
        } else {
            sendMessage("Deadly shards of ice fill the air all around you!");
        }
        Magics.ball(caster, target, Spells["Ice Storm"].area, [5, 50], bonus, damages.cold, "shatters");
    };
    Spells["Ice Storm"].desc = "A violent storm filled with ice shrapnel will cause cold damage of 5d10 plus your intelligence bonus to everyone in a radius of 4 tiles around the target.";
    Spells["Ice Storm"].area = 4;
    Spells["Insanity"] = function (caster, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        var duel = ROT.RNG.getUniformInt(1, 20) + caster.getBonus(caster.intelligence);
        if (target.isInvulnerableTo(damages.confu) ||
            duel < 10 + target.getBonus(target.intelligence) + target.isResistantTo(damages.confu) ? 5 : 0) {
            if (target.type === 'player') {
                sendMessage("Your head suddenly aches, but soon it passes.");
            } else {
                sendMessage("%s looks confused for a second, but soon it passes.".format(target.describeThe(true)));
            }
        } else {
            target.addEffect({
                name: damages.confu,
                duration: 100,
                active: true
            });
            target.intelligence -= 2;
            target.wisdom -= 2;
            if (target.type === 'player') {
                sendMessage('You are really going insane this time...');
            } else {
                target.type = 'confused';
                sendMessage("%s looks extremely confused.".format(target.describeThe(true)));
            }
        }
    };
    Spells["Insanity"].desc = "The target will be unable to think or act rationally for the next 100 rounds.";
    Spells["Great Shout"] = function (caster, target) {
        var bonus = caster.getBonus(caster.intelligence);
        if (caster.type === 'player') {
            sendMessage("An extremely loud sound emanates from you.");
            bonus -= caster.getEquipmentBonus('hind');
        } else {
            sendMessage("An extremely loud sound makes your ears tremble");
        }
        if (!Array.isArray(target)) {
            target = [target.x, target.y];
        }
        var victims = World.getEntitiesWithinRadius(target[0], target[1], 3);
        victims.forEach(function (a) {
            if (a === caster) {
                return;
            }
            var result = testVulnerability(a, ROT.RNG.getUniformInt(6, 60) + bonus, damages.sound);
            var dam = result[0];
            if (caster && caster.type === 'player') {
                if (caster.canSee(a)) {
                    sendMessage(strings.ishit.format(a.describeThe(true), dam));
                }
                a.brain.angry = true;
                if (result[1]) {
                    sendMessage(result[1]);
                }
            }
            a.changeHealth(-dam);
            if (caster.type === 'player' && !a.isAlive()) {
                player.raiseEvent('onKill', a);
            }
        });
        setItems(target[0], target[1], 3, damages.sound, "shatters", caster.type === 'player');
    };
    Spells["Great Shout"].desc = "A sonic wave will cause sound damage of 10d6 plus your intelligence bonus to everything in a ray of 3 tiles around you.";
    Spells["Great Shout"].notarget = true;
    Spells["Swansong"] = function (caster, target) {
        if (caster.type === 'player') {
            sendMessage("You lift your arms to the sky and sing an ancient song of Power.");
        } else {
            sendMessage("%s lift the arms to the sky and sings an ancient song of Power.".format(caster.describeThe(true)));
        }
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (caster.type === 'player') {
            if (caster.canSee(target)) {
                sendMessage("%s dies, consumed by a surge of magic strong enough to crack the very fabric of reality.".format(target.describeThe(true)));
            } else {
                sendMessage("Something screams, consumed by a surge of magic strong enough to crack the very fabric of reality.");
            }
        } else if (target.type === 'player') {
            sendMessage(strings.youhit.format(dam));
        }
        target.die();
        caster.raiseEvent('onKill', target);
        caster.die(caster.type === 'player');
        if (caster.type === 'player' && !caster.isAlive()) {
            necro = strings.dundeath.format(player.getName(), player.plclass, World.lvl, World.name) +
                " killed by the strain of casting the ultimate spell.";
        }
    };
    Spells["Swansong"].desc = "It will instantly kill the target, no matter how strong it is. Unfortunately, it will also kill the caster, that is YOU.";
    //for shamans
    Spells.shamans = ["Minor Healing", "Minor Curse"]
    Spells["Minor Healing"] = function (caster, target) {
        var bonus = caster.getBonus(caster.wisdom);
        var cure = ROT.RNG.getUniformInt(3, 18) + bonus;
        if (caster.type === 'player') {
            sendMessage(strings.cure.format("you"));
        } else {
            sendMessage(strings.cure.format(caster.describeThe()));
        }
        Magics.heal(target, cure);
    };
    Spells["Minor Healing"].desc = "A holy light will allow the target to recover up to 3d6 HP plus your wisdom bonus.";
    Spells["Healing"] = function (caster, target) {
        var bonus = caster.getBonus(caster.wisdom);
        var cure = ROT.RNG.getUniformInt(6, 48) + bonus;
        if (caster.type === 'player') {
            sendMessage(strings.cure.format("you"));
        } else {
            sendMessage(strings.cure.format(caster.describeThe()));
        }
        Magics.heal(target, cure);
    };
    Spells["Healing"].desc = "A holy light will allow the target to recover up to 6d8 HP plus your wisdom bonus.";
    Spells["Major Healing"] = function (caster, target) {
        var bonus = caster.getBonus(caster.wisdom);
        var cure = ROT.RNG.getUniformInt(8, 80) + bonus;
        if (caster.type === 'player') {
            sendMessage(strings.cure.format("you"));
        } else {
            sendMessage(strings.cure.format(caster.describeThe()));
        }
        Magics.heal(target, cure);
    };
    Spells["Major Healing"].desc = "A holy light will allow the target to recover up to 8d10 HP plus your wisdom bonus.";
    Spells["Minor Curse"] = function (caster, target) {
        var bonus = caster.getBonus(caster.wisdom);
        if (caster.type === 'player') {
            sendMessage("You point your finger and curse.");
        } else if (target.type === 'player') {
            if (target.canSee(caster)) {
                sendMessage("%s points a finger at you and curses.".format(caster.describeThe(true)));
            } else {
                sendMessage("You hear an eldritch singsong.");
            }
        } else {
            sendMessage("%s points a finger and curses.".format(caster.describeThe(true)));
        }
        Magics.missile(caster, target, [2, 12], bonus, damages.unholy);
    };
    Spells["Curse"] = function (caster, target) {
        var bonus = caster.getBonus(caster.wisdom);
        if (caster.type === 'player') {
            sendMessage("You point your finger and curse.");
        } else if (target.type === 'player') {
            if (target.canSee(caster)) {
                sendMessage("%s points a finger at you and curses.".format(caster.describeThe(true)));
            } else {
                sendMessage("You hear an eldritch singsong.");
            }
        } else {
            sendMessage("%s points a finger and curses.".format(caster.describeThe(true)));
        }
        Magics.missile(caster, target, [5, 30], bonus, damages.unholy);
    };
    Spells["Major Curse"] = function (caster, target) {
        var bonus = caster.getBonus(caster.wisdom);
        if (caster.type === 'player') {
            sendMessage("You point your finger and curse.");
        } else if (target.type === 'player') {
            if (target.canSee(caster)) {
                sendMessage("%s points a finger at you and curses.".format(caster.describeThe(true)));
            } else {
                sendMessage("You hear an eldritch singsong.");
            }
        } else {
            sendMessage("%s points a finger and curses.".format(caster.describeThe(true)));
        }
        Magics.missile(caster, target, [20, 50], bonus, damages.unholy);
    };
    //for priests
    Spells.priests1 = ["Blessing", "Minor Healing", "Minor Curse"];
    Spells.priests2 = ["Healing", "Curse", "Bless Weapon", "Curse Weapon", "God Beam", "Evil Beam"];
    Spells.priests3 = ["Major Healing", "Major Curse", "Smite the Self-Righteous", "Smite the Ungodly"];
    Spells["Blessing"] = function (caster, target) {
        target = targetFromArray(target, World);
        if (!target) {
            return;
        }
        if (target.hasEffect('blessing')) {
            return;
        } else {
            var incr = 4;
            target.addEffect({
                name: 'blessing',
                duration: 50,
                incr: incr,
                active: true
            });
            target.defence += incr;
            target.attackBonus += incr;
            sendMessage("A divine light surrounds %s.".format(target.type === 'player' ? "you" : target.describeThe()));
        }
    };
    Spells["Bless Weapon"] = function (caster, target) {
        if (target.hasEffect('blessed')) {
            target.getEffect('blessed').duration += 10 + getBonus(caster.wisdom);
            return;
        }
        if (caster.type === 'player') {
            sendMessage("A light surrounds your %s.".format(target.getName()));
        }
        target.addEffect({
            name: 'blessed',
            isAdded: target.extraDamageType.indexOf(damages.holy) >= 0 ? false : true,
            oldname: target.getName(),
            duration: 10 + getBonus(caster.wisdom),
            active: true
        });
        if (target.extraDamageType.indexOf(damages.holy) < 0) {
            target.extraDamageType.push(damages.holy);
            target.name += " (blessed)";
        }
    };
    Spells["Bless Weapon"].item = true;
    Spells["Curse Weapon"] = function (caster, target) {
        if (target.hasEffect('cursed')) {
            target.getEffect('cursed').duration += 10 + getBonus(caster.wisdom);
            return;
        }
        if (caster.type === 'player') {
            sendMessage("A light surrounds your %s.".format(target.getName()));
        }
        target.addEffect({
            name: 'cursed',
            isAdded: target.extraDamageType.indexOf(damages.unholy) >= 0 ? false : true,
            oldname: target.getName(),
            duration: 10 + getBonus(caster.wisdom),
            active: true
        });
        if (target.extraDamageType.indexOf(damages.unholy) < 0) {
            target.extraDamageType.push(damages.unholy);
            target.name += " (cursed)";
        }
    };
    Spells["Curse Weapon"].item = true;
    Spells["Evil Beam"] = function (caster, target) {
        var bonus = caster.getBonus(caster.wisdom);
        if (caster.type === 'player') {
            sendMessage(strings.youshot.format("ray of unholy light", "your finger"));
        } else {
            sendMessage(strings.youshot.format("ray of unholy light", caster.describeThe() + "'s finger"));
        }
        Magics.missile(caster, target, [3, 18], bonus, damages.unholy);
    };
    Spells["Evil Beam"].desc = "A ray of unholy light will cause unholy damage of 3d6 plus your wisdom bonus to a single target.";
    Spells["God Beam"] = function (caster, target) {
        var bonus = caster.getBonus(caster.wisdom);
        if (caster.type === 'player') {
            sendMessage(strings.youshot.format("ray of holy light", "your finger"));
        } else {
            sendMessage(strings.youshot.format("ray of holy light", caster.describeThe() + "'s finger"));
        }
        Magics.missile(caster, target, [3, 18], bonus, damages.holy);
    };
    Spells["God Beam"].desc = "A ray of holy light will cause holy damage of 3d6 plus your wisdom bonus to a single target.";
    Spells["Smite the Self-Righteous"] = function (caster, target) {
        var bonus = Math.floor(caster.getBonus(caster.wisdom) / 2);
        if (caster.type === 'player') {
            bonus -= caster.getEquipmentBonus('hind');
        }
        sendMessage(strings.smite);
        Magics.missile(caster, target, [6, 60], bonus, damages.unholy);
    };
    Spells["Smite the Self-Righteous"].desc = "A cursed hammer of impure light will cause an unholy damage of 6d10 plus half your wisdom bonus to a single target.";
    Spells["Smite the Ungodly"] = function (caster, target) {
        var bonus = Math.floor(caster.getBonus(caster.wisdom) / 2);
        if (caster.type === 'player') {
            bonus -= caster.getEquipmentBonus('hind');
        }
        sendMessage(strings.smite);
        Magics.missile(caster, target, [6, 60], bonus, damages.holy);
    };
    Spells["Smite the Ungodly"].desc = "A divine hammer of light will cause a holy damage of 6d10 plus half your wisdom bonus to a single target.";

    /*
     * Actions and suchlike
     */
    var aimWand = function (what, target, user) {
        Powers[what.power](what, target, user);
        what.charges--;
    };
    /**
     * @param {Thing} attacker
     * @param {Thing} target
     * @returns {Boolean}
     */
    var attack = function (attacker, target) {
        if (attacker === target) {
            return false;
        }
        if (attacker.type === 'player' && target.brain && !target.brain.angry) {
            target.brain.angry = true;
        }
        if (target.hasEffect('sleep')) {
            target.removeEffect('sleep');
        }
        for (var i = 0; i < attacker.attackPerRound; i++) {
            var duel = ROT.RNG.getUniformInt(1, 20);
            if (duel === 1) {
                if (attacker.type === 'player') {
                    sendMessage("You miss horribly.");
                } else if (target.type === 'player' && target.canSee(attacker)) {
                    sendMessage("%s misses you horribly.".format(attacker.describeThe(true)));
                }
                break;
            }
            if (duel === 20 || duel + attacker.getAttackValue() >= 10 + target.getDefence()) {
                var dam = attacker.getDamage();
                var result = false;
                var hplost = 0;
                if (duel === 20) {
                    if (attacker.hasMixin(Mixins.Equipper) && attacker.getHand1()) {
                        dam *= attacker.getHand1().critical;
                    } else {
                        dam *= 2;
                    }
                }
                dam = dam < 0 ? 1 : dam;
                if (attacker.getDamageType()) {
                    result = testVulnerability(target, dam, attacker.getDamageType());
                    dam = result[0];
                }
                var mex = '';
                if (attacker.type === 'player') {
                    mex = "You hit %s: -%s.".format(attacker.canSee(target) ? target.describeThe() : 'something', dam);
                    if (result && result[1]) {
                        mex += " " + result[1];
                    }
                } else if (target.type === 'player') {
                    var culprit = target.canSee(attacker) ? attacker.describeThe(true) : 'Something';
                    if ((dam / target.maxhp) * 100 < 10) {
                        mex = "%s hits you: -%s.".format(culprit, dam);
                    } else {
                        mex = "%s smashes you: -%s.".format(culprit, dam);
                    }
                }
                sendMessage(mex);
                hplost = target.changeHealth(-dam);
                attacker.raiseEvent('onHit', target, dam);
                if (attacker.hasMixin(Mixins.Equipper) && attacker.getHand1()) {
                    attacker.getHand1().raiseEvent('onHit', target, hplost, attacker);
                }
                target.raiseEvent('onTouched', attacker, dam);
                if (!target.isAlive()) {
                    attacker.raiseEvent('onKill', target);
                    return;
                }
            } else {
                if (attacker.type === 'player') {
                    sendMessage(strings.youmiss.format(target.describeThe()));
                } else if (target.type === 'player') {
                    sendMessage("%s misses you.".format(attacker.describeThe(true)));
                }
            }
        }
    };
    var butcher = function (what, isPlayer) {
        if (what.butchered) {
            if (isPlayer) {
                sendMessage("%s is already butchered.".format(what.describeThe(true)));
            }
            return;
        }
        if (what.cooked) {
            if (isPlayer) {
                sendMessage("You should have butchered %s before cooking it.".format(what.describeThe()));
            }
            return;
        }
        if (what.number > 1) {
            what = what.separateItems();
        }
        if (isPlayer) {
            player.removeItem(what);
            sendMessage("You happily butcher %s.".format(what.describeThe()));
        }
        what.butchered = true;
        var text = what.description;
        what.name = what.name.replace(/corpse/, '');
        what.rename("butchered " + what.name);
        what.name = what.name.trim();
        if (what.plural) {
            what.plural = "butchered " + what.plural;
            what.plural = what.plural.replace(/corpses/, '');
        }
        text = text.replace(/. How yummy.../, ", ready to be cooked.");
        text = text.replace(/rotting/, "butchered");
        what.description = text;
        what.type = "butch " + what.type;
        if (isPlayer) {
            player.addItem(what);
        }
    };
    var castPrayer = function (who, spell, target) {
        var duel = ROT.RNG.getUniformInt(1, 20);
        if (duel === 1) {
            if (who.type === 'player') {
                sendMessage("You babble clumsily your prayer.");
            }
            return false;
        }
        if (duel === 20 || duel + who.getBonus(who.wisdom) >= 10) {
            Spells[spell](who, target);
            return true;
        } else if (who.type === 'player') {
            sendMessage("Your prayer remains unanswered.");
        }
        return false;
    };
    var castSpell = function (who, spell, target) {
        var duel = ROT.RNG.getUniformInt(1, 20);
        if (duel === 1) {
            if (who.type === 'player') {
                sendMessage("The spell is a complete failure.");
                who.changeHealth(-1);
                if (!who.isAlive()) {
                    necro = strings.dundeath.format(who.getName(), who.plclass, World.lvl, World.name) + strings.magifail;
                }
            }
            return false;
        }
        if (duel !== 20 && who.type === 'player') {
            duel -= who.getEquipmentBonus('hind');
        }
        if (duel === 20 || duel + getBonus(who.intelligence) >= 10) {
            Spells[spell](who, target);
            return true;
        } else if (who.type === 'player') {
            sendMessage("The spell fails.");
        }
        return false;
    };
    var cook = function (what, isPlayer) {
        if (what.cooked) {
            if (isPlayer) {
                sendMessage("%s is already cooked.".format(what.describeThe(true)));
            }
            return;
        }
        if (what.number > 1) {
            what = what.separateItems();
        }
        if (isPlayer) {
            player.removeItem(what);
            sendMessage("You cook %s while whistling a jolly tune.".format(what.describeThe()));
        }
        what.cooked = true;
        var text = what.description;
        if (what.butchered) {
            what.rename(what.name.replace(/butchered/, 'cooked'));
            what.rename(what.name.replace(/corpse/, ''));
            what.name = what.name.trim();
            text = text.replace(/, ready to be cooked./, ". Looks tasty.");
            text = text.replace(/butchered corpse/, "cooked remains");
            what.description = text;
            text = what.type;
            text = text.replace(/butchered/, "cooked");
            text = text.replace(/corpse/, "");
            text = text.trim();
            what.type = text;
            if (what.power === 'poison') {
                what.power = null;
            }
            if (what.plural) {
                text = what.plural;
                text = text.replace(/butchered/, 'cooked');
                text = text.replace(/corpses/, '');
                what.plural = text;
            }
        } else {
            what.rename("cooked " + what.name);
            text = text.replace(/. How yummy.../, ".");
            text = text.replace(/rotting/, "cooked");
            what.description = text;
            what.type = "cooked " + what.type;
            if (what.plural) {
                what.plural = "cooked " + what.plural;
            }
        }
        if (isPlayer) {
            player.addItem(what);
        }
    };
    var disposeAmmo = function (attacker, target) {
        if (attacker.ammo.hasEffect('alight')) {
            var temp = attacker.ammo.getEffect('alight');
            attacker.ammo.breakingChances = temp.basechanches;
            if (temp.isAdded) {
                attacker.ammo.extraDamageType = attacker.ammo.extraDamageType.filter(function (a) {
                    return a !== damages.fire;
                });
            }
            if (temp.isPlayer) {
                sendMessage('Your ammo burns up completely.');
            }
            attacker.ammo.removeEffect('alight');
            attacker.ammo.raiseEvent('onBroken', attacker, target);
        } else if (attacker.ammo.isBroken(ROT.RNG.getPercentage())) {
            if (attacker.type === "player") {
                sendMessage(strings.ammobr);
            }
            attacker.ammo.raiseEvent('onBroken', attacker, target);
        } else {
            attacker.putAmmoToGround(world, target.getPosition());
        }
        attacker.decreaseAmmos();
    };
    var drink = function (who, what) {
        if (who.type === 'player') {
            sendMessage("You drink %s.".format(what.describeA()));
        }
        if (what.power) {
            Powers[what.power](what, who);
        }
        what.doses--;
        if (what.doses < 1) {
            who.removeSingleItem(what);
        }
    };
    var eat = function (who, what) {
        if (who.type === 'player') {
            sendMessage("You eat %s.".format(what.describeA()));
            if (!what.hasMixin(Mixins.Cookable) && !what.hasMixin(Mixins.Butcherable)) {
                sendMessage("Crunch, crunch, crunch...");
            } else if (what.butchered && !what.cooked) {
                what.energy = Math.floor(what.energy / 3);
                sendMessage("Next time try cooking it first, please.");
            } else if (what.cooked && !what.butchered) {
                what.energy = Math.floor(what.energy / 2);
                sendMessage("Next time try to butcher it first, to remove all the more revolting bits.");
            } else if (what.butchered && what.cooked) {
                sendMessage("Not bad, after all: tastes like adventure.");
            } else {
                what.energy = Math.floor(what.energy / 4);
                if (/rat/i.test(what.name) || /centipede/i.test(what.name)) {
                    sendMessage("Honestly, that's low even for someone like you.");
                } else if (/corpse/i.test(what.name)) {
                    sendMessage("That's disgusting...");
                } else if (/cockroach/i.test(what.name)) {
                    sendMessage("Really, what's wrong with you?");
                } else if (/bone/i.test(what.name)) {
                    sendMessage("Crunchy, but not very tasty.");
                }
            }
        }
        if (who.hasMixin(Mixins.Eater)) {
            who.setEnergy(what.energy);
        }
        if (what.power) {
            Powers[what.power](what, who);
        }
        what.portions--;
        if (what.portions < 1) {
            who.removeSingleItem(what);
        }
    };
    var getBonus = function (which) {
        if (which <= 1) {
            return -5;
        } else if (which === 10 || which === 11) {
            return 0;
        } else {
            if (which < 10) {
                return Math.floor((which - 11) / 2);
            } else {
                return Math.floor((which - 10) / 2);
            }
        }
    };
    var getEverything = function (who) {
        var items = who.getItems();
        var equip = who.equipment.slice();
        if (who.hasMixin(Mixins.Shooter)) {
            equip.push(who.ranged);
            equip.push(who.ammo);
        }
        if (equip.length > 0) {
            if (items) {
                items = equip.concat(items);
            } else {
                items = equip;
            }
        }
        return items;
    };
    var pickupItems = function (indices, who, world) {
        var mapItems = world.getItemsAt(who.getX(), who.getY());
        var added = 0;
        for (var i = 0, j = indices.length; i < j; i++) {
            if (who.addItem(mapItems[indices[i] - added])) {
                mapItems.splice(indices[i] - added, 1);
                added++;
            } else {
                break;
            }
        }
        if (added) {
            world.setItemsAt(mapItems, who.getX(), who.getY());
        }
        return added === indices.length;
    };
    var read = function (who, what) {
        if (who.type === 'player') {
            sendMessage("You read %s.".format(what.describeA()));
        }
        if (what.isOneshot()) {
            who.removeSingleItem(what);
        }
        if (what.power) {
            return Powers[what.power](what, who);
        } else if (who.type === 'player') {
            sendMessage("%s has no visible effect.".format(what.describeThe(true)));
        }
        return true;
    };
    /**
     * What happens after an Item has been thrown.
     * @param {Thing} thrower the one who threw it.
     * @param {Thing} item the thrown item
     * @param {Array} target the place the thrower is targetting
     */
    var resolveThrownItem = function (thrower, item, target) {
        var where = World.getTile(target[0], target[1]);
        if (item.fragile) {
            if (thrower.type === 'player') {
                sendMessage("%s breaks.".format(item.describeThe(true)));
            }
            item.raiseEvent('onBroken', thrower, target);
        } else if (!where.isWalkable()) {
            if (thrower.type === 'player') {
                sendMessage("%s hits the wall and breaks.".format(item.describeThe(true)));
            }
            item.raiseEvent('onBroken', thrower, target);
        } else {
            if (item.dam2) {
                var victim = World.getEntityAt(target[0], target[1]);
                if (victim) {
                    var dam = item.getDamage();
                    if (thrower.type === 'player' && thrower.plclass === 'ranger') {
                        dam += getBonus(thrower.strength);
                    }
                    dam = testVulnerability(victim, dam, item.damageType);
                    if (dam[0] > 0) {
                        if (thrower.type === 'player') {
                            if (thrower.canSee(victim)) {
                                sendMessage(strings.ishit.format(victim.describeThe(true), dam[0]));
                            } else {
                                sendMessage(strings.unseenhit);
                            }
                        } else if (victim.type === 'player') {
                            sendMessage(strings.youhit.format(dam[0]));
                        }
                        victim.changeHealth(-dam[0]);
                        item.raiseEvent('onHit', victim, dam[0], thrower);
                        if (!victim.isAlive()) {
                            thrower.raiseEvent('onKill', victim);
                        }
                    } else {
                        sendMessage("The attack has no effect.");
                    }
                } else if (item.returning) {
                    thrower.addItem(item);
                    if (thrower.type === 'player') {
                        sendMessage("%s comes back to you.".format(item.describeThe(true)));
                    }
                    return true;
                }
            }
            World.addItem(item, { x: target[0], y: target[1] });
        }
    };
    /**
     * What happens to items where things went boom.
     * @param {Number} x the x-axis.
     * @param {Number} y the y-axis.
     * @param {Number} radius how wide the effect is.
     * @param {String} damage the type of damage.
     * @param {String} text a text message to be displayed.
     * @param {Thing} actor the one who caused the explosion.
     */
    var setItems = function (x, y, radius, damage, text, actor) {
        var places = World.getTilesWithinRadius(x, y, radius);
        if (places.length > 0) {
            places.forEach(function (a) {
                var items = World.getItemsAt(a.x, a.y);
                if (items) {
                    var survivors = [];
                    for (var i = 0; i < items.length; i++) {
                        var it = items[i];
                        if (it.isInvulnerableTo(damage) || (it.isResistantTo(damage) && ROT.RNG.getPercentage() < 80) ||
                            (!it.isVulnerableTo(damage) && ROT.RNG.getPercentage() < 10)) {
                            if (it.hasMixin(Mixins.Cookable) && damage === damages.fire) {
                                cook(it);
                            }
                            survivors.push(it);
                        } else {
                            it.raiseEvent('onBroken', actor, [x, y]);
                            if (actor.type === 'player' && player.canSee(it)) {
                                sendMessage("%s %s.".format(it.describeThe(true), text));
                            }
                        }
                    }
                    World.setItemsAt(survivors, a.x, a.y);
                }
            });
        }
    };
    /**
     * @param {Thing} attacker
     * @param {Thing} target
     * @returns {Boolean}
     */
    var shoot = function (attacker, target) {
        if (attacker === target) {
            return false;
        }
        if (attacker.type === 'player' && target.brain && !target.brain.angry) {
            target.brain.angry = true;
        }
        if (target.hasEffect('sleep')) {
            target.removeEffect('sleep');
        }
        var duel = ROT.RNG.getUniformInt(1, 20);
        if (duel === 1) {
            if (attacker.type === 'player') {
                sendMessage("You miss horribly.");
            } else if (target.type === 'player') {
                if (target.canSee(attacker)) {
                    sendMessage("%s misses you horribly.".format(attacker.describeThe(true)));
                } else {
                    sendMessage("%s completely misses you.".format(attacker.ammo.describeA(true)));
                }
            }
            disposeAmmo(attacker, target);
            return false;
        }
        if (duel === 20 || duel + attacker.getRangedValue() >= 10 + target.getDefence()) {
            var dam = attacker.getRangedDamage() + attacker.getAmmo().bonus;
            var result = false;
            if (attacker.type === 'player' && attacker.plclass === 'ranger') {
                dam += getBonus(attacker.strength);
            }
            if (duel === 20) {
                dam *= attacker.getRanged().critical;
            }
            if (attacker.getAmmo().damageType) {
                result = testVulnerability(target, dam, attacker.getAmmo().damageType);
                dam = result[0];
            }
            var mex = '';
            if (attacker.type === 'player') {
                mex = "You shoot %s: -%s.".format(attacker.canSee(target) ? target.describeThe() : 'something', dam);
                if (result && result[1]) {
                    mex += " " + result[1];
                }
            } else if (target.type === 'player') {
                if (target.canSee(attacker)) {
                    mex = "%s shoots you: -%s.".format(attacker.describeThe(true), dam);
                } else {
                    mex = "%s hits you: -%s.".format(attacker.ammo.describeA(true), dam);
                }
            }
            sendMessage(mex);
            target.changeHealth(-dam);
            attacker.raiseEvent('onHit', target, dam);
            attacker.getAmmo().raiseEvent('onHit', target, dam, attacker);
            if (!target.isAlive()) {
                attacker.raiseEvent('onKill', target);
            }
            disposeAmmo(attacker, target);
            return true;
        } else {
            if (attacker.type === 'player') {
                sendMessage(strings.youmiss.format(target.describeThe()));
            } else if (target.type === 'player') {
                if (target.canSee(attacker)) {
                    sendMessage(strings.youmissed.format(attacker.describeThe(true)));
                } else {
                    sendMessage(strings.youmissed.format(attacker.ammo.describeA(true)));
                }
            }
            disposeAmmo(attacker, target);
            return false;
        }
    };
    var summon = function (who, world) {
        if (ROT.RNG.getPercentage() > 21) {
            if (who.type !== 'player' && player.canSee(who)) {
                sendMessage("%s tries to summon help, but fails.".format(who.describeThe(true)));
            }
            return true;
        }
        var where = world.getFreeTilesWithinRadius(who.x, who.y);
        if (where.length) {
            sendMessage("%s summons help.".format(who.describeThe(true)));
            var temp;
            where.forEach(function (a) {
                temp = who.summonable.random();
                if (typeof temp === 'string') {
                    temp = Templates[temp];
                }
                world.addEntity(makeThing(temp), a);
            });
            return true;
        }
        return false;
    };
    var targetFromArray = function (target, world) {
        if (Array.isArray(target)) {
            return World.getEntityAt(target[0], target[1]);
        }
        return target;
    };
    var testVulnerability = function (who, amount, type, isSecondary) {
        var result = [amount, false];
        if (who.isInvulnerableTo(type)) {
            result[0] = 0;
            result[1] = who.type === 'player' ? strings.youvultest.format("unfazed", type) :
                strings.vultest.format(who.describeThe(true), "unfazed", type);
        } else if (who.isResistantTo(type)) {
            result[0] = Math.floor(amount / 2);
            result[1] = who.type === 'player' ? strings.youvultest.format("barely hurt", type) :
                strings.vultest.format(who.describeThe(true), "barely hurt", type);
        } else if (who.isVulnerableTo(type)) {
            result[0] = amount * 2;
            result[1] = who.type === 'player' ? strings.youvultest.format("hit hard", type) :
                strings.vultest.format(who.describeThe(true), "hit hard", type);
        } else if (isSecondary) {
            result[0] = amount;
            result[1] = who.type === 'player' ? strings.youvultest.format("hurt", type) :
                strings.vultest.format(who.describeThe(true), "hurt", type);
        }
        return result;
    };
    var throwItem = function (attacker, target, item) {
        var victim = null;
        if (Array.isArray(target)) {
            victim = World.getEntityAt(target[0], target[1]);
            if (!victim) {
                resolveThrownItem(attacker, item, target);
                return true;
            }
        } else {
            victim = target;
        }
        var duel = ROT.RNG.getUniformInt(1, 20);
        if (duel === 20 || duel + getBonus(attacker.dexterity) >= 10 + victim.getDefence()) {
            if (attacker.type === 'player' && victim.brain && !victim.brain.angry) {
                victim.brain.angry = true;
            }
            if (victim.hasEffect('sleep')) {
                victim.removeEffect('sleep');
            }
            var mex = '';
            if (attacker.type === 'player') {
                mex = "You throw %s to %s.".format(item.describeA(), attacker.canSee(target) ? victim.describeThe() : 'someone');
            } else if (victim.type === 'player') {
                mex = "%s throws -%s to you.".format(victim.canSee(attacker) ? attacker.describeThe(true) : 'Someone', item.describeA());
            }
            if (mex.length) {
                sendMessage(mex);
            }
            resolveThrownItem(attacker, item, [victim.x, victim.y]);
            return true;
        } else {
            if (attacker.type === 'player') {
                sendMessage(strings.youmiss.format(victim.describeThe()));
            } else if (target.type === 'player') {
                sendMessage(strings.youmissed.format(item.describeA(true)));
            }
            if (attacker.plclass && attacker.plclass !== 'ranger') {
                victim = World.getTilesWithinRadius(victim.x, victim.y, 2).random();
            }
            resolveThrownItem(attacker, item, [victim.x, victim.y]);
            return false;
        }
    };
    /**
     * @param {Thing} who
     * @param {Array} direction
     * @param {World} world
     * @returns {Boolean}
     */
    var tryMove = function (who, direction, world) {
        if (direction[0] === 0 && direction[1] === 0) {
            return true;
        }
        if (world.getTile(who.x, who.y) === Templates.quicksandTile) {
            if (ROT.RNG.getUniformInt(1, 20) + who.getBonus(who.dexterity) < 15) {
                if (who.type === "player") {
                    sendMessage("You can't get out of this sandy mess.");
                }
                return true;
            }
        }
        if (who.type === 'player' && who.hasEffect('confusion')) {
            direction = dir.all.random();
            sendMessage('You stagger...');
        }
        var nx = who.x + direction[0];
        var ny = who.y + direction[1];
        var temp = world.getTile(nx, ny);
        var occupant = world.getEntityAt(nx, ny);
        if (occupant) {
            if (who !== occupant && who.hasMixin('Attacker') && (who.type === 'player' ||
                (occupant.type === 'player' && (who.brain.angry || who.hasEffect('confusion'))))) {
                attack(who, occupant);
                return true;
            } else {
                return false;
            }
        } else if (temp.isWalkable(who)) {
            who.move(nx, ny, world);
            if (who.type === 'player') {
                if ((temp === Templates.stairsUp && world.lvl === world.minlvl) ||
                    (temp === Templates.stairsDown && world.lvl === world.maxlvl)) {
                    sendMessage("There is a passage leading to the world outside the dungeon.");
                } else if (temp !== Templates.floorTile) {
                    sendMessage(temp.getDescription());
                }
                var items = world.getItemsAt(nx, ny);
                if (items && items.length) {
                    if (items.length > 4) {
                        sendMessage("There are several items here.");
                    } else {
                        var txt = "You see ";
                        for (var i = 0, j = items.length; i < j; i++) {
                            if (i > 0) {
                                if (i + 1 === j) {
                                    txt += " and ";
                                } else {
                                    txt += ", ";
                                }
                            }
                            var temp = items[i];
                            txt += temp.number > 1 ? temp.getPlural() : temp.describeA();
                        }
                        txt += " here.";
                        sendMessage(txt);
                    }
                }
            } else {
                if (temp === Templates.runedTile) {
                    sendMessage("%s steps on a rune, which explodes.".format(who.describeThe(true)));
                    who.changeHealth(-ROT.RNG.getUniformInt(1, 6));
                    world.setTile(nx, ny, Templates.floorTile);
                    if (!who.isAlive()) {
                        player.raiseEvent("onKill", who);
                    }
                } else if (temp === Templates.destRunedTile) {
                    sendMessage("%s steps on a rune, which explodes.".format(who.describeThe(true)));
                    who.changeHealth(-ROT.RNG.getUniformInt(2, 10));
                    world.setTile(nx, ny, Templates.floorTile);
                    if (!who.isAlive()) {
                        player.raiseEvent("onKill", who);
                    }
                }
            }
            return true;
        }
        return false;
    };
    var tryWildMove = function (who, direction, world) {
        if (who.hasEffect("starving") && who.type === 'player') {
            sendMessage("You are too hungry to travel.");
            return false;
        }
        if (who.hasEffect('hungry') && who.type === 'player') {
            sendMessage("You are hungry.");
        }
        if (direction[0] === 0 && direction[1] === 0) {
            return true;
        }
        var nx = who.x + direction[0];
        var ny = who.y + direction[1];
        var temp = world.getWildTile(nx, ny);
        var place = world.getPlace(nx, ny);
        if (temp > 20) {
            who.move(nx, ny, world);
            if (place) {
                sendMessage("There is an entrance to the dungeon %s here.".format(place.name));
            } else {
                //sendMessage(nx + "-" + ny);
            }
            return true;
        }
        return false;
    };
    var useMagic = function (who, spell, target) {
        if (who.hasMixin(Mixins.Spellcaster)) {
            return castSpell(who, spell, target);
        } else {
            return castPrayer(who, spell, target);
        }
    };

    /*
     * World and Wilderness: the place where everything happens
     */
    var World = {
        init: function (template) {
            template = template || {};
            this.name = template.name || '';
            this.id = template.id || 0;
            this.seed = template.seed || null;
            this.width = template.w || 0;
            this.height = template.h || 0;
            this.minlvl = template.minlvl || 0;
            this.maxlvl = template.maxlvl || 0;
            this.lvl = template.lvl || template.minlvl || 0;
            this.maxpop = template.maxpop || 0;
            this.maxit = template.maxit || 0;
            this.mapx = template.mapx || 0;
            this.mapy = template.mapy || 0;
            this.stairup = template.stup || null;
            this.stairdown = template.stdo || null;
            this.bestiary = template.bestiary || [];
            this.store = template.store || [];
            this.map = [];
            this.visited = [];
            this.entities = {};
            this.items = {};
            this.boss = template.boss || false;
            this.places = template.places || null;
            this.fov = template.fov || null;
            this.scheduler = template.scheduler || null;
            return this;
        },
        isWithinBounds: function (x, y) {
            return x >= 0 && y >= 0 && x < this.width && y < this.height;
        },
        getTile: function (x, y) {
            if (!this.isWithinBounds(x, y)) {
                return Templates.nullTile;
            } else {
                return this.map[x][y] || Templates.nullTile;
            }
        },
        setTile: function (x, y, newTile) {
            if (this.isWithinBounds(x, y)) {
                this.map[x][y] = newTile;
            }
        },
        getWildTile: function (x, y) {
            if (!this.isWithinBounds(x, y)) {
                return -1;
            } else {
                return this.map[x][y] || -1;
            }
        },
        getPlace: function (x, y) {
            if (!this.places) {
                return false;
            }
            return this.places[x + "," + y];
        },
        getTilesWithinRadius: function (x, y, radius) {
            radius = radius || 1;
            var results = [];
            for (var sx = x - radius; sx <= x + radius; sx++) {
                for (var sy = y - radius; sy <= y + radius; sy++) {
                    var temp = this.isWithinBounds(sx, sy) ? this.getTile(sx, sy) : false;
                    if (temp) {
                        results.push({ x: sx, y: sy });
                    }
                }
            }
            return results;
        },
        getFreeTilesWithinRadius: function (x, y, radius) {
            radius = radius || 1;
            return this.getTilesWithinRadius(x, y, radius).filter(function (a) {
                return this.isFree(a.x, a.y);
            }, this);
        },
        getEntityAt: function (x, y) {
            return this.entities[x + "," + y];
        },
        getEntitiesWithinRadius: function (x, y, radius) {
            var results = [];
            var leftX = x - radius;
            var rightX = x + radius;
            var topY = y - radius;
            var bottomY = y + radius;
            for (var key in this.entities) {
                var entity = this.entities[key];
                if (entity.x >= leftX && entity.x <= rightX &&
                        entity.y >= topY && entity.y <= bottomY) {
                    results.push(entity);
                }
            }
            return results;
        },
        addPlace: function (place) {
            this.places[place.mapx + "," + place.mapy] = place;
        },
        addThing: function (thing, where, noschedule) {
            if (thing.hasMixin(Mixins.Living)) {
                this.addEntity(thing, where, noschedule);
            } else {
                this.addItem(thing, where);
            }
        },
        setThing: function (who, fromX, fromY) {
            var key = null;
            if (fromX && fromY) {
                key = fromX + "," + fromY;
                if (this.entities[key] === who) {
                    delete this.entities[key];
                }
            }
            if (!this.isWithinBounds(who.x, who.y)) {
                throw new Error('Position out of bounds!');
            }
            key = who.x + "," + who.y;
            if (this.entities[key]) {
                throw new Error('Place already occupied!');
            }
            this.entities[key] = who;
        },
        getItemsAt: function (x, y) {
            return this.items[x + "," + y];
        },
        setItemsAt: function (items, x, y) {
            var key = x + "," + y;
            if (items.length === 0) {
                if (this.items[key]) {
                    delete this.items[key];
                }
            } else {
                this.items[key] = items;
            }
        },
        getFace: function (x, y, seer) {
            var ent = this.getEntityAt(x, y);
            if (ent && !ent.isInvisible(seer)) {
                return ent;
            } else {
                var stuff = this.getItemsAt(x, y);
                if (stuff) {
                    if (stuff.length > 1) {
                        return Object.create(Face).init({
                            ch: '∞',
                            description: 'A heap of items.'
                        });
                    } else {
                        return stuff[0];
                    }
                } else {
                    return this.getTile(x, y);
                }
            }
        },
        getWildFace: function (x, y) {
            var face = {
                ch: '',
                fg: 'white',
                bg: 'black'
            };
            var ent = this.getEntityAt(x, y);
            var place = this.getPlace(x, y);
            var background = this.isWithinBounds(x, y) ? this.map[x][y] : -1;
            if (ent) {
                face.ch = ent.ch;
                face.fg = ent.fg;
            } else if (place) {
                face.ch = '>';
                face.fg = "black";
            }
            face.bg = background < 0 ? "black" : terrains[background];
            return face;
        },
        isFree: function (x, y) {
            var ent = this.getEntityAt(x, y);
            if (ent) {
                return false;
            } else {
                return this.getTile(x, y).isWalkable();
            }
        },
        findFreePlace: function (xmin, xmax, ymin, ymax) {
            xmin = xmin || 0;
            ymin = ymin || 0;
            xmax = xmax || this.width - 1;
            ymax = ymax || this.height - 1;
            var x, y;
            do {
                x = ROT.RNG.getUniformInt(xmin, xmax);
                y = ROT.RNG.getUniformInt(ymin, ymax);
            } while (!this.isFree(x, y));
            return { x: x, y: y };
        },
        setStairsUp: function (x, y) {
            if (x && y) {
                this.map[x][y] = Templates.stairsUp;
                this.stairup = [x, y];
            } else {
                var temp;
                do {
                    temp = this.findFreePlace();
                } while (this.getTile(temp.x, temp.y) === Templates.stairsDown);
                this.map[temp.x][temp.y] = Templates.stairsUp;
                this.stairup = [temp.x, temp.y];
            }
        },
        setStairsDown: function (x, y) {
            if (x && y) {
                this.map[x][y] = Templates.stairsDown;
                this.stairdown = [x, y];
            } else {
                var temp;
                do {
                    temp = this.findFreePlace();
                } while (this.getTile(temp.x, temp.y) === Templates.stairsUp);
                this.map[temp.x][temp.y] = Templates.stairsDown;
                this.stairdown = [temp.x, temp.y];
            }
        },
        addStairs: function (where, isup) {
            if (!where) {
                this.setStairsDown();
            } else {
                if (isup) {
                    this.setStairsDown(where.x, where.y);
                    if (this.lvl > 1) {
                        this.setStairsUp();
                    }
                } else {
                    this.setStairsUp(where.x, where.y);
                    if (this.lvl < this.maxlvl) {
                        this.setStairsDown();
                    }
                }
            }
        },
        addEntity: function (who, where, noschedule) {
            where = where || this.findFreePlace();
            who.put(where.x, where.y);
            this.setThing(who);
            if (!noschedule && who.hasMixin('Actor')) {
                this.scheduler.addActor(who, true);
            }
        },
        moveEntity: function (who, where) {
            where = where || this.findFreePlace();
            var key = who.x + "," + who.y;
            if (this.entities[key] === who) {
                delete this.entities[key];
            }
            who.put(where.x, where.y);
            this.setThing(who);
        },
        removeEntity: function (who) {
            var key = who.getX() + "," + who.getY();
            if (this.entities[key] === who) {
                delete this.entities[key];
            }
            if (who.hasMixin('Actor')) {
                this.scheduler.removeActor(who);
            }
        },
        addItem: function (what, where) {
            where = where || this.findFreePlace();
            var key = where.x + "," + where.y;
            if (this.items[key]) {
                for (var i = 0, j = this.items[key].length; i < j; i++) {
                    var it = this.items[key][i];
                    if (it.isEqual(what)) {
                        it.stack(what);
                        return true;
                    }
                }
                this.items[key].push(what);
                what.put(where.x, where.y);
            } else {
                this.items[key] = [what];
                what.put(where.x, where.y);
            }
        },
        initMap: function () {
            this.entities = {};
            this.items = {};
            for (var x = 0; x < this.width; x++) {
                this.map[x] = [];
                this.visited[x] = [];
                for (var y = 0; y < this.height; y++) {
                    this.map[x][y] = Templates.nullTile;
                    this.visited[x][y] = false;
                }
            }
            this.fov = null;
        },
        pickWall: function (id) {
            switch (id) {
                case 1:
                    return Templates.bonyWallTile;
                case 2:
                    return Templates.floralWallTile;
                case 3:
                    return Templates.marineWallTile;
                case 4:
                    return Templates.fireWallTile;
                case 5:
                    return Templates.magicWallTile;
                default:
                    return Templates.wallTile;
            }
        },
        makeDungeon: function (seed) {
            if (seed) {
                this.seed = seed;
            } else {
                seed = this.seed;
            }
            var generator = new ROT.Map.Rogue(this.width, this.height);
            var wall = this.pickWall(this.id);
            var that = this;
            ROT.RNG.setSeed(seed);
            generator.create(function (x, y, v) {
                if (v) {
                    that.map[x][y] = wall;
                } else {
                    that.map[x][y] = Templates.floorTile;
                }
            });
        },
        makeDungeon2: function (seed) {
            if (seed) {
                this.seed = seed;
            } else {
                seed = this.seed;
            }
            var generator = new ROT.Map.Uniform(this.width, this.height, { roomDugPercentage: 0.4 });
            var wall = this.pickWall(this.id);
            var that = this;
            ROT.RNG.setSeed(seed);
            generator.create(function (x, y, v) {
                if (v) {
                    that.map[x][y] = wall;
                } else {
                    that.map[x][y] = Templates.floorTile;
                }
            });
        },
        makeWorld: function () {
            var width = this.width;
            var height = this.height;
            var map = [];
            var pitch = terrains.length - 1;
            var border = 4;
            var ratio = 3.1;
            var gen = ROT.RNG.clone();
            var side = 0;
            /**
             * Initialize the 2D Array containing the map.
             * @private
             * @param {Number} h The initial value for the 2D Array.
             */
            function initArray(h) {
                h = h || 0;
                for (var x = 0; x < side; x++) {
                    map[x] = [];
                    for (var y = 0; y < side; y++) {
                        map[x][y] = h;
                    }
                }
            }
            /**
             * @private
             * @returns {Number} The side.
             */
            function setSide() {
                side = Math.max(width + 2, height + 2);
                var n = 4;
                while (Math.pow(2, n) < side) {
                    n++;
                }
                side = Math.pow(2, n) + 1;
                return side;
            }
            /**
             * Set the seed for the 4 corners of the map.
             * @private
             */
            function setCorners() {
                map[0][0] = gen.getUniformInt(0, pitch);
                map[0][side - 1] = gen.getUniformInt(0, pitch);
                map[side - 1][0] = gen.getUniformInt(0, pitch);
                map[side - 1][side - 1] = gen.getUniformInt(0, pitch);
            }
            /**
             * Fill the border of the map with a given value.
             * @private
             * @param {Number} borderwidth Width of the border. Default 1.
             * @param {Number} value The value to be used to fill the borders. Default 0.
             */
            function setBorders(borderwidth, value) {
                value = value || 0;
                borderwidth = borderwidth || 1;
                for (var x = 0; x < side; x++) {
                    for (var y = 0; y < side; y++) {
                        if ((x < borderwidth) || (y < borderwidth) ||
                                (x > width - borderwidth) || (y > height - borderwidth)) {
                            map[x][y] = value;
                        }
                    }
                }
            }
            /**
             * @private
             * @param {Number} avg
             * @param {Number} delta
             * @returns {Number} 
             */
            function addDelta(avg, delta) {
                if (delta) {
                    avg += (((delta * 2) + 1) * gen.getUniform()) - delta;
                }
                return (pitch < avg) ? pitch : (0 > avg) ? 0 : Math.floor(avg);
            }
            /**
             * @private
             * @param {Number} x1 North West corner of the map (x coord).
             * @param {Number} y1 North West corner of the map (y coord).
             * @param {Number} x2 South East corner of the map (x coord).
             * @param {Number} y2 South East corner of the map (y coord).
             * @param {Number} xm Centre of the map (x coord).
             * @param {Number} ym Centre of the map (y coord).
             */
            function make(x1, y1, x2, y2, xm, ym) {
                var delta = (x2 - xm) / ratio,
                        xmym = 0,
                        x1y1 = map[x1][y1],
                        x2y2 = map[x2][y2],
                        x1y2 = map[x1][y2],
                        x2y1 = map[x2][y1];
                if (0 > map[xm][ym]) {
                    map[xm][ym] = addDelta((x1y1 + x1y2 + x2y2 + x2y1) / 4, delta);
                }
                xmym = map[xm][ym];
                if (0 > map[xm][y1]) {
                    map[xm][y1] = addDelta((x1y1 + x2y1 + xmym) / 3, delta);
                }
                if (0 > map[xm][y2]) {
                    map[xm][y2] = addDelta((x1y2 + x2y2 + xmym) / 3, delta);
                }
                if (0 > map[x2][ym]) {
                    map[x2][ym] = addDelta((x2y1 + x2y2 + xmym) / 3, delta);
                }
                if (0 > map[x1][ym]) {
                    map[x1][ym] = addDelta((x1y1 + x1y2 + xmym) / 3, delta);
                }
                if (((x2 - x1) > 2) || ((y2 - y1) > 2)) {
                    delta = (xm - x1) / 2;
                    make(xm, ym, x2, y2, xm + delta, ym + delta);
                    make(x1, ym, xm, y2, xm - delta, ym + delta);
                    make(x1, y1, xm, ym, xm - delta, ym - delta);
                    make(xm, y1, x2, ym, xm + delta, ym - delta);
                }
            }
            function makeMap() {
                if (map.length < 1) {
                    initArray(-1);
                    setCorners(true);
                }
                make(0, 0, side - 1, side - 1, Math.floor((side - 1) / 2), Math.floor((side - 1) / 2));
            }
            function smooth() {
                var s = side - 1, xp1 = [];
                for (var x = 1, xm1 = map[x], x0 = map[x]; x < s; x++) {
                    xp1 = map[x + 1];
                    for (var y = 1, sum = x0[1]; y < s; y++) {
                        sum += (xm1[y - 1] + xm1[y] + xm1[y + 1] + x0[y] + x0[y + 1] +
                                xp1[y - 1] + xp1[y] + xp1[y + 1]);
                        sum = Math.floor((4 < (sum % 9) ? 1 : 0) + (sum / 9));
                        if (pitch < sum) {
                            sum = pitch;
                        }
                        x0[y] = sum;
                    }
                    xm1 = x0;
                    x0 = xp1;
                }
            }
            /**
             * Cut the map, to fit the given width and height.
             */
            function crop() {
                var a = map.slice(1, width + 1),
                        hc = height + 1,
                        x = a.length;
                while (x--) {
                    a[x] = a[x].slice(1, hc);
                }
                map = a;
            }
            //Let's build the map, now.
            gen.setSeed(this.seed);
            setSide();
            initArray(-1);
            setCorners();
            setBorders(border);
            makeMap();
            smooth();
            crop();
            this.map = map;
        },
        setupFOV: function () {
            var that = this;
            this.fov = new ROT.FOV.PreciseShadowcasting(function (x, y) {
                return !that.getTile(x, y).isOpaque();
            });
        },
        populateHelper: function (stuff, number) {
            var max = 0, temp = [];
            stuff.forEach(function (a) {
                if (a[2] <= this.lvl) {
                    max += a[1];
                    temp.push(a);
                }
            }, this);
            for (var n = 0; n < number; n++) {
                var chance = ROT.RNG.getUniformInt(0, max);
                var tot = 0;
                for (var i = 0, j = temp.length; i < j; i++) {
                    var t = temp[i];
                    tot += t[1];
                    if (chance - tot <= 0) {
                        this.addThing(makeThing(t[0]));
                        break;
                    }
                }
            }
        },
        populate: function () {
            this.populateHelper(this.bestiary, this.maxpop);
            this.populateHelper(this.store, this.maxit);
            if (this.boss && !savedGame[this.name] && this.lvl === this.maxlvl) {
                this.addEntity(makeThing(this.boss));
            }
        },
        makeLevel: function () {
            this.initMap();
            if (savedGame.type) {
                switch (savedGame.type) {
                    case 1:
                        this.makeDungeon();
                        savedGame.type = 1;
                        break;
                    case 2:
                        this.makeDungeon2();
                        savedGame.type = 2;
                        break;
                }
            } else {
                if (ROT.RNG.getPercentage() > 50) {
                    this.makeDungeon();
                    savedGame.type = 1;
                } else {
                    this.makeDungeon2();
                    savedGame.type = 2;
                }
            }
            this.setupFOV();
            this.scheduler = Scheduler.init("speed");
            Engine.init(this.scheduler);
        },
        save: function () {
            var that = this;
            var temp = {
                name: that.name,
                id: that.id,
                seed: that.seed,
                w: that.width,
                h: that.height,
                minlvl: that.minlvl,
                maxlvl: that.maxlvl,
                lvl: that.lvl,
                maxpop: that.maxpop,
                maxit: that.maxit,
                mapx: that.mapx,
                mapy: that.mapy,
                stup: that.stairup,
                stdo: that.stairdown,
                bestiary: that.bestiary,
                store: that.store,
                boss: that.boss,
                ent: [],
                it: []
            };
            if (this.places) {
                temp.places = this.places;
            }
            for (var key in this.entities) {
                var a = this.entities[key];
                if (a !== player) {
                    temp.ent.push(a.save());
                }
            }
            for (var key in this.items) {
                var here = this.items[key];
                here.forEach(function (a) {
                    temp.it.push(a.save());
                });
            }
            return temp;
        },
        restore: function (data) {
            var that = this;
            if (data.stup) {
                var x = data.stup[0], y = data.stup[1];
                this.map[x][y] = Templates.stairsUp;
            }
            if (data.stdo) {
                var x = data.stdo[0], y = data.stdo[1];
                this.map[x][y] = Templates.stairsDown;
            }
            data.ent.forEach(function (a) {
                var temp = makeThing(a);
                temp.restore(that);
            });
            data.it.forEach(function (a) {
                var temp = makeThing(a);
                temp.restore(that);
            });
        }
    };

    /*
     * Templates
     */
    var Templates = Object.create(null);
    //Tiles
    Templates.nullTile = makeTile();
    Templates.wallTile = makeTile({
        ch: '#',
        fg: 'goldenrod',
        bg: 'brown',
        opaque: true,
        description: 'Just your average wall'
    });
    Templates.bonyWallTile = makeTile({
        ch: '=',
        fg: 'rgb(255,255,255)',
        bg: 'rgb(45,45,45)',
        opaque: true,
        description: 'A crumbling wall, with suspicious bones sticking out of it'
    });
    Templates.fireWallTile = makeTile({
        ch: '§',
        fg: 'rgb(210,175,0)',
        bg: 'rgb(250,45,10)',
        opaque: true,
        description: 'Looks like some kind of solid fire'
    });
    Templates.floralWallTile = makeTile({
        ch: '*',
        fg: 'rgb(210,17,0)',
        bg: 'rgb(0,245,0)',
        opaque: true,
        description: 'Shrubs and hedges, with some random flower'
    });
    Templates.magicWallTile = makeTile({
        ch: '*',
        fg: 'rgb(210,217,0)',
        bg: 'rgb(0,0,240)',
        opaque: true,
        description: 'The wall is made of a strange, glittering material, like some kind of solidified magic'
    });
    Templates.marineWallTile = makeTile({
        ch: '~',
        fg: 'rgb(0,0,255)',
        bg: 'rgb(0,0,150)',
        opaque: false,
        description: "It looks like it's made out of solidified waves..."
    });
    Templates.floorTile = makeTile({
        ch: '.',
        walk: true,
        description: 'Just your average floor.'
    });
    Templates.fireTile = makeTile({
        ch: '~',
        fg: 'rgb(120,160,10)',
        bg: 'rgb(200,100,30)',
        walk: true,
        damage: 10,
        dtype: damages.fire,
        description: 'There is a blazing fire here.'
    });
    Templates.iceTile = makeTile({
        ch: '=',
        fg: 'cyan',
        bg: 'white',
        walk: true,
        description: 'There is cold, slippery ice here.'
    });
    Templates.magmaTile = makeTile({
        ch: '~',
        fg: 'yellow',
        bg: 'red',
        walk: true,
        damage: 20,
        dtype: damages.fire,
        description: 'There is a pool of boiling lava here.'
    });
    Templates.quicksandTile = makeTile({
        ch: '~',
        fg: 'orange',
        bg: 'yellow',
        walk: true,
        description: 'A very suspicious patch of sand.'
    });
    Templates.runedTile = makeTile({
        ch: '҉',
        fg: 'red',
        walk: true,
        description: 'The floor is engraved with a rune here.'
    });
    Templates.destRunedTile = makeTile({
        ch: '҉',
        fg: 'rgb(150,0,0)',
        walk: true,
        description: 'The floor is engraved with a rune here.'
    });
    Templates.waterTile = makeTile({
        ch: '~',
        fg: 'blue',
        bg: 'cyan',
        walk: true,
        description: 'A speck of stinky water'
    });
    Templates.stairsUp = makeTile({
        ch: '<',
        fg: 'yellow',
        walk: true,
        description: 'A rocky staircase leading upwards.'
    });
    Templates.stairsDown = makeTile({
        ch: '>',
        fg: 'yellow',
        walk: true,
        description: 'A rocky staircase leading downwards.'
    });
    //Items - weapons
    Templates.arrow = {
        name: 'arrow',
        plural: 'arrows',
        ch: '/',
        fg: 'brown',
        bonus: 0,
        damtype: damages.pierce,
        number: 10,
        breakch: 10,
        description: 'A bunch of arrows, useful with a bow',
        invuln: [damages.rust, damages.pois],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Shootable],
        type: 'arrow'
    };
    Templates.arrowElf = {
        name: 'elvish arrow',
        plural: 'elvish arrows',
        ch: '/',
        fg: 'rgb(0,240,0)',
        bonus: 2,
        damtype: damages.pierce,
        number: 15,
        breakch: 5,
        description: 'A bunch of feathery arrows, extremely light and extremely piercing',
        invuln: [damages.rust, damages.pois],
        resist: [damages.fire, damages.acid],
        mixins: [Mixins.Item, Mixins.Shootable],
        type: 'elf arrow'
    };
    Templates.bastardsword = {
        name: 'bastard sword',
        plural: 'bastard swords',
        ch: 'Ϯ',
        fg: 'rgb(100,100,100)',
        attVal: 1,
        dam1: 1,
        dam2: 10,
        part: parts.hand1,
        damtype: damages.cut,
        hind: 2,
        invuln: [damages.pois],
        vuln: [damages.rust],
        description: 'Slightly bigger than your average sword, with a larger hilt allowing you to grab it with one or two hands.',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'bas sword'
    };
    Templates.battleaxe = {
        name: 'battleaxe',
        plural: 'battleaxes',
        ch: 'Ṫ',
        fg: 'darkgrey',
        attVal: 2,
        dam1: 1,
        dam2: 8,
        crit: 3,
        part: parts.hand1,
        damtype: damages.cut,
        hind: 2,
        twohands: true,
        invuln: [damages.pois],
        vuln: [damages.rust],
        description: "The bee's knee, when you need to chop down some enemies",
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'battaxe'
    };
    Templates.bolt = {
        name: 'bolt',
        plural: 'bolts',
        ch: '/',
        fg: 'yellow',
        bonus: 0,
        damtype: damages.pierce,
        number: 10,
        breakch: 5,
        description: 'A bunch of bolts, useful with a crossbow',
        invuln: [damages.pois],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Shootable],
        type: 'bolt'
    };
    Templates.bone = {
        name: 'bone',
        plural: 'bones',
        ch: 'I',
        fg: 'white',
        attVal: 0,
        dam1: 1,
        dam2: 4,
        part: parts.hand1,
        damtype: damages.blunt,
        invuln: [damages.rust, damages.pois],
        description: "Better not ask to whom or what it belonged...",
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.Eatable, Mixins.Throwable],
        type: 'bone'
    };
    Templates.boomerang = {
        name: 'boomerang',
        plural: 'boomerangs',
        ch: '»',
        fg: 'brown',
        attVal: 0,
        dam2: 4,
        part: parts.hand1,
        damtype: damages.cut,
        invuln: [damages.rust],
        vuln: [damages.fire],
        returning: true,
        description: 'Throw it and it will come back to you, unless you hit something.',
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.Throwable],
        type: 'boomerang'
    };
    Templates.club = {
        name: 'club',
        plural: 'clubs',
        ch: 'Ï',
        fg: 'brown',
        attVal: 0,
        dam1: 1,
        dam2: 4,
        part: parts.hand1,
        damtype: damages.blunt,
        description: 'A stout, hard stick',
        invuln: [damages.rust, damages.pois],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'club'
    };
    Templates.crossbow = {
        name: 'light crossbow',
        plural: 'light crossbows',
        ch: '}',
        fg: 'yellow',
        attVal: 0,
        dam1: 1,
        dam2: 8,
        crit: 2,
        shot: true,
        hind: 1,
        description: 'An average crossbow',
        invuln: [damages.rust, damages.pois],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'crossbow'
    };
    Templates.crossbowHeavy = {
        name: 'heavy crossbow',
        plural: 'heavy crossbows',
        ch: '}',
        fg: 'yellow',
        attVal: 0,
        dam1: 1,
        dam2: 10,
        crit: 2,
        shot: true,
        hind: 2,
        description: 'A big crossbow',
        invuln: [damages.pois],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'crossbow'
    };
    Templates.dagger = {
        name: 'dagger',
        plural: 'daggers',
        ch: 'ז',
        fg: 'gray',
        attVal: 0,
        dam1: 1,
        dam2: 4,
        part: parts.hand1,
        damtype: damages.cut,
        invuln: [damages.pois],
        vuln: [damages.rust],
        description: 'An average dagger',
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.Throwable],
        type: 'dagger'
    };
    Templates.flail = {
        name: 'flail',
        plural: 'flails',
        ch: 'ƣ',
        fg: 'darkgrey',
        attVal: 0,
        dam1: 1,
        dam2: 8,
        part: parts.hand1,
        damtype: damages.blunt,
        hind: 2,
        description: "A spiky ball on a chain, quite dangerous if you don't know how to use it",
        invuln: [damages.pois],
        vuln: [damages.fire, damages.rust],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'flail'
    };
    Templates.greataxe = {
        name: 'great axe',
        plural: 'great axes',
        ch: 'Ṱ',
        fg: 'darkgrey',
        attVal: 2,
        dam1: 1,
        dam2: 12,
        crit: 3,
        part: parts.hand1,
        damtype: damages.cut,
        hind: 3,
        invuln: [damages.pois],
        vuln: [damages.rust],
        twohands: true,
        description: 'A really big axe, a two-handed weapon',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'axe 2'
    };
    Templates.greatclub = {
        name: 'massive club',
        plural: 'massive clubs',
        ch: 'Ï',
        fg: 'brown',
        attVal: 1,
        dam1: 2,
        dam2: 8,
        part: parts.hand1,
        damtype: damages.blunt,
        twohands: true,
        hind: 4,
        description: 'More like a small tree than a stick, you need both hands to hold it',
        invuln: [damages.rust, damages.pois],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'club 2'
    };
    Templates.greatsword = {
        name: 'great sword',
        plural: 'great swords',
        ch: 'Ŧ',
        fg: 'darkgrey',
        attVal: 2,
        dam1: 2,
        dam2: 6,
        part: parts.hand1,
        damtype: damages.cut,
        hind: 3,
        twohands: true,
        invuln: [damages.pois],
        vuln: [damages.rust],
        description: 'Your run-of-the-mill great sword, a two-handed weapon',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'sword 2'
    };
    Templates.halbert = {
        name: 'halbert',
        plural: 'halberts',
        ch: 'Ť',
        fg: 'darkgrey',
        attVal: 1,
        dam1: 1,
        dam2: 10,
        crit: 3,
        part: parts.hand1,
        damtype: damages.cut,
        hind: 3,
        twohands: true,
        invuln: [damages.pois],
        vuln: [damages.fire, damages.rust],
        description: 'Think about Swiss soldiers around Vatican City, for example.',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'halbert'
    };
    Templates.handaxe = {
        name: 'handaxe',
        plural: 'handaxe',
        ch: 'р',
        fg: 'gray',
        attVal: 0,
        dam1: 1,
        dam2: 6,
        crit: 3,
        part: parts.hand1,
        damtype: damages.cut,
        invuln: [damages.pois],
        vuln: [damages.rust],
        description: 'You can use it to chop wood as well as enemies',
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.Throwable],
        type: 'handaxe'
    };
    Templates.katana = {
        name: 'katana',
        plural: 'katana',
        ch: 'ſ',
        fg: 'gray',
        attVal: 1,
        dam1: 1,
        dam2: 6,
        bonus: 2,
        part: parts.hand1,
        damtype: damages.cut,
        blchan: 30,
        bldur: 20,
        deepness: 1,
        invuln: [damages.pois],
        vuln: [damages.rust],
        description: 'Hard, slightly curved, with a razor-sharp edge.',
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.Sharp],
        type: 'katana'
    };
    Templates.longbow = {
        name: 'longbow',
        plural: 'longbows',
        ch: '}',
        fg: 'brown',
        attVal: 1,
        dam1: 1,
        dam2: 8,
        crit: 3,
        shot: true,
        hind: 2,
        description: 'An average longbow',
        invuln: [damages.rust, damages.pois],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'longbow'
    };
    Templates.longbowElf = {
        name: 'elvish longbow',
        plural: 'elvish longbows',
        ch: '}',
        fg: 'rgb(0,240,0)',
        attVal: 2,
        dam1: 1,
        dam2: 8,
        bonus: 4,
        crit: 4,
        hind: 1,
        shot: true,
        description: 'An extremely decorated and light weapon, deadly in the hands of an expert',
        invuln: [damages.rust, damages.pois],
        resist: [damages.fire, damages.acid],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'elf longbow'
    };
    Templates.mace = {
        name: 'mace',
        plural: 'maces',
        ch: 'ȹ',
        fg: 'yellow',
        attVal: 0,
        dam1: 1,
        dam2: 6,
        part: parts.hand1,
        damtype: damages.blunt,
        description: 'A sturdy mace',
        invuln: [damages.pois],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'mace'
    };
    Templates.nailedClub = {
        name: 'club with nails',
        plural: 'clubs with nails',
        ch: 'Í',
        fg: 'brown',
        attVal: 0,
        dam1: 1,
        dam2: 4,
        bonus: 2,
        part: parts.hand1,
        damtype: damages.blunt,
        description: 'A stout, hard stick. With nails in it',
        invuln: [damages.pois],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'nclub'
    };
    Templates.pick = {
        name: 'pick',
        plural: 'picks',
        ch: 'Ⱦ',
        fg: 'gray',
        attVal: 0,
        dam1: 1,
        dam2: 6,
        crit: 4,
        part: parts.hand1,
        damtype: damages.pierce,
        hind: 1,
        description: "Let's smash some rocks while singing the hiho song!",
        invuln: [damages.pois],
        vuln: [damages.fire, damages.rust],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'pick'
    };
    Templates.rapier = {
        name: 'rapier',
        plural: 'rapiers',
        ch: 'ᶅ',
        fg: 'gray',
        attVal: 0,
        dam1: 1,
        dam2: 6,
        part: parts.hand1,
        damtype: damages.pierce,
        invuln: [damages.pois],
        vuln: [damages.rust],
        description: 'A slender sword, perfect to pierce your opponents',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'rapier'
    };
    Templates.scimitar = {
        name: 'scimitar',
        plural: 'scimitars',
        ch: 'ʇ',
        fg: 'gray',
        attVal: 1,
        dam1: 1,
        dam2: 6,
        part: parts.hand1,
        damtype: damages.cut,
        invuln: [damages.pois],
        vuln: [damages.rust],
        description: 'A sort of sword, with a curved blade',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'scimitar'
    };
    Templates.scythe = {
        name: 'scythe',
        plural: 'scythes',
        ch: 'Γ',
        fg: 'yellow',
        attVal: 1,
        dam1: 2,
        dam2: 4,
        crit: 4,
        part: parts.hand1,
        twohands: true,
        damtype: damages.cut,
        hind: 2,
        description: 'Useful if you feel like cosplaying as the Grim Reaper',
        invuln: [damages.pois],
        vuln: [damages.fire, damages.rust],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'scythe'
    };
    Templates.shortbow = {
        name: 'shortbow',
        plural: 'shortbows',
        ch: '}',
        fg: 'brown',
        attVal: 0,
        dam1: 1,
        dam2: 6,
        crit: 3,
        shot: true,
        hind: 1,
        description: 'An average shortbow',
        invuln: [damages.rust, damages.pois],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'shortbow'
    };
    Templates.shortsword = {
        name: 'short sword',
        plural: 'short swords',
        ch: 'ז',
        fg: 'gray',
        attVal: 0,
        dam1: 1,
        dam2: 6,
        part: parts.hand1,
        damtype: damages.cut,
        invuln: [damages.pois],
        vuln: [damages.rust],
        description: 'Longer that a dagger, but shorter than a regular sword',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'shortsword'
    };
    Templates.spear = {
        name: 'spear',
        plural: 'spears',
        ch: '|',
        fg: 'chocolate',
        attVal: 1,
        dam1: 1,
        dam2: 8,
        crit: 3,
        part: parts.hand1,
        twohands: true,
        damtype: damages.pierce,
        hind: 2,
        description: 'An average spear',
        invuln: [damages.rust, damages.pois],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.Throwable],
        type: 'spear 2'
    };
    Templates.staff = {
        name: 'staff',
        plural: 'staves',
        ch: '|',
        fg: 'rgb(175,210,35)',
        attVal: 0,
        dam1: 1,
        dam2: 4,
        part: parts.hand1,
        damtype: damages.blunt,
        description: 'A long, ornated stick with a knob on the end, loved by wizards.',
        invuln: [damages.rust, damages.pois],
        resist: [damages.magic, damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'staff'
    };
    Templates.staffElegant = {
        name: 'elegant staff',
        plural: 'elegant staves',
        ch: '|',
        fg: 'rgb(115,235,105)',
        attVal: 1,
        dam1: 1,
        dam2: 6,
        bonus: 1,
        hind: -1,
        part: parts.hand1,
        damtype: damages.blunt,
        description: "Smooth and light, it's a good, comfortable weapon for a wizard.",
        invuln: [damages.rust, damages.pois],
        resist: [damages.magic, damages.fire, damages.acid, damages.sound],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'e staff'
    };
    Templates.staffMagical = {
        name: 'magical staff',
        plural: 'magical staves',
        ch: '|',
        fg: 'rgb(215,155,75)',
        attVal: 2,
        dam1: 2,
        dam2: 6,
        part: parts.hand1,
        damtype: damages.blunt,
        extradamt: [damages.magic],
        description: "Covered with runes and resistant to various elements, it's the only weapon for any self-respectful wizard.",
        invuln: [damages.magic, damages.fire, damages.rust, damages.pois, damages.sound],
        resist: [damages.acid, damages.cold],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'm staff'
    };
    Templates.stiletto = {
        name: 'stiletto',
        plural: 'stilettos',
        ch: 'ˡ',
        fg: 'gray',
        attVal: 1,
        dam1: 1,
        dam2: 3,
        poisdam: 4,
        poisdur: 100,
        poisstr: 20,
        poischa: 16,
        part: parts.hand1,
        damtype: damages.pierce,
        invuln: [damages.pois],
        vuln: [damages.rust],
        description: 'An extremely thin dagger, perfect for assassinations',
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.Poisonous, Mixins.Throwable],
        type: 'stiletto'
    };
    Templates.stilettoVamp = {
        name: 'vampiric stiletto',
        plural: 'vampiric stilettos',
        ch: 'ˡ',
        fg: 'rgb(220,0,0)',
        attVal: 1,
        dam1: 1,
        dam2: 3,
        poisdam: 4,
        poisdur: 100,
        poisstr: 20,
        poischa: 16,
        vamp: 4,
        part: parts.hand1,
        damtype: damages.pierce,
        invuln: [damages.pois],
        vuln: [damages.rust],
        description: 'An extremely thin, poisoned dagger, perfect for assassinations',
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.Poisonous, Mixins.Vampiric],
        type: 'stiletto vam'
    };
    Templates.sword = {
        name: 'sword',
        plural: 'swords',
        ch: 'Ϯ',
        fg: 'gray',
        attVal: 1,
        dam1: 1,
        dam2: 8,
        part: parts.hand1,
        damtype: damages.cut,
        hind: 1,
        invuln: [damages.pois],
        vuln: [damages.rust],
        description: 'Just your average sword',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'sword'
    };
    Templates.swordblessed = {
        name: 'blessed sword',
        plural: 'blessed swords',
        ch: 'Ϯ',
        fg: 'white',
        attVal: 1,
        dam1: 1,
        dam2: 8,
        part: parts.hand1,
        damtype: damages.cut,
        extradamt: [damages.holy],
        newinvuln: [damages.holy],
        newres: [damages.unholy],
        invuln: [damages.holy, damages.unholy, damages.rust, damages.pois, damages.sound],
        hind: 1,
        description: 'A blessed sword, deadly against undead and evildoers.',
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger],
        type: 'blesssword'
    };
    Templates.swordburning = {
        name: 'burning sword',
        plural: 'burning swords',
        ch: 'Ϯ',
        fg: 'red',
        attVal: 1,
        dam1: 1,
        dam2: 8,
        part: parts.hand1,
        damtype: damages.cut,
        extradamt: [damages.fire],
        newres: [damages.fire],
        invuln: [damages.fire, damages.electro, damages.acid, damages.rust, damages.pois, damages.sound],
        vuln: [damages.cold],
        hind: 1,
        description: 'A fiery sword, ready to char you enemies.',
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger],
        type: 'burnsword'
    };
    Templates.swordcursed = {
        name: 'cursed sword',
        plural: 'cursed swords',
        ch: 'Ϯ',
        fg: 'rgb(30,30,30)',
        attVal: 1,
        dam1: 1,
        dam2: 8,
        part: parts.hand1,
        damtype: damages.cut,
        extradamt: [damages.unholy],
        newinvuln: [damages.unholy],
        newres: [damages.holy],
        invuln: [damages.holy, damages.unholy, damages.rust, damages.pois, damages.sound],
        hind: 1,
        description: 'A cursed sword, deadly against sacred enemies.',
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger],
        type: 'curssword'
    };
    Templates.swordvamp = {
        name: 'vampiric sword',
        plural: 'vampiric swords',
        ch: 'Ϯ',
        fg: 'rgb(230,0,0)',
        attVal: 1,
        dam1: 1,
        dam2: 8,
        vamp: 5,
        part: parts.hand1,
        damtype: damages.cut,
        newinvuln: [damages.vamp],
        invuln: [damages.unholy, damages.rust, damages.pois, damages.sound],
        vuln: [damages.holy],
        hind: 1,
        description: 'A weapon that drinks the blood of its victim and gives you part of their strength.',
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger, Mixins.Vampiric],
        type: 'curssword'
    };
    Templates.trident = {
        name: 'trident',
        plural: 'tridents',
        ch: 'ψ',
        fg: 'brown',
        attVal: 0,
        dam1: 1,
        dam2: 8,
        part: parts.hand1,
        damtype: damages.pierce,
        hind: 2,
        description: 'A three-pronged spear, useful to catch fish',
        invuln: [damages.rust, damages.pois],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'trident'
    };
    Templates.waraxeDwar = {
        name: 'dwarven waraxe',
        plural: 'dwarven waraxes',
        ch: 'Ṫ',
        fg: 'grey',
        attVal: 2,
        dam1: 1,
        dam2: 10,
        crit: 3,
        part: parts.hand1,
        damtype: damages.cut,
        hind: 2,
        invuln: [damages.pois],
        resist: [damages.sound],
        vuln: [damages.rust],
        description: "Smaller than a human greataxe, but heavy and very, very dangerous.",
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'waraxe d'
    };
    Templates.warhammer = {
        name: 'warhammer',
        plural: 'warhammers',
        ch: 'Ṕ',
        fg: 'gray',
        attVal: 0,
        dam1: 1,
        dam2: 8,
        crit: 3,
        part: parts.hand1,
        damtype: damages.blunt,
        hind: 1,
        invuln: [damages.pois],
        vuln: [damages.rust],
        description: 'For a big nail, you need a big hammer, right?',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'warhammer'
    };
    Templates.whip = {
        name: 'whip',
        plural: 'whips',
        ch: 'ƺ',
        fg: 'brown',
        attVal: 0,
        dam1: 1,
        dam2: 3,
        part: parts.hand1,
        damtype: damages.cut,
        description: 'Useful if you are into S&M, or if you want to copy some imaginary archaeologist',
        invuln: [damages.rust, damages.pois],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'whip'
    };
    Templates.axeSmasher = {
        name: 'Axe of Smasher',
        plural: 'Axes of Smasher',
        ch: 'Ṫ',
        fg: 'rgb(200,50,80)',
        attVal: 6,
        dam1: 2,
        dam2: 8,
        crit: 2,
        part: parts.hand1,
        damtype: damages.cut,
        hind: 3,
        invuln: [damages.fire, damages.acid, damages.electro, damages.cold, damages.rust, damages.pois, damages.sound],
        resist: [damages.dark, damages.light],
        newinvuln: [damages.dark],
        newres: [damages.acid],
        changes: {
            strength: 3,
            constitution: 3,
            attackPerRound: 1
        },
        description: "Forged by master dwarves, it is rumored to be able to slice through anything. It grants one extra attack per round.",
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.Sharp, Mixins.VulnerabilityChanger, Mixins.DataChanger],
        type: 'smash axe'
    };
    Templates.longbowBlisga = {
        name: 'longbow of Blisga',
        plural: 'longbows of Blisga',
        ch: '}',
        fg: 'rgb(180,60,115)',
        attVal: 3,
        dam1: 2,
        dam2: 8,
        crit: 5,
        shot: true,
        hind: 1,
        changes: {
            dexterity: 3,
            speed: 20
        },
        description: 'Made with the rarest wood, carved with eldritch runes, it can shoot an arrow through a steel plate.',
        invuln: [damages.fire, damages.cold, damages.acid, damages.electro, damages.rust, damages.pois, damages.sound],
        newres: [damages.acid, damages.cold, damages.electro, damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.DataChanger, Mixins.VulnerabilityChanger],
        type: 'blisga longbow'
    };
    Templates.maceLourette = {
        name: 'mace of Lourette',
        plural: 'maces of Lourette',
        ch: 'ȹ',
        fg: 'rgb(147,210,0)',
        attVal: 3,
        dam1: 2,
        dam2: 6,
        part: parts.hand1,
        damtype: damages.blunt,
        extradamt: [damages.cold],
        changes: {
            strength: 4,
            constitution: 4,
            charisma: 2,
            attackPerRound: 1
        },
        description: 'A really cool mace covered with ice; just by looking at it you feel stronger. It grants one extra attack per round.',
        invuln: [damages.cold, damages.fire, damages.acid, damages.electro, damages.rust, damages.sound],
        newinvuln: [damages.cold],
        newres: [damages.fire, damages.confu, damages.light],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger, Mixins.DataChanger],
        type: 'lou mace'
    };
    Templates.scytheDeath = {
        name: 'Scythe of Death',
        plural: 'Scythes of Death',
        ch: 'Γ',
        fg: 'blue',
        attVal: 5,
        dam1: 3,
        dam2: 10,
        crit: 5,
        vamp: 15,
        part: parts.hand1,
        twohands: true,
        damtype: damages.cut,
        extradamt: [damages.cold],
        hind: 2,
        changes: {
            strength: 2,
            constitution: 3,
            intelligence: 2,
            wisdom: 3,
            charisma: 5
        },
        description: "The original Scythe, or so people say. Its blade glows in a blue light, sharp enough to cut the air around it.",
        invuln: [damages.fire, damages.cold, damages.acid, damages.electro, damages.rust, damages.sound],
        resist: [damages.holy, damages.unholy, damages.magic],
        newinvuln: [damages.cold, damages.sleep, damages.paral],
        newres: [damages.holy, damages.unholy],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.Sharp, Mixins.VulnerabilityChanger, Mixins.DataChanger, Mixins.Vampiric],
        type: 'death scythe'
    };
    Templates.spearPelas = {
        name: 'spear of Pelas Ghaza',
        plural: 'spears of Pelas Ghaza',
        ch: '|',
        fg: 'cyan',
        attVal: 4,
        dam1: 2,
        dam2: 8,
        crit: 5,
        part: parts.hand1,
        twohands: true,
        damtype: damages.pierce,
        extradamt: [damages.electro, damages.light],
        hind: 2,
        changes: {
            strength: 4,
            constitution: 2,
            attackPerRound: 1
        },
        description: 'Surrounded by sparkles, you can feel the power of a storm everytime you wield it. It grants one extra attack per round.',
        invuln: [damages.fire, damages.cold, damages.acid, damages.electro, damages.light, damages.rust, damages.sound],
        resist: [damages.magic],
        newinvuln: [damages.electro, damages.light],
        newres: [damages.fire, damages.cold, damages.confu],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger, Mixins.DataChanger],
        type: 'pelas spear'
    };
    Templates.staffGoonyen = {
        name: 'staff of Goo-Nyen',
        plural: 'staff of Goo-Nyen',
        ch: '|',
        fg: 'rgba(5,5,245,.6)',
        attVal: 5,
        dam1: 2,
        dam2: 8,
        part: parts.hand1,
        damtype: damages.magic,
        extradamt: [damages.cold],
        changes: {
            intelligence: 6,
            wisdom: 5,
            strength: 1
        },
        description: "A magical staff entirely made of ice, surrounded by vapour, which will freeze the very soul of its enemies.",
        newinvuln: [damages.cold, damages.light, damages.petro],
        newres: [damages.vamp],
        newvuln: [damages.fire],
        invuln: [damages.magic, damages.cold, damages.fire, damages.electro, damages.acid, damages.rust, damages.sound],
        resist: [damages.light, damages.dark],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger, Mixins.DataChanger],
        type: 'goo staff'
    };
    Templates.swordSandunen = {
        name: 'sword of Sandunen',
        plural: 'swords of Sandunen',
        ch: 'Ϯ',
        fg: 'white',
        attVal: 5,
        dam1: 2,
        dam2: 8,
        part: parts.hand1,
        damtype: damages.cut,
        extradamt: [damages.holy, damages.fire],
        newinvuln: [damages.unholy, damages.holy, damages.fire, damages.pois],
        newres: [damages.acid, damages.electro],
        invuln: [damages.holy, damages.unholy, damages.fire, damages.acid, damages.electro, damages.cold, damages.rust, damages.sound],
        hind: 1,
        changes: {
            strength: 3,
            constitution: 2,
            dexterity: 2,
            wisdom: 1,
            attackPerRound: 2
        },
        description: "A sword of legend, blessed by some god and burning with unstoppable holy fire. It grants two extra attacks per round.",
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger, Mixins.DataChanger],
        type: 'sandu sword'
    };
    //Items - armours
    Templates.chainmail = {
        name: 'chainmail',
        plural: 'chainmails',
        ch: 'ẃ',
        fg: 'gray',
        defVal: 5,
        part: parts.body,
        hind: 4,
        wearable: true,
        invuln: [damages.sound],
        vuln: [damages.rust],
        description: 'A net of metal rings knitted together, covering down to your knees',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'chainmail'
    };
    Templates.chainshirt = {
        name: 'chainshirt',
        plural: 'chainshirts',
        ch: 'ẉ',
        fg: 'gray',
        defVal: 4,
        part: parts.body,
        hind: 3,
        wearable: true,
        invuln: [damages.sound],
        vuln: [damages.rust],
        description: 'A net of metal rings knitted together',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'chainmail'
    };
    Templates.fullplate = {
        name: 'full-plate',
        plural: 'full-plates',
        ch: 'ẅ',
        fg: 'gray',
        defVal: 8,
        part: parts.body,
        hind: 8,
        wearable: true,
        invuln: [damages.sound],
        vuln: [damages.rust],
        description: 'A net of metal rings knitted together, covering down to your knees',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'fullplate'
    };
    Templates.halfplate = {
        name: 'half-plate',
        plural: 'half-plates',
        ch: 'ẇ',
        fg: 'gray',
        defVal: 7,
        part: parts.body,
        hind: 7,
        wearable: true,
        invuln: [damages.sound],
        vuln: [damages.rust],
        description: 'A net of metal rings knitted together, covering down to your knees',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'halfplate'
    };
    Templates.leatherarm = {
        name: 'leather armour',
        plural: 'leather armours',
        ch: 'ʬ',
        fg: 'brown',
        defVal: 2,
        part: parts.body,
        hind: 1,
        wearable: true,
        invuln: [damages.rust, damages.sound, damages.blunt],
        description: 'A light armour, made of hardened leather',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'leath arm'
    };
    Templates.paddedarm = {
        name: 'padded armour',
        plural: 'padded armours',
        ch: 'ʬ',
        fg: 'yellow',
        defVal: 1,
        part: parts.body,
        hind: 0,
        wearable: true,
        invuln: [damages.rust, damages.sound, damages.blunt],
        description: 'Better than nothing, but hardly protective at all',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'padd arm'
    };
    Templates.robe = {
        name: 'robe',
        plural: 'robes',
        ch: 'Δ',
        fg: 'blue',
        defVal: 1,
        part: parts.body,
        wearable: true,
        invuln: [damages.rust, damages.sound, damages.blunt],
        description: 'A vest for mages and priests, covered with sequins and fake runes',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'robe'
    };
    Templates.robeFireproof = {
        name: 'fireproof robe',
        plural: 'fireproof robes',
        ch: 'Δ',
        fg: 'red',
        defVal: 3,
        part: parts.body,
        wearable: true,
        description: "Not very resistant to blows, but it can't be harmed by fire.",
        invuln: [damages.fire, damages.acid, damages.magic, damages.rust, damages.sound, damages.blunt],
        newres: [damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger],
        type: 'robe'
    };
    Templates.robeOrnated = {
        name: 'ornated robe',
        plural: 'ornated robes',
        ch: 'Δ',
        fg: 'rgb(107,14,187)',
        defVal: 2,
        part: parts.body,
        wearable: true,
        changes: {
            charisma: 2
        },
        description: 'A vest for mages and priests, richly decorated and glittering with sequins,',
        invuln: [damages.fire, damages.cold, damages.acid, damages.rust, damages.sound, damages.blunt],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.DataChanger],
        type: 'robe 2'
    };
    Templates.splintmail = {
        name: 'splintmail',
        plural: 'splintmails',
        ch: 'ŵ',
        fg: 'gray',
        defVal: 6,
        part: parts.body,
        hind: 5,
        wearable: true,
        invuln: [damages.sound],
        vuln: [damages.rust],
        description: 'A net of metal rings knitted together, covering down to your knees',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'splintmail'
    };
    Templates.studdedarm = {
        name: 'studded leather armour',
        plural: 'studded leather armours',
        ch: 'ʬ',
        fg: 'brown',
        defVal: 3,
        part: parts.body,
        hind: 2,
        wearable: true,
        invuln: [damages.rust, damages.sound, damages.blunt],
        description: 'A light armour, made of hardened and reinforced leather',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'studd arm'
    };
    Templates.lightshield = {
        name: 'light shield',
        plural: 'light shields',
        ch: 'ɵ',
        fg: 'gray',
        defVal: 1,
        part: parts.hand2,
        hind: 2,
        invuln: [damages.rust, damages.sound],
        description: 'A light shield, made of (wood painted like) steel',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'light shi'
    };
    Templates.heavyshield = {
        name: 'heavy shield',
        plural: 'heavy shields',
        ch: 'θ',
        fg: 'darkgray',
        defVal: 2,
        part: parts.hand2,
        hind: 4,
        invuln: [damages.sound],
        vuln: [damages.rust],
        description: 'A big and heavy shield, exactly what it says on the cover',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'heavy shi'
    };
    Templates.helmInsomnia = {
        name: 'helm of insomnia',
        plural: 'helms of insomnia',
        ch: 'ᴒ',
        fg: 'rgb(200,5,130)',
        defVal: 1,
        part: parts.head,
        hind: 1,
        wearable: true,
        description: "With this on, you can be sure you'll never take a nap again. Very prized by guards.",
        newinvuln: [damages.sleep],
        newres: [damages.confu],
        resist: [damages.rust, damages.sound, damages.cold],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger],
        type: 'insom helm'
    };
    Templates.hornedhelm = {
        name: 'horned helm',
        plural: 'horned helms',
        ch: 'Ȣ',
        fg: 'yellow',
        defVal: 1,
        part: parts.head,
        hind: 1,
        wearable: true,
        resist: [damages.rust],
        description: 'A helm with a pair of horns on it: useful to promote you happy family life',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'horn helm'
    };
    Templates.ironhelm = {
        name: 'iron helm',
        plural: 'iron helms',
        ch: 'ᴒ',
        fg: 'lightgray',
        defVal: 1,
        part: parts.head,
        hind: 1,
        wearable: true,
        resist: [damages.sound],
        vuln: [damages.rust],
        description: 'A simple helm, which will cover and protect your head. Maybe',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'iron helm'
    };
    Templates.pointyHat = {
        name: 'pointy hat',
        plural: 'pointy hats',
        ch: '^',
        fg: 'blue',
        defVal: 1,
        part: parts.head,
        wearable: true,
        invuln: [damages.rust, damages.sound],
        description: 'A hat favoured by magicians, which lokks almost like a reversed ice-cream cone',
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'pointhat'
    };
    Templates.pointyHatBig = {
        name: 'big pointy hat',
        plural: 'big pointy hats',
        ch: '^',
        fg: 'rgb(210,0,49)',
        defVal: 2,
        part: parts.head,
        wearable: true,
        description: 'A tall, heavy hat, impossible to miss even in the middle of a throng',
        invuln: [damages.fire, damages.cold, damages.acid, damages.rust, damages.sound],
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'pointhat 2'
    };
    Templates.ironboot = {
        name: 'iron boots',
        plural: 'iron boots',
        ch: '=',
        fg: 'darkgray',
        defVal: 2,
        part: parts.feet,
        wearable: true,
        changes: {
            dexterity: -2,
            speed: -10
        },
        invuln: [damages.sound],
        vuln: [damages.rust],
        description: "Heavy and hard, your feet will be protected while you trod around like a bull.",
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.DataChanger],
        type: 'iron boot'
    };
    Templates.leatherboot = {
        name: 'leather boots',
        plural: 'leather boots',
        ch: '=',
        fg: 'brown',
        defVal: 1,
        part: parts.feet,
        wearable: true,
        invuln: [damages.sound, damages.rust],
        description: "Quite comfortable to wear, although not exactly stylish.",
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.Throwable],
        type: 'leath boot'
    };
    Templates.pointyShoes = {
        name: 'pointy shoes',
        plural: 'pointy shoes',
        ch: '=',
        fg: 'violet',
        defVal: 0,
        part: parts.feet,
        wearable: true,
        invuln: [damages.rust, damages.sound],
        description: "A normal pair of shoes, but definitely pointy. Wizards like them.",
        mixins: [Mixins.Item, Mixins.Equippable],
        type: 'pointsh'
    };
    Templates.sandalsock = {
        name: 'sandals & white socks',
        plural: 'sandals & white socks',
        ch: '=',
        fg: 'white',
        defVal: 0,
        part: parts.feet,
        wearable: true,
        changes: {
            charisma: -2
        },
        invuln: [damages.rust, damages.sound],
        description: "Sandals and withe socks won't protect you, but they are an instant turnoff for everyone, guaranteed.",
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.DataChanger],
        type: 'sand sock'
    };
    Templates.aegis = {
        name: 'Aegis',
        plural: 'Aegis',
        ch: 'θ',
        fg: 'pink',
        defVal: 6,
        part: parts.hand2,
        hind: 4,
        changes: {
            strength: 4,
            constitution: 5
        },
        description: "A shield covered in goat hide, with the head of Medusa right in the middle.",
        newinvuln: [damages.petro, damages.paral],
        newres: [damages.pierce, damages.blunt, damages.sound, damages.fire],
        invuln: [damages.fire, damages.cold, damages.acid, damages.electro, damages.holy, damages.unholy, damages.rust, damages.sound],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger, Mixins.DataChanger],
        type: 'aegis'
    };
    Templates.archchancellorHat = {
        name: "Archchancellor's Hat",
        plural: "Archchancellor's Hat",
        ch: '^',
        fg: 'rgb(110,130,210)',
        defVal: 5,
        part: parts.head,
        wearable: true,
        changes: {
            intelligence: 5,
            wisdom: 4
        },
        description: 'A humongous hat, impervious to elements, that will magically protect its wearer.',
        newinvuln: [damages.magic, damages.petro, damages.light, damages.fire],
        newres: [damages.cold, damages.acid, damages.electro],
        invuln: [damages.fire, damages.cold, damages.acid, damages.electro, damages.unholy, damages.holy, damages.rust, damages.sound, damages.magic],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger, Mixins.DataChanger],
        type: 'arch hat'
    };
    Templates.bootSarpili = {
        name: 'boots of Sarpili',
        plural: 'boots of Sarpili',
        ch: '=',
        fg: 'rgb(0,220,0)',
        defVal: 4,
        part: parts.feet,
        wearable: true,
        changes: {
            dexterity: 6,
            speed: 30
        },
        invuln: [damages.sound, damages.rust, damages.acid, damages.cold, damages.electro, damages.fire],
        newinvuln: [damages.paral, damages.petro],
        description: "Light as a feather, they allow the wearer to move faster.",
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger, Mixins.DataChanger],
        type: 'sarpi boot'
    };
    Templates.fullplateJar = {
        name: 'full-plate of Jaronite',
        plural: 'full-plates of Jaronite',
        ch: 'ẅ',
        fg: 'blue',
        defVal: 15,
        part: parts.body,
        hind: 20,
        changes: {
            dexterity: -4,
            speed: -50
        },
        wearable: true,
        invuln: [damages.acid, damages.electro, damages.cold, damages.fire, damages.magic, damages.rust, damages.sound],
        newinvuln: [damages.acid, damages.fire, damages.bleed, damages.electro],
        newres: [damages.blunt, damages.cut, damages.pierce, damages.cold, damages.sound],
        description: "Horribly heavy but extremely resistant, you won't be able to move around much, but you'll be safe.",
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger, Mixins.DataChanger],
        type: 'jaro fullplate'
    };
    Templates.manushirt = {
        name: "Manuel's t-shirt",
        plural: "Manuel's t-shirts",
        ch: 'ŵ',
        fg: 'rgb(220,220,220)',
        defVal: 3,
        part: parts.body,
        hind: 0,
        wearable: true,
        changes: {
            strength: 5,
            constitution: 3,
            wisdom: -2,
            charisma: -3
        },
        description: "An apparently normal t-shirt that grants its wearer superhuman resistance to cold weather... and lower its sex appeal.",
        newinvuln: [damages.cold],
        newres: [damages.fire, damages.unholy, damages.holy, damages.blunt],
        invuln: [damages.fire, damages.cold, damages.acid, damages.electro, damages.holy, damages.unholy, damages.rust, damages.sound],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger, Mixins.DataChanger],
        type: 'manushirt'
    };
    Templates.robeSource = {
        name: "Sourcerer's Robe",
        plural: "Sourcerer's Robe",
        ch: 'Δ',
        fg: 'rgb(100,170,79)',
        defVal: 6,
        part: parts.body,
        wearable: true,
        changes: {
            dexterity: 2,
            constitution: 2
        },
        description: "Woven with pure magic, it grants its wearer resistance to many natural and unnatural forces.",
        invuln: [damages.fire, damages.acid, damages.cold, damages.electro, damages.magic, damages.rust, damages.sound],
        newinvuln: [damages.magic],
        newres: [damages.fire, damages.acid, damages.cold, damages.electro, damages.light, damages.dark],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger, Mixins.DataChanger],
        type: 'source robe'
    };
    //Items - potions
    Templates.antidote = {
        name: 'potion of cure poison',
        plural: 'potions of cure poison',
        ch: 'ᵿ',
        fg: 'cornflowerblue',
        power: 'antidote',
        powstr: 1,
        description: 'It wil cure you from poisoning',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'antidote p1'
    };
    Templates.boozePotion = {
        name: 'bottle of booze',
        plural: 'bottles of booze',
        ch: 'ᵿ',
        fg: 'violet',
        power: 'confusion',
        powstr: 20,
        description: 'A liquor made from apples. Well, mainly apples',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'booze p'
    };
    Templates.curePotion = {
        name: 'potion of cure wounds',
        plural: 'potions of cure wounds',
        ch: 'ᵿ',
        fg: 'magenta',
        power: 'heal',
        powstr: 10,
        description: 'Drink it to heal up to 10 HP.',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'curative p1'
    };
    Templates.cureSeriousPotion = {
        name: 'potion of cure serious wounds',
        plural: 'potions of cure serious wounds',
        ch: 'ᵿ',
        fg: 'magenta',
        power: 'heal',
        powstr: 30,
        description: 'Drink it to heal up to 30 HP.',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'curative p2'
    };
    Templates.cureCriticPotion = {
        name: 'potion of cure critical wounds',
        plural: 'potions of cure critical wounds',
        ch: 'ᵿ',
        fg: 'magenta',
        power: 'heal',
        powstr: 60,
        description: 'Drink it to heal up to 60 HP.',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'curative p3'
    };
    Templates.decCharPotion = {
        name: 'potion of dorkness',
        plural: 'potions of dorkness',
        ch: 'ᵿ',
        fg: 'rgb(100,0,150)',
        power: 'decrease',
        powstr: 'charisma',
        description: 'Drink it and it will decrease your charisma',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'chardec p'
    };
    Templates.decConstPotion = {
        name: 'potion of sickness',
        plural: 'potions of sickness',
        ch: 'ᵿ',
        fg: 'yellow',
        power: 'decrease',
        powstr: 'constitution',
        description: 'Drink it and it will decrease your constitution',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'consdec p'
    };
    Templates.decDextPotion = {
        name: 'potion of clumsiness',
        plural: 'potions of clumsiness',
        ch: 'ᵿ',
        fg: 'maroon',
        power: 'decrease',
        powstr: 'dexterity',
        description: 'Drink it and it will decrease your dexterity',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'dextdec p'
    };
    Templates.decIntePotion = {
        name: 'potion of stupidity',
        plural: 'potions of stupidity',
        ch: 'ᵿ',
        fg: 'cyan',
        power: 'decrease',
        powstr: 'intelligence',
        description: 'Drink it and it will decrease your intelligence',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'intdec p'
    };
    Templates.decStrPotion = {
        name: 'potion of weakness',
        plural: 'potions of weakness',
        ch: 'ᵿ',
        fg: 'silver',
        power: 'decrease',
        powstr: 'strength',
        description: 'Drink it and it will decrease your strength',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'strdec p'
    };
    Templates.decWisPotion = {
        name: 'potion of dumbness',
        plural: 'potions of dumbness',
        ch: 'ᵿ',
        fg: 'rgb(0,100,150)',
        power: 'decrease',
        powstr: 'wisdom',
        description: 'Drink it and it will decrease your wisdom',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'wisdec p'
    };
    Templates.healingPotion = {
        name: 'potion of healing',
        plural: 'potions of healing',
        ch: 'ᵿ',
        fg: 'magenta',
        power: 'heal',
        powstr: 100,
        description: 'Drink it to heal up to 100 HP.',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'curative p4'
    };
    Templates.incCharPotion = {
        name: 'potion of charisma',
        plural: 'potions of charisma',
        ch: 'ᵿ',
        fg: 'rgb(100,0,150)',
        power: 'increase',
        powstr: 'charisma',
        description: 'Drink it and it will increase your charisma',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'charis p'
    };
    Templates.incConstPotion = {
        name: 'potion of constitution',
        plural: 'potions of constitution',
        ch: 'ᵿ',
        fg: 'yellow',
        power: 'increase',
        powstr: 'constitution',
        description: 'Drink it and it will increase your constitution',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'constit p'
    };
    Templates.incDextPotion = {
        name: 'potion of dexterity',
        plural: 'potions of dexterity',
        ch: 'ᵿ',
        fg: 'maroon',
        power: 'increase',
        powstr: 'dexterity',
        description: 'Drink it and it will increase your dexterity',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'dexterity p'
    };
    Templates.incIntePotion = {
        name: 'potion of intelligence',
        plural: 'potions of intelligence',
        ch: 'ᵿ',
        fg: 'cyan',
        power: 'increase',
        powstr: 'intelligence',
        description: 'Drink it and it will increase your intelligence',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'intell p'
    };
    Templates.incStrPotion = {
        name: 'potion of strength',
        plural: 'potions of strength',
        ch: 'ᵿ',
        fg: 'silver',
        power: 'increase',
        powstr: 'strength',
        description: 'Drink it and it will increase your strength',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'strength p'
    };
    Templates.incWisPotion = {
        name: 'potion of wisdom',
        plural: 'potions of wisdom',
        ch: 'ᵿ',
        fg: 'rgb(0,100,150)',
        power: 'increase',
        powstr: 'wisdom',
        description: 'Drink it and it will increase your wisdom',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'wisd p'
    };
    Templates.invisibilityPotion = {
        name: 'potion of invisibility',
        plural: 'potions of invisibility',
        ch: 'ᵿ',
        fg: 'aqua',
        power: 'invisibility',
        powstr: 20,
        description: 'A strange liquid, which will make you invisible for a brief period',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'invis p'
    };
    Templates.poisonPotion = {
        name: 'potion of poison',
        plural: 'potions of poison',
        ch: 'ᵿ',
        fg: 'rgb(0,200,0)',
        power: 'poison',
        powstr: 2,
        description: 'Useful if you want to experience a slow and painful death',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'poison p1'
    };
    Templates.resacidPotion = {
        name: 'potion of resistance to acid',
        plural: 'potions of resistance to acid',
        ch: 'ᵿ',
        fg: 'rgb(0,0,235)',
        power: 'resistance',
        powstr: damages.acid,
        description: 'It will make you resistant to acid for a short time',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'resacid p'
    };
    Templates.rescoldPotion = {
        name: 'potion of resistance to cold',
        plural: 'potions of resistance to cold',
        ch: 'ᵿ',
        fg: 'rgb(0,0,100)',
        power: 'resistance',
        powstr: damages.cold,
        description: 'It will make you resistant to cold for a short time',
        fragile: true,
        invuln: [damages.acid, damages.cold],
        resist: [damages.fire, damages.electro],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'rescold p'
    };
    Templates.reselePotion = {
        name: 'potion of resistance to electricity',
        plural: 'potions of resistance to electricity',
        ch: 'ᵿ',
        fg: 'yellow',
        power: 'resistance',
        powstr: damages.electro,
        description: 'It will make you resistant to electricity for a short time.',
        fragile: true,
        invuln: [damages.acid, damages.electro],
        resist: [damages.fire],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'resele p'
    };
    Templates.resfirePotion = {
        name: 'potion of resistance to fire',
        plural: 'potions of resistance to fire',
        ch: 'ᵿ',
        fg: 'red',
        power: 'resistance',
        powstr: damages.fire,
        description: 'It will make you resistant to fire for a short time.',
        fragile: true,
        invuln: [damages.acid, damages.fire],
        resist: [damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'resfire p'
    };
    Templates.respetroPotion = {
        name: 'potion of resistance to petrification',
        plural: 'potions of resistance to petrification',
        ch: 'ᵿ',
        fg: 'gray',
        power: 'resistance',
        powstr: damages.petro,
        description: 'It will make you resistant to petrification for a short time.',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'respetr p'
    };
    Templates.secondLifePotion = {
        name: 'potion of Second Life',
        plural: 'potions of Second Life',
        ch: 'ᵿ',
        fg: 'rgb(' + ROT.RNG.getUniformInt(0, 255) + ',' + ROT.RNG.getUniformInt(0, 255) + ',' + ROT.RNG.getUniformInt(0, 255) + ')',
        power: 'secondlife',
        description: "Drink this and you'll be able to cheat Death... but only once.",
        fragile: true,
        invuln: [damages.acid, damages.magic],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'secondlife p'
    };
    Templates.secondSightPotion = {
        name: 'potion of Second Sight',
        plural: 'potions of Second Sight',
        ch: 'ᵿ',
        fg: 'rgb(' + ROT.RNG.getUniformInt(0, 255) + ',' + ROT.RNG.getUniformInt(0, 255) + ',' + ROT.RNG.getUniformInt(0, 255) + ')',
        power: 'permanentsecondsight',
        description: 'This will permanently change your eyes, allowing you to see what is beyond the everyday world.',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'secondsight p'
    };
    Templates.seeinvisiblePotion = {
        name: 'potion of see invisible',
        plural: 'potions of see invisible',
        ch: 'ᵿ',
        fg: 'rgb(' + ROT.RNG.getUniformInt(0, 255) + ',' + ROT.RNG.getUniformInt(0, 255) + ',' + ROT.RNG.getUniformInt(0, 255) + ')',
        power: 'secondsight',
        powstr: 20,
        description: 'A strange liquid, which will allow you to see invisible things for a short time.',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'seeinv p'
    };
    Templates.slownessPotion = {
        name: 'potion of slowness',
        plural: 'potions of slowness',
        ch: 'ᵿ',
        fg: 'chartreuse',
        power: 'slow',
        powstr: 60,
        description: 'It will decrease your speed for a short time.',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'slow p'
    };
    Templates.speedPotion = {
        name: 'potion of speed',
        plural: 'potions of speed',
        ch: 'ᵿ',
        fg: 'chartreuse',
        power: 'speed',
        powstr: 200,
        description: 'It will increase your speed for a short time.',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'speed p'
    };
    Templates.waterPotion = {
        name: 'potion of water',
        plural: 'potions of water',
        ch: 'ᵿ',
        fg: 'white',
        power: 'water',
        description: 'Plain water, good if you are thirsty.',
        fragile: true,
        invuln: [damages.acid],
        resist: [damages.fire, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Drinkable, Mixins.Throwable],
        type: 'water p'
    };
    //Items - food
    Templates.dwarfBread = {
        name: 'dwarf bread',
        plural: 'dwarf breads',
        ch: '÷',
        fg: 'gray',
        attVal: 0,
        dam2: 6,
        part: parts.hand1,
        damtype: damages.blunt,
        energy: 800,
        description: "Forged, not baked. It can last hundreds of years, it's almost inedible and you can use it as weapon in times of need.",
        invuln: [damages.acid, damages.cold, damages.electro, damages.fire, damages.blunt, damages.sound],
        mixins: [Mixins.Item, Mixins.Eatable, Mixins.Equippable, Mixins.Throwable],
        type: 'dwarbr f'
    };
    Templates.elfBread = {
        name: 'elvish bread',
        plural: 'elvish breads',
        ch: '÷',
        fg: 'yellow',
        energy: 1000,
        power: 'heal',
        powstr: 2,
        description: "Wonderful with elvish jam and elvish butter, but tasty even by itself.",
        resist: [damages.acid, damages.cold, damages.electro, damages.fire, damages.sound],
        mixins: [Mixins.Item, Mixins.Eatable],
        type: 'elfbr f'
    };
    Templates.ironRation = {
        name: 'iron ration',
        plural: 'iron rations',
        ch: '÷',
        fg: 'brown',
        energy: 500,
        description: 'Long-lasting food, not exactly tasty but there are worse things to eat out there.',
        resist: [damages.cold, damages.electro, damages.sound],
        mixins: [Mixins.Item, Mixins.Eatable],
        type: 'ironr f'
    };
    //Items - wands
    Templates.confusionWand = {
        name: 'wand of confusion',
        plural: 'wands of confusion',
        ch: 'ǐ',
        fg: 'darkolivegreen',
        charges: 4,
        powstr: 10,
        power: 'confusion',
        description: 'An ancient wand, carved with strange runes',
        resist: [damages.acid, damages.electro, damages.fire, damages.cold],
        mixins: [Mixins.Item, Mixins.Aimable],
        type: 'wand confusion'
    };
    Templates.fireWand = {
        name: 'wand of fireballs',
        plural: 'wands of fireball',
        ch: 'ǐ',
        fg: 'red',
        charges: 4,
        radius: 3,
        powstr: 15,
        power: 'fireball',
        description: 'An ancient wand, carved with strange runes',
        invuln: [damages.fire],
        resist: [damages.acid, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Aimable],
        type: 'wand fireball'
    };
    Templates.healWand = {
        name: 'wand of healing',
        plural: 'wand of healing',
        ch: 'ǐ',
        fg: 'pink',
        charges: 4,
        powstr: 40,
        power: 'heal',
        description: 'An ancient wand, carved with strange runes',
        resist: [damages.acid, damages.electro, damages.fire, damages.cold],
        mixins: [Mixins.Item, Mixins.Aimable],
        type: 'wand heal'
    };
    Templates.iceWand = {
        name: 'wand of arrows of frost',
        plural: 'wand of arrows of frost',
        ch: 'ǐ',
        fg: 'white',
        charges: 4,
        powstr: 4,
        power: 'icearrow',
        description: 'An ancient wand, carved with strange runes',
        invuln: [damages.cold],
        resist: [damages.acid, damages.electro],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Aimable],
        type: 'wand ice'
    };
    Templates.missileWand = {
        name: 'wand of magic missiles',
        plural: 'wands of magic missiles',
        ch: 'ǐ',
        fg: 'yellow',
        charges: 4,
        powstr: 2,
        power: 'magicmissile',
        description: 'An ancient wand, carved with strange runes',
        resist: [damages.acid, damages.electro, damages.fire, damages.cold],
        mixins: [Mixins.Item, Mixins.Aimable],
        type: 'wand missile'
    };
    //Items - scrolls
    Templates.blessScroll = {
        name: 'scroll of enchant weapon to bless',
        plural: 'scrolls of enchant weapon to bless',
        ch: 'ח',
        fg: 'gray',
        oneshot: true,
        power: 'enchant',
        extra: {
            extradamt: damages.holy,
            newinvuln: [damages.holy],
            extraName: damages.holy
        },
        description: 'Read it to enchant a weapon with a holy power.',
        invuln: [damages.holy, damages.unholy],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'bless sc'
    };
    Templates.burnScroll = {
        name: 'scroll of enchant weapon to burn',
        plural: 'scrolls of enchant weapon to burn',
        ch: 'ח',
        fg: 'gray',
        oneshot: true,
        power: 'enchant',
        extra: {
            extradamt: damages.fire,
            newinvuln: [damages.fire],
            extraName: "burning"
        },
        description: 'Read it to enchant a weapon with the power of fire.',
        invuln: [damages.fire],
        vuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'burn sc'
    };
    Templates.corrodeScroll = {
        name: 'scroll of enchant weapon to corrode',
        plural: 'scrolls of enchant weapon to corrode',
        ch: 'ח',
        fg: 'gray',
        oneshot: true,
        power: 'enchant',
        extra: {
            extradamt: damages.acid,
            newinvuln: [damages.acid],
            extraName: "corrosive"
        },
        description: 'Read it to enchant a weapon with the power of acid.',
        invuln: [damages.acid],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'corrode sc'
    };
    Templates.damnScroll = {
        name: 'scroll of enchant weapon to damn',
        plural: 'scrolls of enchant weapon to damn',
        ch: 'ח',
        fg: 'gray',
        oneshot: true,
        power: 'enchant',
        extra: {
            extradamt: damages.unholy,
            newinvuln: [damages.unholy],
            extraName: damages.unholy
        },
        description: 'Read it to enchant a weapon with an unholy power.',
        invuln: [damages.holy, damages.unholy],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'damn sc'
    };
    Templates.freezeScroll = {
        name: 'scroll of enchant weapon to freeze',
        plural: 'scrolls of enchant weapon to freeze',
        ch: 'ח',
        fg: 'gray',
        oneshot: true,
        power: 'enchant',
        extra: {
            extradamt: damages.cold,
            newinvuln: [damages.cold],
            extraName: "freezing"
        },
        description: 'Read it to enchant a weapon with the power of ice.',
        invuln: [damages.cold],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'freeze sc'
    };
    Templates.recallScroll = {
        name: 'scroll of word of recall',
        plural: 'scrolls of word of recall',
        ch: 'ח',
        fg: 'rgb(0,180,180)',
        oneshot: true,
        power: 'recall',
        description: 'Read it and it will instantly teleport you out of a dungeon and back to the surface',
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'recall sc'
    };
    Templates.rechargeScroll = {
        name: 'scroll of recharge',
        plural: 'scrolls of recharge',
        ch: 'ח',
        fg: 'yellow',
        oneshot: true,
        power: 'recharge',
        description: 'Read it to recharge a wand.',
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'recharge sc'
    };
    Templates.shockScroll = {
        name: 'scroll of enchant weapon to shock',
        plural: 'scrolls of enchant weapon to shock',
        ch: 'ח',
        fg: 'gray',
        oneshot: true,
        power: 'enchant',
        extra: {
            extradamt: damages.electro,
            newinvuln: [damages.electro],
            extraName: "shocking"
        },
        description: 'Read it to enchant a weapon with the power of lightning.',
        invuln: [damages.electro],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'shock sc'
    };
    Templates.teleportScroll = {
        name: 'scroll of teleport',
        plural: 'scrolls of teleport',
        ch: 'ח',
        fg: 'rgb(180,180,180)',
        oneshot: true,
        power: 'teleport',
        description: 'It smells musky and is covered with mystical runes',
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'teleport sc'
    };
    Templates.magicManual = {
        name: "book 'Magic for dummies'",
        plural: "books 'Magic for dummies'",
        ch: 'Ɯ',
        fg: 'rgb(40,20,220)',
        oneshot: true,
        power: 'learnmagic',
        description: "How to become a mighty wizard with 10 minutes of practice a day... or so it claims.",
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'magic man'
    };
    Templates.rangedManual = {
        name: "book 'Ranged fight for dummies'",
        plural: "books 'Ranged fight for dummies'",
        ch: 'Ɯ',
        fg: 'rgb(40,220,20)',
        oneshot: true,
        power: 'learnranged',
        description: "How to become a mighty archer with 10 minutes of practice a day... or so it claims.",
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'rang man'
    };
    Templates.acidsplashGrimoire = {
        name: 'grimoire of Acid Splash',
        plural: 'grimoires of Acid Splash',
        ch: 'ח',
        fg: 'rgb(0,180,0)',
        oneshot: true,
        power: 'learnspell',
        extra: "Acid Splash",
        description: 'An ancient book cointaining the secrets of a spell',
        invuln: [damages.acid, damages.magic],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'acidsp gri'
    };
    Templates.healingGrimoire = {
        name: 'grimoire of Healing',
        plural: 'grimoires of Healing',
        ch: 'ח',
        fg: 'rgb(0,0,120)',
        oneshot: true,
        power: 'learnspell',
        extra: "Healing",
        description: 'An ancient book cointaining the secrets of a spell',
        invuln: [damages.magic],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'heal2 gri'
    };
    Templates.healminGrimoire = {
        name: 'grimoire of Minor Healing',
        plural: 'grimoires of Minor Healing',
        ch: 'ח',
        fg: 'rgb(0,50,60)',
        oneshot: true,
        power: 'learnspell',
        extra: "Minor Healing",
        description: 'An ancient book cointaining the secrets of a spell',
        invuln: [damages.magic],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'heal1 gri'
    };
    Templates.healmajGrimoire = {
        name: 'grimoire of Major Healing',
        plural: 'grimoires of Major Healing',
        ch: 'ח',
        fg: 'rgb(0,90,160)',
        oneshot: true,
        power: 'learnspell',
        extra: "Major Healing",
        description: 'An ancient book cointaining the secrets of a spell',
        invuln: [damages.magic],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'heal3 gri'
    };
    Templates.magicmissGrimoire = {
        name: 'grimoire of Magic Missile',
        plural: 'grimoires of Magic Missile',
        ch: 'ח',
        fg: 'rgb(0,40,200)',
        oneshot: true,
        power: 'learnspell',
        extra: "Magic Missile",
        description: 'An ancient book cointaining the secrets of a spell',
        invuln: [damages.magic],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'magimis gri'
    };
    Templates.petrifyGrimoire = {
        name: 'grimoire of Petrify',
        plural: 'grimoires of Petrify',
        ch: 'ח',
        fg: 'rgb(100,100,100)',
        oneshot: true,
        power: 'learnspell',
        extra: "Petrify",
        description: 'An ancient book cointaining the secrets of a spell',
        invuln: [damages.acid, damages.magic],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'petri gri'
    };
    Templates.recallGrimoire = {
        name: 'grimoire of Word of Recall',
        plural: 'grimoires of Word of Recall',
        ch: 'ח',
        fg: 'silver',
        oneshot: true,
        power: 'learnspell',
        extra: "Word of Recall",
        description: 'An ancient book cointaining the secrets of a spell',
        invuln: [damages.acid, damages.magic],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'reca gri'
    };
    Templates.seeinvisibGrimoire = {
        name: 'grimoire of See Invisible',
        plural: 'grimoires of See Invisible',
        ch: 'ח',
        fg: 'rgb(200,170,10)',
        oneshot: true,
        power: 'learnspell',
        extra: "See Invisible",
        description: 'An ancient book cointaining the secrets of a spell',
        invuln: [damages.acid, damages.magic],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'seeinv gri'
    };
    Templates.smiteungodlyGrimoire = {
        name: 'grimoire of Smite the Ungodly',
        plural: 'grimoires of Smite the Ungodly',
        ch: 'ח',
        fg: 'white',
        oneshot: true,
        power: 'learnspell',
        extra: "Smite the Ungodly",
        description: 'An ancient book cointaining the secrets of a spell',
        invuln: [damages.magic, damages.holy, damages.unholy],
        vuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Readable],
        type: 'smiung gri'
    };
    //Items - amulets & Co
    Templates.acidresAmulet = {
        name: 'amulet of acid resistance',
        plural: 'amulets of acid resistance',
        ch: 'ͼ',
        fg: 'green',
        part: parts.neck,
        wearable: true,
        newres: [damages.acid],
        description: 'It will make its wearer resistant to acid.',
        invuln: [damages.acid],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger],
        type: 'acidres am'
    };
    Templates.coldresAmulet = {
        name: 'amulet of cold resistance',
        plural: 'amulets of cold resistance',
        ch: 'ͼ',
        fg: 'rgb(0,0,150)',
        part: parts.neck,
        wearable: true,
        newres: [damages.cold],
        description: 'It will make its wearer resistant to cold-based attacks.',
        invuln: [damages.cold],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger],
        type: 'colddres am'
    };
    Templates.darkresAmulet = {
        name: 'amulet of resistance to dark',
        plural: 'amulets of resistance to dark',
        ch: 'ͼ',
        fg: 'rgb(30,30,30)',
        part: parts.neck,
        wearable: true,
        newres: [damages.dark],
        description: 'It will make its wearer resistant to dark-based attacks.',
        invuln: [damages.dark],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger],
        type: 'darkres am'
    };
    Templates.elecresAmulet = {
        name: 'amulet of electricity resistance',
        plural: 'amulets of electricity resistance',
        ch: 'ͼ',
        fg: 'yellow',
        part: parts.neck,
        wearable: true,
        newres: [damages.electro],
        description: 'It will make its wearer resistant to electricity-based attacks.',
        invuln: [damages.electro],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger],
        type: 'elecres am'
    };
    Templates.fireresAmulet = {
        name: 'amulet of fire resistance',
        plural: 'amulets of fire resistance',
        ch: 'ͼ',
        fg: 'rgb(230,0,0)',
        part: parts.neck,
        wearable: true,
        newres: [damages.fire],
        description: 'It will make its wearer resistant to fire.',
        invuln: [damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger],
        type: 'fireres am'
    };
    Templates.lightresAmulet = {
        name: 'amulet of resistance to light',
        plural: 'amulets of resistance to light',
        ch: 'ͼ',
        fg: 'gold',
        part: parts.neck,
        wearable: true,
        newres: [damages.light],
        description: 'It will make its wearer resistant to light-based attacks.',
        invuln: [damages.light],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger],
        type: 'lightres am'
    };
    Templates.vampiresAmulet = {
        name: 'amulet of resistance to vampirism',
        plural: 'amulets of resistance to vampirism',
        ch: 'ͼ',
        fg: 'rgb(0,0,180)',
        part: parts.neck,
        wearable: true,
        newres: [damages.vamp],
        description: 'It will make its wearer resistant to attacks that drain life force.',
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger],
        type: 'vampires am'
    };
    Templates.paraimmuAmulet = {
        name: 'amulet of immunity to paralysis',
        plural: 'amulets of immunity to paralysis',
        ch: 'ͼ',
        fg: 'rgb(40,10,150)',
        part: parts.neck,
        wearable: true,
        newinvuln: [damages.paral],
        description: 'It will make its wearer immune to paralysis.',
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger],
        type: 'paraimmu am'
    };
    Templates.holinessAmulet = {
        name: 'amulet of holiness',
        plural: 'amulets of holiness',
        ch: 'ͼ',
        fg: 'white',
        part: parts.neck,
        wearable: true,
        newres: [damages.unholy],
        description: 'It will make its wearer resistant to unholy attacks.',
        invuln: [damages.holy, damages.unholy],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger],
        type: 'holy am'
    };
    Templates.unholinessAmulet = {
        name: 'amulet of unholiness',
        plural: 'amulets of unholiness',
        ch: 'ͼ',
        fg: 'rgb(40,40,40)',
        part: parts.neck,
        wearable: true,
        newres: [damages.holy],
        description: 'It will make its wearer resistant to holy attacks.',
        invuln: [damages.holy, damages.unholy],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger],
        type: 'unholy am'
    };
    Templates.cha4Amulet = {
        name: 'amulet of charisma (+4)',
        plural: 'amulets of charisma (+4)',
        ch: 'ͼ',
        fg: 'rgb(100,0,150)',
        part: parts.neck,
        wearable: true,
        changes: {
            charisma: 4
        },
        description: 'A mysterious amulet, engraved with runes',
        resist: [damages.acid, damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.DataChanger],
        type: 'cha am 4'
    };
    Templates.con4Amulet = {
        name: 'amulet of constitution (+4)',
        plural: 'amulets of constitution (+4)',
        ch: 'ͼ',
        fg: 'yellow',
        part: parts.neck,
        wearable: true,
        changes: {
            constitution: 4
        },
        description: 'A mysterious amulet, engraved with runes',
        resist: [damages.acid, damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.DataChanger],
        type: 'con am 4'
    };
    Templates.dex4Amulet = {
        name: 'amulet of dexterity (+4)',
        plural: 'amulets of dexterity (+4)',
        ch: 'ͼ',
        fg: 'maroon',
        part: parts.neck,
        wearable: true,
        changes: {
            dexterity: 4
        },
        description: 'A mysterious amulet, engraved with runes',
        resist: [damages.acid, damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.DataChanger],
        type: 'dex am 4'
    };
    Templates.inte4Amulet = {
        name: 'amulet of intelligence (+4)',
        plural: 'amulets of intelligence (+4)',
        ch: 'ͼ',
        fg: 'cyan',
        part: parts.neck,
        wearable: true,
        changes: {
            intelligence: 4
        },
        description: 'A mysterious amulet, engraved with runes',
        resist: [damages.acid, damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.DataChanger],
        type: 'inte am 4'
    };
    Templates.str4Amulet = {
        name: 'amulet of strength (+4)',
        plural: 'amulets of strength (+4)',
        ch: 'ͼ',
        fg: 'silver',
        part: parts.neck,
        wearable: true,
        changes: {
            strength: 4
        },
        description: 'A mysterious amulet, engraved with runes',
        resist: [damages.acid, damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.DataChanger],
        type: 'str am 4'
    };
    Templates.wis4Amulet = {
        name: 'amulet of wisdom (+4)',
        plural: 'amulets of wisdom (+4)',
        ch: 'ͼ',
        fg: 'rgb(0,100,150)',
        part: parts.neck,
        wearable: true,
        changes: {
            wisdom: 4
        },
        description: 'A mysterious amulet, engraved with runes',
        resist: [damages.acid, damages.fire],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.DataChanger],
        type: 'wis am 4'
    };
    Templates.kagayaAmulet = {
        name: 'amulet of Kagaya',
        plural: 'amulets of Kagaya',
        ch: 'ͼ',
        fg: 'rgb(108, 39,188)',
        part: parts.neck,
        wearable: true,
        changes: {
            intelligence: 3,
            wisdom: 3,
            charisma: 3
        },
        newinvuln: [damages.paral, damages.confu, damages.sleep, damages.petro, damages.bleed, damages.sound],
        newres: [damages.acid],
        description: 'A mysterious amulet, engraved with runes.',
        invuln: [damages.acid, damages.cold, damages.fire, damages.electro, damages.magic, damages.sound],
        mixins: [Mixins.Item, Mixins.Equippable, Mixins.VulnerabilityChanger, Mixins.DataChanger],
        type: 'kaga am'
    };
    //monsters & Co
    Templates.player = {
        name: 'player',
        ch: '@',
        fg: 'white',
        speed: 100,
        sightRad: 7,
        str: 15,
        dex: 15,
        con: 15,
        inte: 15,
        wis: 15,
        cha: 15,
        maxhp: 20,
        dam2: 3,
        damtype: damages.blunt,
        inventory: 26,
        energy: 2000,
        description: 'You, the almighty player',
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.PlayerActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.XPGainer, Mixins.Eater],
        type: 'player'
    };
    Templates.angel = {
        name: 'angel',
        ch: 'a',
        fg: 'white',
        speed: 200,
        sightRad: 10,
        str: 22,
        dex: 18,
        con: 18,
        inte: 18,
        wis: 18,
        cha: 20,
        hp1: 60,
        hp2: 144,
        dam1: 1,
        dam2: 8,
        bonus: 12,
        damtype: damages.blunt,
        defence: 15,
        challenge: 24,
        description: "God's mailman, in the form of a tall, handsome, winged humanoid",
        resist: [damages.electro, damages.fire, damages.pois, damages.sleep],
        invuln: [damages.acid, damages.cold, damages.holy, damages.petro],
        vuln: [damages.unholy],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.archangel = {
        name: 'archangel',
        ch: 'a',
        fg: 'yellow',
        speed: 210,
        sightRad: 10,
        str: 25,
        dex: 19,
        con: 20,
        inte: 22,
        wis: 23,
        cha: 22,
        hp1: 84,
        hp2: 182,
        dam1: 2,
        dam2: 8,
        bonus: 10,
        dambon: 13,
        damtype: damages.blunt,
        defence: 18,
        challenge: 34,
        description: "God's mailman, in the form of a tall, handsome, winged humanoid, with halo and so on",
        resist: [damages.electro, damages.fire, damages.pois, damages.sleep, damages.bleed],
        invuln: [damages.acid, damages.cold, damages.holy, damages.petro],
        vuln: [damages.unholy],
        equipment: [Templates.greatsword],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.InventoryHolder, Mixins.Equipper],
        type: 'aggressive'
    };
    Templates.angelPrincip = {
        name: 'principate',
        ch: 'a',
        fg: 'rgb(0,160,0)',
        speed: 210,
        sightRad: 15,
        str: 23,
        dex: 23,
        con: 21,
        inte: 25,
        wis: 24,
        cha: 23,
        hp1: 90,
        hp2: 190,
        dam1: 3,
        dam2: 7,
        bonus: 10,
        dambon: 12,
        damtype: damages.blunt,
        defence: 16,
        challenge: 40,
        description: "God's mailman, in the form of a tall, handsome, humanoid with 3 pairs of wings",
        resist: [damages.electro, damages.fire, damages.pois, damages.sleep, damages.bleed],
        invuln: [damages.acid, damages.cold, damages.holy, damages.petro],
        vuln: [damages.unholy],
        equipment: [Templates.swordblessed],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.InventoryHolder, Mixins.Equipper],
        type: 'aggressive'
    };
    Templates.assassin = {
        name: 'assassin',
        ch: 'a',
        fg: 'rgb(40,40,40)',
        speed: 110,
        sightRad: 10,
        str: 12,
        dex: 20,
        con: 12,
        inte: 14,
        wis: 12,
        cha: 12,
        hp1: 8,
        hp2: 22,
        dam2: 4,
        damtype: damages.blunt,
        challenge: 7,
        weight: 8,
        description: "Elegantly dressed in black, he will try to quietly inhume you",
        impass: true,
        equipment: [Templates.stiletto],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.assassinExpert = {
        name: 'expert assassin',
        ch: 'a',
        fg: 'rgb(30,30,30)',
        speed: 120,
        sightRad: 10,
        str: 13,
        dex: 22,
        con: 13,
        inte: 15,
        wis: 12,
        cha: 13,
        hp1: 10,
        hp2: 25,
        dam2: 4,
        damtype: damages.blunt,
        challenge: 20,
        weight: 8,
        description: "Elegantly dressed in black silk but very hard to see, he will try to quietly inhume you",
        specpow: ["Second Sight"],
        impass: true,
        invisibility: true,
        equipment: [Templates.stiletto],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.assassinMaster = {
        name: 'master assassin',
        ch: 'a',
        fg: 'darkolivegreen',
        speed: 200,
        sightRad: 15,
        str: 13,
        dex: 26,
        con: 13,
        inte: 18,
        wis: 15,
        cha: 15,
        hp1: 15,
        hp2: 35,
        dam2: 4,
        damtype: damages.blunt,
        challenge: 30,
        weight: 8,
        description: "He inhumed more people than you could count in a very boring afternoon.. and you are the next.",
        specpow: ["Second Sight"],
        impass: true,
        invisibility: true,
        invuln: [damages.confu, damages.sleep],
        equipment: [Templates.stilettoVamp, Templates.paraimmuAmulet],
        ranged: Templates.crossbow,
        ammo: Templates.bolt,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.ShooterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.bandit = {
        name: 'bandit',
        ch: 'b',
        fg: 'rgb(230,230,230)',
        speed: 106,
        sightRad: 7,
        str: 13,
        dex: 16,
        con: 12,
        inte: 10,
        wis: 9,
        cha: 10,
        hp1: 10,
        hp2: 25,
        dam2: 4,
        damtype: damages.blunt,
        challenge: 6,
        weight: 10,
        description: "Someone who chose a differently honest way to earn a life and doesn't meddle with the stock market",
        impass: true,
        equipment: [Templates.rapier, Templates.leatherarm, Templates.leatherboot],
        items: [Templates.ironRation],
        ranged: Templates.crossbow,
        ammo: Templates.bolt,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.ShooterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.Shooter, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.bearBlack = {
        name: 'black bear',
        ch: 'b',
        fg: 'rgb(50,50,50)',
        speed: 120,
        sightRad: 10,
        str: 19,
        dex: 13,
        con: 15,
        inte: 2,
        wis: 12,
        cha: 6,
        hp1: 9,
        hp2: 30,
        dam1: 1,
        dam2: 4,
        bonus: 4,
        damtype: damages.pierce,
        defence: 2,
        challenge: 9,
        weight: 13,
        energy: 250,
        description: "Not very big, it's just minding its own bear business. Not dangerous if not provoked",
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.BaseActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.CorpseDropper],
        type: 'wander'
    };
    Templates.centaur = {
        name: 'centaur',
        ch: 'c',
        fg: 'gray',
        speed: 200,
        sightRad: 10,
        str: 18,
        dex: 14,
        con: 15,
        inte: 8,
        wis: 13,
        cha: 11,
        hp1: 12,
        hp2: 40,
        dam2: 6,
        bonus: 2,
        damtype: damages.blunt,
        attbon: 2,
        defence: 2,
        apr: 2,
        challenge: 15,
        weight: 30,
        energy: 350,
        description: 'A big, angry horse with a human torso; beware his bow... and his hoofs',
        impass: true,
        equipment: [Templates.spear],
        ranged: [Templates.longbow],
        ammo: [Templates.arrow],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.ShooterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.Shooter, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.centipede = {
        name: 'monstrous centipede',
        ch: 'җ',
        fg: 'brown',
        speed: 100,
        sightRad: 8,
        str: 9,
        dex: 15,
        con: 10,
        inte: 1,
        wis: 10,
        cha: 2,
        hp1: 1,
        hp2: 8,
        dam2: 3,
        damtype: damages.pierce,
        defence: 2,
        poisdam: 1,
        poisdur: 30,
        poisstr: 10,
        poischa: 11,
        challenge: 5,
        description: "It's full of legs and likes scurrying around over everything",
        impass: true,
        invuln: [damages.bleed, damages.confu],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.Poisonous, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.centipedeGiant = {
        name: 'giant monstrous centipede',
        ch: 'Җ',
        fg: 'brown',
        speed: 140,
        sightRad: 10,
        str: 13,
        dex: 15,
        con: 10,
        inte: 1,
        wis: 10,
        cha: 2,
        hp1: 3,
        hp2: 24,
        dam2: 8,
        bonus: 1,
        damtype: damages.pierce,
        defence: 2,
        poisdam: 3,
        poisdur: 40,
        poisstr: 11,
        poischa: 11,
        challenge: 15,
        weight: 20,
        energy: 180,
        description: "It's bigger than a car, full of legs and poisonous. What do you want more?",
        specpow: ["Second Sight"],
        invuln: [damages.bleed, damages.confu],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.Poisonous, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.cockroach = {
        name: 'giant cockroach',
        ch: 'Ӂ',
        fg: 'rgb(25,25,25)',
        speed: 200,
        sightRad: 8,
        str: 20,
        dex: 10,
        con: 20,
        inte: 1,
        wis: 10,
        cha: 5,
        hp1: 30,
        hp2: 80,
        dam1: 3,
        dam2: 6,
        bonus: 4,
        damtype: damages.pierce,
        defence: 10,
        challenge: 30,
        weight: 20,
        energy: 220,
        description: "It's a damn cockroach and it's bigger than a bed. Do you really need to know more?",
        impass: true,
        invuln: [damages.bleed, damages.confu],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.demonBabau = {
        name: 'babau',
        ch: 'b',
        fg: 'maroon',
        speed: 100,
        sightRad: 9,
        str: 21,
        dex: 12,
        con: 20,
        inte: 14,
        wis: 13,
        cha: 16,
        hp1: 42,
        hp2: 91,
        dam1: 1,
        dam2: 6,
        bonus: 5,
        damtype: damages.cut,
        attbon: 5,
        defence: 8,
        challenge: 40,
        description: 'Your worst nightmare when you were a child. No, not the one where your socks chased you.',
        invuln: [damages.electro, damages.pois, damages.sleep],
        resist: [damages.acid, damages.cold, damages.fire, damages.holy],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.demonDretch = {
        name: 'dretch',
        ch: 'd',
        fg: 'rgb(200,0,120)',
        speed: 80,
        sightRad: 9,
        str: 12,
        dex: 10,
        con: 14,
        inte: 5,
        wis: 11,
        cha: 11,
        hp1: 6,
        hp2: 20,
        dam1: 1,
        dam2: 6,
        bonus: 5,
        damtype: damages.cut,
        defence: 6,
        challenge: 10,
        description: 'Small, weak and stupid, it relies on sheer number to overcome you.',
        invuln: [damages.electro, damages.pois],
        resist: [damages.acid, damages.cold, damages.fire, damages.holy],
        impass: true,
        summonable: ['demonDretch'],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SummonerActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.Summoner],
        type: 'aggressive'
    };
    Templates.devilBarbazu = {
        name: 'barbazu',
        ch: 'b',
        fg: 'red',
        speed: 100,
        sightRad: 9,
        str: 15,
        dex: 15,
        con: 17,
        inte: 6,
        wis: 10,
        cha: 10,
        hp1: 24,
        hp2: 66,
        dam1: 1,
        dam2: 10,
        bonus: 3,
        damtype: damages.cut,
        extradamt: [damages.unholy],
        attbon: 5,
        defence: 7,
        challenge: 36,
        description: 'A tall devil with a bg beard. Definitely not a nice guy, but there are worse things.',
        invuln: [damages.fire, damages.pois, damages.sleep],
        resist: [damages.acid, damages.cold, damages.magic, damages.holy],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.devilBezekira = {
        name: 'bezekira',
        ch: 'ƀ',
        fg: 'rgb(125,0,10)',
        speed: 130,
        sightRad: 12,
        str: 23,
        dex: 21,
        con: 17,
        inte: 10,
        wis: 14,
        cha: 10,
        hp1: 32,
        hp2: 88,
        dam1: 1,
        dam2: 8,
        bonus: 6,
        damtype: damages.pierce,
        extradamt: [damages.unholy],
        attbon: 5,
        defence: 6,
        apr: 3,
        challenge: 38,
        description: "Looks like an odd glowing cat, but bigger than a horse. Beware its claws.",
        invuln: [damages.pois, damages.sleep],
        resist: [damages.acid, damages.fire, damages.magic],
        specpow: ["Second Sight"],
        impass: true,
        invisibility: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.devilImp = {
        name: 'imp',
        ch: 'i',
        fg: 'rgb(225,0,00)',
        speed: 100,
        sightRad: 12,
        str: 10,
        dex: 17,
        con: 10,
        inte: 10,
        wis: 12,
        cha: 14,
        hp1: 3,
        hp2: 24,
        dam1: 1,
        dam2: 4,
        damtype: damages.pierce,
        attbon: 5,
        defence: 7,
        challenge: 18,
        regen: 2,
        poisdam: 1,
        poisdur: 50,
        poisstr: 18,
        poischa: 13,
        description: "Very small but very poisonous, it's an invisible bother that will try to sting you with its tail.",
        invuln: [damages.pois, damages.sleep],
        resist: [damages.acid, damages.fire, damages.magic],
        specpow: ["Second Sight"],
        impass: true,
        invisibility: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.Poisonous,
            Mixins.Regenerator],
        type: 'aggressive'
    };
    Templates.devilKyton = {
        name: 'kyton',
        ch: 'k',
        fg: 'red',
        speed: 100,
        sightRad: 9,
        str: 15,
        dex: 15,
        con: 15,
        inte: 6,
        wis: 10,
        cha: 12,
        hp1: 24,
        hp2: 66,
        dam1: 2,
        dam2: 4,
        bonus: 2,
        damtype: damages.blunt,
        extradamt: [damages.unholy],
        attbon: 5,
        defence: 8,
        regen: 3,
        apr: 2,
        challenge: 40,
        description: "A humanoid wrapped in chains, maybe because it's into bondage. Wanna ask?",
        invuln: [damages.cold, damages.pois, damages.sleep],
        resist: [damages.acid, damages.fire, damages.holy],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.Regenerator],
        type: 'aggressive'
    };
    Templates.devilLemure = {
        name: 'lemure',
        ch: 'l',
        fg: 'gray',
        speed: 80,
        sightRad: 12,
        str: 10,
        dex: 10,
        con: 10,
        inte: 10,
        wis: 11,
        cha: 5,
        hp1: 2,
        hp2: 16,
        dam1: 1,
        dam2: 4,
        damtype: damages.pierce,
        attbon: 5,
        defence: 4,
        challenge: 8,
        description: "Mindless and humanoid-ish, the only thing it can understand is clawing stuff apart.",
        invuln: [damages.pois, damages.fire, damages.sleep, damages.confu],
        resist: [damages.acid, damages.cold],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.devilOsyluth = {
        name: 'osyluth',
        ch: 'o',
        fg: 'rgb(130,20,60)',
        speed: 110,
        sightRad: 12,
        str: 21,
        dex: 21,
        con: 21,
        inte: 14,
        wis: 14,
        cha: 14,
        hp1: 60,
        hp2: 130,
        dam1: 1,
        dam2: 8,
        bonus: 5,
        damtype: damages.pierce,
        extradamt: [damages.unholy],
        attbon: 7,
        defence: 10,
        apr: 2,
        poisdam: 2,
        poisdur: 50,
        poisstr: 18,
        poischa: 14,
        challenge: 70,
        description: "A huge humanoid figure, apparently made of bones. It's poisonous and it can call for help.",
        invuln: [damages.pois, damages.sleep, damages.fire, damages.confu],
        resist: [damages.acid, damages.cold, damages.magic, damages.petro, damages.paral, damages.holy],
        specpow: ["Second Sight"],
        impass: true,
        summonable: ['devilLemure'],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SummonerActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.Summoner,
            Mixins.Poisonous],
        type: 'aggressive'
    };
    Templates.duergar = {
        name: 'duergar',
        ch: 'd',
        fg: 'rgb(30,30,30)',
        speed: 90,
        sightRad: 9,
        str: 13,
        dex: 11,
        con: 14,
        inte: 10,
        wis: 9,
        cha: 4,
        hp1: 6,
        hp2: 13,
        dam2: 6,
        damtype: damages.blunt,
        challenge: 8,
        weight: 6,
        description: "A kind of dwarf who only lives underground and never sees the light of day. Not very hospitable.",
        invuln: [damages.pois, damages.paral],
        resist: [damages.dark, damages.magic],
        vuln: [damages.light],
        impass: true,
        invisibility: true,
        items: [Templates.dwarfBread],
        equipment: [Templates.warhammer, Templates.splintmail, Templates.ironhelm, Templates.ironboot],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.dwarf = {
        name: 'dwarf',
        ch: 'd',
        fg: 'yellow',
        speed: 90,
        sightRad: 9,
        str: 13,
        dex: 11,
        con: 14,
        inte: 10,
        wis: 9,
        cha: 6,
        hp1: 3,
        hp2: 10,
        dam2: 6,
        damtype: damages.blunt,
        challenge: 4,
        weight: 6,
        description: "Short and angry, he will earnestly try to chop your knees off.",
        impass: true,
        items: [Templates.dwarfBread],
        equipment: [Templates.handaxe, Templates.chainmail, Templates.ironhelm, Templates.ironboot],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.dwarfGuard = {
        name: 'dwarf guard',
        ch: 'd',
        fg: 'silver',
        speed: 100,
        sightRad: 12,
        str: 18,
        dex: 12,
        con: 21,
        inte: 8,
        wis: 9,
        cha: 5,
        hp1: 15,
        hp2: 30,
        dam2: 6,
        damtype: damages.blunt,
        attbon: 2,
        challenge: 10,
        weight: 6,
        description: "An élite warrior who works directly for the Low King and is nasty even for a dwarf.",
        impass: true,
        items: [Templates.dwarfBread],
        equipment: [Templates.waraxeDwar, Templates.fullplate, Templates.helmInsomnia, Templates.ironboot],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.dwarfWarrior = {
        name: 'dwarf warrior',
        ch: 'd',
        fg: 'gold',
        speed: 90,
        sightRad: 9,
        str: 16,
        dex: 11,
        con: 18,
        inte: 10,
        wis: 9,
        cha: 5,
        hp1: 5,
        hp2: 15,
        dam2: 6,
        damtype: damages.blunt,
        challenge: 5,
        weight: 6,
        description: "Short and angry, he will earnestly try to chop your knees off with a battleaxe.",
        impass: true,
        items: [Templates.dwarfBread],
        equipment: [Templates.waraxeDwar, Templates.halfplate, Templates.ironhelm, Templates.ironboot],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.elemAirSmall = {
        name: 'small elemental of air',
        ch: 'e',
        fg: 'rgba(185,185,185,.6)',
        speed: 170,
        sightRad: 10,
        str: 10,
        dex: 17,
        con: 10,
        inte: 4,
        wis: 11,
        cha: 11,
        hp1: 2,
        hp2: 16,
        dam2: 4,
        damtype: damages.blunt,
        attbon: 2,
        defence: 4,
        challenge: 10,
        description: 'A small, humanoid figure, ethereal and almost intangible, quite impervious to normal damage.',
        impass: true,
        invuln: [damages.electro, damages.petro, damages.acid, damages.bleed],
        resist: [damages.cut, damages.blunt, damages.pierce, damages.cold],
        specpow: ["Second Sight"],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.elemAirMedium = {
        name: 'elemental of air',
        ch: 'e',
        fg: 'rgba(215,215,215,.5)',
        speed: 180,
        sightRad: 15,
        str: 12,
        dex: 21,
        con: 14,
        inte: 4,
        wis: 11,
        cha: 11,
        hp1: 12,
        hp2: 40,
        dam2: 6,
        bonus: 1,
        damtype: damages.blunt,
        attbon: 2,
        defence: 3,
        challenge: 20,
        description: 'A humanoid figure, ethereal and almost intangible, quite impervious to normal damage.',
        impass: true,
        invuln: [damages.electro, damages.petro, damages.acid, damages.bleed],
        resist: [damages.cut, damages.blunt, damages.pierce, damages.cold],
        specpow: ["Second Sight"],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.elemAirLarge = {
        name: 'large elemental of air',
        ch: 'e',
        fg: 'rgba(235,235,235,.4)',
        speed: 200,
        sightRad: 15,
        str: 14,
        dex: 25,
        con: 16,
        inte: 6,
        wis: 11,
        cha: 11,
        hp1: 32,
        hp2: 88,
        dam1: 2,
        dam2: 6,
        bonus: 2,
        damtype: damages.blunt,
        extradamt: [damages.electro],
        attbon: 2,
        defence: 3,
        challenge: 30,
        description: 'A big humanoid figure, almost intangible and quite impervious to normal damage.',
        impass: true,
        invisible: true,
        invuln: [damages.electro, damages.petro, damages.acid, damages.blunt, damages.sleep, damages.confu, damages.pois, damages.bleed],
        resist: [damages.cut, damages.pierce, damages.cold],
        specpow: ["Second Sight"],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.elemAirLord = {
        name: 'lord elemental of air',
        ch: 'E',
        fg: 'rgba(255,255,255,.2)',
        speed: 200,
        sightRad: 15,
        str: 14,
        dex: 25,
        con: 16,
        inte: 6,
        wis: 11,
        cha: 11,
        hp1: 105,
        hp2: 252,
        dam1: 2,
        dam2: 8,
        bonus: 5,
        damtype: damages.blunt,
        extradamt: [damages.electro],
        attbon: 8,
        apr: 2,
        defence: 6,
        challenge: 90,
        description: 'An ancient, powerful lord of air, incredibly hard to see, let alone touch and hurt.',
        impass: true,
        invisible: true,
        invuln: [damages.electro, damages.petro, damages.acid, damages.blunt, damages.sleep, damages.paral, damages.confu, damages.pois, damages.bleed],
        resist: [damages.cut, damages.pierce, damages.cold],
        summonable: ['elemAirSmall', 'elemAirMedium'],
        specpow: ["Second Sight"],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SummonerActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.Summoner],
        type: 'aggressive'
    };
    Templates.elemEarthSmall = {
        name: 'small elemental of earth',
        ch: 'e',
        fg: 'rgb(185,185,0)',
        speed: 70,
        sightRad: 10,
        str: 17,
        dex: 8,
        con: 13,
        inte: 4,
        wis: 11,
        cha: 11,
        hp1: 4,
        hp2: 18,
        dam2: 6,
        bonus: 4,
        damtype: damages.blunt,
        attbon: 2,
        defence: 8,
        challenge: 10,
        description: 'A small, humanoid figure, stout and hard, which can really kick arses.',
        impass: true,
        invuln: [damages.petro, damages.acid, damages.bleed],
        resist: [damages.cut, damages.blunt, damages.pierce, damages.fire],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.elemEarthMedium = {
        name: 'elemental of earth',
        ch: 'e',
        fg: 'rgb(205,145,0)',
        speed: 70,
        sightRad: 10,
        str: 21,
        dex: 8,
        con: 17,
        inte: 4,
        wis: 11,
        cha: 11,
        hp1: 16,
        hp2: 44,
        dam2: 8,
        bonus: 7,
        damtype: damages.blunt,
        attbon: 4,
        defence: 8,
        challenge: 20,
        description: 'A humanoid figure, stout and hard, which can really kick arses.',
        impass: true,
        invuln: [damages.petro, damages.acid, damages.bleed],
        resist: [damages.cut, damages.blunt, damages.pierce, damages.fire],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.elemEarthLarge = {
        name: 'large elemental of earth',
        ch: 'e',
        fg: 'rgb(235,235,0)',
        speed: 70,
        sightRad: 15,
        str: 25,
        dex: 8,
        con: 19,
        inte: 6,
        wis: 11,
        cha: 11,
        hp1: 40,
        hp2: 96,
        dam1: 2,
        dam2: 8,
        bonus: 7,
        damtype: damages.blunt,
        attbon: 6,
        defence: 9,
        challenge: 40,
        description: 'A towering humanoid figure, stout and hard, ready to kick ten different kinds of shit out of you.',
        impass: true,
        invuln: [damages.petro, damages.acid, damages.cut, damages.sleep, damages.paral, damages.confu, damages.pois, damages.bleed],
        resist: [damages.blunt, damages.pierce, damages.fire, damages.electro],
        specpow: ["Second Sight"],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.elemEarthLord = {
        name: 'lord elemental of earth',
        ch: 'E',
        fg: 'rgb(255,255,0)',
        speed: 85,
        sightRad: 15,
        str: 31,
        dex: 8,
        con: 21,
        inte: 8,
        wis: 11,
        cha: 11,
        hp1: 126,
        hp2: 273,
        dam1: 2,
        dam2: 10,
        bonus: 10,
        damtype: damages.blunt,
        attbon: 10,
        apr: 2,
        defence: 11,
        challenge: 90,
        description: 'An ancient, powerful lord of earth, incredibly hard to harm, who can shatter mountains with a fist. Or something like that.',
        impass: true,
        invuln: [damages.petro, damages.acid, damages.cut, damages.electro, damages.sleep, damages.paral, damages.confu, damages.pois, damages.bleed],
        resist: [damages.blunt, damages.pierce, damages.fire, damages.cold],
        summonable: ['elemEarthSmall', 'elemEarthMedium'],
        specpow: ["Second Sight"],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SummonerActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.Summoner],
        type: 'aggressive'
    };
    Templates.elemFireSmall = {
        name: 'small elemental of fire',
        ch: 'e',
        fg: 'rgb(145,0,0)',
        speed: 120,
        sightRad: 10,
        str: 10,
        dex: 13,
        con: 10,
        inte: 4,
        wis: 11,
        cha: 11,
        hp1: 2,
        hp2: 16,
        dam2: 4,
        damtype: damages.blunt,
        touchdam: damages.fire,
        attbon: 2,
        defence: 4,
        challenge: 10,
        description: 'A small, humanoid figure entirely made of fire and definitely hot-headed.',
        impass: true,
        invuln: [damages.fire, damages.acid, damages.pois, damages.bleed],
        resist: [damages.cut, damages.blunt, damages.pierce, damages.electro],
        vuln: [damages.cold],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.HurtingSkin],
        type: 'aggressive'
    };
    Templates.elemFireMedium = {
        name: 'elemental of fire',
        ch: 'e',
        fg: 'rgb(205,0,0)',
        speed: 120,
        sightRad: 10,
        str: 12,
        dex: 17,
        con: 14,
        inte: 4,
        wis: 11,
        cha: 11,
        hp1: 12,
        hp2: 40,
        dam2: 6,
        bonus: 1,
        damtype: damages.blunt,
        touchdam: damages.fire,
        attbon: 4,
        defence: 8,
        challenge: 20,
        description: 'A humanoid figure entirely made of fire that literally burn by the desire of torching your arse.',
        impass: true,
        invuln: [damages.fire, damages.acid, damages.pois, damages.bleed],
        resist: [damages.cut, damages.blunt, damages.pierce, damages.electro, damages.sleep, damages.petro],
        vuln: [damages.cold],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.HurtingSkin],
        type: 'aggressive'
    };
    Templates.elemFireLarge = {
        name: 'large elemental of fire',
        ch: 'e',
        fg: 'rgb(255,0,0)',
        speed: 140,
        sightRad: 15,
        str: 14,
        dex: 21,
        con: 16,
        inte: 6,
        wis: 11,
        cha: 11,
        hp1: 32,
        hp2: 88,
        dam1: 2,
        dam2: 6,
        bonus: 2,
        damtype: damages.blunt,
        touchdam: damages.fire,
        attbon: 6,
        defence: 3,
        challenge: 40,
        description: 'A pillar of fire, advancing toward you, melting everything it touches.',
        impass: true,
        invuln: [damages.fire, damages.acid, damages.sleep, damages.paral, damages.petro, damages.pois, damages.bleed],
        resist: [damages.cut, damages.blunt, damages.pierce, damages.electro, damages.confu],
        vuln: [damages.cold],
        specpow: ["Second Sight"],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.HurtingSkin],
        type: 'aggressive'
    };
    Templates.elemFireLord = {
        name: 'lord elemental of fire',
        ch: 'E',
        fg: 'rgb(255,0,0)',
        speed: 150,
        sightRad: 15,
        str: 20,
        dex: 27,
        con: 18,
        inte: 6,
        wis: 11,
        cha: 11,
        hp1: 105,
        hp2: 252,
        dam1: 2,
        dam2: 8,
        bonus: 5,
        damtype: damages.blunt,
        touchdam: damages.fire,
        attbon: 10,
        apr: 2,
        defence: 6,
        challenge: 90,
        description: 'An ancient, powerful lord of fire, whose touch can melt continents, whose soul is global warming. Or something like that.',
        impass: true,
        invuln: [damages.fire, damages.acid, damages.sleep, damages.paral, damages.petro, damages.electro, damages.confu, damages.pois, damages.bleed],
        resist: [damages.cut, damages.blunt, damages.pierce, damages.light],
        vuln: [damages.cold],
        summonable: ['elemFireSmall', 'elemFireMedium'],
        specpow: ["Second Sight"],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SummonerActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.Summoner, Mixins.HurtingSkin],
        type: 'aggressive'
    };
    Templates.elemWaterSmall = {
        name: 'small elemental of water',
        ch: 'e',
        fg: 'rgb(0,0,145)',
        speed: 100,
        sightRad: 10,
        str: 14,
        dex: 10,
        con: 13,
        inte: 4,
        wis: 11,
        cha: 11,
        hp1: 4,
        hp2: 18,
        dam2: 6,
        bonus: 3,
        damtype: damages.blunt,
        attbon: 2,
        defence: 7,
        challenge: 10,
        description: 'A small, humanoid figure entirely made of water, ready to smash you like a wave against a reef.',
        impass: true,
        invuln: [damages.light, damages.acid, damages.bleed],
        resist: [damages.cut, damages.blunt, damages.pierce, damages.electro],
        vuln: [damages.fire],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.elemWaterMedium = {
        name: 'elemental of water',
        ch: 'e',
        fg: 'rgb(0,0,205)',
        speed: 100,
        sightRad: 10,
        str: 16,
        dex: 12,
        con: 17,
        inte: 4,
        wis: 11,
        cha: 11,
        hp1: 16,
        hp2: 44,
        dam2: 8,
        bonus: 4,
        damtype: damages.blunt,
        attbon: 4,
        defence: 8,
        challenge: 25,
        description: 'A humanoid figure entirely made of water and angrier than a seastorm.',
        impass: true,
        invuln: [damages.light, damages.acid, damages.bleed],
        resist: [damages.cut, damages.blunt, damages.pierce, damages.electro, damages.confu, damages.sleep],
        vuln: [damages.fire],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.elemWaterLarge = {
        name: 'large elemental of water',
        ch: 'e',
        fg: 'rgb(0,0,255)',
        speed: 120,
        sightRad: 15,
        str: 20,
        dex: 14,
        con: 19,
        inte: 6,
        wis: 11,
        cha: 11,
        hp1: 40,
        hp2: 96,
        dam1: 2,
        dam2: 8,
        bonus: 5,
        damtype: damages.blunt,
        attbon: 6,
        defence: 8,
        challenge: 45,
        description: 'A living tsunami advancing toward you to smash your puny efforts once and for all.',
        impass: true,
        invuln: [damages.light, damages.acid, damages.petro, damages.pois, damages.sleep, damages.confu, damages.paral, damages.bleed],
        resist: [damages.cut, damages.blunt, damages.pierce, damages.electro, damages.light, damages.vamp],
        vuln: [damages.fire],
        specpow: ["Second Sight"],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.elemWaterLord = {
        name: 'lord elemental of water',
        ch: 'E',
        fg: 'rgb(0,0,255)',
        speed: 130,
        sightRad: 15,
        str: 26,
        dex: 20,
        con: 21,
        inte: 8,
        wis: 11,
        cha: 11,
        hp1: 126,
        hp2: 273,
        dam1: 2,
        dam2: 10,
        bonus: 8,
        damtype: damages.blunt,
        attbon: 10,
        apr: 2,
        defence: 7,
        challenge: 90,
        description: 'An ancient, powerful lord of water, whose touch can change coastlines all around the world. Or something like that.',
        impass: true,
        invuln: [damages.light, damages.acid, damages.petro, damages.pois, damages.sleep, damages.confu, damages.blunt, damages.paral, damages.bleed],
        resist: [damages.cut, damages.pierce, damages.electro, damages.light, damages.vamp],
        vuln: [damages.fire],
        summonable: ['elemWaterSmall', 'elemWaterMedium'],
        specpow: ["Second Sight"],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SummonerActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.Summoner],
        type: 'aggressive'
    };
    Templates.elf = {
        name: 'elf',
        ch: 'e',
        fg: 'rgb(0,200,0)',
        speed: 120,
        sightRad: 12,
        str: 12,
        dex: 24,
        con: 13,
        inte: 14,
        wis: 10,
        cha: 20,
        hp1: 10,
        hp2: 29,
        dam2: 5,
        damtype: damages.blunt,
        challenge: 10,
        weight: 8,
        energy: 220,
        description: "Not the kind that sings gaily under the stars, but the one that laughs fiendishly while torturing a pitiful oik like you",
        specpow: ["Second Sight"],
        impass: true,
        items: [Templates.elfBread],
        equipment: [Templates.rapier, Templates.paddedarm],
        ranged: Templates.longbow,
        ammo: Templates.arrow,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.ShooterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.Shooter, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.elfArcher = {
        name: 'elf archer',
        ch: 'e',
        fg: 'rgb(10,225,0)',
        speed: 130,
        sightRad: 12,
        str: 11,
        dex: 26,
        con: 12,
        inte: 13,
        wis: 10,
        cha: 20,
        hp1: 10,
        hp2: 29,
        dam2: 4,
        damtype: damages.blunt,
        challenge: 26,
        weight: 8,
        energy: 220,
        description: "Not the kind that sings gaily under the stars, but the one that happily turns you into a pincushion",
        specpow: ["Second Sight"],
        impass: true,
        items: [Templates.elfBread],
        equipment: [Templates.dagger],
        ranged: Templates.longbowElf,
        ammo: Templates.arrowElf,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.ShooterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.Shooter, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.elfMage = {
        name: 'elf mage',
        ch: 'e',
        fg: 'rgb(20,220,10)',
        speed: 100,
        sightRad: 14,
        str: 10,
        dex: 20,
        con: 11,
        inte: 22,
        wis: 10,
        cha: 20,
        hp1: 10,
        hp2: 29,
        dam2: 4,
        damtype: damages.blunt,
        challenge: 40,
        weight: 8,
        energy: 240,
        description: "Glamorous, terrific, fantastic and so on, but definitely not a nice guy.",
        specpow: ["Second Sight"],
        impass: true,
        offsp: ['Magic Missile', 'Slow Down', 'Touch of Idiocy', 'Sleep', "Ray of Light"],
        defsp: ['Mage Armour', 'Fast Foot', "Teleport", "Healing", "Invisibility"],
        items: [Templates.elfBread],
        equipment: [Templates.staffElegant, Templates.robeFireproof],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SpellcasterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.faun = {
        name: 'faun',
        ch: 'f',
        fg: 'rgb(89,200,0)',
        speed: 145,
        sightRad: 10,
        str: 16,
        dex: 20,
        con: 14,
        inte: 10,
        wis: 10,
        cha: 15,
        hp1: 19,
        hp2: 39,
        dam2: 6,
        damtype: damages.pierce,
        attbon: 2,
        defence: 4,
        challenge: 8,
        weight: 10,
        energy: 240,
        description: 'A cheerful chap, with legs, tail and horns of a goat. Mischievous but not dangerous, unless you bother him',
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'wander'
    };
    Templates.ghast = {
        name: 'ghast',
        ch: 'g',
        fg: 'rgb(200,200,200)',
        speed: 100,
        sightRad: 10,
        str: 17,
        dex: 17,
        con: 10,
        inte: 13,
        wis: 14,
        cha: 16,
        hp1: 7,
        hp2: 51,
        dam1: 1,
        dam2: 8,
        bonus: 3,
        paradur: 4,
        paracha: 15,
        damtype: damages.pierce,
        defence: 4,
        challenge: 20,
        description: 'A hungry, very dangerous undead, whose bite can paralyze you',
        specpow: ["Second Sight"],
        invuln: [damages.sleep, damages.bleed, damages.vamp],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.Paralyzer],
        type: 'aggressive'
    };
    Templates.ghost = {
        name: 'ghost',
        ch: 'g',
        fg: 'rgb(200,200,200)',
        speed: 100,
        sightRad: 15,
        str: 15,
        dex: 14,
        con: 14,
        inte: 13,
        wis: 12,
        cha: 12,
        hp1: 15,
        hp2: 35,
        dam1: 1,
        dam2: 6,
        bonus: 2,
        damtype: damages.unholy,
        defence: 4,
        vamp: 5,
        challenge: 25,
        description: 'The chilly, ethereal remains of someone, whose simple touch can drain your life away',
        resist: [damages.cut, damages.blunt, damages.pierce, damages.magic],
        invuln: [damages.pois, damages.vamp, damages.sleep, damages.confu, damages.cold, damages.paral,
            damages.petro, damages.electro, damages.acid, damages.dark, damages.bleed],
        vuln: [damages.fire, damages.holy],
        specpow: ["Second Sight"],
        invisibility: true,
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.Vampiric],
        type: 'aggressive'
    };
    Templates.ghoul = {
        name: 'ghoul',
        ch: 'g',
        fg: 'gray',
        speed: 100,
        sightRad: 9,
        str: 13,
        dex: 15,
        con: 10,
        inte: 13,
        wis: 14,
        cha: 12,
        hp1: 2,
        hp2: 24,
        dam1: 1,
        dam2: 6,
        bonus: 1,
        paradur: 4,
        paracha: 12,
        damtype: damages.pierce,
        defence: 2,
        challenge: 10,
        description: 'A hungry undead, who really likes you raw and whose bite can paralyze you',
        invuln: [damages.sleep, damages.bleed, damages.vamp],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.Paralyzer],
        type: 'aggressive'
    };
    Templates.goblin = {
        name: 'goblin',
        ch: 'g',
        fg: 'yellow',
        speed: 105,
        sightRad: 8,
        str: 11,
        dex: 13,
        con: 12,
        inte: 10,
        wis: 9,
        cha: 6,
        hp1: 2,
        hp2: 7,
        dam2: 6,
        damtype: damages.blunt,
        defence: 1,
        challenge: 2,
        weight: 4,
        description: 'Small, smelly, angry and ugly',
        impass: true,
        equipment: [Templates.club],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.goblinArcher = {
        name: 'goblin archer',
        ch: 'g',
        fg: 'rgb(170,170,13)',
        speed: 110,
        sightRad: 8,
        str: 11,
        dex: 15,
        con: 10,
        inte: 10,
        wis: 9,
        cha: 6,
        hp1: 2,
        hp2: 7,
        dam2: 6,
        damtype: damages.blunt,
        defence: 1,
        challenge: 6,
        weight: 4,
        description: 'Small, smelly, angry and ugly, armed with a bow',
        impass: true,
        equipment: [Templates.club],
        ranged: Templates.shortbow,
        ammo: Templates.arrow,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.ShooterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.Shooter, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.goblinFemale = {
        name: 'female goblin',
        ch: 'g',
        fg: 'rgb(180,220,50)',
        speed: 105,
        sightRad: 8,
        str: 10,
        dex: 14,
        con: 12,
        inte: 10,
        wis: 10,
        cha: 8,
        hp1: 2,
        hp2: 7,
        dam2: 6,
        damtype: damages.blunt,
        defence: 1,
        challenge: 2,
        weight: 4,
        description: "It's somehow female-ish looking and pretty... angry at you",
        impass: true,
        equipment: [Templates.bone],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.goblinShaman = {
        name: 'goblin shaman',
        ch: 'g',
        fg: 'rgb(230,180,50)',
        speed: 100,
        sightRad: 10,
        str: 10,
        dex: 12,
        con: 10,
        inte: 11,
        wis: 14,
        cha: 8,
        hp1: 2,
        hp2: 7,
        dam2: 6,
        damtype: damages.blunt,
        challenge: 12,
        weight: 4,
        description: 'Some kind of goblin priest, decorated with bones and feathers',
        impass: true,
        offsp: ["Minor Curse"],
        defsp: ["Minor Healing"],
        equipment: [Templates.club],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.ShamanActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.goblinVeteran = {
        name: 'goblin veteran',
        ch: 'g',
        fg: 'rgb(170,190,70)',
        speed: 110,
        sightRad: 10,
        str: 13,
        dex: 16,
        con: 13,
        inte: 12,
        wis: 10,
        cha: 8,
        hp1: 5,
        hp2: 15,
        dam2: 6,
        damtype: damages.blunt,
        defence: 1,
        challenge: 6,
        weight: 4,
        description: 'A warrior who survived plenty of battles, ready to keep its winning-streak going',
        impass: true,
        equipment: [Templates.mace],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.golem = {
        name: 'golem',
        ch: 'Ĝ',
        fg: 'rgb(130,210,0)',
        speed: 80,
        sightRad: 10,
        str: 25,
        dex: 9,
        con: 10,
        inte: 10,
        wis: 11,
        cha: 1,
        hp1: 41,
        hp2: 140,
        dam1: 2,
        dam2: 10,
        bonus: 7,
        damtype: damages.blunt,
        attack: 8,
        apr: 2,
        defence: 13,
        challenge: 35,
        description: 'A huge animated statue made of really hardened clay, its fists are like sledgehammers and its body is very. very hard',
        impass: true,
        invuln: [damages.petro, damages.electro, damages.pierce, damages.sleep, damages.confu, damages.paral,
            damages.vamp, damages.pois, damages.bleed],
        resist: [damages.cut, damages.fire, damages.cold, damages.magic],
        specpow: ["Second Sight"],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.halfOrc = {
        name: 'half orc',
        ch: 'o',
        fg: 'yellow',
        speed: 105,
        sightRad: 8,
        str: 16,
        dex: 13,
        con: 12,
        inte: 10,
        wis: 8,
        cha: 8,
        hp1: 2,
        hp2: 9,
        dam2: 6,
        damtype: damages.blunt,
        challenge: 6,
        weight: 10,
        description: 'A very ugly human, sure enough, muscular, hairy and with jutting jaws',
        impass: true,
        equipment: [Templates.nailedClub, Templates.lightshield, Templates.leatherarm],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.hobgoblin = {
        name: 'hobgoblin',
        ch: 'h',
        fg: 'rgb(170,122,0)',
        speed: 100,
        sightRad: 9,
        str: 13,
        dex: 13,
        con: 14,
        inte: 10,
        wis: 9,
        cha: 8,
        hp1: 3,
        hp2: 10,
        dam2: 6,
        damtype: damages.blunt,
        defence: 1,
        challenge: 5,
        weight: 7,
        description: 'The bigger cousin of goblin, slightly smarter and more cunning',
        impass: true,
        equipment: [Templates.sword],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.holyCow = {
        name: 'holy cow',
        ch: 'ȣ',
        fg: 'white',
        speed: 125,
        sightRad: 8,
        str: 22,
        dex: 10,
        con: 16,
        inte: 2,
        wis: 11,
        cha: 4,
        hp1: 20,
        hp2: 55,
        dam2: 8,
        bonus: 9,
        damtype: damages.pierce,
        extradamt: [damages.holy],
        defence: 3,
        challenge: 15,
        weight: 50,
        energy: 450,
        description: 'A fat, angry bovine, with a halo over its horns',
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.kobold = {
        name: 'kobold',
        ch: 'k',
        fg: 'maroon',
        speed: 100,
        sightRad: 8,
        str: 9,
        dex: 13,
        con: 10,
        inte: 10,
        hp1: 1,
        hp2: 8,
        dam2: 4,
        damtype: damages.blunt,
        defence: 2,
        challenge: 1.5,
        weight: 3,
        corpseff: 'poison',
        corpefst: 1,
        description: 'Small, dark, almost reptiloid',
        resist: [damages.pois],
        impass: true,
        equipment: [Templates.spear],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.koboldArcher = {
        name: 'kobold archer',
        ch: 'k',
        fg: 'brown',
        speed: 110,
        sightRad: 8,
        str: 9,
        dex: 13,
        con: 10,
        inte: 10,
        hp1: 1,
        hp2: 8,
        dam2: 4,
        damtype: damages.blunt,
        defence: 2,
        challenge: 4,
        weight: 3,
        corpseff: 'poison',
        corpefst: 1,
        description: 'Small, dark, almost reptiloid, armed with a bow',
        resist: [damages.pois],
        impass: true,
        equipment: [Templates.dagger],
        ranged: Templates.shortbow,
        ammo: Templates.arrow,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.ShooterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.Shooter, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.lacedon = {
        name: 'lacedon',
        ch: 'l',
        fg: 'gray',
        speed: 100,
        sightRad: 9,
        str: 13,
        dex: 15,
        con: 10,
        inte: 13,
        wis: 14,
        cha: 12,
        hp1: 2,
        hp2: 24,
        dam1: 1,
        dam2: 6,
        bonus: 1,
        paradur: 4,
        paracha: 12,
        damtype: damages.pierce,
        defence: 2,
        challenge: 10,
        description: 'The aquatic version of a ghoul, it can paralyze you with its bite',
        invuln: [damages.sleep, damages.bleed, damages.vamp],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.Paralyzer],
        type: 'aggressive'
    };
    Templates.mage = {
        name: 'mage',
        ch: 'm',
        fg: 'red',
        speed: 90,
        sightRad: 7,
        str: 11,
        dex: 16,
        con: 9,
        inte: 18,
        wis: 15,
        cha: 12,
        hp1: 6,
        hp2: 13,
        dam2: 4,
        damtype: damages.blunt,
        challenge: 8,
        weight: 10,
        description: 'A cocky young wizard in training, who wants to test what has learned so far',
        impass: true,
        offsp: ['Magic Missile', 'Ray of Frost'],
        defsp: ['Mage Armour'],
        equipment: [Templates.staff, Templates.robe, Templates.pointyHat, Templates.pointyShoes],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SpellcasterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.mageSenior = {
        name: 'senior mage',
        ch: 'm',
        fg: 'rgb(230,0,44)',
        speed: 100,
        sightRad: 9,
        str: 10,
        dex: 14,
        con: 9,
        inte: 25,
        wis: 18,
        cha: 14,
        hp1: 12,
        hp2: 26,
        dam2: 6,
        damtype: damages.blunt,
        challenge: 23,
        weight: 12,
        description: 'A professional wizard with a 2-feet tall hat, ready to prod some serious buttocks',
        specpow: ["Second Sight"],
        impass: true,
        offsp: ['Magic Missile', 'Ray of Frost', "Minor Bolt", "Ray of Light"],
        defsp: ['Mage Armour', "Teleport", 'Fast Foot'],
        equipment: [Templates.staffElegant, Templates.robeOrnated, Templates.pointyHatBig, Templates.pointyShoes],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SpellcasterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.mageGreat = {
        name: 'great mage',
        ch: 'm',
        fg: 'rgb(200,120,144)',
        speed: 120,
        sightRad: 12,
        str: 8,
        dex: 15,
        con: 9,
        inte: 30,
        wis: 22,
        cha: 16,
        hp1: 20,
        hp2: 36,
        dam1: 2,
        dam2: 10,
        damtype: damages.magic,
        challenge: 42,
        weight: 15,
        description: 'A very expert and fat wizard, covered in defensive spells and ready to wreak havoc everywhere',
        specpow: ["Second Sight"],
        impass: true,
        offsp: ["Magic Missile", "Lightning Bolt", "Fireball", "Ray of Light"],
        defsp: ['Mage Armour', "Teleport", "Healing", "Invisibility"],
        equipment: [Templates.staffMagical, Templates.robeFireproof, Templates.pointyHatBig, Templates.pointyShoes],
        invuln: [damages.fire],
        resist: [damages.magic, damages.acid, damages.light, damages.electro, damages.cold],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SpellcasterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.mantis = {
        name: 'giant mantis',
        ch: 'Ϫ',
        fg: 'green',
        speed: 130,
        sightRad: 10,
        str: 19,
        dex: 8,
        con: 15,
        inte: 2,
        wis: 14,
        cha: 11,
        hp1: 12,
        hp2: 40,
        dam1: 1,
        dam2: 8,
        bonus: 8,
        damtype: damages.cut,
        defence: 5,
        attbon: 4,
        challenge: 20,
        weight: 10,
        energy: 225,
        description: "As big as an adult man, it will try to grab you and bite your head off. Even if you don't want to mate.",
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.merfolk = {
        name: 'merfolk',
        ch: 'm',
        fg: 'rgb(0,0,175)',
        speed: 95,
        sightRad: 10,
        str: 13,
        dex: 13,
        con: 14,
        inte: 10,
        wis: 9,
        cha: 10,
        hp1: 3,
        hp2: 10,
        dam2: 6,
        bonus: 2,
        defence: 2,
        damtype: damages.blunt,
        challenge: 6,
        weight: 12,
        energy: 250,
        description: "A strange half-human, half-fish hybrid, who doesn't like intruders very much",
        impass: true,
        equipment: [Templates.trident],
        ranged: [Templates.crossbow],
        ammo: [Templates.bolt],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.ShooterActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.Equipper,
            Mixins.InventoryHolder, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.mummy = {
        name: 'mummy',
        ch: 'm',
        fg: 'rgb(110,110,110)',
        speed: 80,
        sightRad: 10,
        str: 24,
        dex: 10,
        con: 10,
        inte: 6,
        wis: 14,
        cha: 15,
        hp1: 11,
        hp2: 99,
        dam1: 1,
        dam2: 6,
        bonus: 10,
        damtype: damages.blunt,
        defence: 10,
        challenge: 20,
        description: "Embalmed and wrapped in old bandages, a walking attempt to preserve a corpse from rotting",
        resist: [damages.cold],
        invuln: [damages.pois, damages.vamp, damages.sleep, damages.confu, damages.bleed],
        vuln: [damages.fire],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.nagaDark = {
        name: 'dark naga',
        ch: 's',
        fg: 'darkgray',
        speed: 90,
        sightRad: 10,
        str: 14,
        dex: 15,
        con: 14,
        inte: 16,
        wis: 15,
        cha: 17,
        hp1: 19,
        hp2: 82,
        dam1: 2,
        dam2: 4,
        bonus: 2,
        damtype: damages.pierce,
        attbon: 2,
        defence: 2,
        poisdam: 3,
        poisdur: 40,
        poisstr: 17,
        poischa: 12,
        challenge: 40,
        weight: 14,
        energy: 250,
        description: 'A very long snake with a human face, poisonous and able to cast unpleasant spells. Not nice.',
        impass: true,
        invuln: [damages.sleep, damages.pois],
        resist: [damages.acid, damages.confu, damages.paral],
        offsp: ["Magic Missile", "Ray of Frost", "Minor Bolt"],
        defsp: ["Invisibility", "Mage Armour"],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SpellcasterActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.Poisonous, Mixins.Spellcaster, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.nagaWater = {
        name: 'water naga',
        ch: 's',
        fg: 'cyan',
        speed: 90,
        sightRad: 8,
        str: 16,
        dex: 13,
        con: 18,
        inte: 10,
        wis: 17,
        cha: 15,
        hp1: 35,
        hp2: 84,
        dam1: 2,
        dam2: 6,
        bonus: 4,
        damtype: damages.pierce,
        attbon: 2,
        defence: 4,
        poisdam: 3,
        poisdur: 40,
        poisstr: 17,
        poischa: 12,
        challenge: 36,
        weight: 14,
        energy: 250,
        description: 'A very long snake with a human face, poisonous and able to use magic. Not nice.',
        impass: true,
        invuln: [damages.sleep],
        resist: [damages.acid, damages.confu],
        offsp: ["Magic Missile", "Acid Arrow"],
        defsp: ["Invisibility", "Mage Armour"],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SpellcasterActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.Poisonous, Mixins.Spellcaster, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.octopoid = {
        name: 'octopoid',
        ch: 'ѫ',
        fg: 'rgb(175,175,175)',
        speed: 100,
        sightRad: 10,
        str: 19,
        dex: 15,
        con: 12,
        inte: 10,
        wis: 7,
        cha: 4,
        hp1: 20,
        hp2: 35,
        dam2: 6,
        bonus: 2,
        damtype: damages.blunt,
        challenge: 12,
        weight: 15,
        energy: 250,
        description: 'More or less anthropomorfic (for a given value of anthropomorfic), but with many strong tentacles',
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.octopoidWarrior = {
        name: 'octopoid warrior',
        ch: 'ѭ',
        fg: 'rgb(125,125,125)',
        speed: 100,
        sightRad: 10,
        str: 21,
        dex: 16,
        con: 16,
        inte: 6,
        wis: 6,
        cha: 4,
        hp1: 30,
        hp2: 55,
        dam2: 8,
        bonus: 2,
        damtype: damages.blunt,
        challenge: 18,
        weight: 16,
        energy: 250,
        description: 'A strange mixture of human and octopus, very strong and quite angry',
        impass: true,
        equipment: [Templates.spear],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.CorpseDropper, Mixins.Equipper],
        type: 'aggressive'
    };
    Templates.ogre = {
        name: 'ogre',
        ch: 'O',
        fg: 'yellow',
        speed: 120,
        sightRad: 8,
        str: 21,
        dex: 8,
        con: 15,
        inte: 6,
        wis: 10,
        cha: 7,
        hp1: 15,
        hp2: 43,
        dam2: 8,
        damtype: damages.blunt,
        defence: 5,
        challenge: 13,
        weight: 24,
        energy: 240,
        description: 'A very big orc or a small giant? Something nasty, for sure',
        impass: true,
        equipment: [Templates.greatclub, Templates.studdedarm],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.ogreMage = {
        name: 'ogre mage',
        ch: 'O',
        fg: 'rgb(200,0,0)',
        speed: 120,
        sightRad: 10,
        str: 21,
        dex: 10,
        con: 17,
        inte: 17,
        wis: 14,
        cha: 14,
        hp1: 15,
        hp2: 43,
        dam2: 8,
        damtype: damages.blunt,
        defence: 5,
        challenge: 20,
        weight: 25,
        energy: 240,
        description: 'A very big orc or a small giant? Something nasty, and it can even cast spell',
        specpow: ["Second Sight"],
        impass: true,
        offsp: ['Magic Missile', 'Ray of Frost', 'Slow Down', "Sleep"],
        defsp: ['Mage Armour', 'Fast Foot', "Minor Healing", "Invisibility"],
        equipment: [Templates.greatsword],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SpellcasterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.ogreShaman = {
        name: 'ogre shaman',
        ch: 'O',
        fg: 'rgb(200,0,10)',
        speed: 120,
        sightRad: 10,
        str: 21,
        dex: 10,
        con: 17,
        inte: 14,
        wis: 17,
        cha: 14,
        hp1: 15,
        hp2: 43,
        dam2: 8,
        damtype: damages.blunt,
        defence: 5,
        challenge: 18,
        weight: 25,
        energy: 240,
        description: 'A very big orc or a small giant? Something nasty for sure, here in its priestly version',
        specpow: ["Second Sight"],
        impass: true,
        offsp: ["Minor Curse", "Curse"],
        defsp: ["Minor Healing", "Healing"],
        equipment: [Templates.greatsword],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.ShamanActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.orc = {
        name: 'orc',
        ch: 'o',
        fg: 'green',
        speed: 100,
        sightRad: 6,
        str: 17,
        dex: 11,
        con: 12,
        inte: 8,
        wis: 7,
        cha: 6,
        hp1: 2,
        hp2: 9,
        dam2: 6,
        damtype: damages.blunt,
        challenge: 4,
        weight: 10,
        description: 'Your standard bad guy, really',
        impass: true,
        equipment: [Templates.nailedClub, Templates.lightshield],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.orcArcher = {
        name: 'orc archer',
        ch: 'o',
        fg: 'rgb(5,230,0)',
        speed: 110,
        sightRad: 7,
        str: 17,
        dex: 11,
        con: 12,
        inte: 8,
        wis: 7,
        cha: 6,
        hp1: 2,
        hp2: 9,
        dam2: 6,
        damtype: damages.blunt,
        challenge: 6,
        weight: 10,
        description: 'Your standard bad guy, now armed with a bow',
        impass: true,
        equipment: [Templates.nailedClub, Templates.leatherarm],
        ranged: Templates.shortbow,
        ammo: Templates.arrow,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.ShooterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.Shooter, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.orcElite = {
        name: 'orc',
        ch: 'o',
        fg: 'rgb(0,125,0)',
        speed: 120,
        sightRad: 10,
        str: 20,
        dex: 12,
        con: 14,
        inte: 9,
        wis: 7,
        cha: 6,
        hp1: 10,
        hp2: 26,
        dam2: 6,
        damtype: damages.blunt,
        challenge: 8,
        weight: 10,
        description: "Stronger than average and scarred, it's a veteran of many battles, ready to survive against you, too",
        impass: true,
        equipment: [Templates.katana, Templates.lightshield, Templates.studdedarm],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.orcFemale = {
        name: 'female orc',
        ch: 'o',
        fg: 'rgb(30,200,80)',
        speed: 100,
        sightRad: 6,
        str: 16,
        dex: 12,
        con: 11,
        inte: 8,
        wis: 7,
        cha: 7,
        hp1: 2,
        hp2: 9,
        dam2: 6,
        damtype: damages.blunt,
        challenge: 4,
        weight: 10,
        description: 'Your standard bad guy, now of a female-ish persuasion',
        impass: true,
        equipment: [Templates.nailedClub, Templates.lightshield],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.orcShaman = {
        name: 'orc shaman',
        ch: 'o',
        fg: 'rgb(0,220,0)',
        speed: 100,
        sightRad: 10,
        str: 14,
        dex: 11,
        con: 12,
        inte: 13,
        wis: 15,
        cha: 10,
        hp1: 2,
        hp2: 9,
        dam2: 6,
        damtype: damages.blunt,
        challenge: 9,
        weight: 10,
        description: 'Some kind of orc priest, ornated with bones and feathers',
        impass: true,
        offsp: ["Minor Curse"],
        defsp: ["Minor Healing"],
        equipment: [Templates.dagger],
        items: [Templates.boozePotion],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.ShamanActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.paladin = {
        name: 'paladin',
        ch: 'p',
        fg: 'rgb(255,200,30)',
        speed: 110,
        sightRad: 10,
        str: 20,
        dex: 17,
        con: 20,
        inte: 8,
        wis: 18,
        cha: 25,
        hp1: 30,
        hp2: 45,
        dam2: 6,
        damtype: damages.blunt,
        challenge: 25,
        weight: 10,
        description: "A smiling bigot in a shiny armour, out to fight whatever he thinks as evil. People like you, for a start.",
        impass: true,
        invuln: [damages.holy],
        resist: [damages.unholy, damages.petro, damages.sleep, damages.paral, damages.confu],
        offsp: ["Minor Curse", "Curse", "God Beam"],
        defsp: ["Minor Healing", "Healing", "Blessing"],
        items: [Templates.ironRation],
        equipment: [Templates.bastardsword, Templates.fullplate, Templates.helmInsomnia, Templates.heavyshield, Templates.ironboot],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.ShamanActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.paladinDark = {
        name: 'dark paladin',
        ch: 'p',
        fg: 'rgb(35,35,35)',
        speed: 110,
        sightRad: 10,
        str: 20,
        dex: 17,
        con: 20,
        inte: 8,
        wis: 18,
        cha: 25,
        hp1: 30,
        hp2: 45,
        dam2: 6,
        damtype: damages.blunt,
        challenge: 25,
        weight: 10,
        description: "A frowning bigot in a gloomy armour, out to fight whatever he thinks as good. Even people like you, yes.",
        impass: true,
        invuln: [damages.unholy],
        resist: [damages.holy, damages.petro, damages.sleep, damages.paral, damages.confu],
        offsp: ["Minor Curse", "Curse", "Evil Beam"],
        defsp: ["Minor Healing", "Healing", "Blessing"],
        items: [Templates.ironRation],
        equipment: [Templates.swordvamp, Templates.fullplate, Templates.helmInsomnia, Templates.heavyshield, Templates.ironboot],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.ShamanActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.priest = {
        name: 'priest',
        ch: 'p',
        fg: 'rgb(255,255,255)',
        speed: 100,
        sightRad: 10,
        str: 12,
        dex: 14,
        con: 20,
        inte: 13,
        wis: 26,
        cha: 14,
        hp1: 20,
        hp2: 33,
        dam2: 6,
        damtype: damages.blunt,
        challenge: 20,
        weight: 12,
        description: "A fatass in a white robe, he really likes little kids. And money.",
        impass: true,
        resist: [damages.unholy, damages.petro, damages.sleep, damages.paral, damages.confu],
        offsp: ["Minor Curse", "Curse", "God Beam"],
        defsp: ["Minor Healing", "Healing"],
        equipment: [Templates.staff, Templates.robeOrnated, Templates.holinessAmulet],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.ShamanActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.pseudodragon = {
        name: 'pseudodragon',
        ch: 'd',
        fg: 'yellow',
        speed: 100,
        sightRad: 15,
        str: 6,
        dex: 15,
        con: 13,
        inte: 10,
        wis: 12,
        cha: 10,
        hp1: 4,
        hp2: 26,
        dam2: 2,
        damtype: damages.pierce,
        defence: 6,
        poisdam: 2,
        poisdur: 100,
        poisstr: 18,
        poischa: 14,
        challenge: 4,
        corpseff: 'poison',
        corpefst: 2,
        description: 'A tiny dragon, almost pocket-sized, but with a nasty poisonous tail',
        impass: true,
        invuln: [damages.sleep, damages.paral],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.Poisonous, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.rat = {
        name: 'rat',
        ch: 'r',
        fg: 'grey',
        speed: 120,
        sightRad: 8,
        str: 2,
        dex: 15,
        con: 10,
        inte: 2,
        wis: 12,
        cha: 2,
        maxhp: 2,
        dam2: 2,
        damtype: damages.pierce,
        defence: 2,
        energy: 160,
        description: 'A fat, disgusting and most likely germy rodent',
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.ratGiant = {
        name: 'giant rat',
        ch: 'r',
        fg: 'brown',
        speed: 120,
        sightRad: 10,
        str: 5,
        dex: 18,
        con: 13,
        inte: 4,
        wis: 12,
        cha: 2,
        hp1: 2,
        hp2: 6,
        dam2: 3,
        damtype: damages.pierce,
        challenge: 2.5,
        defence: 2,
        weight: 2,
        energy: 180,
        description: 'Bigger than a cat, it looks at you with hungry little eyes',
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.ratKing = {
        name: 'rat king',
        ch: 'R',
        fg: 'rgb(140,140,140)',
        speed: 100,
        sightRad: 10,
        str: 8,
        dex: 14,
        con: 18,
        inte: 18,
        wis: 8,
        cha: 2,
        hp1: 8,
        hp2: 20,
        dam2: 6,
        damtype: damages.pierce,
        challenge: 10,
        defence: 3,
        weight: 8,
        description: "A bunch of rats with their tails tied together, it might have special powers according to folklore",
        resist: [damages.sleep, damages.petro, damages.paral, damages.dark],
        vuln: [damages.light],
        impass: true,
        summonable: ['rat', 'ratGiant'],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SummonerActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.CorpseDropper, Mixins.Summoner],
        type: 'aggressive'
    };
    Templates.rustmonster = {
        name: 'rust monster',
        ch: 'r',
        fg: 'orange',
        speed: 80,
        sightRad: 8,
        str: 10,
        dex: 17,
        con: 13,
        inte: 2,
        wis: 13,
        cha: 8,
        hp1: 10,
        hp2: 45,
        dam2: 3,
        damtype: damages.pierce,
        touchdam: damages.rust,
        defence: 5,
        challenge: 30,
        weight: 10,
        energy: 100,
        description: "It vaguely looks like a lobster, but the real trouble are its antennae: everything they touch will rust in a moment.",
        impass: true,
        invuln: [damages.bleed, damages.sleep],
        resist: [damages.confu],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.CorpseDropper, Mixins.HurtingSkin],
        type: 'aggressive'
    };
    Templates.satyr = {
        name: 'satyr',
        ch: 's',
        fg: 'pink',
        speed: 140,
        sightRad: 10,
        str: 10,
        dex: 13,
        con: 12,
        inte: 12,
        wis: 13,
        cha: 13,
        hp1: 14,
        hp2: 35,
        dam2: 6,
        damtype: damages.blunt,
        attbon: 2,
        defence: 4,
        challenge: 6,
        weight: 8,
        description: 'Short and stout, with a big beard, equine ears, equine tail and equine... something else. Beware his flute',
        specpow: ["Second Sight"],
        impass: true,
        equipment: [Templates.nailedClub],
        items: [Templates.boozePotion],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'wander'
    };
    Templates.skeleton = {
        name: 'skeleton',
        ch: 'h',
        fg: 'white',
        speed: 100,
        sightRad: 8,
        str: 13,
        dex: 17,
        con: 10,
        inte: 0,
        wis: 10,
        cha: 1,
        hp1: 3,
        hp2: 12,
        dam1: 1,
        dam2: 8,
        bonus: 1,
        damtype: damages.blunt,
        defence: 2,
        challenge: 4,
        description: 'A jolly example of walking human anatomy',
        invuln: [damages.pois, damages.vamp, damages.sleep, damages.confu, damages.cold, damages.bleed],
        resist: [damages.pierce],
        vuln: [damages.blunt],
        specpow: ["Second Sight"],
        impass: true,
        equipment: [Templates.scimitar, Templates.lightshield],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper],
        type: 'aggressive'
    };
    Templates.skeletonGoblin = {
        name: 'skeleton goblin',
        ch: 'g',
        fg: 'white',
        speed: 110,
        sightRad: 8,
        str: 11,
        dex: 15,
        con: 10,
        inte: 0,
        wis: 10,
        cha: 1,
        hp1: 2,
        hp2: 7,
        dam2: 6,
        damtype: damages.blunt,
        defence: 2,
        challenge: 3,
        description: 'A jolly example of walking goblin anatomy',
        invuln: [damages.pois, damages.vamp, damages.sleep, damages.confu, damages.cold, damages.bleed],
        resist: [damages.pierce],
        vuln: [damages.blunt],
        specpow: ["Second Sight"],
        impass: true,
        equipment: [Templates.dagger],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper],
        type: 'aggressive'
    };
    Templates.skeletonKobold = {
        name: 'skeleton kobold',
        ch: 'k',
        fg: 'white',
        speed: 100,
        sightRad: 8,
        str: 10,
        dex: 15,
        con: 10,
        inte: 0,
        wis: 10,
        cha: 1,
        hp1: 2,
        hp2: 8,
        dam2: 4,
        damtype: damages.blunt,
        defence: 2,
        challenge: 4,
        description: 'A jolly example of walking kobold anatomy',
        invuln: [damages.pois, damages.vamp, damages.sleep, damages.confu, damages.cold, damages.bleed],
        resist: [damages.pierce],
        vuln: [damages.blunt],
        specpow: ["Second Sight"],
        impass: true,
        equipment: [Templates.spear],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper],
        type: 'aggressive'
    };
    Templates.skeletonOrc = {
        name: 'skeleton orc',
        ch: 'o',
        fg: 'white',
        speed: 100,
        sightRad: 8,
        str: 17,
        dex: 13,
        con: 10,
        inte: 0,
        wis: 10,
        cha: 1,
        hp1: 2,
        hp2: 9,
        dam2: 6,
        damtype: damages.blunt,
        defence: 2,
        challenge: 4,
        description: 'A jolly example of walking orcish anatomy',
        invuln: [damages.pois, damages.vamp, damages.sleep, damages.confu, damages.cold, damages.bleed],
        resist: [damages.pierce],
        vuln: [damages.blunt],
        specpow: ["Second Sight"],
        impass: true,
        equipment: [Templates.scimitar, Templates.lightshield],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper],
        type: 'aggressive'
    };
    Templates.skeletonWolf = {
        name: 'skeleton wolf',
        ch: 'w',
        fg: 'white',
        speed: 200,
        sightRad: 10,
        str: 21,
        dex: 14,
        con: 10,
        inte: 0,
        wis: 10,
        cha: 1,
        hp1: 2,
        hp2: 24,
        dam1: 1,
        dam2: 6,
        bonus: 1,
        damtype: damages.pierce,
        attbon: 1,
        defence: 2,
        challenge: 4,
        description: 'A jolly example of walking canine anatomy',
        invuln: [damages.pois, damages.vamp, damages.sleep, damages.confu, damages.cold, damages.bleed],
        resist: [damages.pierce],
        vuln: [damages.blunt],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper],
        type: 'aggressive'
    };
    Templates.snake = {
        name: 'snake',
        ch: 's',
        fg: 'green',
        speed: 90,
        sightRad: 5,
        str: 6,
        dex: 17,
        con: 11,
        inte: 1,
        hp1: 1,
        hp2: 8,
        dam2: 2,
        damtype: damages.pierce,
        defence: 4,
        poisdam: 1,
        poisdur: 50,
        poisstr: 15,
        poischa: 11,
        challenge: 3,
        energy: 180,
        description: 'A poisonous snake, minding its own reptilian business',
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.BaseActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.Poisonous, Mixins.CorpseDropper],
        type: 'wander'
    };
    Templates.spiderGiant = {
        name: 'giant spider',
        ch: 'Ӿ',
        fg: 'rgb(30,30,30)',
        speed: 100,
        sightRad: 10,
        str: 15,
        dex: 17,
        con: 12,
        inte: 2,
        wis: 10,
        cha: 2,
        hp1: 8,
        hp2: 36,
        dam1: 1,
        dam2: 8,
        bonus: 3,
        damtype: damages.pierce,
        attbon: 3,
        defence: 1,
        poisdam: 2,
        poisdur: 40,
        poisstr: 17,
        poischa: 13,
        challenge: 30,
        weight: 10,
        corpseff: 'poison',
        corpefst: 2,
        description: "Do you like spiders? This one does like you... for dinner.",
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.Poisonous,
            Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.stagbeetle = {
        name: 'giant stag beetle',
        ch: 'ŏ',
        fg: 'gray',
        speed: 100,
        sightRad: 10,
        str: 23,
        dex: 10,
        con: 17,
        inte: 2,
        wis: 10,
        cha: 9,
        hp1: 28,
        hp2: 77,
        dam1: 4,
        dam2: 6,
        bonus: 9,
        damtype: damages.pierce,
        defence: 9,
        attbon: 2,
        challenge: 30,
        weight: 25,
        description: "An enormous beetle that can eat a whole field of crop in a very short time. Quite dangerous.",
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.tojanida = {
        name: 'tojanida',
        ch: 't',
        fg: 'rgb(0,140,240)',
        speed: 100,
        sightRad: 10,
        str: 16,
        dex: 13,
        con: 15,
        inte: 10,
        wis: 12,
        cha: 9,
        hp1: 21,
        hp2: 70,
        dam1: 2,
        dam2: 8,
        bonus: 3,
        damtype: damages.pierce,
        challenge: 40,
        apr: 2,
        attbon: 2,
        defence: 12,
        weight: 13,
        energy: 220,
        description: "It looks like a very big shell, with four leg-like limbs and two claws. And a bad character.",
        invuln: [damages.acid, damages.cold],
        resist: [damages.electro, damages.fire],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.tojanidaElder = {
        name: 'elder tojanida',
        ch: 't',
        fg: 'rgb(0,0,255)',
        speed: 100,
        sightRad: 10,
        str: 22,
        dex: 13,
        con: 19,
        inte: 10,
        wis: 12,
        cha: 9,
        hp1: 75,
        hp2: 180,
        dam1: 4,
        dam2: 6,
        bonus: 6,
        damtype: damages.pierce,
        challenge: 60,
        apr: 2,
        attbon: 5,
        defence: 13,
        weight: 30,
        energy: 250,
        description: "It looks like an enormous shell, with four leg-like limbs and two claws. And a bad character.",
        invuln: [damages.acid, damages.cold],
        resist: [damages.electro, damages.fire],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.tojanidaYoung = {
        name: 'young tojanida',
        ch: 't',
        fg: 'rgb(0,100,200)',
        speed: 100,
        sightRad: 10,
        str: 14,
        dex: 13,
        con: 15,
        inte: 10,
        wis: 12,
        cha: 9,
        hp1: 9,
        hp2: 30,
        dam1: 2,
        dam2: 6,
        bonus: 2,
        damtype: damages.pierce,
        challenge: 20,
        apr: 2,
        defence: 11,
        weight: 5,
        energy: 220,
        description: "It looks like a big shell, with four leg-like limbs and two claws. And a bad character.",
        invuln: [damages.acid, damages.cold],
        resist: [damages.electro, damages.fire],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.triton = {
        name: 'triton',
        ch: 't',
        fg: 'rgb(0,0,210)',
        speed: 110,
        sightRad: 8,
        str: 12,
        dex: 10,
        con: 12,
        inte: 13,
        wis: 13,
        cha: 11,
        hp1: 6,
        hp2: 27,
        dam2: 6,
        damtype: damages.blunt,
        attbon: 2,
        defence: 6,
        challenge: 6,
        weight: 10,
        energy: 230,
        description: 'Half man, half fish, fully angry with you, you filthy polluter of the sea',
        impass: true,
        equipment: [Templates.trident],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.troglodyte = {
        name: 'troglodyte',
        ch: 't',
        fg: 'rgb(0,180,40)',
        speed: 100,
        sightRad: 7,
        str: 10,
        dex: 6,
        con: 14,
        inte: 8,
        wis: 10,
        cha: 10,
        hp1: 6,
        hp2: 20,
        dam1: 1,
        dam2: 4,
        apr: 2,
        damtype: damages.pierce,
        defence: 6,
        challenge: 7.5,
        weight: 8,
        energy: 180,
        description: 'A short, reptilian humanoid, not exactly clean and not exactly used to diplomacy',
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.InventoryHolder, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.troll = {
        name: 'troll',
        ch: 't',
        fg: 'rgb(100,230,140)',
        speed: 80,
        sightRad: 7,
        str: 23,
        dex: 14,
        con: 23,
        inte: 6,
        wis: 9,
        cha: 6,
        hp1: 42,
        hp2: 84,
        dam1: 1,
        dam2: 6,
        bonus: 6,
        damtype: damages.blunt,
        defence: 4,
        challenge: 10,
        weight: 30,
        energy: 90,
        description: 'A huge, strong, ugly thing, ready to punch you to the next week',
        invuln: [damages.bleed],
        resist: [damages.pois, damages.petro],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.unicorn = {
        name: 'unicorn',
        ch: 'u',
        fg: 'white',
        speed: 250,
        sightRad: 10,
        str: 20,
        dex: 17,
        con: 21,
        inte: 10,
        wis: 21,
        cha: 24,
        hp1: 24,
        hp2: 60,
        dam1: 1,
        dam2: 8,
        bonus: 8,
        apr: 2,
        damtype: damages.pierce,
        defence: 5,
        challenge: 20,
        weight: 40,
        energy: 420,
        description: 'A big, horned horse, definitely not happy to see you walking in its woods',
        invuln: [damages.sleep, damages.petro],
        resist: [damages.paral, damages.confu, damages.magic],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.vampire = {
        name: 'young vampire',
        ch: 'v',
        fg: 'red',
        speed: 120,
        sightRad: 10,
        str: 18,
        dex: 14,
        con: 14,
        inte: 15,
        wis: 16,
        cha: 18,
        hp1: 20,
        hp2: 34,
        dam2: 6,
        defence: 6,
        vamp: 4,
        damtype: damages.pierce,
        challenge: 17,
        description: 'A hungry but still unexperienced undead, dressed like a toff',
        resist: [damages.petro],
        vuln: [damages.light, damages.fire],
        invuln: [damages.pois, damages.cold, damages.vamp, damages.sleep, damages.confu, damages.bleed],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Vampiric],
        type: 'aggressive'
    };
    Templates.vampireAdult = {
        name: 'adult vampire',
        ch: 'v',
        fg: 'blue',
        speed: 150,
        sightRad: 12,
        str: 20,
        dex: 16,
        con: 15,
        inte: 18,
        wis: 18,
        cha: 20,
        hp1: 40,
        hp2: 64,
        dam2: 8,
        defence: 6,
        vamp: 8,
        damtype: damages.pierce,
        challenge: 15,
        description: 'A hungry, experienced undead, dressed like a toff',
        resist: [damages.petro],
        vuln: [damages.light, damages.fire],
        invuln: [damages.pois, damages.cold, damages.vamp, damages.sleep, damages.confu, damages.paral, damages.bleed],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Vampiric],
        type: 'aggressive'
    };
    Templates.vampireElder = {
        name: 'elder vampire',
        ch: 'v',
        fg: 'gray',
        speed: 200,
        sightRad: 15,
        str: 25,
        dex: 22,
        con: 20,
        inte: 24,
        wis: 24,
        cha: 25,
        hp1: 70,
        hp2: 90,
        dam2: 10,
        defence: 6,
        vamp: 10,
        damtype: damages.pierce,
        challenge: 25,
        description: 'A hungry, very experienced undead, dressed like an old fashioned toff',
        vuln: [damages.light, damages.fire],
        invuln: [damages.pois, damages.cold, damages.vamp, damages.sleep, damages.confu, damages.paral, damages.petro, damages.bleed],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Vampiric],
        type: 'aggressive'
    };
    Templates.warrior = {
        name: 'warrior',
        ch: 'w',
        fg: 'rgb(130,30,0)',
        speed: 100,
        sightRad: 7,
        str: 17,
        dex: 15,
        con: 16,
        inte: 10,
        wis: 9,
        cha: 10,
        hp1: 15,
        hp2: 30,
        dam2: 6,
        damtype: damages.blunt,
        challenge: 8,
        weight: 10,
        description: "A freelance hack-n-slasher, who want to test his weapon on someone.",
        impass: true,
        equipment: [Templates.sword, Templates.studdedarm, Templates.leatherboot],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.wasp = {
        name: 'giant wasp',
        ch: 'w',
        fg: 'yellow',
        speed: 140,
        sightRad: 10,
        str: 18,
        dex: 12,
        con: 14,
        inte: 1,
        wis: 13,
        cha: 11,
        hp1: 15,
        hp2: 50,
        dam2: 3,
        bonus: 6,
        damtype: damages.pierce,
        defence: 2,
        poisdam: 2,
        poisdur: 30,
        poisstr: 14,
        poischa: 12,
        challenge: 14,
        weight: 2,
        energy: 160,
        description: 'A wasp, bigger than a dog and VERY angry',
        invuln: [damages.confu, damages.bleed, damages.sleep],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.Poisonous, Mixins.CorpseDropper],
        type: 'aggressive'
    };
    Templates.willow = {
        name: 'willow',
        ch: 'w',
        fg: 'rgb(50,160,40)',
        sightRad: 10,
        str: 13,
        dex: 18,
        con: 13,
        inte: 1,
        wis: 10,
        cha: 4,
        hp1: 6,
        hp2: 12,
        dam1: 1,
        dam2: 4,
        damtype: damages.blunt,
        defence: 1,
        challenge: 7,
        description: 'An eldritch willow-like bush, whose branches keep moving and feeling around',
        invuln: [damages.sleep, damages.confu, damages.paral, damages.pois, damages.bleed],
        resist: [damages.pierce],
        vuln: [damages.fire],
        impass: true,
        mixins: [Mixins.Living, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.wolf = {
        name: 'wolf',
        ch: 'w',
        fg: 'gray',
        speed: 200,
        sightRad: 10,
        str: 13,
        dex: 15,
        con: 15,
        inte: 2,
        wis: 12,
        cha: 6,
        hp1: 6,
        hp2: 20,
        dam1: 1,
        dam2: 6,
        bonus: 1,
        damtype: damages.pierce,
        defence: 2,
        challenge: 6,
        weight: 5,
        description: 'Looks like a big dog; not dangerous unless you bother it.',
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.BaseActor, Mixins.Sight, Mixins.BaseAttacker,
            Mixins.CorpseDropper],
        type: 'wander'
    };
    Templates.wraith = {
        name: 'wraith',
        ch: 'w',
        fg: 'rgb(100,100,100)',
        speed: 110,
        sightRad: 15,
        str: 15,
        dex: 16,
        con: 14,
        inte: 14,
        wis: 14,
        cha: 15,
        hp1: 5,
        hp2: 60,
        dam2: 6,
        damtype: damages.unholy,
        attbon: 2,
        defence: 2,
        vamp: 6,
        challenge: 30,
        description: 'A spirit of sheer malevolence, extremely hard to touch by any non magical mean.',
        invuln: [damages.pois, damages.vamp, damages.sleep, damages.confu, damages.cold, damages.paral,
            damages.petro, damages.electro, damages.acid, damages.dark, damages.bleed, damages.cut, damages.blunt,
            damages.pierce, damages.unholy],
        vuln: [damages.fire, damages.holy],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker, Mixins.Vampiric],
        type: 'aggressive'
    };
    Templates.zombie = {
        name: 'human zombie',
        ch: 'h',
        fg: 'gray',
        speed: 60,
        sightRad: 5,
        str: 12,
        dex: 8,
        con: 10,
        inte: 0,
        wis: 10,
        cha: 1,
        hp1: 5,
        hp2: 25,
        dam1: 1,
        dam2: 6,
        bonus: 1,
        damtype: damages.blunt,
        defence: 2,
        challenge: 5,
        description: 'A rotting human corpse, still walking and bothering people',
        resist: [damages.cold, damages.paral],
        invuln: [damages.pois, damages.vamp, damages.sleep, damages.confu, damages.bleed],
        vuln: [damages.fire],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.zombieKobold = {
        name: 'kobold zombie',
        ch: 'k',
        fg: 'gray',
        speed: 60,
        sightRad: 6,
        str: 8,
        dex: 11,
        con: 10,
        inte: 0,
        wis: 10,
        cha: 1,
        hp1: 5,
        hp2: 25,
        dam1: 1,
        dam2: 4,
        damtype: damages.blunt,
        defence: 2,
        challenge: 3,
        description: 'A rotting kobold corpse, still walking and bothering people. It could be related to COBOL...',
        resist: [damages.cold, damages.paral],
        invuln: [damages.pois, damages.vamp, damages.sleep, damages.confu, damages.bleed],
        vuln: [damages.fire],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    Templates.zombieOgre = {
        name: 'ogre zombie',
        ch: 'O',
        fg: 'gray',
        speed: 60,
        sightRad: 5,
        str: 23,
        dex: 6,
        con: 10,
        inte: 0,
        wis: 10,
        cha: 1,
        hp1: 11,
        hp2: 99,
        dam1: 1,
        dam2: 8,
        bonus: 9,
        damtype: damages.blunt,
        defence: 8,
        challenge: 19,
        description: 'A rotting ogre corpse, still walking and bothering people',
        resist: [damages.cold, damages.paral],
        invuln: [damages.pois, damages.vamp, damages.sleep, damages.confu, damages.bleed],
        vuln: [damages.fire],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.BaseAttacker],
        type: 'aggressive'
    };
    //unique monsters
    Templates.bagulhonn = {
        name: 'Bagul Honn the Big Baddie',
        ch: 'Ω',
        fg: 'rgb(200,0,155)',
        speed: 350,
        sightRad: 15,
        str: 35,
        dex: 34,
        con: 30,
        inte: 30,
        wis: 31,
        cha: 21,
        hp1: 280,
        hp2: 300,
        dam1: 2,
        dam2: 10,
        bonus: 5,
        damtype: damages.blunt,
        extradamt: [damages.unholy],
        apr: 3,
        attbon: 8,
        defence: 11,
        challenge: 150,
        description: "The ultimate boss, defeat it and you'll have won. Easier said than done, though...",
        invuln: [damages.petro, damages.confu, damages.sleep, damages.paral, damages.dark],
        resist: [damages.light, damages.acid, damages.electro, damages.cold, damages.blunt, damages.sound],
        items: [Templates.healingPotion],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Boss],
        type: 'aggressive'
    };
    Templates.fisschon = {
        name: 'Fiss-Chon the Tyrant of the Deep',
        ch: 'Ω',
        fg: 'rgb(0,0,255)',
        speed: 110,
        sightRad: 15,
        str: 25,
        dex: 22,
        con: 30,
        inte: 10,
        wis: 11,
        cha: 11,
        hp1: 200,
        hp2: 230,
        dam1: 2,
        dam2: 10,
        bonus: 2,
        damtype: damages.blunt,
        apr: 4,
        defence: 9,
        challenge: 115,
        description: "Lurking at the bottom of the ocean, it will crush everything with its mighty (and highly immoral) tentacles",
        invuln: [damages.petro, damages.confu, damages.sleep, damages.paral, damages.dark],
        resist: [damages.light, damages.acid, damages.electro, damages.cold, damages.blunt],
        summonable: ['octopoid', 'octopoidWarrior'],
        items: [Templates.kagayaAmulet, Templates.healingPotion],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SummonerActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Summoner, Mixins.Boss],
        type: 'aggressive'
    };
    Templates.goblinKing = {
        name: 'Fardur the Goblin King',
        ch: 'Ω',
        fg: 'silver',
        speed: 135,
        sightRad: 12,
        str: 19,
        dex: 18,
        con: 20,
        inte: 14,
        wis: 15,
        cha: 13,
        hp1: 52,
        hp2: 70,
        dam2: 8,
        dambon: 5,
        damtype: damages.blunt,
        defence: 2,
        challenge: 40,
        description: 'An overgrown goblin with silver hair, ready to swat you like a fily and eat your guts. Or something like that',
        specpow: ["Second Sight"],
        impass: true,
        invuln: [damages.paral, damages.petro],
        resist: [damages.acid, damages.confu, damages.dark],
        equipment: [Templates.maceLourette, Templates.splintmail, Templates.helmInsomnia, Templates.paraimmuAmulet],
        items: [Templates.incIntePotion, Templates.incStrPotion, Templates.secondSightPotion],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.Boss],
        type: 'aggressive'
    };
    Templates.inbaryek = {
        name: 'In-Bar Yek the Low King',
        ch: 'Ω',
        fg: 'rgb(30,220,30)',
        speed: 100,
        sightRad: 12,
        str: 25,
        dex: 17,
        con: 28,
        inte: 14,
        wis: 12,
        cha: 12,
        hp1: 80,
        hp2: 96,
        dam2: 8,
        dambon: 7,
        damtype: damages.blunt,
        attbon: 2,
        defence: 2,
        challenge: 60,
        description: 'Low King of the dwarves, he is ready to defend his country from any taller invader.',
        specpow: ["Second Sight"],
        impass: true,
        invuln: [damages.paral, damages.sleep, damages.confu, damages.petro, damages.dark],
        resist: [damages.magic, damages.pois],
        vuln: [damages.light],
        equipment: [Templates.axeSmasher, Templates.fullplateJar, Templates.helmInsomnia],
        items: [Templates.healingPotion],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.Boss],
        type: 'aggressive'
    };
    Templates.orcLord = {
        name: 'Baloss the Orc Lord',
        ch: 'Ω',
        fg: 'rgb(30,220,30)',
        speed: 120,
        sightRad: 12,
        str: 25,
        dex: 18,
        con: 25,
        inte: 16,
        wis: 16,
        cha: 15,
        hp1: 62,
        hp2: 78,
        dam2: 8,
        dambon: 7,
        damtype: damages.blunt,
        defence: 6,
        challenge: 45,
        description: 'A fierce, humongous orc, smartly dressed (at least for orc standard) and ready to smash the puny intruder, i.e. you',
        specpow: ["Second Sight"],
        impass: true,
        invuln: [damages.sleep],
        resist: [damages.fire, damages.unholy, damages.electro],
        vuln: [damages.acid],
        equipment: [Templates.greatsword, Templates.manushirt, Templates.hornedhelm, Templates.bootSarpili],
        items: [Templates.incIntePotion, Templates.incStrPotion, Templates.damnScroll, Templates.fireWand, Templates.healingPotion],
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.AggressiveActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.Boss],
        type: 'aggressive'
    };
    Templates.partug = {
        name: 'Parthug-Haj the Flatulent',
        ch: 'Ω',
        fg: 'rgb(0,170,0)',
        speed: 120,
        sightRad: 10,
        str: 25,
        dex: 14,
        con: 35,
        inte: 20,
        wis: 18,
        cha: 10,
        hp1: 45,
        hp2: 56,
        dam1: 2,
        dam2: 12,
        bonus: 3,
        damtype: damages.blunt,
        defence: 5,
        poisdam: 3,
        poisdur: 30,
        poisstr: 16,
        poischa: 12,
        challenge: 40,
        description: "A writhing, thinking mass of flesh, covered in poison and very, very dangerous",
        invuln: [damages.pois],
        resist: [damages.acid, damages.confu, damages.sleep],
        items: [Templates.acidresAmulet, Templates.corrodeScroll],
        offsp: ["Magic Missile", "Acid Arrow"],
        defsp: ["Minor Healing", "Teleport"],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SpellcasterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.Poisonous, Mixins.Boss],
        type: 'aggressive'
    };
    Templates.scartoo = {
        name: 'Scar-too Chen the Unseen',
        ch: 'Ω',
        fg: 'indianred',
        speed: 130,
        sightRad: 15,
        str: 20,
        dex: 16,
        con: 20,
        inte: 30,
        wis: 28,
        cha: 30,
        hp1: 80,
        hp2: 96,
        dam1: 2,
        dam2: 12,
        bonus: 4,
        damtype: damages.unholy,
        defence: 10,
        vamp: 10,
        challenge: 70,
        description: "Normal eyes can't see it, but you can feel its chilly touch draining your life away, while it whispers insanity in your ears.",
        resist: [damages.cut, damages.blunt, damages.pierce, damages.magic],
        invuln: [damages.pois, damages.vamp, damages.sleep, damages.confu, damages.cold, damages.paral,
            damages.petro, damages.electro, damages.acid, damages.dark],
        vuln: [damages.fire, damages.holy],
        items: [Templates.con4Amulet, Templates.damnScroll, Templates.shockScroll, Templates.secondLifePotion, Templates.healingPotion, Templates.scytheDeath],
        offsp: ["Ice Storm", "Paralysis", "Touch of Idiocy", "Insanity", "Sleep"],
        defsp: ["Dispel Magic", "Teleport"],
        specpow: ["Second Sight"],
        impass: true,
        invisible: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SpellcasterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.Vampiric, Mixins.Boss],
        type: 'aggressive'
    };
    Templates.sigulhott = {
        name: 'Sigul Hott the Green',
        ch: 'Ω',
        fg: 'rgb(0,255,0)',
        speed: 125,
        sightRad: 15,
        str: 17,
        dex: 20,
        con: 18,
        inte: 40,
        wis: 28,
        cha: 27,
        hp1: 80,
        hp2: 89,
        dam1: 2,
        dam2: 10,
        bonus: 2,
        damtype: damages.blunt,
        apr: 2,
        defence: 9,
        regen: 4,
        challenge: 85,
        description: "Looks like a giant walking shrub, but it can sprout life from everywhere with a mere touch of its branches",
        invuln: [damages.pois, damages.acid, damages.petro, damages.confu, damages.sleep, damages.paral, damages.pierce],
        resist: [damages.light, damages.dark, damages.electro, damages.holy, damages.unholy, damages.blunt],
        vuln: [damages.fire],
        summonable: ['willow'],
        items: [Templates.aegis, Templates.longbowBlisga, Templates.healingPotion],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SummonerActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Regenerator, Mixins.Summoner, Mixins.Boss],
        type: 'aggressive'
    };
    Templates.sourcerer = {
        name: 'Valìss the Sourcerer',
        ch: 'Ω',
        fg: 'rgba(200,35,55,.5)',
        speed: 150,
        sightRad: 15,
        str: 15,
        dex: 18,
        con: 16,
        inte: 40,
        wis: 25,
        cha: 25,
        hp1: 85,
        hp2: 99,
        dam1: 2,
        dam2: 10,
        bonus: 5,
        damtype: damages.magic,
        defence: 10,
        challenge: 110,
        description: "Master of magic, he can change with ease the very fabric of reality. Or so he claims.",
        resist: [damages.cut, damages.blunt, damages.pierce, damages.pois, damages.acid, damages.magic, damages.sound],
        invuln: [damages.sleep, damages.confu, damages.cold, damages.paral, damages.electro, damages.petro, damages.tele],
        equip: [Templates.archchancellorHat, Templates.staffGoonyen, Templates.robeSource, Templates.healingPotion, Templates.freezeScroll],
        offsp: ["Melt Floor", "Quicksand", "Thunderstorm", 'Ice Storm', "Petrify", "Fireball"],
        defsp: ["Fast Foot", "Mage Armour", "Healing"],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SpellcasterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.Spellcaster, Mixins.Boss],
        type: 'aggressive'
    };
    Templates.teshtak = {
        name: 'Tesh-Tak Huedra the Holier-Than-Thou',
        ch: 'Ω',
        fg: 'rgb(255,255,255)',
        speed: 200,
        sightRad: 15,
        str: 30,
        dex: 20,
        con: 25,
        inte: 30,
        wis: 40,
        cha: 30,
        hp1: 165,
        hp2: 180,
        dam1: 2,
        dam2: 8,
        bonus: 4,
        damtype: damages.holy,
        extradamt: [damages.fire],
        defence: 10,
        challenge: 120,
        description: "The highest Good in the world... or so he sees himself. His holy fire will char your very soul, you filthy sinner.",
        resist: [damages.blunt, damages.pois, damages.acid, damages.vamp, damages.cold, damages.sound],
        invuln: [damages.sleep, damages.confu, damages.electro, damages.paral, damages.fire, damages.petro, damages.holy],
        items: [Templates.smiteungodlyGrimoire],
        equip: [Templates.swordSandunen],
        offsp: ["Smite the Ungodly", "Fireball", "God Beam"],
        defsp: ["Blessing", "Healing"],
        specpow: ["Second Sight"],
        impass: true,
        mixins: [Mixins.Living, Mixins.Mobile, Mixins.SpellcasterActor, Mixins.Sight, Mixins.InventoryHolder,
            Mixins.BaseAttacker, Mixins.Equipper, Mixins.Boss],
        type: 'aggressive'
    };
    //Dungeons
    Templates.arborea = {
        name: 'Arborea',
        id: 2,
        minlvl: 30,
        maxlvl: 52,
        maxpop: 28,
        maxit: 8,
        boss: Templates.sigulhott,
        bestiary: [[Templates.pseudodragon, 7, 33], [Templates.satyr, 6, 36], [Templates.troll, 8, 31],
            [Templates.wolf, 12, 30], [Templates.snake, 12, 30], [Templates.bandit, 12, 30], [Templates.ogre, 8, 34],
            [Templates.mage, 8, 31], [Templates.warrior, 8, 32], [Templates.elf, 20, 35], [Templates.elfMage, 7, 40],
            [Templates.mageSenior, 5, 46], [Templates.faun, 10, 41], [Templates.unicorn, 5, 47], [Templates.centaur, 8, 44],
            [Templates.ogreMage, 4, 43], [Templates.ogreShaman, 6, 43], [Templates.wasp, 8, 45], [Templates.willow, 10, 35],
            [Templates.elemEarthSmall, 10, 35], [Templates.elemEarthMedium, 7, 42], [Templates.bearBlack, 7, 30],
            [Templates.stagbeetle, 6, 37], [Templates.mantis, 8, 35], [Templates.spiderGiant, 7, 39]],
        store: [[Templates.antidote, 10, 30], [Templates.cureCriticPotion, 7, 32], [Templates.curePotion, 15, 30],
            [Templates.cureSeriousPotion, 10, 31], [Templates.healWand, 4, 35], [Templates.rechargeScroll, 6, 33],
            [Templates.incDextPotion, 3, 36], [Templates.shockScroll, 2, 40], [Templates.decStrPotion, 5, 37],
            [Templates.battleaxe, 3, 39], [Templates.handaxe, 6, 32], [Templates.healminGrimoire, 1, 36],
            [Templates.arrow, 8, 31], [Templates.teleportScroll, 5, 42], [Templates.acidresAmulet, 4, 37],
            [Templates.lightresAmulet, 5, 41], [Templates.seeinvisiblePotion, 1, 43], [Templates.rangedManual, 1, 45],
            [Templates.healingGrimoire, 1, 43], [Templates.incWisPotion, 3, 40], [Templates.poisonPotion, 7, 35],
            [Templates.incCharPotion, 3, 38], [Templates.cha4Amulet, 4, 43], [Templates.dex4Amulet, 5, 40],
            [Templates.healingPotion, 3, 40], [Templates.boomerang, 8, 33], [Templates.slownessPotion, 4, 37],
            [Templates.speedPotion, 4, 37]],
        w: 60,
        h: 60,
        mapx: 69,
        mapy: 199
    };
    Templates.avernus = {
        name: 'Avernus',
        id: 4,
        minlvl: 60,
        maxlvl: 100,
        maxpop: 33,
        maxit: 5,
        boss: Templates.bagulhonn,
        bestiary: [[Templates.ratKing, 5, 60], [Templates.elemFireSmall, 10, 60], [Templates.elemFireMedium, 8, 65],
            [Templates.elemFireLarge, 5, 75], [Templates.elemFireLord, 2, 86], [Templates.elemAirLord, 2, 86],
            [Templates.elemEarthLord, 2, 86], [Templates.mageGreat, 6, 73], [Templates.vampireElder, 6, 67],
            [Templates.demonBabau, 7, 64], [Templates.demonDretch, 25, 62], [Templates.devilKyton, 10, 68],
            [Templates.devilBezekira, 8, 73], [Templates.devilImp, 15, 60], [Templates.devilLemure, 20, 60],
            [Templates.devilOsyluth, 4, 82], [Templates.ghost, 10, 62], [Templates.ghast, 8, 64],
            [Templates.duergar, 10, 60], [Templates.rustmonster, 4, 71], [Templates.wraith, 6, 70],
            [Templates.paladinDark, 16, 80]],
        store: [[Templates.antidote, 12, 60], [Templates.cureSeriousPotion, 20, 60], [Templates.cureCriticPotion, 15, 61],
            [Templates.invisibilityPotion, 6, 63], [Templates.speedPotion, 5, 67], [Templates.seeinvisiblePotion, 8, 62],
            [Templates.resacidPotion, 8, 60], [Templates.rescoldPotion, 8, 60], [Templates.reselePotion, 8, 60],
            [Templates.resfirePotion, 8, 60], [Templates.respetroPotion, 6, 64], [Templates.poisonPotion, 6, 62],
            [Templates.teleportScroll, 7, 62], [Templates.incStrPotion, 4, 68], [Templates.incConstPotion, 4, 65],
            [Templates.incIntePotion, 4, 69], [Templates.incDextPotion, 4, 68], [Templates.str4Amulet, 5, 64],
            [Templates.dex4Amulet, 5, 64], [Templates.con4Amulet, 5, 65], [Templates.cha4Amulet, 5, 65],
            [Templates.inte4Amulet, 5, 66], [Templates.wis4Amulet, 5, 66], [Templates.healingPotion, 10, 66],
            [Templates.slownessPotion, 5, 67]],
        w: 90,
        h: 30,
        mapx: 120,
        mapy: 76
    };
    Templates.basica = {
        name: 'Basica',
        id: 0,
        minlvl: 1,
        maxlvl: 10,
        maxpop: 20,
        maxit: 9,
        boss: Templates.partug,
        bestiary: [[Templates.orc, 25, 2], [Templates.goblin, 30, 1], [Templates.rat, 35, 1],
            [Templates.kobold, 25, 1], [Templates.snake, 10, 2], [Templates.mage, 8, 7],
            [Templates.troll, 6, 9], [Templates.wolf, 10, 4], [Templates.goblinArcher, 10, 6],
            [Templates.koboldArcher, 10, 4], [Templates.orcArcher, 7, 7], [Templates.warrior, 7, 8],
            [Templates.ratKing, 2, 8]],
        store: [[Templates.chainshirt, 5, 6], [Templates.curePotion, 22, 1], [Templates.antidote, 8, 1],
            [Templates.confusionWand, 4, 5], [Templates.sword, 3, 4], [Templates.cureSeriousPotion, 10, 5],
            [Templates.rechargeScroll, 5, 4], [Templates.leatherarm, 6, 2], [Templates.speedPotion, 8, 7],
            [Templates.shortsword, 5, 3], [Templates.trident, 8, 4], [Templates.robe, 7, 3], [Templates.pointyHat, 7, 3],
            [Templates.waterPotion, 6, 1], [Templates.cureCriticPotion, 6, 9], [Templates.arrow, 7, 1],
            [Templates.fireresAmulet, 3, 8], [Templates.resfirePotion, 4, 8], [Templates.ironRation, 5, 4],
            [Templates.boomerang, 3, 5], [Templates.slownessPotion, 2, 7]],
        w: 60,
        h: 22,
        mapx: 150,
        mapy: 200
    };
    Templates.bigothia = {
        name: 'Bigothia',
        id: 0,
        minlvl: 40,
        maxlvl: 70,
        maxpop: 30,
        maxit: 8,
        boss: Templates.teshtak,
        bestiary: [[Templates.angel, 10, 40], [Templates.archangel, 8, 45], [Templates.angelPrincip, 7, 49],
            [Templates.holyCow, 5, 40], [Templates.elemAirSmall, 9, 40], [Templates.elemAirMedium, 7, 47],
            [Templates.elemAirLarge, 5, 58], [Templates.elemAirLord, 2, 65], [Templates.paladin, 15, 40],
            [Templates.priest, 10, 40]],
        store: [[Templates.antidote, 6, 45], [Templates.cureCriticPotion, 8, 47], [Templates.curePotion, 15, 40],
            [Templates.cureSeriousPotion, 10, 45], [Templates.fireWand, 3, 47], [Templates.blessScroll, 3, 54],
            [Templates.rechargeScroll, 3, 46], [Templates.speedPotion, 5, 46], [Templates.teleportScroll, 6, 44],
            [Templates.arrow, 5, 40], [Templates.shockScroll, 2, 53], [Templates.swordblessed, 1, 54],
            [Templates.burnScroll, 2, 40], [Templates.holinessAmulet, 3, 49], [Templates.healmajGrimoire, 1, 54],
            [Templates.healminGrimoire, 1, 45], [Templates.poisonPotion, 6, 47], [Templates.incStrPotion, 3, 46],
            [Templates.incWisPotion, 4, 50], [Templates.incCharPotion, 3, 47], [Templates.incIntePotion, 3, 55],
            [Templates.inte4Amulet, 6, 50], [Templates.wis4Amulet, 6, 50], [Templates.healingPotion, 5, 55],
            [Templates.slownessPotion, 5, 47]],
        w: 80,
        h: 40,
        mapx: 112,
        mapy: 137
    };
    Templates.cryptor = {
        name: 'Cryptor',
        id: 1,
        minlvl: 25,
        maxlvl: 42,
        maxpop: 25,
        maxit: 8,
        boss: Templates.scartoo,
        bestiary: [[Templates.rat, 20, 25], [Templates.zombie, 12, 30], [Templates.vampire, 12, 33],
            [Templates.skeleton, 17, 28], [Templates.skeletonGoblin, 18, 25], [Templates.skeletonOrc, 16, 29],
            [Templates.skeletonWolf, 14, 31], [Templates.vampireAdult, 7, 35], [Templates.vampireElder, 3, 40],
            [Templates.zombieKobold, 15, 27], [Templates.zombieOgre, 10, 37], [Templates.ratGiant, 15, 25],
            [Templates.ghoul, 8, 32], [Templates.ghast, 5, 35], [Templates.mummy, 5, 38], [Templates.ghost, 3, 37],
            [Templates.ratKing, 4, 30], [Templates.skeletonKobold, 18, 25], [Templates.wraith, 1, 39]],
        store: [[Templates.antidote, 10, 25], [Templates.cureCriticPotion, 8, 30], [Templates.curePotion, 15, 25],
            [Templates.cureSeriousPotion, 10, 30], [Templates.missileWand, 5, 29], [Templates.hornedhelm, 7, 31],
            [Templates.rechargeScroll, 8, 39], [Templates.speedPotion, 6, 32], [Templates.heavyshield, 6, 33],
            [Templates.scythe, 4, 27], [Templates.battleaxe, 5, 28], [Templates.warhammer, 5, 31],
            [Templates.arrow, 10, 25], [Templates.swordburning, 2, 39], [Templates.damnScroll, 3, 36],
            [Templates.teleportScroll, 5, 34], [Templates.poisonPotion, 7, 30], [Templates.darkresAmulet, 5, 28],
            [Templates.swordcursed, 2, 40], [Templates.seeinvisiblePotion, 2, 33], [Templates.magicManual, 1, 35],
            [Templates.unholinessAmulet, 4, 36], [Templates.decCharPotion, 5, 32], [Templates.incWisPotion, 4, 37],
            [Templates.poisonPotion, 6, 33], [Templates.incStrPotion, 4, 35], [Templates.incConstPotion, 4, 34],
            [Templates.con4Amulet, 4, 35], [Templates.wis4Amulet, 3, 37], [Templates.healingPotion, 5, 40],
            [Templates.slownessPotion, 4, 32]],
        w: 80,
        h: 25,
        mapx: 173,
        mapy: 120
    };
    Templates.goblund = {
        name: 'Goblund',
        id: 0,
        minlvl: 15,
        maxlvl: 30,
        maxpop: 35,
        maxit: 8,
        boss: Templates.goblinKing,
        bestiary: [[Templates.goblin, 25, 15], [Templates.goblinArcher, 15, 17], [Templates.goblinShaman, 8, 20],
            [Templates.rat, 15, 15], [Templates.ratGiant, 10, 17], [Templates.skeletonGoblin, 10, 21],
            [Templates.goblinFemale, 12, 16], [Templates.goblinVeteran, 7, 23], [Templates.troglodyte, 9, 18],
            [Templates.centipede, 8, 16], [Templates.centipedeGiant, 4, 24], [Templates.cockroach, 3, 26],
            [Templates.ratKing, 2, 22], [Templates.hobgoblin, 10, 22], [Templates.duergar, 6, 25]],
        store: [[Templates.curePotion, 15, 15], [Templates.antidote, 7, 18], [Templates.cureSeriousPotion, 10, 18],
            [Templates.rechargeScroll, 3, 20], [Templates.cureCriticPotion, 6, 23], [Templates.arrow, 6, 17],
            [Templates.paraimmuAmulet, 2, 17], [Templates.unholinessAmulet, 2, 20], [Templates.corrodeScroll, 2, 24],
            [Templates.helmInsomnia, 2, 21], [Templates.healWand, 2, 26], [Templates.teleportScroll, 3, 19],
            [Templates.seeinvisiblePotion, 1, 27], [Templates.healminGrimoire, 1, 26], [Templates.resacidPotion, 5, 20],
            [Templates.rescoldPotion, 5, 24], [Templates.reselePotion, 5, 23], [Templates.respetroPotion, 3, 29],
            [Templates.poisonPotion, 7, 18], [Templates.str4Amulet, 2, 25], [Templates.con4Amulet, 3, 23],
            [Templates.boomerang, 6, 18], [Templates.speedPotion, 4, 20], [Templates.slownessPotion, 4, 20]],
        w: 60,
        h: 25,
        mapx: 132,
        mapy: 186
    };
    Templates.nanikar = {
        name: 'Nanikar',
        id: 0,
        minlvl: 35,
        maxlvl: 51,
        maxpop: 30,
        maxit: 7,
        boss: Templates.inbaryek,
        bestiary: [[Templates.dwarf, 25, 35], [Templates.dwarfWarrior, 20, 37], [Templates.duergar, 10, 45],
            [Templates.rat, 15, 35], [Templates.ratGiant, 10, 35], [Templates.centipede, 12, 35],
            [Templates.centipedeGiant, 8, 38], [Templates.cockroach, 6, 40], [Templates.ratKing, 4, 42],
            [Templates.elemEarthSmall, 10, 38], [Templates.elemEarthMedium, 8, 43], [Templates.elemEarthLarge, 4, 48],
            [Templates.rustmonster, 6, 44], [Templates.dwarfGuard, 8, 45], [Templates.nagaDark, 4, 46]],
        store: [[Templates.curePotion, 18, 35], [Templates.antidote, 8, 36], [Templates.cureSeriousPotion, 15, 35],
            [Templates.rechargeScroll, 3, 40], [Templates.cureCriticPotion, 10, 43], [Templates.arrow, 6, 37],
            [Templates.poisonPotion, 7, 38], [Templates.pick, 8, 36], [Templates.resacidPotion, 6, 38],
            [Templates.acidresAmulet, 5, 39], [Templates.str4Amulet, 4, 41], [Templates.con4Amulet, 4, 42],
            [Templates.healingPotion, 5, 47], [Templates.boomerang, 5, 37], [Templates.speedPotion, 4, 37],
            [Templates.slownessPotion, 4, 37], [Templates.bolt, 7, 44]],
        w: 60,
        h: 35,
        mapx: 206,
        mapy: 130
    };
    Templates.orkody = {
        name: 'Orkody',
        id: 0,
        minlvl: 10,
        maxlvl: 27,
        maxpop: 30,
        maxit: 7,
        boss: Templates.orcLord,
        bestiary: [[Templates.rat, 15, 10], [Templates.orc, 25, 10], [Templates.orcArcher, 15, 13],
            [Templates.snake, 7, 11], [Templates.orcShaman, 10, 17], [Templates.halfOrc, 13, 15],
            [Templates.ogre, 9, 19], [Templates.ogreMage, 3, 26], [Templates.troglodyte, 7, 13],
            [Templates.ogreShaman, 4, 24], [Templates.ratGiant, 10, 12], [Templates.orcFemale, 20, 11],
            [Templates.ratKing, 2, 18], [Templates.orcElite, 9, 18]],
        store: [[Templates.antidote, 7, 10], [Templates.cureCriticPotion, 7, 17], [Templates.curePotion, 15, 10],
            [Templates.cureSeriousPotion, 10, 15], [Templates.fireWand, 3, 15], [Templates.hornedhelm, 10, 14],
            [Templates.rechargeScroll, 4, 14], [Templates.speedPotion, 5, 16], [Templates.heavyshield, 9, 15],
            [Templates.halbert, 6, 15], [Templates.battleaxe, 4, 18], [Templates.warhammer, 5, 16],
            [Templates.arrow, 8, 10], [Templates.freezeScroll, 2, 17], [Templates.healWand, 5, 20],
            [Templates.teleportScroll, 6, 19], [Templates.poisonPotion, 6, 18], [Templates.rescoldPotion, 4, 20],
            [Templates.paraimmuAmulet, 2, 20], [Templates.chainmail, 4, 13], [Templates.seeinvisiblePotion, 2, 21],
            [Templates.str4Amulet, 2, 21], [Templates.con4Amulet, 3, 23], [Templates.slownessPotion, 4, 17]],
        w: 80,
        h: 25,
        mapx: 225,
        mapy: 164
    };
    Templates.sourceria = {
        name: 'Sourceria',
        id: 5,
        minlvl: 44,
        maxlvl: 73,
        maxpop: 24,
        maxit: 7,
        boss: Templates.sourcerer,
        bestiary: [[Templates.mage, 15, 44], [Templates.mageSenior, 9, 52], [Templates.mageGreat, 5, 60],
            [Templates.elfMage, 8, 48], [Templates.ogreMage, 7, 50], [Templates.elemFireSmall, 10, 45],
            [Templates.elemFireMedium, 7, 51], [Templates.elemFireLarge, 5, 59], [Templates.elemEarthSmall, 10, 45],
            [Templates.elemEarthMedium, 7, 52], [Templates.elemEarthLarge, 4, 60], [Templates.elemAirSmall, 11, 44],
            [Templates.elemAirMedium, 7, 51], [Templates.elemAirLarge, 5, 58], [Templates.golem, 5, 65],
            [Templates.elemWaterSmall, 10, 46], [Templates.elemWaterMedium, 7, 52], [Templates.elemWaterLarge, 5, 60],
            [Templates.elemAirLord, 3, 70], [Templates.elemEarthLord, 3, 70], [Templates.elemFireLord, 3, 70],
            [Templates.elemWaterLord, 3, 70]],
        store: [[Templates.antidote, 10, 44], [Templates.cureSeriousPotion, 15, 44], [Templates.cureCriticPotion, 10, 55],
            [Templates.rechargeScroll, 8, 45], [Templates.arrow, 6, 44], [Templates.resacidPotion, 8, 46],
            [Templates.rescoldPotion, 8, 46], [Templates.reselePotion, 8, 46], [Templates.resfirePotion, 8, 46],
            [Templates.respetroPotion, 6, 50], [Templates.healWand, 7, 52], [Templates.fireWand, 7, 52],
            [Templates.magicmissGrimoire, 5, 50], [Templates.magicManual, 1, 50], [Templates.recallGrimoire, 3, 58],
            [Templates.petrifyGrimoire, 3, 61], [Templates.poisonPotion, 3, 50], [Templates.incIntePotion, 5, 55],
            [Templates.incWisPotion, 4, 53], [Templates.incDextPotion, 4, 57], [Templates.seeinvisibGrimoire, 5, 47],
            [Templates.inte4Amulet, 6, 50], [Templates.wis4Amulet, 6, 50], [Templates.healingPotion, 7, 60],
            [Templates.speedPotion, 5, 47], [Templates.slownessPotion, 5, 47]],
        w: 50,
        h: 50,
        mapx: 276,
        mapy: 158
    };
    Templates.thalassia = {
        name: 'Thalassia',
        id: 3,
        minlvl: 50,
        maxlvl: 80,
        maxpop: 24,
        maxit: 6,
        boss: Templates.fisschon,
        bestiary: [[Templates.triton, 15, 50], [Templates.lacedon, 9, 55], [Templates.octopoid, 13, 52],
            [Templates.octopoidWarrior, 10, 57], [Templates.merfolk, 17, 50], [Templates.elemWaterSmall, 11, 54],
            [Templates.elemWaterMedium, 8, 62], [Templates.elemWaterLarge, 5, 68], [Templates.elemWaterLord, 2, 74],
            [Templates.nagaWater, 7, 60], [Templates.tojanidaYoung, 8, 58], [Templates.tojanida, 7, 66],
            [Templates.tojanidaElder, 4, 73], [Templates.assassinMaster, 8, 61]],
        store: [[Templates.antidote, 8, 55], [Templates.cureCriticPotion, 14, 51], [Templates.cureSeriousPotion, 18, 50],
            [Templates.speedPotion, 6, 54], [Templates.rescoldPotion, 6, 52], [Templates.corrodeScroll, 3, 54],
            [Templates.rechargeScroll, 6, 50], [Templates.resfirePotion, 6, 56], [Templates.teleportScroll, 6, 52],
            [Templates.arrow, 8, 50], [Templates.shockScroll, 2, 63], [Templates.resacidPotion, 5, 50],
            [Templates.seeinvisiblePotion, 1, 53], [Templates.healingGrimoire, 1, 55], [Templates.poisonPotion, 6, 53],
            [Templates.incDextPotion, 4, 60], [Templates.incCharPotion, 4, 59], [Templates.incConstPotion, 4, 62],
            [Templates.dex4Amulet, 4, 57], [Templates.inte4Amulet, 4, 63], [Templates.healingPotion, 10, 60],
            [Templates.slownessPotion, 5, 55]],
        w: 80,
        h: 50,
        mapx: 261,
        mapy: 43
    };
    Templates.wilderness = {
        name: 'Wilderness',
        id: 0,
        w: 300,
        h: 300,
        seed: 4343,
        places: {
            "69,199": Templates.arborea,
            "112,137": Templates.bigothia,
            "120,76": Templates.avernus,
            "132,186": Templates.goblund,
            "150,200": Templates.basica,
            "173,120": Templates.cryptor,
            "206,130": Templates.nanikar,
            "225,164": Templates.orkody,
            "261,43": Templates.thalassia,
            "276,158": Templates.sourceria
        }
    };
    //⌂ <- future symbol for towns

    /*
     * Messages management, save & load, switching levels and other random stuff
     */
    var sendMessage = function (message) {
        messages.push(message);
    };
    var clearMessages = function () {
        messages = [];
        hideSection("dialog");
    };
    var hasMessages = function () {
        return messages.length > 0;
    };
    var writeMessages = function () {
        var mex = '';
        for (var i = 0, ii = messages.length; i < ii; i++) {
            mex += messages[i];
            if (ii > 1 && i < ii - 1) {
                mex += strings.dot;
            }
        }
        dialog.innerHTML = "<p>" + mex + "</p>";
        if (isSectionVisible("gioco")) {
            showSection("dialog");
        }
    };
    var writeInfo = function () {
        var eff = "";
        for (var key in player.getEffects()) {
            eff += key.capitalize() + ' ';
        }
        infoplay.innerHTML = "<p>";
        if (eff.length > 0) {
            infoplay.innerHTML += "<span class='red'>" + eff + "</span>";
        }
        infoplay.innerHTML += "<br>HP: %s Lvl: %s XP: %s".format(player.getHealth(), player.getLevel(),
            player.getExperience()) + "</p>"
        infodun.innerHTML = "<p>" + "%s: %s".format(World.name, World.lvl) + "</p>";
    };
    var save = function () {
        if (player.isAlive() && localStorage) {
            savedGame.player = player.save();
            savedGame.world = World.save();
            savedGame.wild = isWilderness;
            localStorage.setItem('scantanador', JSON.stringify(savedGame));
            console.log("Game saved");
            return true;
        } else {
            console.log("Can't save the game");
            return false;
        }
    };
    var deleteSavedGame = function () {
        if (localStorage && localStorage.getItem('scantanador')) {
            localStorage.removeItem('scantanador');
            console.log("Deleted saved game");
        }
    };
    var canLoad = function () {
        return localStorage && localStorage.getItem('scantanador');
    };
    var load = function () {
        if (canLoad()) {
            savedGame = JSON.parse(localStorage.getItem("scantanador"));
            World.init(savedGame.world);
            player = makeThing(savedGame.player);
            isWilderness = savedGame.wild;
            if (isWilderness) {
                World.makeWorld();
            } else {
                World.makeLevel();
            }
            player.restore(World, isWilderness);
            World.restore(savedGame.world);
            drawScreen();
            if (!isWilderness) {
                showSection("data");
                Engine.start();
            }
            return true;
        }
        console.log("Failed to load the game");
        return false;
    };
    var getLine = function (startX, startY, endX, endY) {
        var points = [];
        var dx = Math.abs(endX - startX);
        var dy = Math.abs(endY - startY);
        var sx = (startX < endX) ? 1 : -1;
        var sy = (startY < endY) ? 1 : -1;
        var err = dx - dy;
        var e2;
        while (true) {
            points.push({ x: startX, y: startY });
            if (startX === endX && startY === endY) {
                break;
            }
            e2 = err * 2;
            if (e2 > -dx) {
                err -= dy;
                startX += sx;
            }
            if (e2 < dx) {
                err += dx;
                startY += sy;
            }
        }
        return points;
    };
    var writeDamage = function (whose) {
        if (whose.hasMixin(Mixins.Equipper) && whose.getHand1()) {
            var weapon = whose.getPart(parts.hand1);
            var text = weapon.dam1 + "d" + weapon.dam2;
            var bonus = weapon.bonus ? getBonus(whose.strength) + weapon.bonus : getBonus(whose.strength);
            if (whose.damageBonus) {
                bonus += whose.damageBonus;
            }
            if (bonus) {
                text += bonus > 0 ? " + " + bonus : " - " + Math.abs(bonus);
            }
            if (weapon.extraDamageType && weapon.extraDamageType.length > 0) {
                text += " + " + weapon.extraDamageType.join(", ");
            }
            return text;
        }
        return whose.diceNumber + "d" + whose.diceFaces;
    };
    var goToWilderness = function (where) {
        isWilderness = true;
        World.init(Templates.wilderness);
        World.makeWorld();
        World.addEntity(player, where, true);
        if (player.hasEffect("invisible")) {
            player.removeEffect("invisible");
        }
        hideSection("data");
        drawScreen();
    };
    var openNewGame = function () {
        if (!load()) {
            World.init(Templates.basica);
            World.seed = Date.now();
            World.makeLevel();
            World.addEntity(player);
            World.addStairs(player.getPosition());
            World.populate();
            savedGame[World.name] = false;
            sendMessage('Welcome to Scantanador!<br>Press [?] for a list of keys, press [Enter] or click/tap on the @ icon to access the main menu.');
            showSection("data");
            drawScreen();
            Engine.start();
        }
    };
    var canDescend = function (up) {
        if (isWilderness) {
            return World.getPlace(player.getX(), player.getY());
        }
        var pos = World.getTile(player.getX(), player.getY());
        if (up) {
            return pos === Templates.stairsUp;
        } else {
            return pos === Templates.stairsDown;
        }
    };
    var descendStairs = function (where) {
        if (isWilderness) {
            isWilderness = false;
            World.init(where);
            World.seed = Date.now();
            World.makeLevel();
            World.addEntity(player);
            World.addStairs(player.getPosition());
            World.populate();
            sendMessage('You enter the dungeon %s.'.format(where.name));
            if (!savedGame[where.name]) {
                savedGame[where.name] = false;
            }
            showSection("data");
            drawScreen();
            Engine.start();
            return true;
        }
        if ((isUp && World.lvl === World.minlvl) || (!isUp && World.lvl === World.maxlvl)) {
            if (player.hasEffect("starving")) {
                sendMessage("You are too hungry to travel right now.");
                return false;
            }
            for (var key in player.getEffects()) {
                if (key !== "starving" && key !== "hungry") {
                    player.removeEffect(key);
                }
            }
            goToWilderness({
                x: World.mapx,
                y: World.mapy
            });
            sendMessage('You climb back to the surface.');
            drawScreen();
            return true;
        }
        savedGame.type = 0;
        World.seed = Date.now();
        World.makeLevel();
        World.addEntity(player);
        World.addStairs(player.getPosition(), isUp);
        if (isUp) {
            World.lvl--;
            sendMessage('You climb back to the previous level.');
        } else {
            World.lvl++;
            sendMessage('You descend to the next level.');
        }
        World.populate();
        drawScreen();
        Engine.start();
        return true;
    };

    /*
     * Screen action functions and helpers
     */
    var getWhichItems = function (items, testFunction) {
        return items.filter(function (a) {
            return testFunction(a);
        });
    };
    var moveTarget = function (direction) {
        var offX = midx - player.getX();
        var offY = midy - player.getY();
        var tempX = targetscreen.targetx + direction[0] + offX;
        var tempY = targetscreen.targety + direction[1] + offY;
        if (tempX >= 0 && tempX < swidth) {
            targetscreen.targetx += direction[0];
        }
        if (tempY >= 0 && tempY < sheight) {
            targetscreen.targety += direction[1];
        }
        if (!targetscreen.hasTarget) {
            drawScreen();
            return;
        }
        clearMessages();
        var x = targetscreen.targetx;
        var y = targetscreen.targety;
        if (player.vision[x + ',' + y]) {
            var entity = World.getEntityAt(x, y);
            var items = World.getItemsAt(x, y);
            if (entity && entity.isInvisible(player)) {
                sendMessage(strings.conftext.format(entity.getRepresentation(), entity.getName()));
            } else if (items && items.length) {
                var item = items[0];
                sendMessage(strings.conftext.format(item.getRepresentation(),
                        item.number > 1 ? item.getPlural() : item.getName()));
            } else {
                var here = World.getTile(x, y);
                sendMessage(strings.conftext.format(here.getRepresentation(), here.getDescription()));
            }
        } else {
            sendMessage('Out of range.');
        }
        drawScreen();
    };
    var okAbility = function (selectedItems) {
        var key = Object.keys(selectedItems)[0];
        var item = selectedItems[key];
        return Abilities[item](player);
    };
    var okAim = function (selectedItems) {
        var key = Object.keys(selectedItems)[0];
        var target = selectedItems[key];
        doAim(target, true);
        return false;
    };
    var okBase = function (selected) {
        var selectedItems = {};
        for (var key in selected) {
            selectedItems[key] = itemscreen.items[key];
        }
        if (itemscreen.ok(selectedItems)) {
            doConclude();
            return true;
        }
    };
    var okButcher = function (selectedItems) {
        var key = Object.keys(selectedItems)[0];
        var item = selectedItems[key];
        butcher(item, true);
        return true;
    };
    var okCast = function (selectedSpell) {
        var keys = Object.keys(selectedSpell);
        if (keys.length > 0) {
            var spell = selectedSpell[keys[0]];
            if (Spells[spell].notarget) {
                castSpell(player, spell, [player.x, player.y]);
                return true;
            }
            doCastSpell(spell, true);
            return;
        }
        return true;
    };
    var okCook = function (selectedItems) {
        var key = Object.keys(selectedItems)[0];
        var item = selectedItems[key];
        cook(item, true);
        return true;
    };
    var okDrink = function (selectedItems) {
        var key = Object.keys(selectedItems)[0];
        var item = selectedItems[key];
        drink(player, item);
        return true;
    };
    var okDrop = function (selectedItems) {
        var keys = Object.keys(selectedItems);
        if (keys.length === 1) {
            var item = selectedItems[keys[0]];
            sendMessage("You drop %s.".format(item.number > 1 ? item.getPlural() : item.describeA()));
            player.dropItem(item, World);
            return true;
        } else if (keys.length > 1) {
            for (var i = 0, ii = keys.length; i < ii; i++) {
                player.dropItem(selectedItems[keys[i]], World);
            }
            sendMessage("You drop various items.");
            return true;
        }
        return true;
    };
    var okEat = function (selectedItems) {
        var key = Object.keys(selectedItems)[0];
        var item = selectedItems[key];
        eat(player, item);
        return true;
    };
    var okEmpowerItem = function (selectedItems) {
        var key = Object.keys(selectedItems)[0];
        var target = selectedItems[key];
        if (useMagic(player, itemscreen.item, target)) {
            var sep = false;
            if (target.number > 1) {
                target = target.separateItems();
                sep = true;
            }
            if (sep) {
                player.addItem(target);
            }
        }
        itemscreen.item = null;
        return true;
    };
    var okEnchant = function (selectedItems) {
        var key = Object.keys(selectedItems)[0];
        var target = selectedItems[key];
        var sep = false;
        if (target.number > 1) {
            target = target.separateItems();
            sep = true;
        }
        target.extraDamageType.push(itemscreen.item.extradamt);
        if (itemscreen.item.newinvuln) {
            itemscreen.item.newinvuln.forEach(function (a) {
                target.addInvulnerability(a);
            });
        }
        sendMessage("Your %s has been enchanted.".format(target.getName()));
        target.rename(itemscreen.item.extraName + " " + target.name);
        sendMessage("You now have %s.".format(target.describeA()));
        if (sep) {
            player.addItem(target);
        }
        itemscreen.item = null;
        return true;
    };
    var okExamine = function (selectedItem) {
        var keys = Object.keys(selectedItem);
        if (keys.length > 0) {
            var item = selectedItem[keys[0]];
            sendMessage("<span class='green'>%s</span>: %s".format(item.getName(true), item.getDescription()));
        }
        return true;
    };
    var okLearn = function (selectedSpell) {
        var keys = Object.keys(selectedSpell);
        if (keys.length > 0) {
            var spell = selectedSpell[keys[0]];
            player.learnSpell(spell);
            return true;
        }
        return true;
    };
    var okMagicShoot = function () {
        clearMessages();
        var x = targetscreen.targetx, y = targetscreen.targety;
        if (typeof targetscreen.item === 'string') {
            var spell = targetscreen.item;
            if (Spells[spell].inline) {
                var line = getLine(player.x, player.y, x, y);
                for (var i = 1, j = line.length; i < j; i++) {
                    var point = line[i];
                    var temp = World.getEntityAt(point.x, point.y);
                    var here = World.getTile(point.x, point.y);
                    if (temp && temp.type !== 'player') {
                        castSpell(player, spell, temp);
                        return true;
                    } else if (!here.isWalkable()) {
                        castSpell(player, spell, [point.x, point.y]);
                    }
                }
            }
            castSpell(player, spell, [x, y]);
            return true;
        }
        if (targetscreen.item.hasMixin(Mixins.Aimable)) {
            if (targetscreen.item.charges <= 0) {
                sendMessage("%s has no charges left.".format(targetscreen.item.describeThe(true)));
                return true;
            }
            if (x !== player.x && y !== player.y) {
                var line = getLine(player.x, player.y, x, y);
                for (var i = 1, j = line.length; i < j; i++) {
                    var point = line[i];
                    var temp = World.getEntityAt(point.x, point.y);
                    if (temp && temp.type !== 'player') {
                        aimWand(targetscreen.item, [point.x, point.y], player);
                        return true;
                    }
                }
            }
            aimWand(targetscreen.item, [x, y], player);
        }
        return true;
    };
    var okPickup = function (selectedItems) {
        if (!pickupItems(Object.keys(selectedItems), player, World)) {
            sendMessage("Your inventory is full! You couldn't pick up all the items.");
        } else if (Object.keys(selectedItems).length > 1) {
            sendMessage("You pick up various items.");
        } else {
            var key = Object.keys(selectedItems)[0];
            var item = selectedItems[key];
            sendMessage(strings.pick.format(item.number > 1 ? item.getPlural() : item.describeA()));
        }
        return true;
    };
    var okPoison = function (selectedItems) {
        var key = Object.keys(selectedItems)[0];
        var target = selectedItems[key];
        var sep = false;
        if (target.number > 20) {
            target = target.separateItems(20);
            sep = true;
        }
        target.addMixin(Mixins.Poisonous, {
            poisdam: itemscreen.item.powerStrength,
            poisdur: 50,
            poisstr: 15,
            poischa: 15
        });
        if (target.number > 1) {
            sendMessage("Your %s have been enchanted.".format(target.getPlural()));
        } else {
            sendMessage("Your %s has been enchanted.".format(target.getName()));
        }
        target.rename("poisoned " + target.name);
        target.type = 'pois ' + target.type;
        if (sep) {
            player.addItem(target);
        }
        player.removeSingleItem(itemscreen.item);
        itemscreen.item = null;
        return true;
    };
    var okRead = function (selectedItems) {
        var key = Object.keys(selectedItems)[0];
        var item = selectedItems[key];
        return read(player, item);
    };
    var okRecharge = function (selectedItems) {
        var key = Object.keys(selectedItems)[0];
        var target = selectedItems[key];
        target.recharge(ROT.RNG.getUniformInt(2, 6));
        sendMessage("You recharge %s.".format(target.describeThe()));
        return true;
    };
    var okReload = function (selectedItems) {
        var key = Object.keys(selectedItems)[0];
        var item = selectedItems[key];
        if (player.getAmmo()) {
            if (player.reload(item)) {
                player.removeItem(item);
            } else {
                player.loadAmmo(item);
            }
            sendMessage(strings.ammolo.format(item.number > 1 ? item.getPlural() : item.describeA(),
                player.getAmmos() > 1 ? player.getAmmo().getPlural() : player.getAmmo().describeA()));
            return true;
        } else {
            player.loadAmmo(item);
            sendMessage(strings.ammolo.format(item.number > 1 ? item.getPlural() : item.describeA(),
                player.getAmmos() > 1 ? player.getAmmo().getPlural() : player.getAmmo().describeA()));
            return true;
        }
    };
    var okShoot = function () {
        clearMessages();
        var x = targetscreen.targetx, y = targetscreen.targety;
        var target = World.getEntityAt(x, y);
        var line = getLine(player.getX(), player.getY(), x, y);
        for (var i = 0, j = line.length; i < j; i++) {
            var point = line[i];
            var temp = World.getEntityAt(point.x, point.y);
            if (temp && temp.type !== 'player') {
                shoot(player, temp);
                return true;
            }
            temp = World.getTile(point.x, point.y);
            if (!temp.isWalkable()) {
                sendMessage(strings.ammobr);
                player.ammo.raiseEvent('onBroken', player, [point.x, point.y]);
                player.decreaseAmmos();
                return true;
            }
        }
        if (target) {
            shoot(player, target);
        } else {
            temp = World.getTile(x, y);
            if (temp.isWalkable() && temp.damage === 0) {
                player.putAmmoToGround(World, { x: x, y: y });
            } else {
                sendMessage(strings.ammobr);
            }
            player.decreaseAmmos();
        }
        return true;
    };
    var okSkill = function (selectedSkill) {
        var keys = Object.keys(selectedSkill);
        if (keys.length > 0) {
            var skill = selectedSkill[keys[0]];
            if (skill === "Increase") {
                doIncreaseStats();
                return;
            } else {
                player.addSpecialPower(skill);
                if (!Abilities[skill].usable) {
                    Abilities[skill](player);
                } else {
                    sendMessage("Now you can [u]se the ability %s.".format(skill));
                }
                if (player.plclass === 'wizard' && player.level % 3 === 0) {
                    doLearnSpell();
                    return;
                }
            }
        }
        return true;
    };
    var okTarget = function () {
        if (targetscreen.ok()) {
            isTarget = false;
            doConclude();
            return true;
        }
    };
    var okThrow = function (selectedItems) {
        var key = Object.keys(selectedItems)[0];
        var target = selectedItems[key];
        doThrow(target, true);
        return false;
    };
    var okThrowItem = function () {
        clearMessages();
        var item = targetscreen.item;
        if (item.number > 1) {
            item = item.separateItems(1);
        } else {
            player.removeItem(item);
        }
        var x = targetscreen.targetx, y = targetscreen.targety;
        var target = World.getEntityAt(x, y);
        var line = getLine(player.getX(), player.getY(), x, y);
        for (var i = 0, j = line.length; i < j; i++) {
            var point = line[i];
            var temp = World.getEntityAt(point.x, point.y);
            if (temp && temp.type !== 'player') {
                throwItem(player, temp, item);
                return true;
            }
            temp = World.getTile(point.x, point.y);
            if (!temp.isWalkable()) {
                throwItem(player, [point.x, point.y], item);
                return true;
            }
        }
        if (target) {
            throwItem(player, target, item);
        } else {
            throwItem(player, [x, y], item);
        }
        return true;
    };
    var okWear = function (selectedItems) {
        var key = Object.keys(selectedItems)[0];
        var item = selectedItems[key];
        player.equip(item);
        sendMessage("You are wearing %s now.".format(item.describeA()));
        if (item.hindrance && player.plclass === 'wizard') {
            sendMessage('This will hinder your magical skill.');
        }
        return true;
    };
    var okWield = function (selectedItems) {
        var key = Object.keys(selectedItems)[0];
        var item = selectedItems[key];
        if ((item.isShooting() && player.wieldRanged(item)) || player.equip(item)) {
            sendMessage("You are wielding %s now.".format(item.describeA()));
            if (item.hindrance && player.plclass === 'wizard') {
                sendMessage('This will hinder your magical skill.');
            }
            return true;
        }
        if (!hasMessages()) {
            sendMessage("You can't wield %s.".format(item.describeA()));
        }
        return true;
    };
    //Functions for reacting to player-generated events. Mainly
    var doAbility = function () {
        clearMessages();
        if (isWilderness) {
            sendMessage(strings.onlydun);
            return;
        }
        if (player.hasEffect('confusion')) {
            sendMessage('You are too confused.');
            return;
        }
        var items = player.getSpecialPowers().filter(function (a) {
            return Abilities[a].usable;
        });
        if (items.length > 0) {
            writeItems(items, okAbility, strings.whichw.format('skill', 'use'), false);
            goToSection("items");
        } else {
            sendMessage("You have no skill to use.");
        }
        return items.length > 0;
    };
    var doAim = function (item) {
        isTarget = true;
        backToGame();
        writeTarget(true, okMagicShoot, item);
    };
    var doButcher = function () {
        clearMessages();
        var items = getWhichItems(player.getItems(), function (item) {
            return item && item.hasMixin(Mixins.Butcherable) && !item.butchered && !item.cooked;
        });
        if (items.length > 0) {
            writeItems(items, okButcher, strings.whichw.format('carcass', 'butcher'), false);
            goToSection("items");
        } else {
            sendMessage(strings.notto.format("butcher"));
        }
        return items.length > 0;
    };
    var doCastSpell = function (spell) {
        if (Spells[spell].item) {
            var items = getWhichItems(getEverything(player), function (item) {
                return item && (item.hasMixin(Mixins.Equippable) && item.part === parts.hand1) ||
                    item.hasMixin(Mixins.Shootable);
            });
            if (items.length > 0) {
                writeItems(items, okEmpowerItem, strings.whichw.format('item', 'empower'), false);
                itemscreen.item = spell;
                goToSection("items");
            } else {
                sendMessage(strings.notto.format("empower"));
                backToGame();
            }
            return items.length > 0;
        }
        isTarget = true;
        backToGame();
        writeTarget(true, okMagicShoot, spell);
    };
    var doConclude = function () {
        player.applyEffects();
        if (isWilderness) {
            player.setEnergy(-50);
        } else if (player.hasEffect("berserker")) {
            player.setEnergy(-20);
        } else {
            player.setEnergy(-1);
        }
        if (!isWilderness) {
            Engine.start();
        }
    };
    var doCook = function () {
        clearMessages();
        var items = getWhichItems(player.getItems(), function (item) {
            return item && item.hasMixin(Mixins.Cookable) && !item.cooked;
        });
        if (items.length > 0) {
            writeItems(items, okCook, strings.whichw.format('item', 'cook'), false);
            goToSection("items");
        } else {
            sendMessage(strings.notto.format("cook"));
        }
        return items.length > 0;
    };
    var doDescend = function (up) {
        clearMessages();
        if (!canDescend(up)) {
            if (up && isWilderness) {
                sendMessage("Are you searching for a stairway to heaven? You can't go upwards from here.");
                return false;
            }
            sendMessage("There are no stairs here.");
            return false;
        } else {
            if (isWilderness) {
                return descendStairs(World.getPlace(player.getX(), player.getY()));
            } else {
                return descendStairs();
            }
        }
    };
    var doDrink = function () {
        clearMessages();
        var items = getWhichItems(player.getItems(), function (item) {
            return item && item.hasMixin(Mixins.Drinkable);
        });
        if (items.length > 0) {
            writeItems(items, okDrink, strings.whichw.format('potion', 'drink'), false);
            goToSection("items");
        } else {
            sendMessage(strings.notto.format("drink"));
        }
        return items.length > 0;
    };
    var doDrop = function () {
        clearMessages();
        var items = player.getItems();
        if (items.length > 0) {
            writeItems(items, okDrop, strings.whichw.format('items', 'drop'), true);
            goToSection("items");
        } else {
            sendMessage(strings.notto.format("drop"));
        }
        return items.length > 0;
    };
    var doEat = function () {
        clearMessages();
        var items = getWhichItems(player.getItems(), function (item) {
            return item && item.hasMixin(Mixins.Eatable);
        });
        if (items.length > 0) {
            writeItems(items, okEat, strings.whichw.format('food', 'eat'), false);
            goToSection("items");
        } else {
            sendMessage(strings.notto.format("eat"));
        }
        return items.length > 0;
    };
    var doEnchant = function (extra) {
        clearMessages();
        var items = getWhichItems(getEverything(player), function (item) {
            return item && ((item.hasMixin(Mixins.Equippable) && item.part === parts.hand1) ||
                item.hasMixin(Mixins.Shootable)) && item.extraDamageType.indexOf(extra.extradamt) < 0;
        });
        if (items.length > 0) {
            itemscreen.item = extra;
            writeItems(items, okEnchant, strings.whichw.format('item', 'enchant'), false);
            goToSection("items");
        } else {
            sendMessage(strings.notto.format("enchant"));
            return true;
        }
    };
    var doEquipment = function () {
        clearMessages();
        writeEquip();
        goToSection("stats");
    };
    var doExamine = function () {
        clearMessages();
        var items = player.getItems();
        if (items.length > 0) {
            writeItems(items, okExamine, 'Examine an item', false);
            goToSection("items");
        } else {
            sendMessage(strings.notto.format("examine"));
        }
        return items.length > 0;
    };
    var doIncreaseStats = function () {
        writeLevelup();
        goToSection("levelup");
    };
    var doLearnSpell = function () {
        var list = [];
        if (player.level > 45) {
            list = list.concat(Spells.sixth);
        }
        if (player.level > 36) {
            list = list.concat(Spells.fifth);
        }
        if (player.level > 27) {
            list = list.concat(Spells.fourth);
        }
        if (player.level > 18) {
            list = list.concat(Spells.third);
        }
        if (player.level > 9) {
            list = list.concat(Spells.second);
        }
        list = list.concat(Spells.first);
        var items = getWhichItems(list, function (item) {
            return player.spells.indexOf(item) < 0;
        });
        if (items.length > 0) {
            writeItems(items, okLearn, strings.whichw.format('spell', 'learn'), false);
            goToSection("items");
        } else {
            sendMessage("You can't learn any new spell.");
            return true;
        }
    };
    var doLevelup = function () {
        var items = Abilities[player.plclass].filter(function (a) {
            return !player.hasSpecialPower(a) && (!Abilities[a].minimum || player.level >= Abilities[a].minimum) &&
                (!Abilities[a].prereq || player.getSpecialPowers().indexOf(Abilities[a].prereq) >= 0);
        });
        writeItems(items, okSkill, strings.whichw.format('skill', 'learn'), false, true);
        goToSection("items");
    };
    var doLook = function () {
        clearMessages();
        isTarget = true;
        writeTarget(false);
    };
    var doMagic = function () {
        clearMessages();
        if (!player.hasMixin(Mixins.Spellcaster)) {
            sendMessage("You don't know how to cast spells.");
            return false;
        }
        if (isWilderness) {
            sendMessage(strings.onlydun);
            return false;
        }
        if (player.hasEffect('confusion')) {
            sendMessage('You are too confused.');
            return false;
        }
        var items = getWhichItems(player.spells, function (item) {
            return Spells[item];
        });
        if (items.length > 0) {
            writeItems(items, okCast, strings.whichw.format('spell', 'cast'), false);
            goToSection("items");
        } else {
            sendMessage("You have no spell to cast.");
        }
        return items.length > 0;
    };
    var doMap = function () {
        isMap = true;
        var tw = swidth * wsize, th = sheight * hsize;
        var size = 0;
        if (isWilderness) {
            size = Math.max(Math.floor(tw / World.width), Math.floor(th / World.height));
        } else {
            size = Math.min(Math.floor(tw / World.width), Math.floor(th / World.height));
        }
        hideSection("dialog");
        hideSection("data");
        renderMap(size);
    };
    var doMenu = function () {
        hideSection("dialog");
        goToSection("menu");
    };
    var doMovement = function (direction, world) {
        clearMessages();
        if (isWilderness) {
            if (tryWildMove(player, direction, world)) {
                player.applyEffects();
            } else {
                sendMessage("You can't walk on the water. Yet.");
            }
            drawScreen();
        } else {
            if (tryMove(player, direction, world)) {
                doConclude();
            } else {
                sendMessage("You can't walk through this.");
                writeMessages();
            }
        }
    };
    var doPickup = function () {
        clearMessages();
        var items = World.getItemsAt(player.getX(), player.getY());
        if (!items || items.length === 0) {
            sendMessage("There is nothing here to pick up.");
            return false;
        } else if (items.length === 1) {
            var item = items[0];
            if (pickupItems([0], player, World)) {
                sendMessage(strings.pick.format(item.number > 1 ? item.getPlural() : item.describeA()));
            } else {
                sendMessage("Your inventory is full! Nothing was picked up.");
            }
            doConclude();
            return false;
        } else {
            writeItems(items, okPickup, "What do you want to pick up?", true);
            goToSection("items");
            return true;
        }
    };
    var doPoison = function () {
        clearMessages();
        var items = getWhichItems(player.getItems(), function (item) {
            return item && item.hasMixin(Mixins.Drinkable) && item.power === 'poison';
        });
        if (items.length < 1) {
            sendMessage("You have no bottle of poison with you.");
            return false;
        }
        itemscreen.item = items[0];
        items = getWhichItems(getEverything(player), function (item) {
            return item && item.hasMixin(Mixins.Shootable) && !item.hasMixin(Mixins.Poisonous);
        });
        if (items.length > 0) {
            writeItems(items, okPoison, strings.whichw.format('ammo', 'poison'), false);
            goToSection("items");
        } else {
            sendMessage(strings.notto.format("poison"));
            itemscreen.item = null;
        }
        return false;
    };
    var doRead = function () {
        clearMessages();
        var items = getWhichItems(player.getItems(), function (item) {
            return item && item.hasMixin(Mixins.Readable);
        });
        if (items.length > 0) {
            writeItems(items, okRead, strings.whichw.format('item', 'read'), false);
            goToSection("items");
        } else {
            sendMessage(strings.notto.format("read"));
        }
        return items.length > 0;
    };
    var doRecharge = function () {
        clearMessages();
        var items = getWhichItems(player.getItems(), function (item) {
            return item && item.hasMixin(Mixins.Aimable);
        });
        if (items.length > 0) {
            writeItems(items, okRecharge, strings.whichw.format('item', 'recharge'), false);
            goToSection("items");
        } else {
            sendMessage(strings.notto.format("recharge"));
            return true;
        }
    };
    var doReload = function () {
        clearMessages();
        if (!player.hasMixin(Mixins.Shooter)) {
            sendMessage("You are not a ranged fighter.");
            return false;
        }
        if (!player.getRanged()) {
            sendMessage(strings.notto.format("reload"));
            return false;
        }
        var items = getWhichItems(player.getItems(), function (item) {
            return item && item.hasMixin(Mixins.Shootable);
        });
        if (items.length > 0) {
            writeItems(items, okReload, strings.whichw.format('ammo', 'use'), false);
            goToSection("items");
        } else {
            sendMessage('You have no ammo in your inventory.');
        }
        return items.length > 0;
    };
    var doRune = function () {
        clearMessages();
        isTarget = true;
        writeTarget(true, okRune);
    };
    var doShoot = function () {
        clearMessages();
        if (!player.hasMixin(Mixins.Shooter)) {
            sendMessage("You are not a ranged fighter.");
            return false;
        }
        if (isWilderness) {
            sendMessage(strings.onlydun);
            return false;
        }
        if (!player.getRanged()) {
            sendMessage('You have nothing to shoot with.');
            return false;
        }
        if (player.getAmmos() === 0) {
            sendMessage('You have no ammo.');
            return false;
        }
        isTarget = true;
        writeTarget(true, okShoot);
        return true;
    };
    var doStatistics = function () {
        clearMessages();
        writeStats();
        goToSection("stats");
    };
    var doTakeoff = function () {
        clearMessages();
        if (player.equipment.length > 0) {
            writeTakeoff();
            goToSection("takeoff");
        } else {
            sendMessage(strings.notto.format("take off"));
        }
        return player.equipment.length > 0;
    };
    var doThrow = function (item) {
        isTarget = true;
        backToGame();
        writeTarget(true, okThrowItem, item);
    };
    var doThrowSelect = function () {
        clearMessages();
        if (isWilderness) {
            sendMessage(strings.onlydun);
            return false;
        }
        var items = getWhichItems(player.getItems(), function (item) {
            return item && item.hasMixin(Mixins.Throwable);
        });
        if (items.length > 0) {
            writeItems(items, okThrow, strings.whichw.format('item', 'throw'), false);
            goToSection("items");
        } else {
            sendMessage(strings.notto.format("throw"));
        }
        return items.length > 0;
    };
    var doWandSelect = function () {
        clearMessages();
        if (isWilderness) {
            sendMessage(strings.onlydun);
            return false;
        }
        var items = getWhichItems(player.getItems(), function (item) {
            return item && item.hasMixin(Mixins.Aimable);
        });
        if (items.length > 0) {
            writeItems(items, okAim, strings.whichw.format('wand', 'aim'), false);
            goToSection("items");
        } else {
            sendMessage(strings.notto.format("aim"));
        }
        return items.length > 0;
    };
    var doWear = function () {
        clearMessages();
        var items = getWhichItems(player.getItems(), function (item) {
            return item && item.hasMixin('Equippable') && item.wearable;
        });
        if (items.length > 0) {
            writeItems(items, okWear, strings.whichw.format('item', 'wear'), false);
            goToSection("items");
        } else {
            sendMessage(strings.notto.format("wear"));
        }
        return items.length > 0;
    };
    var doWield = function () {
        clearMessages();
        var items = getWhichItems(player.getItems(), function (item) {
            return item && item.hasMixin(Mixins.Equippable) && (item.getPart() === parts.hand1 ||
                item.getPart() === parts.hand2 || (item.isShooting() && player.hasMixin(Mixins.Shooter)));
        });
        if (items.length > 0) {
            writeItems(items, okWield, strings.whichw.format('weapon', 'wield'), false);
            goToSection("items");
        } else {
            sendMessage(strings.notto.format("wield"));
        }
        return items.length > 0;
    };
    //How to make a class. Or something like that
    var makeWarrior = function () {
        player = makeThing(Templates.player);
        player.rename(nome);
        player.plclass = 'warrior';
        player.strength = 18;
        player.dexterity = 12;
        player.constitution = 17;
        player.intelligence = 8;
        player.wisdom = 10;
        player.charisma = 13;
        player.equip(makeThing(Templates.club));
        player.equip(makeThing(Templates.leatherarm));
        player.recalculateHP();
        startGame();
    };
    var makeRanger = function () {
        player = makeThing(Templates.player);
        player.rename(nome);
        player.plclass = 'ranger';
        player.strength = 12;
        player.dexterity = 18;
        player.constitution = 14;
        player.intelligence = 11;
        player.wisdom = 11;
        player.charisma = 12;
        player.speed = 120;
        player.addMixin(Mixins.Shooter);
        player.equip(makeThing(Templates.dagger));
        player.wieldRanged(makeThing(Templates.shortbow));
        player.loadAmmo(makeThing(Templates.arrow));
        player.recalculateHP();
        startGame();
    };
    var makeWizard = function () {
        player = makeThing(Templates.player);
        player.rename(nome);
        player.plclass = 'wizard';
        player.strength = 9;
        player.dexterity = 12;
        player.constitution = 9;
        player.intelligence = 18;
        player.wisdom = 16;
        player.charisma = 14;
        player.speed = 80;
        player.equip(makeThing(Templates.staff));
        player.recalculateHP();
        player.addMixin(Mixins.Spellcaster);
        player.learnSpell(Spells.first.random());
        player.learnSpell(Spells.first.filter(function (a) {
            return player.spells.indexOf(a) < 0;
        }).random());
        startGame();
    };

    /*
     * Screens and HTML management
     */
    var showSection = function (sectionId) {
        document.getElementById(sectionId).style.display = 'block';
        if (sectionId === 'stats' || sectionId === 'aiuto' || sectionId === 'classe' ||
            sectionId === 'items' || sectionId === 'takeoff' || sectionId === 'menu') {
            document.getElementById("omega").classList.add("centered");
        }
    };
    var hideSection = function (sectionId) {
        document.getElementById(sectionId).style.display = 'none';
    };
    var hideEverything = function () {
        sectID.forEach(function (a) {
            hideSection(a);
        });
    };
    var isSectionVisible = function (sectionId) {
        return document.getElementById(sectionId).style.display === 'block';
    };
    var goToSection = function (sectionId) {
        hideEverything();
        showSection(sectionId);
    };
    var setName = function () {
        nome = 'player';
        goToSection('nome');
    };
    var getName = function () {
        var elem = document.getElementById('name');
        var temp = elem.value;
        temp ? nome = temp : nome = 'player';
        elem.value = '';
        goToSection('classe');
    };
    var startGame = function () {
        window.addEventListener('resize', resizeScreen, false);
        document.getElementById("omega").classList.remove("centered");
        goToSection("gioco");
        openNewGame();
        resizeScreen();
    };
    var backToGame = function (evt) {
        if (evt) {
            evt.stopImmediatePropagation();
        }
        document.getElementById("omega").classList.remove("centered");
        goToSection('gioco');
        showSection("data");
        drawScreen();
    };
    var reloadGame = function () {
        nome = 'player';
        Engine.init();
        clearMessages();
        player = null;
        World.init();
        necro = '';
        savedGame = {};
        isUp = false, isWilderness = false, isTarget = false;
        goToSection("intro");
        //document.location.reload();
    };
    var performFuneral = function (isSuicide) {
        if (isSuicide) {
            necro = strings.dundeath.format(player.getName(), player.plclass, World.lvl, World.name) +
                    " killed by acute boredom.";
        }
        deleteSavedGame();
        document.getElementById("necro").innerHTML = necro;
        clearMessages();
        goToSection("morte");
    };
    var celebrateVictory = function () {
        document.getElementById("winner").innerHTML = player.getName();
        document.getElementById("winclass").innerHTML = player.plclass;
        clearMessages();
        deleteSavedGame();
        goToSection("vittoria");
    };
    var quitGame = function () {
        if (savedGame["Avernus"]) {
            celebrateVictory();
        } else {
            performFuneral(true);
        }
    };

    var getEventPosition = function (evt) {
        if (evt.touches) {
            var x = evt.touches[0].clientX;
            var y = evt.touches[0].clientY;
        } else {
            var x = evt.clientX;
            var y = evt.clientY;
        }
        var place = document.getElementById("screen");
        var bb = place.getBoundingClientRect();
        x -= bb.left;
        y -= bb.top;
        if (x < 0 || y < 0 || x >= place.clientWidth || y >= place.clientHeight) {
            return [-1, -1];
        }
        return [Math.floor(x / wsize), Math.floor(y / hsize)];
    };
    var setRelativeCentre = function () {
        return [midx - player.x, midy - player.y];
    };
    var manageClassEvents = function (key) {
        switch (key) {
            case keys.VK_A:
                makeWarrior();
                break;
            case keys.VK_B:
                makeRanger();
                break;
            case keys.VK_C:
                makeWizard();
                break;
        }
    };
    var manageGameKeyEvents = function (key) {
        if (!player.isAlive()) {
            if (key.keyCode === keys.VK_RETURN) {
                performFuneral();
            }
            return;
        }
        if (isMap) {
            if (key.keyCode === keys.VK_ESCAPE || key.keyCode === keys.VK_SPACE) {
                isMap = false;
                if (!isWilderness) {
                    showSection('data');
                }
                drawScreen();
            }
            return;
        }
        switch (key.keyCode) {
            case keys.VK_1:
            case keys.VK_NUMPAD1:
            case keys.VK_END:
                doMovement(dir.SW, World);
                break;
            case keys.VK_2:
            case keys.VK_NUMPAD2:
            case keys.VK_DOWN:
                doMovement(dir.S, World);
                break;
            case keys.VK_3:
            case keys.VK_NUMPAD3:
            case keys.VK_PAGE_DOWN:
                doMovement(dir.SE, World);
                break;
            case keys.VK_4:
            case keys.VK_NUMPAD4:
            case keys.VK_LEFT:
                doMovement(dir.W, World);
                break;
            case keys.VK_5:
            case keys.VK_NUMPAD5:
            case keys.VK_PERIOD:
                clearMessages();
                doConclude();
                break;
            case keys.VK_6:
            case keys.VK_NUMPAD6:
            case keys.VK_RIGHT:
                doMovement(dir.E, World);
                break;
            case keys.VK_7:
            case keys.VK_NUMPAD7:
            case keys.VK_HOME:
                doMovement(dir.NW, World);
                break;
            case keys.VK_8:
            case keys.VK_NUMPAD8:
            case keys.VK_UP:
                doMovement(dir.N, World);
                break;
            case keys.VK_9:
            case keys.VK_NUMPAD9:
            case keys.VK_PAGE_UP:
                doMovement(dir.NE, World);
                break;
            case keys.VK_A:
                doWandSelect();
                break;
            case keys.VK_B:
                doButcher();
                break;
            case keys.VK_C:
                doCook();
                break;
            case keys.VK_D:
                doDrop();
                break;
            case keys.VK_E:
                if (key.shiftKey) {
                    doEquipment();
                } else {
                    doEat();
                }
                break;
            case keys.VK_G:
            case keys.VK_COMMA:
                doPickup();
                break;
            case keys.VK_I:
                doExamine();
                break;
            case keys.VK_L:
                if (key.shiftKey) {
                    doLook();
                } else {
                    doReload();
                }
                break;
            case keys.VK_M:
                doMagic();
                //if (key.shiftKey) {
                //    doMap();
                //    return;
                //} else {
                //    doMagic();
                //}
                break;
            case keys.VK_P:
                doStatistics();
                break;
            case keys.VK_Q:
                if (key.ctrlKey) {
                    quitGame();
                } else {
                    doDrink();
                }
                break;
            case keys.VK_R:
                doRead();
                break;
            case keys.VK_S:
                if (key.shiftKey) {
                    clearMessages();
                    save();
                    sendMessage("Game saved.");
                } else {
                    doShoot();
                }
                break;
            case keys.VK_T:
                if (key.shiftKey) {
                    doTakeoff();
                } else {
                    doThrowSelect();
                }
                break;
            case keys.VK_U:
                doAbility();
                break;
            case keys.VK_W:
                if (key.shiftKey) {
                    doWear();
                } else {
                    doWield();
                }
                break;
            case keys.VK_DELETE:
                deleteSavedGame();
                break;
            case keys.VK_ESCAPE:
                save();
                clearMessages();
                goToSection('intro');
                break;
            case keys.VK_RETURN:
                doMenu();
                break;
        }
        drawScreen();
    };
    var manageGameKeyPressEvents = function (chara) {
        if (chara === '>') {
            isUp = false;
            if (!doDescend(isUp)) {
                redraw();
            }
        } else if (chara === '<') {
            isUp = true;
            if (!doDescend(isUp)) {
                redraw();
            }
        } else if (chara === '?') {
            goToSection('aiuto');
        }
    };
    var manageItemEvents = function (key) {
        if ((key === keys.VK_ESCAPE || key === keys.VK_SPACE) && !itemscreen.mustchoose) {
            return true;
        } else if (key === keys.VK_RETURN && itemscreen.multiselect &&
            Object.keys(itemscreen.selected).length > 0) {
            return okBase(itemscreen.selected);
        } else if (key >= keys.VK_A && key <= keys.VK_Z) {
            var index = key - keys.VK_A;
            if (itemscreen.items[index]) {
                if (itemscreen.multiselect) {
                    if (itemscreen.selected[index]) {
                        delete itemscreen.selected[index];
                    } else {
                        itemscreen.selected[index] = true;
                    }
                    document.getElementById("item" + index).classList.toggle("selected");
                } else {
                    itemscreen.selected[index] = true;
                    return okBase(itemscreen.selected);
                }
            }
        }
    };
    var manageLevelupEvents = function (key) {
        var result = false;
        switch (key) {
            case keys.VK_A:
                player.strength++;
                sendMessage(strings.charchange.format("stronger"));
                result = true;
                break;
            case keys.VK_B:
                player.dexterity++;
                sendMessage(strings.charchange.format("nimbler"));
                result = true;
                break;
            case keys.VK_C:
                player.constitution++;
                player.recalculateHP();
                sendMessage(strings.charchange.format("tougher"));
                result = true;
                break;
            case keys.VK_D:
                player.intelligence++;
                sendMessage(strings.charchange.format("more clever"));
                result = true;
                break;
            case keys.VK_E:
                player.wisdom++;
                sendMessage(strings.charchange.format("wiser"));
                result = true;
                break;
            case keys.VK_F:
                player.charisma++;
                sendMessage(strings.charchange.format("more confident"));
                result = true;
                break;
        }
        if (result) {
            if (player.hasMixin(Mixins.Spellcaster) && player.level % 3 === 0) {
                doLearnSpell();
            } else {
                return true;
            }
        }
    };
    var manageTakeoffEvents = function (key) {
        var temp = null;
        switch (key) {
            case keys.VK_A:
                temp = player.getPart(parts.hand1);
                if (temp) {
                    sendMessage(strings.remostr.format(temp.getName()));
                    player.unequip(temp);
                    doConclude();
                } else {
                    sendMessage(strings.noremo.format("main weapon"));
                }
                return true;
            case keys.VK_B:
                temp = player.getPart(parts.hand2);
                if (temp) {
                    sendMessage(strings.remostr.format(temp.getName()));
                    player.unequip(temp);
                    doConclude();
                } else {
                    sendMessage(strings.noremo.format("secondary weapon"));
                }
                return true;
            case keys.VK_C:
                temp = player.getPart(parts.body);
                if (temp) {
                    sendMessage(strings.remostr.format(temp.getName()));
                    player.unequip(temp);
                    doConclude();
                } else {
                    sendMessage(strings.noremo.format("armour"));
                }
                return true;
            case keys.VK_D:
                temp = player.getPart(parts.head);
                if (temp) {
                    sendMessage(strings.remostr.format(temp.getName()));
                    player.unequip(temp);
                    doConclude();
                } else {
                    sendMessage(strings.noremo.format("helm"));
                }
                return true;
            case keys.VK_E:
                temp = player.getPart(parts.neck);
                if (temp) {
                    sendMessage(strings.remostr.format(temp.getName()));
                    player.unequip(temp);
                    doConclude();
                } else {
                    sendMessage(strings.noremo.format("neck item"));
                }
                return true;
            case keys.VK_F:
                temp = player.getPart(parts.feet);
                if (temp) {
                    sendMessage(strings.remostr.format(temp.getName()));
                    player.unequip(temp);
                    doConclude();
                } else {
                    sendMessage(strings.noremo.format("footwear"));
                }
                return true;
            case keys.VK_G:
                if (!player.hasMixin(Mixins.Shooter)) {
                    break;
                }
                if (player.getRanged()) {
                    sendMessage(strings.remostr.format(player.getRanged().getName()));
                    player.unwieldRanged();
                    doConclude();
                } else {
                    sendMessage(strings.noremo.format("ranged weapon"));
                }
                return true;
            case keys.VK_H:
                if (!player.hasMixin(Mixins.Shooter)) {
                    break;
                }
                if (player.getAmmo()) {
                    sendMessage(strings.remostr.format(player.getAmmo().getName()));
                    player.removeAmmo();
                    doConclude();
                } else {
                    sendMessage(strings.noremo.format("ammo"));
                }
                return true;
            case keys.VK_SPACE:
            case keys.VK_ESCAPE:
                return true;
            default:
                return false;
        }
    };
    var manageTargetEvents = function (key) {
        switch (key) {
            case keys.VK_1:
            case keys.VK_NUMPAD1:
            case keys.VK_END:
                moveTarget(dir.SW);
                break;
            case keys.VK_2:
            case keys.VK_NUMPAD2:
            case keys.VK_DOWN:
                moveTarget(dir.S);
                break;
            case keys.VK_3:
            case keys.VK_NUMPAD3:
            case keys.VK_PAGE_DOWN:
                moveTarget(dir.SE);
                break;
            case keys.VK_4:
            case keys.VK_NUMPAD4:
            case keys.VK_LEFT:
                moveTarget(dir.W);
                break;
            case keys.VK_6:
            case keys.VK_NUMPAD6:
            case keys.VK_RIGHT:
                moveTarget(dir.E);
                break;
            case keys.VK_7:
            case keys.VK_NUMPAD7:
            case keys.VK_HOME:
                moveTarget(dir.NW);
                break;
            case keys.VK_8:
            case keys.VK_NUMPAD8:
            case keys.VK_UP:
                moveTarget(dir.N);
                break;
            case keys.VK_9:
            case keys.VK_NUMPAD9:
            case keys.VK_PAGE_UP:
                moveTarget(dir.NE);
                break;
            case keys.VK_ESCAPE:
                isTarget = false;
                clearMessages();
                drawScreen();
                break;
            case keys.VK_RETURN:
                return okTarget();
        }
    };
    var clearScreen = function (context, wsize, hsize) {
        context.fillStyle = "black";
        context.fillRect(0, 0, swidth * wsize, sheight * hsize);
    };
    var drawBar = function (context, whose, x, y, wsize) {
        var len = wsize - 4;
        if (whose.maxhp === whose.hp) {
            context.fillStyle = "rgba(0, 255, 0, .6)";
            context.fillRect(x + 2, y + 1, len, 4);
        } else if (whose.hp < 1) {
            context.fillStyle = "rgba(255, 0, 0, .6)";
            context.fillRect(x + 2, y + 1, len, 4);
        } else {
            var greenlen = Math.ceil((whose.hp / whose.maxhp) * len);
            context.fillStyle = "rgba(255, 0, 0, .6)";
            context.fillRect(x + 2, y + 1, len, 4);
            context.fillStyle = "rgba(0, 255, 0, .6)";
            context.fillRect(x + 2, y + 1, greenlen, 4);
        }
    }
    var drawText = function (context, chara, colour, x, y, wsize, hsize) {
        var halfx = Math.floor(wsize / 2), halfy = Math.floor(hsize / 2);
        context.font = "bold " + sfont + "px Times, serif";
        context.fillStyle = colour;
        context.textAlign = "center";
        context.textBaseline = "middle";
        context.fillText(chara, x * wsize + halfx, y * hsize + halfy);
    };
    var drawTile = function (context, colour, x, y, wsize, hsize) {
        context.fillStyle = colour;
        context.fillRect(x * wsize, y * hsize, wsize, hsize);
    };
    var drawFace = function (context, face, x, y, wsize, hsize) {
        drawTile(context, face.bg, x, y, wsize, hsize);
        drawText(context, face.ch, face.fg, x, y, wsize, hsize);
    };
    var renderMap = function (size) {
        clearScreen(context, wsize, hsize);
        for (var x = 0; x < World.width; x++) {
            for (var y = 0; y < World.height; y++) {
                var face = isWilderness ? World.getWildFace(x, y) : World.getTile(x, y);
                drawTile(context, face.bg, x, y, size, size);
            }
        }
    };
    var renderTiles = function (context, wsize, hsize) {
        clearScreen(context, wsize, hsize);
        var temp = setRelativeCentre();
        var visibleCells = player.look(World);
        for (var key in visibleCells) {
            var parts = key.split(",");
            var x = parseInt(parts[0], 10), dx = x + temp[0];
            var y = parseInt(parts[1], 10), dy = y + temp[1];
            var face = World.getFace(x, y, player);
            var ent = World.getEntityAt(x, y);
            drawFace(context, face, dx, dy, wsize, hsize);
            if (ent && !ent.isInvisible(player) && ent.hp < ent.maxhp) {
                drawBar(context, ent, dx * wsize, dy * hsize, wsize);
            }
        }
        if (isTarget) {
            drawText(context, 'X', 'magenta', targetscreen.targetx + temp[0], targetscreen.targety + temp[1], wsize, hsize);
            var what = targetscreen.item;
            if (Spells[what] && Spells[what].area) {
                var area = World.getTilesWithinRadius(targetscreen.targetx, targetscreen.targety, Spells[what].area);
                var colour = "rgba(200,200,0,.4)";
                if (/acid/i.test(what)) {
                    colour = "rgba(0,200,0,.4)";
                } else if (/fire/i.test(what)) {
                    colour = "rgba(200,0,0,.4)";
                } else if (/thunder/i.test(what) || /light/i.test(what)) {
                    colour = "rgba(200,200,0,.4)";
                } else if (/ice/i.test(what)) {
                    colour = "rgba(255,255,255,.4)";
                }
                if (area.length) {
                    area.forEach(function (a) {
                        drawTile(context, colour, a.x + temp[0], a.y + temp[1], wsize, hsize);
                    });
                }
            } else if ((Spells[what] && Spells[what].inline) ||
                (targetscreen.hasTarget && (!what || (typeof what !== 'string' && what.hasMixin(Mixins.Throwable))))) {
                var path = getLine(player.x, player.y, targetscreen.targetx, targetscreen.targety);
                path.pop();
                path.shift();
                if (path.length > 0) {
                    path.forEach(function (a) {
                        drawText(context, '*', 'magenta', a.x + temp[0], a.y + temp[1], wsize, hsize);
                    });
                }
            }
        }
    };
    var renderWilderness = function (context, wsize, hsize) {
        var propoX = player.x - midx;
        var propoY = player.y - midy;
        for (var x = 0; x < swidth; x++) {
            for (var y = 0; y < sheight; y++) {
                var face = World.getWildFace(x + propoX, y + propoY);
                drawTile(context, face.bg, x, y, wsize, hsize);
                if (face.ch) {
                    drawText(context, face.ch, face.fg, x, y, wsize, hsize);
                }
            }
        }
    };
    var redraw = function () {
        if (hasMessages()) {
            writeMessages();
        }
        if (!isWilderness && !isTarget) {
            writeInfo();
        }
    };
    var drawScreen = function () {
        if (isWilderness) {
            renderWilderness(context, wsize, hsize);
        } else {
            renderTiles(context, wsize, hsize);
        }
        redraw();
    };
    var writeEquip = function () {
        document.getElementById("tit").innerHTML = "Your equipment";
        var text = "Main weapon: %s".format(player.getHand1() ? player.getHand1().getName(true) : 'Nothing') + "<br>" +
            "Secondary weapon: %s".format(player.getHand2() ? player.getHand2().getName(true) : 'Nothing') + "<br>" +
            "Armour: %s".format(player.getBody() ? player.getBody().getName(true) : 'Nothing') + "<br>" +
            "On head: %s".format(player.getPart(parts.head) ? player.getPart(parts.head).getName(true) : 'Nothing') + "<br>" +
            "Around the neck: %s".format(player.getPart(parts.neck) ? player.getPart(parts.neck).getName(true) : 'Nothing') + "<br>" +
            "On feet: %s".format(player.getPart(parts.feet) ? player.getPart(parts.feet).getName(true) : 'Nothing');
        if (player.hasMixin(Mixins.Shooter)) {
            text += "<br>" + "Ranged weapon: %s".format(player.getRanged() ? player.getRanged().getName(true) :
                'Nothing') + "<br>" +
                "Ammo: %s".format(player.getAmmo() ? player.getAmmo().getName(true) + " (" + player.getAmmos() + ")" : 'None');
        }
        document.getElementById("stuff").innerHTML = text;
    };
    var writeItems = function (items, okFunction, caption, multiselect, mustchoose) {
        var i = 0, j = 0;
        var prefix = null, suffix = null, letter = null, tid = null;
        var letters = 'abcdefghijklmnopqrstuvwxyz';
        itemscreen.ok = okFunction;
        itemscreen.multiselect = multiselect;
        itemscreen.mustchoose = mustchoose || false;
        itemscreen.items = items;
        itemscreen.selected = {};
        document.getElementById("itemtit").innerHTML = caption;
        for (i = 0; i < 26; i++) {
            tid = "item" + i;
            hideSection(tid);
            document.getElementById(tid).classList.remove("selected");
        }
        for (i = 0, j = items.length; i < j; i++) {
            var item = items[i];
            if (item) {
                letter = letters[i];
                tid = "item" + i;
                if (typeof item === 'string') {
                    document.getElementById(tid).innerHTML = letter + ') ' + item;
                    if (Spells[item] && Spells[item].desc) {
                        document.getElementById(tid).innerHTML += strings.spelldesc.format(Spells[item].desc);
                    } else if (Abilities[item] && Abilities[item].desc) {
                        document.getElementById(tid).innerHTML += strings.spelldesc.format(Abilities[item].desc);
                    }
                } else {
                    prefix = ' ';
                    suffix = '';
                    prefix += item.getNumber() > 1 ? item.getPlural() : item.getName();
                    if (player.equipment.indexOf(item) >= 0) {
                        suffix = " (in use)";
                    }
                    document.getElementById(tid).innerHTML = letter + ') ' + prefix + suffix;
                }
                showSection(tid);
            }
        }
        if (multiselect) {
            showSection("sayok");
        } else {
            hideSection("sayok");
        }
        if (mustchoose) {
            hideSection("back1");
        } else {
            showSection("back1");
        }
    };
    var writeLevelup = function () {
        document.getElementById("lutit").innerHTML = "You can increase one of your characteristics";
        document.getElementById("ch0").innerHTML = "a) Strength: " + player.strength;
        document.getElementById("ch1").innerHTML = "b) Dexterity: " + player.dexterity;
        document.getElementById("ch2").innerHTML = "c) Constitution: " + player.constitution;
        document.getElementById("ch3").innerHTML = "d) Intelligence: " + player.intelligence;
        document.getElementById("ch4").innerHTML = "e) Wisdom: " + player.wisdom;
        document.getElementById("ch5").innerHTML = "f) Charisma: " + player.charisma;
    };
    var writeStats = function () {
        document.getElementById("tit").innerHTML = player.getName() + " the " + player.plclass;
        var text = "Level: " + strings.whiteln.format(player.getLevel()) + "<br>" + (player.level < 50 ?
            "Experience: <span class='white'>%s/%s</span>".format(player.getExperience(), player.getNextLevelXP()) :
            "Experience: " + strings.whiteln.format(player.getExperience())) + "<br>" +
            "Strength: " + strings.bonusln.format(player.strength, getBonus(player.strength)) + "<br>" +
            "Dexterity: " + strings.bonusln.format(player.dexterity, getBonus(player.dexterity)) + "<br>" +
            "Constitution: " + strings.bonusln.format(player.constitution, getBonus(player.constitution)) + "<br>" +
            "Intelligence: " + strings.bonusln.format(player.intelligence, getBonus(player.intelligence)) + "<br>" +
            "Wisdom: " + strings.bonusln.format(player.wisdom, getBonus(player.wisdom)) + "<br>" +
            "Charisma: " + strings.bonusln.format(player.charisma, getBonus(player.charisma)) + "<br>" +
            "Bonus to melee attack: " + strings.whiteln.format(player.getAttackValue()) + "<br>" +
            "Bonus to defence: " + strings.whiteln.format(player.getDefence()) + "<br>" +
            "Damage per melee attack: " + strings.whiteln.format(writeDamage(player)) + "<br>" +
            "Attacks per round: " + strings.whiteln.format(player.attackPerRound);
        if (player.hasMixin(Mixins.Spellcaster)) {
            text += "<br>Hindrance: " + strings.whiteln.format(player.getEquipmentBonus('hind')) +
                "<br>Known spells: " + strings.whiteln.format(player.spells.length);
        }
        text += "<br>Resistant to: " + strings.whiteln.format(player.getResistances().join(", ") || "Nothing") +
            "<br>Invulnerable to: " + strings.whiteln.format(player.getInvulnerabilities().join(", ") || "Nothing") +
            "<br>Very vulnerable to: " + strings.whiteln.format(player.getVulnerables().join(", ") || "Nothing");
        document.getElementById("stuff").innerHTML = text;
    };
    var writeTakeoff = function () {
        //document.getElementById("totit").innerText = "Which equipped item do you want to take off?";
        document.getElementById("ton0").innerHTML = player.getHand1() ? player.getHand1().getName(true) : 'None';
        document.getElementById("ton1").innerHTML = player.getHand2() ? player.getHand2().getName(true) : 'None';
        document.getElementById("ton2").innerHTML = player.getBody() ? player.getBody().getName(true) : 'None';
        document.getElementById("ton3").innerHTML = player.getPart(parts.head) ? player.getPart(parts.head).getName(true) :
            'Nothing';
        document.getElementById("ton4").innerHTML = player.getPart(parts.neck) ? player.getPart(parts.neck).getName(true) :
            'Nothing';
        document.getElementById("ton5").innerHTML = player.getPart(parts.feet) ? player.getPart(parts.feet).getName(true) :
            'Nothing';
        if (player.hasMixin(Mixins.Shooter)) {
            document.getElementById("ton6").innerHTML = player.getRanged() ?
                player.getRanged().getName(true) : 'None';
            document.getElementById("ton7").innerHTML = player.getAmmo() ?
                player.getAmmo().getName(true) + " (" + player.getAmmos() + ")" : 'None';
        } else {
            hideSection("to6");
            hideSection("to7");
        }
    };
    var writeTarget = function (hasTarget, okFunction, item) {
        targetscreen.targetx = player.x;
        targetscreen.targety = player.y;
        targetscreen.hasTarget = hasTarget;
        targetscreen.ok = okFunction;
        targetscreen.item = item;
        if (hasTarget) {
            sendMessage("Click on your target or move the X over it.");
        }
        infoplay.innerHTML = "<p>Click here or press [Esc] to exit</p>";
        drawScreen();
    };

    /*
     * Display management
     */
    var addClickListeners = function (id, key, action) {
        document.getElementById(id).addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (action(key)) {
                backToGame();
            }
        }, false);
    };
    var setDimensions = function (ww, wh) {
        var canvas = document.getElementById("screen");
        swidth = Math.floor(ww / wsize) - 1;
        sheight = Math.floor(wh / hsize);
        canvas.width = swidth * wsize;
        canvas.height = sheight * hsize;
    };
    var setFonts = function (width, height) {
        if (width > 1000 && height > 400) {
            sfont = 27;
            hsize = 35;
            wsize = 30;
        } else {
            sfont = 23;
            hsize = 30;
            wsize = 25;
        }
    };
    var resizeScreen = function () {
        var ww = window.innerWidth;
        var wh = window.innerHeight;
        setFonts(ww, wh);
        setDimensions(ww, wh);
        midx = Math.floor(swidth / 2);
        midy = Math.ceil(sheight / 2);
        if (isSectionVisible("gioco")) {
            drawScreen();
        }
    };

    /*
     * Starting the game
     */
    var handleCache = function () {
        function status(msg) {
            console.log(msg);
        }
        window.applicationCache.onchecking = function () {
            status("Checking for a new version.");
            return false;
        };
        window.applicationCache.onnoupdate = function () {
            status("This version is up-to-date.")
            return false;
        };
        window.applicationCache.ondownloading = function () {
            status("Downloading new version...");
            window.progresscount = 0; // Used in the progress handler below
            return false;
        };
        window.applicationCache.onprogress = function (e) {
            var progress = "";
            if (e && e.lengthComputable) {
                progress = " " + Math.round(100 * e.loaded / e.total) + "%";
            } else {
                progress = " (" + ++progresscount + ")";
            }
            status("Downloading new version" + progress);
            return false;
        };
        window.applicationCache.oncached = function () {
            status("This application is now cached locally.");
            return false;
        };
        window.applicationCache.onupdateready = function () {
            status("A new version has been downloaded. Reloading.");
            document.location.reload();
            return false;
        };
        window.applicationCache.onerror = function () {
            status("Couldn't load manifest or cache application");
            return false;
        };
        window.applicationCache.onobsolete = function () {
            status("This application is no longer cached. " +
            "Reload to get the latest version from the network.");
            document.location.reload();
            return false;
        };
    };
    var setEvents = function () {
        document.getElementById('introb').addEventListener('pointerdown', function () {
            if (canLoad()) {
                startGame();
            } else {
                setName();
            }
        }, false);
        document.getElementById("warrior").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            manageClassEvents(ROT.VK_A);
        }, false);
        document.getElementById("ranger").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            manageClassEvents(ROT.VK_B);
        }, false);
        document.getElementById("wizard").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            manageClassEvents(ROT.VK_C);
        }, false);
        document.getElementById('vittoriab').addEventListener('pointerdown', reloadGame, false);
        document.getElementById('morteb').addEventListener('pointerdown', reloadGame, false);
        document.getElementById('via').addEventListener('click', function (evt) {
            evt.stopImmediatePropagation();
            getName();
        }, true);
        document.getElementById('back').addEventListener('pointerdown', function (evt) {
            backToGame(evt);
        }, false);
        document.getElementById('back1').addEventListener('pointerdown', function (evt) {
            backToGame(evt);
        }, false);
        document.getElementById('back2').addEventListener('pointerdown', function (evt) {
            backToGame(evt);
        }, false);
        document.getElementById('sayok').addEventListener('pointerdown', function (evt) {
            if (manageItemEvents(ROT.VK_RETURN)) {
                backToGame(evt);
                refresh();
            }
        }, false);
        document.getElementById('stats').addEventListener('pointerdown', function (evt) {
            backToGame(evt);
        }, false);
        document.getElementById("dialog").addEventListener("pointerdown", function (evt) {
            if (isTarget && targetscreen.hasTarget) {
                evt.stopImmediatePropagation();
                okTarget();
            }
        }, false);
        document.getElementById("gioco").addEventListener("pointermove", function (evt) {
            if (isTarget || !player.isAlive()) {
                return;
            }
            var where = getEventPosition(evt);
            var ex = where[0], ey = where[1];
            if (ex === -1 || ey === -1) {
                return;
            }
            var temp = setRelativeCentre();
            var dx = ex - temp[0];
            var dy = ey - temp[1];
            if (!player.vision[dx + ',' + dy]) {
                return;
            }
            var entity = World.getEntityAt(dx, dy);
            var items = World.getItemsAt(dx, dy);
            var place = World.getTile(dx, dy);
            var text = false;
            if (entity && !entity.isInvisible(player)) {
                clearMessages();
		String.
                text = String.format('%s - %s (HP %s): %s',
                        entity.getRepresentation(),
                        entity.getName(),
                        entity.getHealth(),
                        entity.getDescription());
            } else if (items && items.length) {
                clearMessages();
                var item = items[0];
                text = String.format('%s - %s: %s',
                        item.getRepresentation(),
                        item.number > 1 ? item.getPlural() : item.getName(),
                        item.getDescription());
            } else if (place !== Templates.floorTile) {
                text = place.getDescription();
            }
            if (text) {
                clearMessages();
                sendMessage(text);
                redraw();
            }
        }, false);
        document.getElementById("gioco").addEventListener("pointerdown", function (evt) {
            if (!player.isAlive()) {
                performFuneral();
                return;
            }
            var where = getEventPosition(evt);
            var ex = where[0], ey = where[1];
            if (ex === -1 || ey === -1) {
                return;
            }
            if (!isTarget) {
                if (ex === midx && ey === midy) {
                    doMenu();
                    return;
                }
                clearMessages();
                var thirdw = Math.floor(swidth / 3);
                var thirdh = Math.floor(sheight / 3);
                if (ex <= thirdw) {
                    if (ey <= thirdh) {
                        doMovement(dir.NW, World);
                    } else if (ey >= sheight - thirdh) {
                        doMovement(dir.SW, World);
                    } else {
                        doMovement(dir.W, World);
                    }
                } else if (ex >= swidth - thirdw) {
                    if (ey <= thirdh) {
                        doMovement(dir.NE, World);
                    } else if (ey >= sheight - thirdh) {
                        doMovement(dir.SE, World);
                    } else {
                        doMovement(dir.E, World);
                    }
                } else {
                    if (ey <= thirdh) {
                        doMovement(dir.N, World);
                    } else if (ey >= sheight - thirdh) {
                        doMovement(dir.S, World);
                    } else {
                        doConclude();
                    }
                }
            } else {
                var temp = setRelativeCentre();
                var dx = ex - temp[0];
                var dy = ey - temp[1];
                targetscreen.targetx = dx;
                targetscreen.targety = dy;
                if (targetscreen.hasTarget) {
                    var entity = World.getEntityAt(dx, dy);
                    var items = World.getItemsAt(dx, dy);
                    var place = World.getTile(dx, dy);
                    if (entity) {
                        clearMessages();
                        sendMessage(strings.conftext.format(entity.getRepresentation(), entity.getName()));
                    } else if (items && items.length) {
                        clearMessages();
                        var item = items[0];
                        sendMessage(strings.conftext.format(item.getRepresentation(), item.number > 1 ?
                            item.getPlural() : item.getName()));
                    } else if (place !== Templates.floorTile) {
                        clearMessages();
                        sendMessage(strings.conftext.format(place.getRepresentation(), place.getDescription()));
                    }
                }
                drawScreen();
            }
        }, false);
        document.getElementById("data").addEventListener("pointerdown", function (evt) {
            if (isTarget) {
                evt.stopImmediatePropagation();
                isTarget = false;
            }
        }, false);
        for (var i = 0; i < 26; i++) {
            addClickListeners("item" + i, keys.VK_A + i, manageItemEvents);
        }
        for (var i = 0; i < 6; i++) {
            addClickListeners("ch" + i, keys.VK_A + i, manageLevelupEvents);
        }
        for (var i = 0; i < 8; i++) {
            addClickListeners("to" + i, keys.VK_A + i, manageTakeoffEvents);
        }
        document.getElementById("menuesc").addEventListener("pointerdown", function (evt) {
            backToGame(evt);
        }, false);
        document.getElementById("menusave").addEventListener("pointerdown", function (evt) {
            clearMessages();
            save();
            sendMessage("Game saved.");
            backToGame(evt);
        }, false);
        document.getElementById("menuhelp").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            goToSection("aiuto");
        }, false);
        document.getElementById("menuequ").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            doEquipment();
        }, false);
        document.getElementById("menuinv").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doExamine()) {
                backToGame();
            }
        }, false);
        document.getElementById("menulook").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            doLook();
        }, false);
        //document.getElementById("menumap").addEventListener("pointerdown", function (evt) {
        //    evt.stopImmediatePropagation();
        //    doMap();
        //}, false);
        document.getElementById("menustat").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            doStatistics();
        }, false);
        document.getElementById("menuaim").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doWandSelect()) {
                backToGame();
            }
        }, false);
        document.getElementById("menubut").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doButcher()) {
                backToGame();
            }
        }, false);
        document.getElementById("menucook").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doCook()) {
                backToGame();
            }
        }, false);
        document.getElementById("menudrop").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doDrop()) {
                backToGame();
            }
        }, false);
        document.getElementById("menueat").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doEat()) {
                backToGame();
            }
        }, false);
        document.getElementById("menupick").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doPickup()) {
                backToGame();
            }
        }, false);
        document.getElementById("menuload").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doReload()) {
                backToGame();
            }
        }, false);
        document.getElementById("menumag").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doMagic()) {
                backToGame();
            }
        }, false);
        document.getElementById("menuquaff").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doDrink()) {
                backToGame();
            }
        }, false);
        document.getElementById("menuread").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doRead()) {
                backToGame();
            }
        }, false);
        document.getElementById("menushoot").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doShoot()) {
                backToGame();
            }
        }, false);
        document.getElementById("menutake").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doTakeoff()) {
                backToGame();
            }
        }, false);
        document.getElementById("menuthrow").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doThrowSelect()) {
                backToGame();
            }
        }, false);
        document.getElementById("menuuse").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doAbility()) {
                backToGame();
            }
        }, false);
        document.getElementById("menuwield").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doWield()) {
                backToGame();
            }
        }, false);
        document.getElementById("menuwear").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            if (!doWear()) {
                backToGame();
            }
        }, false);
        document.getElementById("menudown").addEventListener("pointerdown", function (evt) {
            isUp = false;
            backToGame(evt);
            if (!doDescend(isUp)) {
                redraw();
            }
        }, false);
        document.getElementById("menuup").addEventListener("pointerdown", function (evt) {
            isUp = true;
            backToGame(evt);
            if (!doDescend(isUp)) {
                redraw();
            }
        }, false);
        document.getElementById("menuquit").addEventListener("pointerdown", function (evt) {
            evt.stopImmediatePropagation();
            quitGame();
        }, false);
        document.addEventListener('keydown', function (evt) {
            if (isSectionVisible("gioco")) {
                if (isTarget) {
                    manageTargetEvents(evt.keyCode);
                } else {
                    manageGameKeyEvents(evt);
                }
            } else if (isSectionVisible("classe")) {
                evt.stopImmediatePropagation();
                manageClassEvents(evt.keyCode);
            } else if (isSectionVisible("takeoff")) {
                evt.stopImmediatePropagation();
                if (manageTakeoffEvents(evt.keyCode)) {
                    backToGame();
                }
            } else if (isSectionVisible("items")) {
                evt.stopImmediatePropagation();
                if (manageItemEvents(evt.keyCode)) {
                    backToGame();
                }
            } else if (isSectionVisible("levelup")) {
                evt.stopImmediatePropagation();
                if (manageLevelupEvents(evt.keyCode)) {
                    backToGame();
                }
            } else if (evt.keyCode === keys.VK_SPACE) {
                if (isSectionVisible('aiuto') || isSectionVisible("stats")) {
                    backToGame();
                } else if (isSectionVisible('morte') || isSectionVisible('vittoria')) {
                    reloadGame();
                } else if (isSectionVisible('intro')) {
                    if (canLoad()) {
                        startGame();
                    } else {
                        setName();
                    }
                }
            } else if (isSectionVisible("nome") && evt.keyCode === keys.VK_RETURN) {
                getName();
            } else if ((isSectionVisible('aiuto') || isSectionVisible("stats") || isSectionVisible("menu")) &&
                evt.keyCode === keys.VK_ESCAPE) {
                backToGame(evt);
            }
        }, false);
        document.addEventListener('keypress', function (evt) {
            if (isSectionVisible("gioco")) {
                manageGameKeyPressEvents(String.fromCharCode(evt.charCode));
            }
        }, false);
        //handleCache();
    };
    var main = function () {
        setFonts(window.innerWidth, window.innerHeight);
        goToSection("intro");
        dialog = document.getElementById("dialog");
        infoplay = document.getElementById("player");
        infodun = document.getElementById("dungeon");
        context = document.getElementById("screen").getContext("2d");
    };
    main();
    setEvents();
}());